#ifndef MCTRANSFORM_HEADERS_H
#define MCTRANSFORM_HEADERS_H

#include <stdio.h>
#include <math.h>
#include <utils/Pm_MeshLite.H>


class MCTransform {

private:

    R3Pt m_Xref;
    R3Vec m_Nref;
    R3Vec m_Lambda;
    R3Vec m_Mu;
    R3Vec m_Nu;

public:

    int setTransform( const R3Pt &point, const R3Vec &normal );

    void toLocal( const R3Pt &in_point, const R3Vec &in_normal,
                        R3Pt &out_point,      R3Vec &out_normal ) const;

    void toLocal( R3Pt &point ) const;

    void toLocal( R3Vec &normal ) const;

    void fromLocal( const R3Pt &in_point, const R3Vec &in_normal,
                          R3Pt &out_point,      R3Vec &out_normal ) const;

    void fromLocal( R3Pt &point ) const;

    void fromLocal( R3Vec &normal ) const;

    static void Weingarten( const double A, const double B, const double C,
                            double &k1, double &k2, 
                            R3Vec &v1, R3Vec &v2 );

    void dump( FILE *out ) const;

    MCTransform();

    ~MCTransform();

};

#endif
