// FITTools_FitLine.h: interface for the FITTools_FitLine class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FITTOOLS_FITLINE_H__EA145FF1_16F8_11D5_8CFF_00010270C860__INCLUDED_)
#define AFX_FITTOOLS_FITLINE_H__EA145FF1_16F8_11D5_8CFF_00010270C860__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <fitting/FITTools_Least_squares.H>
#include <utils/Rn_Line_seg.H>

/** \class FITTools_FitLine FITTools_FitLine.H fitting/FITTools_FitLine.H
  \brief Fit to a line 
    \ingroup FittingElems

  Uses an implicit approach
*/
class FITTools_FitLine : public FITTools_LS  
{
protected:
    double     m_dPercError;
    R2Line_seg m_seg2D;
    R3Line_seg m_seg3D;
public:
    ///
    double     Error() const { return m_dPercError; }
    ///
    R2Line     Line2D( )     const;
    ///
    const R2Line_seg &Line_seg2D( ) const;
    ///
    R3Line     Line3D( )     const;
    ///
    const R3Line_seg &Line_seg3D( ) const;

    /// 2D line
    void Fit( const Array<R2Pt> &in_apt );
    /// 3D line
    void Fit( const Array<R3Pt> &in_apt );

    FITTools_FitLine() : FITTools_LS(1,1,1), m_dPercError(0.0) { };
    /// 2D line
	FITTools_FitLine( const Array<R2Pt> &in_apt );
    /// 3D line
	FITTools_FitLine( const Array<R3Pt> &in_apt );
    ///
    virtual ~FITTools_FitLine() {}

    ///
    static WINbool Test();
};

#endif // !defined(AFX_FITTOOLS_FITLINE_H__EA145FF1_16F8_11D5_8CFF_00010270C860__INCLUDED_)
