#ifndef _PMEIGENBASIS_DEFS_H
#define _PMEIGENBASIS_DEFS_H

#include <utils/Rn_Defs.H>
#include <utils/Mesh_GMesh.H>

class PMSubdivVertex;
class PMSubdivPt;

class PMEigenBasis {
private:
    static int sm_iMaxSize;

    double EvalSpline( const double * in_adCoefs,
                       double         in_dU, 
                       double         in_dV ) const;
public:
    static void SetMaxSize( int in_iN ) { sm_iMaxSize = in_iN; }

    void ProjectPoints( const Array<const PMSubdivVertex *> & in_aopVs,
                        Array<PMSubdivPt>                   & out_aptSubdiv ) const;

    void ProjectPoints( const Array<const PMSubdivVertex *> & in_aopVs,
                        Array<R3Pt>                         & out_aptSubdiv ) const;

    void ProjectPoints( const Array<Vertex> & in_aopVs,
                        Array<R3Pt>         & out_aptSubdiv ) const;

    PMSubdivPt EvalSrfSubdiv( const R2Pt              & in_ptUV,
                              const Array<PMSubdivPt> & in_aptSubdiv ) const;

    R3Pt EvalSrfPt( const R2Pt        & in_ptUV,
                    const Array<R3Pt> & in_aptSubdiv ) const;

    PMEigenBasis() {}
    ~PMEigenBasis() {}

    static void Test();
};

#endif
