inline PMSubdivVertex &
PMSubdivMesh::SubVertex( const PMVertex &in_v )
{ 
    return m_aoSubVerts[ in_v.UTILSId() ]; 
}

inline const PMSubdivVertex &
PMSubdivMesh::CSubVertex( const PMVertex &in_v ) const
{ 
    return m_aoSubVerts[ in_v.UTILSId() ]; 
}

inline PMSubdivEdge &
PMSubdivMesh::SubEdge( const PMEdge &in_e )
{ 
    return m_aoSubEdges[ in_e.UTILSId() ]; 
}

inline const PMSubdivEdge &
PMSubdivMesh::CSubEdge( const PMEdge &in_e ) const
{ 
    return m_aoSubEdges[ in_e.UTILSId() ]; 
}

inline PMSubdivFace &
PMSubdivMesh::SubFace( const PMFace &in_f )
{ 
    return m_aoSubFaces[ in_f.UTILSId() ]; 
}

inline const PMSubdivFace &
PMSubdivMesh::CSubFace( const PMFace &in_f ) const
{ 
    return m_aoSubFaces[ in_f.UTILSId() ]; 
}



///
inline const R3Pt &
PMSubdivMesh::Subdiv_pt( const PMVertex & in_v ) const
{ 
    return CSubVertex(in_v).SubdivPt(); 
}

///
inline const PMSubdivPt &
PMSubdivMesh::Subdiv   ( const PMVertex & in_v, int in_iDepth ) const
{ 
    if ( in_iDepth <= 0 || m_meshpNextLevel == NULL )
        return CSubVertex(in_v); 
    else
        return m_meshpNextLevel->Subdiv( *CSubVertex(in_v).SubVert(), in_iDepth-1 );
}
///
inline const R3Pt &
PMSubdivMesh::Subdiv_pt( const PMEdge & in_e ) const
{ 
    return CSubEdge(in_e).SubdivPt(); 
}
///
inline const PMSubdivPt &
PMSubdivMesh::Subdiv   ( const PMEdge & in_e, int in_iDepth ) const
{ 
    if ( in_iDepth == 0 || m_meshpNextLevel == NULL )
        return CSubEdge(in_e); 
    else
        return m_meshpNextLevel->Subdiv( *CSubEdge(in_e).SubVert(), in_iDepth-1 );
}

///
inline const R3Pt &
PMSubdivMesh::Subdiv_pt( const PMFace & in_f ) const 
{ 
    return CSubFace(in_f).SubdivPt(); 
}
///
inline const PMSubdivPt &
PMSubdivMesh::Subdiv   ( const PMFace & in_f, int in_iDepth ) const
{ 
    if ( in_iDepth == 0 || m_meshpNextLevel == NULL )
        return CSubFace(in_f);
    else
        return m_meshpNextLevel->Subdiv( *CSubFace(in_f).SubVert(), in_iDepth-1 );
}
