// fitting.cpp : Defines the entry point for the console application.
//

#include "StdAfx.H"
#include <fitting/FITTools_Least_squares.H>
#include <fitting/FITTools_LSConstrained.H>
#include <fitting/FITCrv_Fit_curveTC.H>
#include <fitting/Fit_RBF.H>
#include <fitting/Fit_RbfGauss.H>
#include <fitting/Fit_RbfThinPlate.H>
#include <fitting/Fit_RbfSpline.H>
#include <fitting/FITTools_FitLine.H>

extern void BadLS1();
extern void BadLS2a();
extern void BadLS2b();
extern void BadLS3();

int main(int argc, char* argv[])
{
    FITTools_LSConstrained::Test();

    FITTools_LS ls(10, 5, 3);

	Array<R2Pt> apt;
	FITTools_FitLine fitLine( apt );
    
    ls.Test();
    
    CRVFit3TC crvFit;
    
    crvFit.Test();
    
    BadLS2a();
    BadLS2b();

    FITRbfGauss rbfGauss;
    FITRbfThinPlate rbfTP;
    FITRbfSpline rbfSpline;

    return 0;
}

