#ifndef CURVATUREPROFILES_HEADERS_H
#define CURVATUREPROFILES_HEADERS_H

#include<MC/MC_Data.H>
#include<MC/MC_Point.H>

void SphereProfile( const double radius );

void EllipsoidProfile( const double radius, const double a, const double b);

void SaddleProfile( const double radius, const double a, const double b);

void NoiseTest( const int shape, const int valence,
                const double radius, const double a, const double b,  
                const double phi1, const double phi2, const int nphi,
                const double dr_e1, const double dr_e2, const int ndr_e, 
                const double dr_c1, const double dr_c2, const int ndr_c,
                const double dphi_e1, const double dphi_e2, const int ndphi_e, 
                const double dphi_c1, const double dphi_c2, const int ndphi_c, 
                const double dtheta1, const double dtheta2, const int ndtheta,
                const int nRings = 2 );

void InitializeData( PMeshLite &mesh, Array<MCData> &data );

void WriteCurvatureData( const int shape, 
                         const double radius, const int valence,
                         const double a, const double b,  
                         const double phi, const double dr_e, 
                         const double dr_c, const double dphi_e, 
                         const double dphi_c, const double dtheta,
                         Array<MCData> &data, Array<MCPoint> &points,
                         Array<WINbool> &valid );

void WriteVectorErrorData( const int shape, 
                           const double radius, const int valence,
                           const double a, const double b,  
                           const double phi, const double dr_e, 
                           const double dr_c, const double dphi_e, 
                           const double dphi_c, const double dtheta,
                           Array<MCData> &data, Array<MCPoint> &points,
                           Array<WINbool> &valid );

void CalculateCurvatures( Array<MCData> &data, Array<MCPoint> &points,
                          Array<WINbool> &valid );

#endif
