#include "StdAfx.H"
#include <utils/Rn_Defs.H>
#include <utils/Pm_MeshLite.H>

void PMeshLite::FilterLocations( Array<R3Pt> &out_apt, const double in_dPercMove ) const
{
    out_apt.need( NumVertices() );

    ForMeshVertex( *this, v ) {
        out_apt[ v->IndexId() ] = v->GetLoc();

        const Array<Vertex> aopVNeigh = VertexVertices( v );

        R3Pt ptAvg(0,0,0);
        for ( int iV = 0; iV < aopVNeigh.num(); iV++ ) {
            for ( int j = 0; j < 3; j++ )
                ptAvg[j] += aopVNeigh[iV]->GetLoc()[j];
        }

        if ( aopVNeigh.num() ) {
            const double dSum = 1.0 / (double) aopVNeigh.num();
            for ( int j = 0; j < 3; j++ )
                ptAvg[j] = ptAvg[j] * dSum;
        }

        out_apt[ v->IndexId() ] = Lerp( v->GetLoc(), ptAvg, in_dPercMove );
    } EndFor;
}


void PMeshLite::Filter( const double in_dPercMove )
{
    Array<R3Pt> apt;
    FilterLocations( apt, in_dPercMove );

    ForMeshVertex( *this, v ) {
        v->SetLoc( apt[ v->IndexId() ] );
    } EndFor;
}