/**@name Meshes and operations on meshes

   Classes beginning with PMeshLite <br>

   This mesh class is a wrapper around Hugues' meshes
   (utilities/meshes). It is a simpler version than PMMesh, but
   has much of the same functionality. <br>

   Operations include closest point and ray intersection test, and OpenGL
   drawing. The vertices, edges, and faces have a minimal amount of
   data in them. <br>

   The vertices, edges, and faces have unique ids (IndexId()). 

<br> Files in include/utils:
<dd><li> PM_MeshLite.H

<br> Files in src/utils/PMeshLite/:
<dd><li> PMeshLite.cpp
<dd><li> PMeshLite_Silo.cpp (Silouhette edges)
<dd><li> PMeshLite_IO.cpp
<dd><li> PMeshLite_Intersect.cpp
<dd><li> PMeshLite_Tools.cpp

<br> Files in src/utils/OpenGL/OGLPMeshLite:
<dd><li> OGLPMeshesPMeshLite.cpp

<p>See utils/mesh, include/utils/Mesh_GMesh, and include/utils/Mesh_Mesh
for Hugues' mesh definition.

<p> The mesh intersection code can be found in utils/mesh/MESHIntersect.cpp

*/

//@{

/**@name Mesh */
//@{
\include <../../../include/utils/PM_PMeshLite.H>
//@Include: ../../../include/utils/Mesh_Intersect.H
//@}

//@}
