#include "StdAfx.H"

#include <utils/Rn_BBox.H>

WINbool R3BBox::Test()
{
    R3BBox bbox1, bbox2;

    bbox1.SetExtents( R3Pt( 0.1, 0.2, 0.3 ) );
    bbox1.ApplyTransform( R4Matrix::Rotation(1, M_PI / 2.0 ) );

    bbox2 = bbox1;
    VERIFY( bbox1 == bbox2 );

    R3BBox bbox3( bbox1 );

    ASSERT( bbox1 == bbox3 );

    const R3Vec vecMove(0.7, 0.2, 0.8);
    bbox3.ApplyTransform( R4Matrix::Translation( vecMove ) );

    VERIFY( bbox1.NCorners() == 8 );
    for ( int i = 0; i < bbox1.NCorners(); i++ )
        VERIFY( ApproxEqual( bbox1.Corner(i) + vecMove, bbox3.Corner(i) ) );

    ofstream out(WINDataHome("Test/rbox.txt"), ios::out );
    bbox1.Write( out );
    out.close();

    R3BBox bbox4;
    ifstream in(WINDataHome("Test/rbox.txt"), ios::in );
    bbox4.Read(in);
    in.close();

    ASSERT( bbox4 == bbox1 );

    const R3Pt pt( 0,0,0 );

    ASSERT( bbox1.Inside( pt ) );

    bbox1.ResetMatrix();

    return TRUE;
}
