<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">

<!-- saved from url=(0062)http://www.lboro.ac.uk/departments/ma/gallery/quat/src/quat.cc -->

<HTML><HEAD>

<META http-equiv=Content-Type content="text/html; charset=windows-1252">

<META content="MSHTML 6.00.2715.400" name=GENERATOR></HEAD>

<BODY><PRE>#include     &lt;iostream.h&gt;       // stream library

#include     &lt;math.h&gt;           // math routines

#include     &lt;stdlib.h&gt;         // standard lib for exit() function



#include "quat.h"



quat::quat( float rr, float ii, float jj, float kk )

: r(rr),i(ii),j(jj),k(kk)

{}



float quat::norm() const

{

  return r*r+i*i+j*j+k*k;

}



float quat::abs() const

{

  return sqrt(norm());

}



quat&amp; quat::negate()

{

  r = -r;

  i = -i;

  j = -j;

  k = -k;

  return *this;

}



quat&amp; quat::conjugate()

{

  i = -i;

  j = -j;

  k = -k;

  return *this;

}



quat&amp; quat::square()

{

  float temp = 2*r;

  r = r*r-(i*i+j*j+k*k);

  i *= temp;

  j *= temp;

  k *= temp;

  return *this;

}



quat&amp; quat::invert()

{

  float temp = norm();

  r /= temp;

  i /= -temp;

  j /= -temp;

  k /= -temp;

  return (*this);       // Okay, same norm.

}



quat&amp; quat::operator+=(const quat&amp; b)

{

  r+=b.r; i+=b.i; j+=b.j; k+=b.k; return *this;

}



quat&amp; quat::operator-=(const quat&amp; b)

{

  r-=b.r; i-=b.i; j-=b.j; k-=b.k; return *this;

}



quat&amp; quat::operator*=(const float b)

{

  r*=b; i*=b; j*=b; k*=b; return *this;

}



quat&amp; quat::operator/=(const float b)

{

  r/=b; i/=b; j/=b; k/=b; return *this;

}



quat&amp; quat::operator*=(const quat&amp; b)

{

  float t0 = (k-j)*(b.j-b.k);

  float t1 = (r+i)*(b.r+b.i);

  float t2 = (r-i)*(b.j+b.k);

  float t3 = (k+j)*(b.r-b.i);

  float t4 = (k-i)*(b.i-b.j);

  float t5 = (k+i)*(b.i+b.j);

  float t6 = (r+j)*(b.r-b.k);

  float t7 = (r-j)*(b.r+b.k);

  float t8 = t5+t6+t7;

  float t9 = (t4+t8)/2;

  r = t0+t9-t5;

  i = t1+t9-t8;

  j = t2+t9-t7;

  k = t3+t9-t6;

  return *this;

}



quat&amp; quat::operator/=(const quat&amp; b)

{

  quat temp = b;

  return (*this)*=(temp.invert());      // Ugh!

}



int operator==(const quat&amp; a, const quat&amp; b)

{

  return (a.r==b.r &amp;&amp; a.i==b.i &amp;&amp; a.j==b.j &amp;&amp; a.k==b.k);

}



int operator!=(const quat&amp; a, const quat&amp; b)

{

  return !(a==b); // derived operator

}



quat operator-(quat&amp; x)

{

  return x.negate();

}



quat sqrt(const quat&amp; x)

{

  cerr&lt;&lt;"sqrt(const quat&amp;) undefined because quat::sqrt() undefined."&lt;&lt;endl;

  exit(1);      // Should be derived from member function.

}



ostream&amp; operator&lt;&lt;(ostream&amp; ost, const quat&amp; x)

{

  return ost&lt;&lt;"( "&lt;&lt;x.r&lt;&lt;", "&lt;&lt;x.i&lt;&lt;", "&lt;&lt;x.j&lt;&lt;", "&lt;&lt;x.k&lt;&lt;" )";

}



</PRE></BODY></HTML>

