/** \defgroup CurvesSurfaces  Spline curves and surfaces
<br>
  Classes starting with CRV and SRF. <br>
  Content: 
  - NURBS
  - NURB surfaces (somewhat incomplete)
  - Linear epsilon approximation to NURB curve
  - Hermite curves
  

<br> Files in: include/utils <br>
  - Crv_NurbTC.H
  - Crv_NurbTC_i.H
  - Crv_Knot_vec.H
  - Crv_Knot_vec_i.H
  - Crv_Nurb_sampledTC.H
  - Crv_SamplesTC.H
  - Crv_Nurb_sampledTC_i.H
  - Crv_Alpha.H
  - Crv_Basis.H
  - Crv_Fit_curveTC.H
  - Srf_NurbTC.H
  - Srf_NurbTC_i.H
  - Srf_Draw.H

<br> Files in: utils/splines/ <br>
  - CRVAlpha.cpp
  - CRVNurbTC.cpp
  - CRVSamplesTC.cpp
  - CRVNurb_sampledTC.cpp
  - CRVKnot_vec.cpp
  - CRVAlpha.cpp
  - CRVBasis.cpp
  - CRVSpace.cpp
  - CRVFit_curveTC.cpp
  - SRFNurbTC.cpp
  - SRFDraw.cpp
  - SRFNurbs_clip.cpp

<br> Files in: include/OpenGL <br>
  - Ogl_CrvDrawTC.H

<br> Files in: include/fitting <br>
  - FITCrv_Fit_curveTC.H

<br> Files in: utils/OpenGL/ <br>
  - OPENGLCrvDraw.cpp

The CRValpha* files are used for the refinement routines.
<br>
   Libraries needed: Splines, Utils, Geometry <br>
   For fitting: Makefile commands: <br>
   - LAPACK = uselapack

 */
//@{
/** \defgroup SplinesBSplines  BSpline curves 
  Creating, refining, fitting, sampling, and drawing non-uniform b-spline curves (UBS, NUBS, NURBS) */
/** \defgroup SplinesSrfs  BSpline surfaces 
  Creating, sampling, and drawing non-uniform b-spline surfaces (UBS, NUBS, NURBS) */
/** \defgroup HermiteCrvs Hermite curves
  Creating Hermite curves */
//@}



