//Ppm.cpp
//
//This defines a few functions that will save images as PPMs.
//
//Created: Thu Aug  5 12:27:56 PDT 2004
//Creator: Leon Barrett

#include <utils/Ppm.H>
#include <fstream>

using namespace std;


void WritePPM( std::ostream & os, int width, int height, unsigned short * data )
{
  int i, j, c;
  //output the header
  os << "P6" << endl;
  os << "#written by utils/Ppm.cpp" << endl;
  os << width << " " << height << endl;
  os << 65535 << endl;
  //output the data
  os.write((char*)data,width*height*3*sizeof(unsigned short));
}


void WritePPM( char * fileName, int width, int height, unsigned short * data )
{
  ofstream outfile(fileName);
  if( !outfile.good() )
    return;
  WritePPM( outfile, width, height, data );
}
