#include "StdAfx.H"
#include <utils/Utils_Timer.H>

#ifdef WIN32

UTILSTick UTILSTickStart(void)
{
	struct _timeb time;
	UTILSTick tick;

	_ftime(&time);
	tick.milliseconds = time.millitm;
	tick.seconds = time.time;

	return tick;
}

UTILSTick UTILSTickEnd(UTILSTick tickStart)
{
	struct _timeb time;
	UTILSTick tickEnd;

	_ftime(&time);
	tickEnd.milliseconds = time.millitm - tickStart.milliseconds;
	tickEnd.seconds = time.time - tickStart.seconds;

	if (tickEnd.milliseconds < 0)
		{
		tickEnd.milliseconds += 1000;
		tickEnd.seconds--;
		}
	return tickEnd;
}

double UTILSSecondsFromTick(UTILSTick tick)
{
	return ((double)tick.seconds)+(((double)tick.milliseconds)/1000);
}

#else

UTILSTick UTILSTickStart(void)
{
 	UTILSTick tick;
     tick.seconds = 0;
	return tick;
}

UTILSTick UTILSTickEnd(UTILSTick tickStart)
{
	UTILSTick tickEnd;
     tickEnd.seconds = 0;

	return tickEnd;
}

double UTILSSecondsFromTick(UTILSTick tick)
{
	return ((double)tick.seconds)+(((double)tick.milliseconds)/1000);
}


#endif
