/** \defgroup Utilities General utilities
<br>
  Classes starting with Utils_. <br>
  Content: 
  - 2D and 3D dots
  - Mapping to and from quadrilaterals
  - Barycentric coordinates on a 2D polygon
  - Colors
  - boolean toggle
  - platform-safe binary IO
  - Icosahedral sampling (points evenly distributed on a sphere)
   
<br> Files in: include/utils <br>
  - Utils_Bits.H
  - Utils_Io.H
  - Utils_Color.H
  - Utils_Toggle.H
  - Utils_Element.H, Utils_Element_i.H
  - Utils_Dots.H
  - Utils_Dots_i.H
  - Utils_Timer.H
  - Utils_Polygon_mapping.H
  - Utils_Barys.H
  - Utils_IcosahedralSampler.cpp

<br> Files in: utilities/utils/ <br>
  - UTILSBits.cpp
  - UTILSIo.cpp
  - UTILSColor.cpp
  - UTILSDots.cpp
  - UTILSElement.cpp
  - UTILSRawImage.cpp
  - UTILSBarys.cpp
  - UTILSpolygon.cpp
  - UTILSIcosahedralSampler.cpp
<br>
   Libraries needed: Utils, Geometry
  */
//@{
/** \defgroup UtilitiesGeom Dots, barycoords, Sphere sampling, quad to square mapping */
/** \defgroup UtilitiesFunc Bits, Binary IO, Toggles */
/** \defgroup UtilitiesColor Color */
//@}
