#include "StdAfx.H"
#include <utils/Utils_Bits.H>
#include <utils/Utils_Element.H>
#include <utils/Utils_Barys.H>
#include <utils/Utils_Polygon_mapping.H>
#include <utils/Utils_Dots.H>
#include <utils/Utils_Io.H>
#include <utils/Utils_IcosahedralSampler.H>

char g_strDataHome[] = "./";

class UTILSDouble : public UTILSElement {
public:
   double m_dDouble;
};


typedef struct {
    double dValue;
    int    iIndx;
} QSType;
int QSCompare( const void *in_op1, const void *in_op2 )
{
    return ((QSType *) in_op1)->dValue > ((QSType *) in_op2)->dValue;
}

static void TestSort()
{
    Array< QSType > aiN(15);

    for (int i = 0; i < aiN.num(); i++) {
        aiN[i].dValue = 20.0 - i;
        aiN[i].iIndx = i;
    }

    qsort( (void*) &aiN[0], aiN.num(), sizeof( QSType ), QSCompare );

    for (FORINT i = 0; i < aiN.num(); i++) {
        cerr << aiN[i].iIndx << " " << aiN[i].dValue << "\n";
    }
}


static void TestIcoso()
{
    UTILSIcosahedralSampler icoSamp;

    ofstream out("icoso.m");
    Array<R3Vec> adTest;
    UTILSDotArray    oDots;
    icoSamp.GetSamples(3, adTest);
    for (int i = 0; i < adTest.num(); i++) {
        cout << adTest[i] << "\n";
        out << adTest[i][0] << " " << adTest[i][1] << " " << adTest[i][2] << "\n";
        oDots.Add( R3Pt( adTest[i][0], adTest[i][1], adTest[i][2] ), UTILSColor::WHITE );

    }
    out.close();
    oDots.Write("icoso.txt");
    //    UTILSDotArray::Write( oDots, "icoso.txt");
}

int main( int argc, char **argv )
{

    UTILSBits                 oBits(100);
    UTILSElementArray<UTILSDouble> oElemArray(UTILSElement::VERTEX, TRUE);
    
    WINbool res1 = UTILSBarys::Test();
    WINbool res3 = UTILSPolygon::Test();
    
    return 0;
}
