/*******************************************************************************
!                             INTEL CONFIDENTIAL
!   Copyright(C) 1999-2005 Intel Corporation. All Rights Reserved.
!   The source code contained  or  described herein and all documents related to
!   the source code ("Material") are owned by Intel Corporation or its suppliers
!   or licensors.  Title to the  Material remains with  Intel Corporation or its
!   suppliers and licensors. The Material contains trade secrets and proprietary
!   and  confidential  information of  Intel or its suppliers and licensors. The
!   Material  is  protected  by  worldwide  copyright  and trade secret laws and
!   treaty  provisions. No part of the Material may be used, copied, reproduced,
!   modified, published, uploaded, posted, transmitted, distributed or disclosed
!   in any way without Intel's prior express written permission.
!   No license  under any  patent, copyright, trade secret or other intellectual
!   property right is granted to or conferred upon you by disclosure or delivery
!   of the Materials,  either expressly, by implication, inducement, estoppel or
!   otherwise.  Any  license  under  such  intellectual property  rights must be
!   express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!      Intel(R) Math Kernel Library (MKL) interface for LAPACK routines
!******************************************************************************/

#ifndef _MKL_LAPACK_H_
#define _MKL_LAPACK_H_

#include "mkl_types.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

void    CBDSQR(char *uplo,int *n,int *ncvt,int *nru,int *ncc,float *d,float *e, MKL_Complex8 *vt,int *ldvt, MKL_Complex8 *u,int *ldu, MKL_Complex8 *c,int *ldc,float *rwork,int *info);
void    cbdsqr(char *uplo,int *n,int *ncvt,int *nru,int *ncc,float *d,float *e, MKL_Complex8 *vt,int *ldvt, MKL_Complex8 *u,int *ldu, MKL_Complex8 *c,int *ldc,float *rwork,int *info);
void    CGBBRD(char *vect,int *m,int *n,int *ncc,int *kl,int *ku, MKL_Complex8 *ab,int *ldab,float *d,float *e, MKL_Complex8 *q,int *ldq, MKL_Complex8 *pt,int *ldpt, MKL_Complex8 *c,int *ldc, MKL_Complex8 *work,float *rwork,int *info);
void    cgbbrd(char *vect,int *m,int *n,int *ncc,int *kl,int *ku, MKL_Complex8 *ab,int *ldab,float *d,float *e, MKL_Complex8 *q,int *ldq, MKL_Complex8 *pt,int *ldpt, MKL_Complex8 *c,int *ldc, MKL_Complex8 *work,float *rwork,int *info);
void    CGBCON(char *norm,int *n,int *kl,int *ku, MKL_Complex8 *ab,int *ldab,int *ipiv,float *anorm,float *rcond, MKL_Complex8 *work,float *rwork,int *info);
void    cgbcon(char *norm,int *n,int *kl,int *ku, MKL_Complex8 *ab,int *ldab,int *ipiv,float *anorm,float *rcond, MKL_Complex8 *work,float *rwork,int *info);
void    CGBEQU(int *m,int *n,int *kl,int *ku, MKL_Complex8 *ab,int *ldab,float *r,float *c,float *rowcnd,float *colcnd,float *amax,int *info);
void    cgbequ(int *m,int *n,int *kl,int *ku, MKL_Complex8 *ab,int *ldab,float *r,float *c,float *rowcnd,float *colcnd,float *amax,int *info);
void    CGBRFS(char *trans,int *n,int *kl,int *ku,int *nrhs, MKL_Complex8 *ab,int *ldab, MKL_Complex8 *afb,int *ldafb,int *ipiv, MKL_Complex8 *b,int *ldb, MKL_Complex8 *x,int *ldx,float *ferr,float *berr, MKL_Complex8 *work,float *rwork,int *info);
void    cgbrfs(char *trans,int *n,int *kl,int *ku,int *nrhs, MKL_Complex8 *ab,int *ldab, MKL_Complex8 *afb,int *ldafb,int *ipiv, MKL_Complex8 *b,int *ldb, MKL_Complex8 *x,int *ldx,float *ferr,float *berr, MKL_Complex8 *work,float *rwork,int *info);
void    CGBSV(int *n,int *kl,int *ku,int *nrhs, MKL_Complex8 *ab,int *ldab,int *ipiv, MKL_Complex8 *b,int *ldb,int *info);
void    cgbsv(int *n,int *kl,int *ku,int *nrhs, MKL_Complex8 *ab,int *ldab,int *ipiv, MKL_Complex8 *b,int *ldb,int *info);
void    CGBSVX(char *fact,char *trans,int *n,int *kl,int *ku,int *nrhs, MKL_Complex8 *ab,int *ldab, MKL_Complex8 *afb,int *ldafb,int *ipiv,char *equed,float *r,float *c, MKL_Complex8 *b,int *ldb, MKL_Complex8 *x,int *ldx,float *rcond,float *ferr,float *berr, MKL_Complex8 *work,float *rwork,int *info);
void    cgbsvx(char *fact,char *trans,int *n,int *kl,int *ku,int *nrhs, MKL_Complex8 *ab,int *ldab, MKL_Complex8 *afb,int *ldafb,int *ipiv,char *equed,float *r,float *c, MKL_Complex8 *b,int *ldb, MKL_Complex8 *x,int *ldx,float *rcond,float *ferr,float *berr, MKL_Complex8 *work,float *rwork,int *info);
void    CGBTF2(int *m,int *n,int *kl,int *ku, MKL_Complex8 *ab,int *ldab,int *ipiv,int *info);
void    cgbtf2(int *m,int *n,int *kl,int *ku, MKL_Complex8 *ab,int *ldab,int *ipiv,int *info);
void    CGBTRF(int *m,int *n,int *kl,int *ku, MKL_Complex8 *ab,int *ldab,int *ipiv,int *info);
void    cgbtrf(int *m,int *n,int *kl,int *ku, MKL_Complex8 *ab,int *ldab,int *ipiv,int *info);
void    CGBTRS(char *trans,int *n,int *kl,int *ku,int *nrhs, MKL_Complex8 *ab,int *ldab,int *ipiv, MKL_Complex8 *b,int *ldb,int *info);
void    cgbtrs(char *trans,int *n,int *kl,int *ku,int *nrhs, MKL_Complex8 *ab,int *ldab,int *ipiv, MKL_Complex8 *b,int *ldb,int *info);
void    CGEBAK(char *job,char *side,int *n,int *ilo,int *ihi,float *scale,int *m, MKL_Complex8 *v,int *ldv,int *info);
void    cgebak(char *job,char *side,int *n,int *ilo,int *ihi,float *scale,int *m, MKL_Complex8 *v,int *ldv,int *info);
void    CGEBAL(char *job,int *n, MKL_Complex8 *a,int *lda,int *ilo,int *ihi,float *scale,int *info);
void    cgebal(char *job,int *n, MKL_Complex8 *a,int *lda,int *ilo,int *ihi,float *scale,int *info);
void    CGEBD2(int *m,int *n, MKL_Complex8 *a,int *lda,float *d,float *e, MKL_Complex8 *tauq, MKL_Complex8 *taup, MKL_Complex8 *work,int *info);
void    cgebd2(int *m,int *n, MKL_Complex8 *a,int *lda,float *d,float *e, MKL_Complex8 *tauq, MKL_Complex8 *taup, MKL_Complex8 *work,int *info);
void    CGEBRD(int *m,int *n, MKL_Complex8 *a,int *lda,float *d,float *e, MKL_Complex8 *tauq, MKL_Complex8 *taup, MKL_Complex8 *work,int *lwork,int *info);
void    cgebrd(int *m,int *n, MKL_Complex8 *a,int *lda,float *d,float *e, MKL_Complex8 *tauq, MKL_Complex8 *taup, MKL_Complex8 *work,int *lwork,int *info);
void    CGECON(char *norm,int *n, MKL_Complex8 *a,int *lda,float *anorm,float *rcond, MKL_Complex8 *work,float *rwork,int *info);
void    cgecon(char *norm,int *n, MKL_Complex8 *a,int *lda,float *anorm,float *rcond, MKL_Complex8 *work,float *rwork,int *info);
void    CGEEQU(int *m,int *n, MKL_Complex8 *a,int *lda,float *r,float *c,float *rowcnd,float *colcnd,float *amax,int *info);
void    cgeequ(int *m,int *n, MKL_Complex8 *a,int *lda,float *r,float *c,float *rowcnd,float *colcnd,float *amax,int *info);
void    CGEES(char *jobvs,char *sort,void *select,int *n, MKL_Complex8 *a,int *lda,int *sdim, MKL_Complex8 *w, MKL_Complex8 *vs,int *ldvs, MKL_Complex8 *work,int *lwork,float *rwork,void *bwork,int *info);
void    cgees(char *jobvs,char *sort,void *select,int *n, MKL_Complex8 *a,int *lda,int *sdim, MKL_Complex8 *w, MKL_Complex8 *vs,int *ldvs, MKL_Complex8 *work,int *lwork,float *rwork,void *bwork,int *info);
void    CGEESX(char *jobvs,char *sort,void *select,char *sense,int *n, MKL_Complex8 *a,int *lda,int *sdim, MKL_Complex8 *w, MKL_Complex8 *vs,int *ldvs,float *rconde,float *rcondv, MKL_Complex8 *work,int *lwork,float *rwork,void *bwork,int *info);
void    cgeesx(char *jobvs,char *sort,void *select,char *sense,int *n, MKL_Complex8 *a,int *lda,int *sdim, MKL_Complex8 *w, MKL_Complex8 *vs,int *ldvs,float *rconde,float *rcondv, MKL_Complex8 *work,int *lwork,float *rwork,void *bwork,int *info);
void    CGEEV(char *jobvl,char *jobvr,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *w, MKL_Complex8 *vl,int *ldvl, MKL_Complex8 *vr,int *ldvr, MKL_Complex8 *work,int *lwork,float *rwork,int *info);
void    cgeev(char *jobvl,char *jobvr,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *w, MKL_Complex8 *vl,int *ldvl, MKL_Complex8 *vr,int *ldvr, MKL_Complex8 *work,int *lwork,float *rwork,int *info);
void    CGEEVX(char *balanc,char *jobvl,char *jobvr,char *sense,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *w, MKL_Complex8 *vl,int *ldvl, MKL_Complex8 *vr,int *ldvr,int *ilo,int *ihi,float *scale,float *abnrm,float *rconde,float *rcondv, MKL_Complex8 *work,int *lwork,float *rwork,int *info);
void    cgeevx(char *balanc,char *jobvl,char *jobvr,char *sense,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *w, MKL_Complex8 *vl,int *ldvl, MKL_Complex8 *vr,int *ldvr,int *ilo,int *ihi,float *scale,float *abnrm,float *rconde,float *rcondv, MKL_Complex8 *work,int *lwork,float *rwork,int *info);
void    CGEGS(char *jobvsl,char *jobvsr,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb, MKL_Complex8 *alpha, MKL_Complex8 *beta, MKL_Complex8 *vsl,int *ldvsl, MKL_Complex8 *vsr,int *ldvsr, MKL_Complex8 *work,int *lwork,float *rwork,int *info);
void    cgegs(char *jobvsl,char *jobvsr,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb, MKL_Complex8 *alpha, MKL_Complex8 *beta, MKL_Complex8 *vsl,int *ldvsl, MKL_Complex8 *vsr,int *ldvsr, MKL_Complex8 *work,int *lwork,float *rwork,int *info);
void    CGEGV(char *jobvl,char *jobvr,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb, MKL_Complex8 *alpha, MKL_Complex8 *beta, MKL_Complex8 *vl,int *ldvl, MKL_Complex8 *vr,int *ldvr, MKL_Complex8 *work,int *lwork,float *rwork,int *info);
void    cgegv(char *jobvl,char *jobvr,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb, MKL_Complex8 *alpha, MKL_Complex8 *beta, MKL_Complex8 *vl,int *ldvl, MKL_Complex8 *vr,int *ldvr, MKL_Complex8 *work,int *lwork,float *rwork,int *info);
void    CGEHD2(int *n,int *ilo,int *ihi, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *work,int *info);
void    cgehd2(int *n,int *ilo,int *ihi, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *work,int *info);
void    CGEHRD(int *n,int *ilo,int *ihi, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *work,int *lwork,int *info);
void    cgehrd(int *n,int *ilo,int *ihi, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *work,int *lwork,int *info);
void    CGELQ2(int *m,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *work,int *info);
void    cgelq2(int *m,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *work,int *info);
void    CGELQF(int *m,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *work,int *lwork,int *info);
void    cgelqf(int *m,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *work,int *lwork,int *info);
void    CGELS(char *trans,int *m,int *n,int *nrhs, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb, MKL_Complex8 *work,int *lwork,int *info);
void    cgels(char *trans,int *m,int *n,int *nrhs, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb, MKL_Complex8 *work,int *lwork,int *info);
void    CGELSD(int *m,int *n,int *nrhs, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb,float *s,float *rcond,int *rank, MKL_Complex8 *work,int *lwork,float *rwork,int *iwork,int *info);
void    cgelsd(int *m,int *n,int *nrhs, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb,float *s,float *rcond,int *rank, MKL_Complex8 *work,int *lwork,float *rwork,int *iwork,int *info);
void    CGELSS(int *m,int *n,int *nrhs, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb,float *s,float *rcond,int *rank, MKL_Complex8 *work,int *lwork,float *rwork,int *info);
void    cgelss(int *m,int *n,int *nrhs, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb,float *s,float *rcond,int *rank, MKL_Complex8 *work,int *lwork,float *rwork,int *info);
void    CGELSX(int *m,int *n,int *nrhs, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb,int *jpvt,float *rcond,int *rank, MKL_Complex8 *work,float *rwork,int *info);
void    cgelsx(int *m,int *n,int *nrhs, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb,int *jpvt,float *rcond,int *rank, MKL_Complex8 *work,float *rwork,int *info);
void    CGELSY(int *m,int *n,int *nrhs, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb,int *jpvt,float *rcond,int *rank, MKL_Complex8 *work,int *lwork,float *rwork,int *info);
void    cgelsy(int *m,int *n,int *nrhs, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb,int *jpvt,float *rcond,int *rank, MKL_Complex8 *work,int *lwork,float *rwork,int *info);
void    CGEQL2(int *m,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *work,int *info);
void    cgeql2(int *m,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *work,int *info);
void    CGEQLF(int *m,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *work,int *lwork,int *info);
void    cgeqlf(int *m,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *work,int *lwork,int *info);
void    CGEQP3(int *m,int *n, MKL_Complex8 *a,int *lda,int *jpvt, MKL_Complex8 *tau, MKL_Complex8 *work,int *lwork,float *rwork,int *info);
void    cgeqp3(int *m,int *n, MKL_Complex8 *a,int *lda,int *jpvt, MKL_Complex8 *tau, MKL_Complex8 *work,int *lwork,float *rwork,int *info);
void    CGEQPF(int *m,int *n, MKL_Complex8 *a,int *lda,int *jpvt, MKL_Complex8 *tau, MKL_Complex8 *work,float *rwork,int *info);
void    cgeqpf(int *m,int *n, MKL_Complex8 *a,int *lda,int *jpvt, MKL_Complex8 *tau, MKL_Complex8 *work,float *rwork,int *info);
void    CGEQR2(int *m,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *work,int *info);
void    cgeqr2(int *m,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *work,int *info);
void    CGEQRF(int *m,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *work,int *lwork,int *info);
void    cgeqrf(int *m,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *work,int *lwork,int *info);
void    CGERFS(char *trans,int *n,int *nrhs, MKL_Complex8 *a,int *lda, MKL_Complex8 *af,int *ldaf,int *ipiv, MKL_Complex8 *b,int *ldb, MKL_Complex8 *x,int *ldx,float *ferr,float *berr, MKL_Complex8 *work,float *rwork,int *info);
void    cgerfs(char *trans,int *n,int *nrhs, MKL_Complex8 *a,int *lda, MKL_Complex8 *af,int *ldaf,int *ipiv, MKL_Complex8 *b,int *ldb, MKL_Complex8 *x,int *ldx,float *ferr,float *berr, MKL_Complex8 *work,float *rwork,int *info);
void    CGERQ2(int *m,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *work,int *info);
void    cgerq2(int *m,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *work,int *info);
void    CGERQF(int *m,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *work,int *lwork,int *info);
void    cgerqf(int *m,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *work,int *lwork,int *info);
void    CGESC2(int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *rhs,int *ipiv,int *jpiv,float *scale);
void    cgesc2(int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *rhs,int *ipiv,int *jpiv,float *scale);
void    CGESDD(char *jobz,int *m,int *n, MKL_Complex8 *a,int *lda,float *s, MKL_Complex8 *u,int *ldu, MKL_Complex8 *vt,int *ldvt, MKL_Complex8 *work,int *lwork,float *rwork,int *iwork,int *info);
void    cgesdd(char *jobz,int *m,int *n, MKL_Complex8 *a,int *lda,float *s, MKL_Complex8 *u,int *ldu, MKL_Complex8 *vt,int *ldvt, MKL_Complex8 *work,int *lwork,float *rwork,int *iwork,int *info);
void    CGESV(int *n,int *nrhs, MKL_Complex8 *a,int *lda,int *ipiv, MKL_Complex8 *b,int *ldb,int *info);
void    cgesv(int *n,int *nrhs, MKL_Complex8 *a,int *lda,int *ipiv, MKL_Complex8 *b,int *ldb,int *info);
void    CGESVD(char *jobu,char *jobvt,int *m,int *n, MKL_Complex8 *a,int *lda,float *s, MKL_Complex8 *u,int *ldu, MKL_Complex8 *vt,int *ldvt, MKL_Complex8 *work,int *lwork,float *rwork,int *info);
void    cgesvd(char *jobu,char *jobvt,int *m,int *n, MKL_Complex8 *a,int *lda,float *s, MKL_Complex8 *u,int *ldu, MKL_Complex8 *vt,int *ldvt, MKL_Complex8 *work,int *lwork,float *rwork,int *info);
void    CGESVX(char *fact,char *trans,int *n,int *nrhs, MKL_Complex8 *a,int *lda, MKL_Complex8 *af,int *ldaf,int *ipiv,char *equed,float *r,float *c, MKL_Complex8 *b,int *ldb, MKL_Complex8 *x,int *ldx,float *rcond,float *ferr,float *berr, MKL_Complex8 *work,float *rwork,int *info);
void    cgesvx(char *fact,char *trans,int *n,int *nrhs, MKL_Complex8 *a,int *lda, MKL_Complex8 *af,int *ldaf,int *ipiv,char *equed,float *r,float *c, MKL_Complex8 *b,int *ldb, MKL_Complex8 *x,int *ldx,float *rcond,float *ferr,float *berr, MKL_Complex8 *work,float *rwork,int *info);
void    CGETC2(int *n, MKL_Complex8 *a,int *lda,int *ipiv,int *jpiv,int *info);
void    cgetc2(int *n, MKL_Complex8 *a,int *lda,int *ipiv,int *jpiv,int *info);
void    CGETF2(int *m,int *n, MKL_Complex8 *a,int *lda,int *ipiv,int *info);
void    cgetf2(int *m,int *n, MKL_Complex8 *a,int *lda,int *ipiv,int *info);
void    CGETRF(int *m,int *n, MKL_Complex8 *a,int *lda,int *ipiv,int *info);
void    cgetrf(int *m,int *n, MKL_Complex8 *a,int *lda,int *ipiv,int *info);
void    CGETRI(int *n, MKL_Complex8 *a,int *lda,int *ipiv, MKL_Complex8 *work,int *lwork,int *info);
void    cgetri(int *n, MKL_Complex8 *a,int *lda,int *ipiv, MKL_Complex8 *work,int *lwork,int *info);
void    CGETRS(char *trans,int *n,int *nrhs, MKL_Complex8 *a,int *lda,int *ipiv, MKL_Complex8 *b,int *ldb,int *info);
void    cgetrs(char *trans,int *n,int *nrhs, MKL_Complex8 *a,int *lda,int *ipiv, MKL_Complex8 *b,int *ldb,int *info);
void    CGGBAK(char *job,char *side,int *n,int *ilo,int *ihi,float *lscale,float *rscale,int *m, MKL_Complex8 *v,int *ldv,int *info);
void    cggbak(char *job,char *side,int *n,int *ilo,int *ihi,float *lscale,float *rscale,int *m, MKL_Complex8 *v,int *ldv,int *info);
void    CGGBAL(char *job,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb,int *ilo,int *ihi,float *lscale,float *rscale,float *work,int *info);
void    cggbal(char *job,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb,int *ilo,int *ihi,float *lscale,float *rscale,float *work,int *info);
void    CGGES(char *jobvsl,char *jobvsr,char *sort,void *selctg,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb,int *sdim, MKL_Complex8 *alpha, MKL_Complex8 *beta, MKL_Complex8 *vsl,int *ldvsl, MKL_Complex8 *vsr,int *ldvsr, MKL_Complex8 *work,int *lwork,float *rwork,void *bwork,int *info);
void    cgges(char *jobvsl,char *jobvsr,char *sort,void *selctg,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb,int *sdim, MKL_Complex8 *alpha, MKL_Complex8 *beta, MKL_Complex8 *vsl,int *ldvsl, MKL_Complex8 *vsr,int *ldvsr, MKL_Complex8 *work,int *lwork,float *rwork,void *bwork,int *info);
void    CGGESX(char *jobvsl,char *jobvsr,char *sort,void *selctg,char *sense,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb,int *sdim, MKL_Complex8 *alpha, MKL_Complex8 *beta, MKL_Complex8 *vsl,int *ldvsl, MKL_Complex8 *vsr,int *ldvsr,float *rconde,float *rcondv, MKL_Complex8 *work,int *lwork,float *rwork,int *iwork,int *liwork,void *bwork,int *info);
void    cggesx(char *jobvsl,char *jobvsr,char *sort,void *selctg,char *sense,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb,int *sdim, MKL_Complex8 *alpha, MKL_Complex8 *beta, MKL_Complex8 *vsl,int *ldvsl, MKL_Complex8 *vsr,int *ldvsr,float *rconde,float *rcondv, MKL_Complex8 *work,int *lwork,float *rwork,int *iwork,int *liwork,void *bwork,int *info);
void    CGGEV(char *jobvl,char *jobvr,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb, MKL_Complex8 *alpha, MKL_Complex8 *beta, MKL_Complex8 *vl,int *ldvl, MKL_Complex8 *vr,int *ldvr, MKL_Complex8 *work,int *lwork,float *rwork,int *info);
void    cggev(char *jobvl,char *jobvr,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb, MKL_Complex8 *alpha, MKL_Complex8 *beta, MKL_Complex8 *vl,int *ldvl, MKL_Complex8 *vr,int *ldvr, MKL_Complex8 *work,int *lwork,float *rwork,int *info);
void    CGGEVX(char *balanc,char *jobvl,char *jobvr,char *sense,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb, MKL_Complex8 *alpha, MKL_Complex8 *beta, MKL_Complex8 *vl,int *ldvl, MKL_Complex8 *vr,int *ldvr,int *ilo,int *ihi,float *lscale,float *rscale,float *abnrm,float *bbnrm,float *rconde,float *rcondv, MKL_Complex8 *work,int *lwork,float *rwork,int *iwork,void *bwork,int *info);
void    cggevx(char *balanc,char *jobvl,char *jobvr,char *sense,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb, MKL_Complex8 *alpha, MKL_Complex8 *beta, MKL_Complex8 *vl,int *ldvl, MKL_Complex8 *vr,int *ldvr,int *ilo,int *ihi,float *lscale,float *rscale,float *abnrm,float *bbnrm,float *rconde,float *rcondv, MKL_Complex8 *work,int *lwork,float *rwork,int *iwork,void *bwork,int *info);
void    CGGGLM(int *n,int *m,int *p, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb, MKL_Complex8 *d, MKL_Complex8 *x, MKL_Complex8 *y, MKL_Complex8 *work,int *lwork,int *info);
void    cggglm(int *n,int *m,int *p, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb, MKL_Complex8 *d, MKL_Complex8 *x, MKL_Complex8 *y, MKL_Complex8 *work,int *lwork,int *info);
void    CGGHRD(char *compq,char *compz,int *n,int *ilo,int *ihi, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb, MKL_Complex8 *q,int *ldq, MKL_Complex8 *z,int *ldz,int *info);
void    cgghrd(char *compq,char *compz,int *n,int *ilo,int *ihi, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb, MKL_Complex8 *q,int *ldq, MKL_Complex8 *z,int *ldz,int *info);
void    CGGLSE(int *m,int *n,int *p, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb, MKL_Complex8 *c, MKL_Complex8 *d, MKL_Complex8 *x, MKL_Complex8 *work,int *lwork,int *info);
void    cgglse(int *m,int *n,int *p, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb, MKL_Complex8 *c, MKL_Complex8 *d, MKL_Complex8 *x, MKL_Complex8 *work,int *lwork,int *info);
void    CGGQRF(int *n,int *m,int *p, MKL_Complex8 *a,int *lda, MKL_Complex8 *taua, MKL_Complex8 *b,int *ldb, MKL_Complex8 *taub, MKL_Complex8 *work,int *lwork,int *info);
void    cggqrf(int *n,int *m,int *p, MKL_Complex8 *a,int *lda, MKL_Complex8 *taua, MKL_Complex8 *b,int *ldb, MKL_Complex8 *taub, MKL_Complex8 *work,int *lwork,int *info);
void    CGGRQF(int *m,int *p,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *taua, MKL_Complex8 *b,int *ldb, MKL_Complex8 *taub, MKL_Complex8 *work,int *lwork,int *info);
void    cggrqf(int *m,int *p,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *taua, MKL_Complex8 *b,int *ldb, MKL_Complex8 *taub, MKL_Complex8 *work,int *lwork,int *info);
void    CGGSVD(char *jobu,char *jobv,char *jobq,int *m,int *n,int *p,int *k,int *l, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb,float *alpha,float *beta, MKL_Complex8 *u,int *ldu, MKL_Complex8 *v,int *ldv, MKL_Complex8 *q,int *ldq, MKL_Complex8 *work,float *rwork,int *iwork,int *info);
void    cggsvd(char *jobu,char *jobv,char *jobq,int *m,int *n,int *p,int *k,int *l, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb,float *alpha,float *beta, MKL_Complex8 *u,int *ldu, MKL_Complex8 *v,int *ldv, MKL_Complex8 *q,int *ldq, MKL_Complex8 *work,float *rwork,int *iwork,int *info);
void    CGGSVP(char *jobu,char *jobv,char *jobq,int *m,int *p,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb,float *tola,float *tolb,int *k,int *l, MKL_Complex8 *u,int *ldu, MKL_Complex8 *v,int *ldv, MKL_Complex8 *q,int *ldq,int *iwork,float *rwork, MKL_Complex8 *tau, MKL_Complex8 *work,int *info);
void    cggsvp(char *jobu,char *jobv,char *jobq,int *m,int *p,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb,float *tola,float *tolb,int *k,int *l, MKL_Complex8 *u,int *ldu, MKL_Complex8 *v,int *ldv, MKL_Complex8 *q,int *ldq,int *iwork,float *rwork, MKL_Complex8 *tau, MKL_Complex8 *work,int *info);
void    CGTCON(char *norm,int *n, MKL_Complex8 *dl, MKL_Complex8 *d, MKL_Complex8 *du, MKL_Complex8 *du2,int *ipiv,float *anorm,float *rcond, MKL_Complex8 *work,int *info);
void    cgtcon(char *norm,int *n, MKL_Complex8 *dl, MKL_Complex8 *d, MKL_Complex8 *du, MKL_Complex8 *du2,int *ipiv,float *anorm,float *rcond, MKL_Complex8 *work,int *info);
void    CGTRFS(char *trans,int *n,int *nrhs, MKL_Complex8 *dl, MKL_Complex8 *d, MKL_Complex8 *du, MKL_Complex8 *dlf, MKL_Complex8 *df, MKL_Complex8 *duf, MKL_Complex8 *du2,int *ipiv, MKL_Complex8 *b,int *ldb, MKL_Complex8 *x,int *ldx,float *ferr,float *berr, MKL_Complex8 *work,float *rwork,int *info);
void    cgtrfs(char *trans,int *n,int *nrhs, MKL_Complex8 *dl, MKL_Complex8 *d, MKL_Complex8 *du, MKL_Complex8 *dlf, MKL_Complex8 *df, MKL_Complex8 *duf, MKL_Complex8 *du2,int *ipiv, MKL_Complex8 *b,int *ldb, MKL_Complex8 *x,int *ldx,float *ferr,float *berr, MKL_Complex8 *work,float *rwork,int *info);
void    CGTSV(int *n,int *nrhs, MKL_Complex8 *dl, MKL_Complex8 *d, MKL_Complex8 *du, MKL_Complex8 *b,int *ldb,int *info);
void    cgtsv(int *n,int *nrhs, MKL_Complex8 *dl, MKL_Complex8 *d, MKL_Complex8 *du, MKL_Complex8 *b,int *ldb,int *info);
void    CGTSVX(char *fact,char *trans,int *n,int *nrhs, MKL_Complex8 *dl, MKL_Complex8 *d, MKL_Complex8 *du, MKL_Complex8 *dlf, MKL_Complex8 *df, MKL_Complex8 *duf, MKL_Complex8 *du2,int *ipiv, MKL_Complex8 *b,int *ldb, MKL_Complex8 *x,int *ldx,float *rcond,float *ferr,float *berr, MKL_Complex8 *work,float *rwork,int *info);
void    cgtsvx(char *fact,char *trans,int *n,int *nrhs, MKL_Complex8 *dl, MKL_Complex8 *d, MKL_Complex8 *du, MKL_Complex8 *dlf, MKL_Complex8 *df, MKL_Complex8 *duf, MKL_Complex8 *du2,int *ipiv, MKL_Complex8 *b,int *ldb, MKL_Complex8 *x,int *ldx,float *rcond,float *ferr,float *berr, MKL_Complex8 *work,float *rwork,int *info);
void    CGTTRF(int *n, MKL_Complex8 *dl, MKL_Complex8 *d, MKL_Complex8 *du, MKL_Complex8 *du2,int *ipiv,int *info);
void    cgttrf(int *n, MKL_Complex8 *dl, MKL_Complex8 *d, MKL_Complex8 *du, MKL_Complex8 *du2,int *ipiv,int *info);
void    CGTTRS(char *trans,int *n,int *nrhs, MKL_Complex8 *dl, MKL_Complex8 *d, MKL_Complex8 *du, MKL_Complex8 *du2,int *ipiv, MKL_Complex8 *b,int *ldb,int *info);
void    cgttrs(char *trans,int *n,int *nrhs, MKL_Complex8 *dl, MKL_Complex8 *d, MKL_Complex8 *du, MKL_Complex8 *du2,int *ipiv, MKL_Complex8 *b,int *ldb,int *info);
void    CGTTS2(int *itrans,int *n,int *nrhs, MKL_Complex8 *dl, MKL_Complex8 *d, MKL_Complex8 *du, MKL_Complex8 *du2,int *ipiv, MKL_Complex8 *b,int *ldb);
void    cgtts2(int *itrans,int *n,int *nrhs, MKL_Complex8 *dl, MKL_Complex8 *d, MKL_Complex8 *du, MKL_Complex8 *du2,int *ipiv, MKL_Complex8 *b,int *ldb);
void    CHBEV(char *jobz,char *uplo,int *n,int *kd, MKL_Complex8 *ab,int *ldab,float *w, MKL_Complex8 *z,int *ldz, MKL_Complex8 *work,float *rwork,int *info);
void    chbev(char *jobz,char *uplo,int *n,int *kd, MKL_Complex8 *ab,int *ldab,float *w, MKL_Complex8 *z,int *ldz, MKL_Complex8 *work,float *rwork,int *info);
void    CHBEVD(char *jobz,char *uplo,int *n,int *kd, MKL_Complex8 *ab,int *ldab,float *w, MKL_Complex8 *z,int *ldz, MKL_Complex8 *work,int *lwork,float *rwork,int *lrwork,int *iwork,int *liwork,int *info);
void    chbevd(char *jobz,char *uplo,int *n,int *kd, MKL_Complex8 *ab,int *ldab,float *w, MKL_Complex8 *z,int *ldz, MKL_Complex8 *work,int *lwork,float *rwork,int *lrwork,int *iwork,int *liwork,int *info);
void    CHBEVX(char *jobz,char *range,char *uplo,int *n,int *kd, MKL_Complex8 *ab,int *ldab, MKL_Complex8 *q,int *ldq,float *vl,float *vu,int *il,int *iu,float *abstol,int *m,float *w, MKL_Complex8 *z,int *ldz, MKL_Complex8 *work,float *rwork,int *iwork,int *ifail,int *info);
void    chbevx(char *jobz,char *range,char *uplo,int *n,int *kd, MKL_Complex8 *ab,int *ldab, MKL_Complex8 *q,int *ldq,float *vl,float *vu,int *il,int *iu,float *abstol,int *m,float *w, MKL_Complex8 *z,int *ldz, MKL_Complex8 *work,float *rwork,int *iwork,int *ifail,int *info);
void    CHBGST(char *vect,char *uplo,int *n,int *ka,int *kb, MKL_Complex8 *ab,int *ldab, MKL_Complex8 *bb,int *ldbb, MKL_Complex8 *x,int *ldx, MKL_Complex8 *work,float *rwork,int *info);
void    chbgst(char *vect,char *uplo,int *n,int *ka,int *kb, MKL_Complex8 *ab,int *ldab, MKL_Complex8 *bb,int *ldbb, MKL_Complex8 *x,int *ldx, MKL_Complex8 *work,float *rwork,int *info);
void    CHBGV(char *jobz,char *uplo,int *n,int *ka,int *kb, MKL_Complex8 *ab,int *ldab, MKL_Complex8 *bb,int *ldbb,float *w, MKL_Complex8 *z,int *ldz, MKL_Complex8 *work,float *rwork,int *info);
void    chbgv(char *jobz,char *uplo,int *n,int *ka,int *kb, MKL_Complex8 *ab,int *ldab, MKL_Complex8 *bb,int *ldbb,float *w, MKL_Complex8 *z,int *ldz, MKL_Complex8 *work,float *rwork,int *info);
void    CHBGVD(char *jobz,char *uplo,int *n,int *ka,int *kb, MKL_Complex8 *ab,int *ldab, MKL_Complex8 *bb,int *ldbb,float *w, MKL_Complex8 *z,int *ldz, MKL_Complex8 *work,int *lwork,float *rwork,int *lrwork,int *iwork,int *liwork,int *info);
void    chbgvd(char *jobz,char *uplo,int *n,int *ka,int *kb, MKL_Complex8 *ab,int *ldab, MKL_Complex8 *bb,int *ldbb,float *w, MKL_Complex8 *z,int *ldz, MKL_Complex8 *work,int *lwork,float *rwork,int *lrwork,int *iwork,int *liwork,int *info);
void    CHBGVX(char *jobz,char *range,char *uplo,int *n,int *ka,int *kb, MKL_Complex8 *ab,int *ldab, MKL_Complex8 *bb,int *ldbb, MKL_Complex8 *q,int *ldq,float *vl,float *vu,int *il,int *iu,float *abstol,int *m,float *w, MKL_Complex8 *z,int *ldz, MKL_Complex8 *work,float *rwork,int *iwork,int *ifail,int *info);
void    chbgvx(char *jobz,char *range,char *uplo,int *n,int *ka,int *kb, MKL_Complex8 *ab,int *ldab, MKL_Complex8 *bb,int *ldbb, MKL_Complex8 *q,int *ldq,float *vl,float *vu,int *il,int *iu,float *abstol,int *m,float *w, MKL_Complex8 *z,int *ldz, MKL_Complex8 *work,float *rwork,int *iwork,int *ifail,int *info);
void    CHBTRD(char *vect,char *uplo,int *n,int *kd, MKL_Complex8 *ab,int *ldab,float *d,float *e, MKL_Complex8 *q,int *ldq, MKL_Complex8 *work,int *info);
void    chbtrd(char *vect,char *uplo,int *n,int *kd, MKL_Complex8 *ab,int *ldab,float *d,float *e, MKL_Complex8 *q,int *ldq, MKL_Complex8 *work,int *info);
void    CHECON(char *uplo,int *n, MKL_Complex8 *a,int *lda,int *ipiv,float *anorm,float *rcond, MKL_Complex8 *work,int *info);
void    checon(char *uplo,int *n, MKL_Complex8 *a,int *lda,int *ipiv,float *anorm,float *rcond, MKL_Complex8 *work,int *info);
void    CHEEV(char *jobz,char *uplo,int *n, MKL_Complex8 *a,int *lda,float *w, MKL_Complex8 *work,int *lwork,float *rwork,int *info);
void    cheev(char *jobz,char *uplo,int *n, MKL_Complex8 *a,int *lda,float *w, MKL_Complex8 *work,int *lwork,float *rwork,int *info);
void    CHEEVD(char *jobz,char *uplo,int *n, MKL_Complex8 *a,int *lda,float *w, MKL_Complex8 *work,int *lwork,float *rwork,int *lrwork,int *iwork,int *liwork,int *info);
void    cheevd(char *jobz,char *uplo,int *n, MKL_Complex8 *a,int *lda,float *w, MKL_Complex8 *work,int *lwork,float *rwork,int *lrwork,int *iwork,int *liwork,int *info);
void    CHEEVR(char *jobz,char *range,char *uplo,int *n, MKL_Complex8 *a,int *lda,float *vl,float *vu,int *il,int *iu,float *abstol,int *m,float *w, MKL_Complex8 *z,int *ldz,int *isuppz, MKL_Complex8 *work,int *lwork,float *rwork,int *lrwork,int *iwork,int *liwork,int *info);
void    cheevr(char *jobz,char *range,char *uplo,int *n, MKL_Complex8 *a,int *lda,float *vl,float *vu,int *il,int *iu,float *abstol,int *m,float *w, MKL_Complex8 *z,int *ldz,int *isuppz, MKL_Complex8 *work,int *lwork,float *rwork,int *lrwork,int *iwork,int *liwork,int *info);
void    CHEEVX(char *jobz,char *range,char *uplo,int *n, MKL_Complex8 *a,int *lda,float *vl,float *vu,int *il,int *iu,float *abstol,int *m,float *w, MKL_Complex8 *z,int *ldz, MKL_Complex8 *work,int *lwork,float *rwork,int *iwork,int *ifail,int *info);
void    cheevx(char *jobz,char *range,char *uplo,int *n, MKL_Complex8 *a,int *lda,float *vl,float *vu,int *il,int *iu,float *abstol,int *m,float *w, MKL_Complex8 *z,int *ldz, MKL_Complex8 *work,int *lwork,float *rwork,int *iwork,int *ifail,int *info);
void    CHEGS2(int *itype,char *uplo,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb,int *info);
void    chegs2(int *itype,char *uplo,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb,int *info);
void    CHEGST(int *itype,char *uplo,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb,int *info);
void    chegst(int *itype,char *uplo,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb,int *info);
void    CHEGV(int *itype,char *jobz,char *uplo,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb,float *w, MKL_Complex8 *work,int *lwork,float *rwork,int *info);
void    chegv(int *itype,char *jobz,char *uplo,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb,float *w, MKL_Complex8 *work,int *lwork,float *rwork,int *info);
void    CHEGVD(int *itype,char *jobz,char *uplo,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb,float *w, MKL_Complex8 *work,int *lwork,float *rwork,int *lrwork,int *iwork,int *liwork,int *info);
void    chegvd(int *itype,char *jobz,char *uplo,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb,float *w, MKL_Complex8 *work,int *lwork,float *rwork,int *lrwork,int *iwork,int *liwork,int *info);
void    CHEGVX(int *itype,char *jobz,char *range,char *uplo,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb,float *vl,float *vu,int *il,int *iu,float *abstol,int *m,float *w, MKL_Complex8 *z,int *ldz, MKL_Complex8 *work,int *lwork,float *rwork,int *iwork,int *ifail,int *info);
void    chegvx(int *itype,char *jobz,char *range,char *uplo,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb,float *vl,float *vu,int *il,int *iu,float *abstol,int *m,float *w, MKL_Complex8 *z,int *ldz, MKL_Complex8 *work,int *lwork,float *rwork,int *iwork,int *ifail,int *info);
void    CHERFS(char *uplo,int *n,int *nrhs, MKL_Complex8 *a,int *lda, MKL_Complex8 *af,int *ldaf,int *ipiv, MKL_Complex8 *b,int *ldb, MKL_Complex8 *x,int *ldx,float *ferr,float *berr, MKL_Complex8 *work,float *rwork,int *info);
void    cherfs(char *uplo,int *n,int *nrhs, MKL_Complex8 *a,int *lda, MKL_Complex8 *af,int *ldaf,int *ipiv, MKL_Complex8 *b,int *ldb, MKL_Complex8 *x,int *ldx,float *ferr,float *berr, MKL_Complex8 *work,float *rwork,int *info);
void    CHESV(char *uplo,int *n,int *nrhs, MKL_Complex8 *a,int *lda,int *ipiv, MKL_Complex8 *b,int *ldb, MKL_Complex8 *work,int *lwork,int *info);
void    chesv(char *uplo,int *n,int *nrhs, MKL_Complex8 *a,int *lda,int *ipiv, MKL_Complex8 *b,int *ldb, MKL_Complex8 *work,int *lwork,int *info);
void    CHESVX(char *fact,char *uplo,int *n,int *nrhs, MKL_Complex8 *a,int *lda, MKL_Complex8 *af,int *ldaf,int *ipiv, MKL_Complex8 *b,int *ldb, MKL_Complex8 *x,int *ldx,float *rcond,float *ferr,float *berr, MKL_Complex8 *work,int *lwork,float *rwork,int *info);
void    chesvx(char *fact,char *uplo,int *n,int *nrhs, MKL_Complex8 *a,int *lda, MKL_Complex8 *af,int *ldaf,int *ipiv, MKL_Complex8 *b,int *ldb, MKL_Complex8 *x,int *ldx,float *rcond,float *ferr,float *berr, MKL_Complex8 *work,int *lwork,float *rwork,int *info);
void    CHETD2(char *uplo,int *n, MKL_Complex8 *a,int *lda,float *d,float *e, MKL_Complex8 *tau,int *info);
void    chetd2(char *uplo,int *n, MKL_Complex8 *a,int *lda,float *d,float *e, MKL_Complex8 *tau,int *info);
void    CHETF2(char *uplo,int *n, MKL_Complex8 *a,int *lda,int *ipiv,int *info);
void    chetf2(char *uplo,int *n, MKL_Complex8 *a,int *lda,int *ipiv,int *info);
void    CHETRD(char *uplo,int *n, MKL_Complex8 *a,int *lda,float *d,float *e, MKL_Complex8 *tau, MKL_Complex8 *work,int *lwork,int *info);
void    chetrd(char *uplo,int *n, MKL_Complex8 *a,int *lda,float *d,float *e, MKL_Complex8 *tau, MKL_Complex8 *work,int *lwork,int *info);
void    CHETRF(char *uplo,int *n, MKL_Complex8 *a,int *lda,int *ipiv, MKL_Complex8 *work,int *lwork,int *info);
void    chetrf(char *uplo,int *n, MKL_Complex8 *a,int *lda,int *ipiv, MKL_Complex8 *work,int *lwork,int *info);
void    CHETRI(char *uplo,int *n,float *a,int *lda,int *ipiv,float *work,int *info);
void    chetri(char *uplo,int *n,float *a,int *lda,int *ipiv,float *work,int *info);
void    CHETRS(char *uplo,int *n,int *nrhs, MKL_Complex8 *a,int *lda,int *ipiv, MKL_Complex8 *b,int *ldb,int *info);
void    chetrs(char *uplo,int *n,int *nrhs, MKL_Complex8 *a,int *lda,int *ipiv, MKL_Complex8 *b,int *ldb,int *info);
void    CHGEQZ(char *job,char *compq,char *compz,int *n,int *ilo,int *ihi, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb, MKL_Complex8 *alpha, MKL_Complex8 *beta, MKL_Complex8 *q,int *ldq, MKL_Complex8 *z,int *ldz, MKL_Complex8 *work,int *lwork,float *rwork,int *info);
void    chgeqz(char *job,char *compq,char *compz,int *n,int *ilo,int *ihi, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb, MKL_Complex8 *alpha, MKL_Complex8 *beta, MKL_Complex8 *q,int *ldq, MKL_Complex8 *z,int *ldz, MKL_Complex8 *work,int *lwork,float *rwork,int *info);
void    CHPCON(char *uplo,int *n, MKL_Complex8 *ap,int *ipiv,float *anorm,float *rcond, MKL_Complex8 *work,int *info);
void    chpcon(char *uplo,int *n, MKL_Complex8 *ap,int *ipiv,float *anorm,float *rcond, MKL_Complex8 *work,int *info);
void    CHPEV(char *jobz,char *uplo,int *n, MKL_Complex8 *ap,float *w, MKL_Complex8 *z,int *ldz, MKL_Complex8 *work,float *rwork,int *info);
void    chpev(char *jobz,char *uplo,int *n, MKL_Complex8 *ap,float *w, MKL_Complex8 *z,int *ldz, MKL_Complex8 *work,float *rwork,int *info);
void    CHPEVD(char *jobz,char *uplo,int *n, MKL_Complex8 *ap,float *w, MKL_Complex8 *z,int *ldz, MKL_Complex8 *work,int *lwork,float *rwork,int *lrwork,int *iwork,int *liwork,int *info);
void    chpevd(char *jobz,char *uplo,int *n, MKL_Complex8 *ap,float *w, MKL_Complex8 *z,int *ldz, MKL_Complex8 *work,int *lwork,float *rwork,int *lrwork,int *iwork,int *liwork,int *info);
void    CHPEVX(char *jobz,char *range,char *uplo,int *n, MKL_Complex8 *ap,float *vl,float *vu,int *il,int *iu,float *abstol,int *m,float *w, MKL_Complex8 *z,int *ldz, MKL_Complex8 *work,float *rwork,int *iwork,int *ifail,int *info);
void    chpevx(char *jobz,char *range,char *uplo,int *n, MKL_Complex8 *ap,float *vl,float *vu,int *il,int *iu,float *abstol,int *m,float *w, MKL_Complex8 *z,int *ldz, MKL_Complex8 *work,float *rwork,int *iwork,int *ifail,int *info);
void    CHPGST(int *itype,char *uplo,int *n, MKL_Complex8 *ap, MKL_Complex8 *bp,int *info);
void    chpgst(int *itype,char *uplo,int *n, MKL_Complex8 *ap, MKL_Complex8 *bp,int *info);
void    CHPGV(int *itype,char *jobz,char *uplo,int *n, MKL_Complex8 *ap, MKL_Complex8 *bp,float *w, MKL_Complex8 *z,int *ldz, MKL_Complex8 *work,float *rwork,int *info);
void    chpgv(int *itype,char *jobz,char *uplo,int *n, MKL_Complex8 *ap, MKL_Complex8 *bp,float *w, MKL_Complex8 *z,int *ldz, MKL_Complex8 *work,float *rwork,int *info);
void    CHPGVD(int *itype,char *jobz,char *uplo,int *n, MKL_Complex8 *ap, MKL_Complex8 *bp,float *w, MKL_Complex8 *z,int *ldz, MKL_Complex8 *work,int *lwork,float *rwork,int *lrwork,int *iwork,int *liwork,int *info);
void    chpgvd(int *itype,char *jobz,char *uplo,int *n, MKL_Complex8 *ap, MKL_Complex8 *bp,float *w, MKL_Complex8 *z,int *ldz, MKL_Complex8 *work,int *lwork,float *rwork,int *lrwork,int *iwork,int *liwork,int *info);
void    CHPGVX(int *itype,char *jobz,char *range,char *uplo,int *n, MKL_Complex8 *ap, MKL_Complex8 *bp,float *vl,float *vu,int *il,int *iu,float *abstol,int *m,float *w, MKL_Complex8 *z,int *ldz, MKL_Complex8 *work,float *rwork,int *iwork,int *ifail,int *info);
void    chpgvx(int *itype,char *jobz,char *range,char *uplo,int *n, MKL_Complex8 *ap, MKL_Complex8 *bp,float *vl,float *vu,int *il,int *iu,float *abstol,int *m,float *w, MKL_Complex8 *z,int *ldz, MKL_Complex8 *work,float *rwork,int *iwork,int *ifail,int *info);
void    CHPRFS(char *uplo,int *n,int *nrhs, MKL_Complex8 *ap, MKL_Complex8 *afp,int *ipiv, MKL_Complex8 *b,int *ldb, MKL_Complex8 *x,int *ldx,float *ferr,float *berr, MKL_Complex8 *work,float *rwork,int *info);
void    chprfs(char *uplo,int *n,int *nrhs, MKL_Complex8 *ap, MKL_Complex8 *afp,int *ipiv, MKL_Complex8 *b,int *ldb, MKL_Complex8 *x,int *ldx,float *ferr,float *berr, MKL_Complex8 *work,float *rwork,int *info);
void    CHPSV(char *uplo,int *n,int *nrhs, MKL_Complex8 *ap,int *ipiv, MKL_Complex8 *b,int *ldb,int *info);
void    chpsv(char *uplo,int *n,int *nrhs, MKL_Complex8 *ap,int *ipiv, MKL_Complex8 *b,int *ldb,int *info);
void    CHPSVX(char *fact,char *uplo,int *n,int *nrhs, MKL_Complex8 *ap, MKL_Complex8 *afp,int *ipiv, MKL_Complex8 *b,int *ldb, MKL_Complex8 *x,int *ldx,float *rcond,float *ferr,float *berr, MKL_Complex8 *work,float *rwork,int *info);
void    chpsvx(char *fact,char *uplo,int *n,int *nrhs, MKL_Complex8 *ap, MKL_Complex8 *afp,int *ipiv, MKL_Complex8 *b,int *ldb, MKL_Complex8 *x,int *ldx,float *rcond,float *ferr,float *berr, MKL_Complex8 *work,float *rwork,int *info);
void    CHPTRD(char *uplo,int *n, MKL_Complex8 *ap,float *d,float *e, MKL_Complex8 *tau,int *info);
void    chptrd(char *uplo,int *n, MKL_Complex8 *ap,float *d,float *e, MKL_Complex8 *tau,int *info);
void    CHPTRF(char *uplo,int *n, MKL_Complex8 *ap,int *ipiv,int *info);
void    chptrf(char *uplo,int *n, MKL_Complex8 *ap,int *ipiv,int *info);
void    CHPTRI(char *uplo,int *n,float *ap,int *ipiv,float *work,int *info);
void    chptri(char *uplo,int *n,float *ap,int *ipiv,float *work,int *info);
void    CHPTRS(char *uplo,int *n,int *nrhs, MKL_Complex8 *ap,int *ipiv, MKL_Complex8 *b,int *ldb,int *info);
void    chptrs(char *uplo,int *n,int *nrhs, MKL_Complex8 *ap,int *ipiv, MKL_Complex8 *b,int *ldb,int *info);
void    CHSEIN(char *side,char *eigsrc,char *initv,void *select,int *n, MKL_Complex8 *h,int *ldh, MKL_Complex8 *w, MKL_Complex8 *vl,int *ldvl, MKL_Complex8 *vr,int *ldvr,int *mm,int *m, MKL_Complex8 *work,float *rwork,int *ifaill,int *ifailr,int *info);
void    chsein(char *side,char *eigsrc,char *initv,void *select,int *n, MKL_Complex8 *h,int *ldh, MKL_Complex8 *w, MKL_Complex8 *vl,int *ldvl, MKL_Complex8 *vr,int *ldvr,int *mm,int *m, MKL_Complex8 *work,float *rwork,int *ifaill,int *ifailr,int *info);
void    CHSEQR(char *job,char *compz,int *n,int *ilo,int *ihi, MKL_Complex8 *h,int *ldh, MKL_Complex8 *w, MKL_Complex8 *z,int *ldz, MKL_Complex8 *work,int *lwork,int *info);
void    chseqr(char *job,char *compz,int *n,int *ilo,int *ihi, MKL_Complex8 *h,int *ldh, MKL_Complex8 *w, MKL_Complex8 *z,int *ldz, MKL_Complex8 *work,int *lwork,int *info);
void    CLABRD(int *m,int *n,int *nb, MKL_Complex8 *a,int *lda,float *d,float *e, MKL_Complex8 *tauq, MKL_Complex8 *taup, MKL_Complex8 *x,int *ldx, MKL_Complex8 *y,int *ldy);
void    clabrd(int *m,int *n,int *nb, MKL_Complex8 *a,int *lda,float *d,float *e, MKL_Complex8 *tauq, MKL_Complex8 *taup, MKL_Complex8 *x,int *ldx, MKL_Complex8 *y,int *ldy);
void    CLACGV(int *n, MKL_Complex8 *x,int *incx);
void    clacgv(int *n, MKL_Complex8 *x,int *incx);
void    CLACON(int *n, MKL_Complex8 *v,float *x,float *est,int *kase);
void    clacon(int *n, MKL_Complex8 *v,float *x,float *est,int *kase);
void    CLACP2(char *uplo,int *m,int *n,float *a,int *lda, MKL_Complex8 *b,int *ldb);
void    clacp2(char *uplo,int *m,int *n,float *a,int *lda, MKL_Complex8 *b,int *ldb);
void    CLACPY(char *uplo,int *m,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb);
void    clacpy(char *uplo,int *m,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb);
void    CLACRM(int *m,int *n, MKL_Complex8 *a,int *lda,float *b,int *ldb, MKL_Complex8 *c,int *ldc,float *rwork);
void    clacrm(int *m,int *n, MKL_Complex8 *a,int *lda,float *b,int *ldb, MKL_Complex8 *c,int *ldc,float *rwork);
void    CLACRT(int *n, MKL_Complex8 *cx,int *incx, MKL_Complex8 *cy,int *incy, MKL_Complex8 *c, MKL_Complex8 *s);
void    clacrt(int *n, MKL_Complex8 *cx,int *incx, MKL_Complex8 *cy,int *incy, MKL_Complex8 *c, MKL_Complex8 *s);
void    CLADIV( MKL_Complex8 *pres, MKL_Complex8 *x, MKL_Complex8 *y);
void    cladiv( MKL_Complex8 *pres, MKL_Complex8 *x, MKL_Complex8 *y);
void    CLAED0(int *qsiz,int *n,float *d,float *e, MKL_Complex8 *q,int *ldq, MKL_Complex8 *qstore,int *ldqs,float *rwork,int *iwork,int *info);
void    claed0(int *qsiz,int *n,float *d,float *e, MKL_Complex8 *q,int *ldq, MKL_Complex8 *qstore,int *ldqs,float *rwork,int *iwork,int *info);
void    CLAED7(int *n,int *cutpnt,int *qsiz,int *tlvls,int *curlvl,int *curpbm,float *d, MKL_Complex8 *q,int *ldq,float *rho,int *indxq,float *qstore,int *qptr,int *prmptr,int *perm,int *givptr,int *givcol,float *givnum, MKL_Complex8 *work,float *rwork,int *iwork,int *info);
void    claed7(int *n,int *cutpnt,int *qsiz,int *tlvls,int *curlvl,int *curpbm,float *d, MKL_Complex8 *q,int *ldq,float *rho,int *indxq,float *qstore,int *qptr,int *prmptr,int *perm,int *givptr,int *givcol,float *givnum, MKL_Complex8 *work,float *rwork,int *iwork,int *info);
void    CLAED8(int *k,int *n,int *qsiz, MKL_Complex8 *q,int *ldq,float *d,float *rho,int *cutpnt,float *z,float *dlamda, MKL_Complex8 *q2,int *ldq2,float *w,int *indxp,int *indx,int *indxq,int *perm,int *givptr,int *givcol,float *givnum,int *info);
void    claed8(int *k,int *n,int *qsiz, MKL_Complex8 *q,int *ldq,float *d,float *rho,int *cutpnt,float *z,float *dlamda, MKL_Complex8 *q2,int *ldq2,float *w,int *indxp,int *indx,int *indxq,int *perm,int *givptr,int *givcol,float *givnum,int *info);
void    CLAEIN(void *rightv,void *noinit,int *n, MKL_Complex8 *h,int *ldh, MKL_Complex8 *w, MKL_Complex8 *v, MKL_Complex8 *b,int *ldb,float *rwork,float *eps3,float *smlnum,int *info);
void    claein(void *rightv,void *noinit,int *n, MKL_Complex8 *h,int *ldh, MKL_Complex8 *w, MKL_Complex8 *v, MKL_Complex8 *b,int *ldb,float *rwork,float *eps3,float *smlnum,int *info);
void    CLAESY( MKL_Complex8 *a, MKL_Complex8 *b, MKL_Complex8 *c, MKL_Complex8 *rt1, MKL_Complex8 *rt2, MKL_Complex8 *evscal, MKL_Complex8 *cs1, MKL_Complex8 *sn1);
void    claesy( MKL_Complex8 *a, MKL_Complex8 *b, MKL_Complex8 *c, MKL_Complex8 *rt1, MKL_Complex8 *rt2, MKL_Complex8 *evscal, MKL_Complex8 *cs1, MKL_Complex8 *sn1);
void    CLAEV2( MKL_Complex8 *a, MKL_Complex8 *b, MKL_Complex8 *c,float *rt1,float *rt2,float *cs1, MKL_Complex8 *sn1);
void    claev2( MKL_Complex8 *a, MKL_Complex8 *b, MKL_Complex8 *c,float *rt1,float *rt2,float *cs1, MKL_Complex8 *sn1);
void    CLAGS2(void *upper,float *a1, MKL_Complex8 *a2,float *a3,float *b1, MKL_Complex8 *b2,float *b3,float *csu, MKL_Complex8 *snu,float *csv, MKL_Complex8 *snv,float *csq, MKL_Complex8 *snq);
void    clags2(void *upper,float *a1, MKL_Complex8 *a2,float *a3,float *b1, MKL_Complex8 *b2,float *b3,float *csu, MKL_Complex8 *snu,float *csv, MKL_Complex8 *snv,float *csq, MKL_Complex8 *snq);
void    CLAGTM(char *trans,int *n,int *nrhs,float *alpha, MKL_Complex8 *dl, MKL_Complex8 *d, MKL_Complex8 *du, MKL_Complex8 *x,int *ldx,float *beta, MKL_Complex8 *b,int *ldb);
void    clagtm(char *trans,int *n,int *nrhs,float *alpha, MKL_Complex8 *dl, MKL_Complex8 *d, MKL_Complex8 *du, MKL_Complex8 *x,int *ldx,float *beta, MKL_Complex8 *b,int *ldb);
void    CLAHEF(char *uplo,int *n,int *nb,int *kb, MKL_Complex8 *a,int *lda,int *ipiv, MKL_Complex8 *w,int *ldw,int *info);
void    clahef(char *uplo,int *n,int *nb,int *kb, MKL_Complex8 *a,int *lda,int *ipiv, MKL_Complex8 *w,int *ldw,int *info);
void    CLAHQR(void *wantt,void *wantz,int *n,int *ilo,int *ihi,float *h,int *ldh, MKL_Complex8 *w,int *iloz,int *ihiz, MKL_Complex8 *z,int *ldz,int *info);
void    clahqr(void *wantt,void *wantz,int *n,int *ilo,int *ihi,float *h,int *ldh, MKL_Complex8 *w,int *iloz,int *ihiz, MKL_Complex8 *z,int *ldz,int *info);
void    CLAHRD(int *n,int *k,int *nb, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *t,int *ldt, MKL_Complex8 *y,int *ldy);
void    clahrd(int *n,int *k,int *nb, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *t,int *ldt, MKL_Complex8 *y,int *ldy);
void    CLAIC1(int *job,int *j, MKL_Complex8 *x,float *sest, MKL_Complex8 *w, MKL_Complex8 *gamma,float *sestpr, MKL_Complex8 *s, MKL_Complex8 *c);
void    claic1(int *job,int *j, MKL_Complex8 *x,float *sest, MKL_Complex8 *w, MKL_Complex8 *gamma,float *sestpr, MKL_Complex8 *s, MKL_Complex8 *c);
void    CLALS0(int *icompq,int *nl,int *nr,int *sqre,int *nrhs, MKL_Complex8 *b,int *ldb, MKL_Complex8 *bx,int *ldbx,int *perm,int *givptr,int *givcol,int *ldgcol,float *givnum,int *ldgnum,float *poles,float *difl,float *difr,float *z,float *k,float *c,float *s,float *rwork,int *info);
void    clals0(int *icompq,int *nl,int *nr,int *sqre,int *nrhs, MKL_Complex8 *b,int *ldb, MKL_Complex8 *bx,int *ldbx,int *perm,int *givptr,int *givcol,int *ldgcol,float *givnum,int *ldgnum,float *poles,float *difl,float *difr,float *z,float *k,float *c,float *s,float *rwork,int *info);
void    CLALSA(int *icompq,int *smlsiz,int *n,int *nrhs, MKL_Complex8 *b,int *ldb, MKL_Complex8 *bx,int *ldbx,float *u,int *ldu,float *vt,float *k,float *difl,float *difr,float *z,float *poles,int *givptr,int *givcol,int *ldgcol,int *perm,float *givnum,float *c,float *s,float *rwork,int *iwork,int *info);
void    clalsa(int *icompq,int *smlsiz,int *n,int *nrhs, MKL_Complex8 *b,int *ldb, MKL_Complex8 *bx,int *ldbx,float *u,int *ldu,float *vt,float *k,float *difl,float *difr,float *z,float *poles,int *givptr,int *givcol,int *ldgcol,int *perm,float *givnum,float *c,float *s,float *rwork,int *iwork,int *info);
void    CLALSD(char *uplo,int *smlsiz,int *n,int *nrhs,float *d,float *e, MKL_Complex8 *b,int *ldb,float *rcond,int *rank, MKL_Complex8 *work,float *rwork,int *iwork,int *info);
void    clalsd(char *uplo,int *smlsiz,int *n,int *nrhs,float *d,float *e, MKL_Complex8 *b,int *ldb,float *rcond,int *rank, MKL_Complex8 *work,float *rwork,int *iwork,int *info);
float   CLANGB(char *norm,int *n,int *kl,int *ku, MKL_Complex8 *ab,int *ldab,float *work);
float   clangb(char *norm,int *n,int *kl,int *ku, MKL_Complex8 *ab,int *ldab,float *work);
float   CLANGE(char *norm,int *m,int *n, MKL_Complex8 *a,int *lda,float *work);
float   clange(char *norm,int *m,int *n, MKL_Complex8 *a,int *lda,float *work);
float   CLANGT(char *norm,int *n, MKL_Complex8 *dl, MKL_Complex8 *d, MKL_Complex8 *du);
float   clangt(char *norm,int *n, MKL_Complex8 *dl, MKL_Complex8 *d, MKL_Complex8 *du);
float   CLANHB(char *norm,char *uplo,int *n,int *k, MKL_Complex8 *ab,int *ldab,float *work);
float   clanhb(char *norm,char *uplo,int *n,int *k, MKL_Complex8 *ab,int *ldab,float *work);
float   CLANHE(char *norm,char *uplo,int *n, MKL_Complex8 *a,int *lda,float *work);
float   clanhe(char *norm,char *uplo,int *n, MKL_Complex8 *a,int *lda,float *work);
float   CLANHP(char *norm,char *uplo,int *n, MKL_Complex8 *ap,float *work);
float   clanhp(char *norm,char *uplo,int *n, MKL_Complex8 *ap,float *work);
float   CLANHS(char *norm,int *n, MKL_Complex8 *a,int *lda,float *work);
float   clanhs(char *norm,int *n, MKL_Complex8 *a,int *lda,float *work);
float   CLANHT(char *norm,int *n,float *d, MKL_Complex8 *e);
float   clanht(char *norm,int *n,float *d, MKL_Complex8 *e);
float   CLANSB(char *norm,char *uplo,int *n,int *k, MKL_Complex8 *ab,int *ldab,float *work);
float   clansb(char *norm,char *uplo,int *n,int *k, MKL_Complex8 *ab,int *ldab,float *work);
float   CLANSP(char *norm,char *uplo,int *n, MKL_Complex8 *ap,float *work);
float   clansp(char *norm,char *uplo,int *n, MKL_Complex8 *ap,float *work);
float   CLANSY(char *norm,char *uplo,int *n, MKL_Complex8 *a,int *lda,float *work);
float   clansy(char *norm,char *uplo,int *n, MKL_Complex8 *a,int *lda,float *work);
float   CLANTB(char *norm,char *uplo,char *diag,int *n,int *k, MKL_Complex8 *ab,int *ldab,float *work);
float   clantb(char *norm,char *uplo,char *diag,int *n,int *k, MKL_Complex8 *ab,int *ldab,float *work);
float   CLANTP(char *norm,char *uplo,char *diag,int *n, MKL_Complex8 *ap,float *work);
float   clantp(char *norm,char *uplo,char *diag,int *n, MKL_Complex8 *ap,float *work);
float   CLANTR(char *norm,char *uplo,char *diag,int *m,int *n, MKL_Complex8 *a,int *lda,float *work);
float   clantr(char *norm,char *uplo,char *diag,int *m,int *n, MKL_Complex8 *a,int *lda,float *work);
void    CLAPLL(int *n, MKL_Complex8 *x,int *incx, MKL_Complex8 *y,int *incy,float *ssmin);
void    clapll(int *n, MKL_Complex8 *x,int *incx, MKL_Complex8 *y,int *incy,float *ssmin);
void    CLAPMT(void *forwrd,int *m,int *n, MKL_Complex8 *x,int *ldx,int *k);
void    clapmt(void *forwrd,int *m,int *n, MKL_Complex8 *x,int *ldx,int *k);
void    CLAQGB(int *m,int *n,int *kl,int *ku, MKL_Complex8 *ab,int *ldab,float *r,float *c,float *rowcnd,float *colcnd,float *amax,char *equed);
void    claqgb(int *m,int *n,int *kl,int *ku, MKL_Complex8 *ab,int *ldab,float *r,float *c,float *rowcnd,float *colcnd,float *amax,char *equed);
void    CLAQGE(int *m,int *n, MKL_Complex8 *a,int *lda,float *r,float *c,float *rowcnd,float *colcnd,float *amax,char *equed);
void    claqge(int *m,int *n, MKL_Complex8 *a,int *lda,float *r,float *c,float *rowcnd,float *colcnd,float *amax,char *equed);
void    CLAQHB(char *uplo,int *n,int *kd, MKL_Complex8 *ab,int *ldab,float *s,float *scond,float *amax,char *equed);
void    claqhb(char *uplo,int *n,int *kd, MKL_Complex8 *ab,int *ldab,float *s,float *scond,float *amax,char *equed);
void    CLAQHE(char *uplo,int *n, MKL_Complex8 *a,int *lda,float *s,float *scond,float *amax,char *equed);
void    claqhe(char *uplo,int *n, MKL_Complex8 *a,int *lda,float *s,float *scond,float *amax,char *equed);
void    CLAQHP(char *uplo,int *n, MKL_Complex8 *ap,float *s,float *scond,float *amax,char *equed);
void    claqhp(char *uplo,int *n, MKL_Complex8 *ap,float *s,float *scond,float *amax,char *equed);
void    CLAQP2(int *m,int *n,int *offset, MKL_Complex8 *a,int *lda,int *jpvt, MKL_Complex8 *tau,float *vn1,float *vn2, MKL_Complex8 *work);
void    claqp2(int *m,int *n,int *offset, MKL_Complex8 *a,int *lda,int *jpvt, MKL_Complex8 *tau,float *vn1,float *vn2, MKL_Complex8 *work);
void    CLAQPS(int *m,int *n,int *offset,int *nb,int *kb, MKL_Complex8 *a,int *lda,int *jpvt, MKL_Complex8 *tau,float *vn1,float *vn2, MKL_Complex8 *auxv, MKL_Complex8 *f,int *ldf);
void    claqps(int *m,int *n,int *offset,int *nb,int *kb, MKL_Complex8 *a,int *lda,int *jpvt, MKL_Complex8 *tau,float *vn1,float *vn2, MKL_Complex8 *auxv, MKL_Complex8 *f,int *ldf);
void    CLAQSB(char *uplo,int *n,int *kd, MKL_Complex8 *ab,int *ldab,float *s,float *scond,float *amax,char *equed);
void    claqsb(char *uplo,int *n,int *kd, MKL_Complex8 *ab,int *ldab,float *s,float *scond,float *amax,char *equed);
void    CLAQSP(char *uplo,int *n, MKL_Complex8 *ap,float *s,float *scond,float *amax,char *equed);
void    claqsp(char *uplo,int *n, MKL_Complex8 *ap,float *s,float *scond,float *amax,char *equed);
void    CLAQSY(char *uplo,int *n, MKL_Complex8 *a,int *lda,float *s,float *scond,float *amax,char *equed);
void    claqsy(char *uplo,int *n, MKL_Complex8 *a,int *lda,float *s,float *scond,float *amax,char *equed);
void    CLAR1V(int *n,int *b1,int *bn,float *sigma,float *d,float *l,float *ld,float *lld,float *gersch, MKL_Complex8 *z,float *ztz,float *mingma,int *r,int *isuppz,float *work);
void    clar1v(int *n,int *b1,int *bn,float *sigma,float *d,float *l,float *ld,float *lld,float *gersch, MKL_Complex8 *z,float *ztz,float *mingma,int *r,int *isuppz,float *work);
void    CLAR2V(int *n, MKL_Complex8 *x, MKL_Complex8 *y, MKL_Complex8 *z,int *incx,float *c, MKL_Complex8 *s,int *incc);
void    clar2v(int *n, MKL_Complex8 *x, MKL_Complex8 *y, MKL_Complex8 *z,int *incx,float *c, MKL_Complex8 *s,int *incc);
void    CLARCM(int *m,int *n,float *a,int *lda, MKL_Complex8 *b,int *ldb, MKL_Complex8 *c,int *ldc,float *rwork);
void    clarcm(int *m,int *n,float *a,int *lda, MKL_Complex8 *b,int *ldb, MKL_Complex8 *c,int *ldc,float *rwork);
void    CLARF(char *side,int *m,int *n, MKL_Complex8 *v,int *incv, MKL_Complex8 *tau, MKL_Complex8 *c,int *ldc, MKL_Complex8 *work);
void    clarf(char *side,int *m,int *n, MKL_Complex8 *v,int *incv, MKL_Complex8 *tau, MKL_Complex8 *c,int *ldc, MKL_Complex8 *work);
void    CLARFB(char *side,char *trans,char *direct,char *storev,int *m,int *n,int *k, MKL_Complex8 *v,int *ldv, MKL_Complex8 *t,int *ldt, MKL_Complex8 *c,int *ldc, MKL_Complex8 *work,int *ldwork);
void    clarfb(char *side,char *trans,char *direct,char *storev,int *m,int *n,int *k, MKL_Complex8 *v,int *ldv, MKL_Complex8 *t,int *ldt, MKL_Complex8 *c,int *ldc, MKL_Complex8 *work,int *ldwork);
void    CLARFG(int *n, MKL_Complex8 *alpha, MKL_Complex8 *x,int *incx, MKL_Complex8 *tau);
void    clarfg(int *n, MKL_Complex8 *alpha, MKL_Complex8 *x,int *incx, MKL_Complex8 *tau);
void    CLARFT(char *direct,char *storev,int *n,int *k, MKL_Complex8 *v,int *ldv, MKL_Complex8 *tau, MKL_Complex8 *t,int *ldt);
void    clarft(char *direct,char *storev,int *n,int *k, MKL_Complex8 *v,int *ldv, MKL_Complex8 *tau, MKL_Complex8 *t,int *ldt);
void    CLARFX(char *side,int *m,int *n, MKL_Complex8 *v, MKL_Complex8 *tau, MKL_Complex8 *c,int *ldc, MKL_Complex8 *work);
void    clarfx(char *side,int *m,int *n, MKL_Complex8 *v, MKL_Complex8 *tau, MKL_Complex8 *c,int *ldc, MKL_Complex8 *work);
void    CLARGV(int *n, MKL_Complex8 *x,int *incx, MKL_Complex8 *y,int *incy,float *c,int *incc);
void    clargv(int *n, MKL_Complex8 *x,int *incx, MKL_Complex8 *y,int *incy,float *c,int *incc);
void    CLARNV(int *idist,int *iseed,int *n, MKL_Complex8 *x);
void    clarnv(int *idist,int *iseed,int *n, MKL_Complex8 *x);
void    CLARRV(int *n,float *d,float *l,int *isplit,int *m,float *w,int *iblock,float *gersch,float *tol, MKL_Complex8 *z,int *ldz,int *isuppz,float *work,int *iwork,int *info);
void    clarrv(int *n,float *d,float *l,int *isplit,int *m,float *w,int *iblock,float *gersch,float *tol, MKL_Complex8 *z,int *ldz,int *isuppz,float *work,int *iwork,int *info);
void    CLARTG( MKL_Complex8 *f, MKL_Complex8 *g,float *cs, MKL_Complex8 *sn, MKL_Complex8 *r);
void    clartg( MKL_Complex8 *f, MKL_Complex8 *g,float *cs, MKL_Complex8 *sn, MKL_Complex8 *r);
void    CLARTV(int *n, MKL_Complex8 *x,int *incx, MKL_Complex8 *y,int *incy,float *c, MKL_Complex8 *s,int *incc);
void    clartv(int *n, MKL_Complex8 *x,int *incx, MKL_Complex8 *y,int *incy,float *c, MKL_Complex8 *s,int *incc);
void    CLARZ(char *side,int *m,int *n,int *l, MKL_Complex8 *v,int *incv, MKL_Complex8 *tau, MKL_Complex8 *c,int *ldc, MKL_Complex8 *work);
void    clarz(char *side,int *m,int *n,int *l, MKL_Complex8 *v,int *incv, MKL_Complex8 *tau, MKL_Complex8 *c,int *ldc, MKL_Complex8 *work);
void    CLARZB(char *side,char *trans,char *direct,char *storev,int *m,int *n,int *k,int *l, MKL_Complex8 *v,int *ldv, MKL_Complex8 *t,int *ldt, MKL_Complex8 *c,int *ldc, MKL_Complex8 *work,int *ldwork);
void    clarzb(char *side,char *trans,char *direct,char *storev,int *m,int *n,int *k,int *l, MKL_Complex8 *v,int *ldv, MKL_Complex8 *t,int *ldt, MKL_Complex8 *c,int *ldc, MKL_Complex8 *work,int *ldwork);
void    CLARZT(char *direct,char *storev,int *n,int *k, MKL_Complex8 *v,int *ldv, MKL_Complex8 *tau, MKL_Complex8 *t,int *ldt);
void    clarzt(char *direct,char *storev,int *n,int *k, MKL_Complex8 *v,int *ldv, MKL_Complex8 *tau, MKL_Complex8 *t,int *ldt);
void    CLASCL(char *type,int *kl,int *ku,float *cfrom,float *cto,int *m,int *n, MKL_Complex8 *a,int *lda,int *info);
void    clascl(char *type,int *kl,int *ku,float *cfrom,float *cto,int *m,int *n, MKL_Complex8 *a,int *lda,int *info);
void    CLASET(char *uplo,int *m,int *n, MKL_Complex8 *alpha, MKL_Complex8 *beta, MKL_Complex8 *a,int *lda);
void    claset(char *uplo,int *m,int *n, MKL_Complex8 *alpha, MKL_Complex8 *beta, MKL_Complex8 *a,int *lda);
void    CLASR(char *side,char *pivot,char *direct,int *m,int *n,float *c,float *s, MKL_Complex8 *a,int *lda);
void    clasr(char *side,char *pivot,char *direct,int *m,int *n,float *c,float *s, MKL_Complex8 *a,int *lda);
void    CLASSQ(int *n, MKL_Complex8 *x,int *incx,float *scale,float *sumsq);
void    classq(int *n, MKL_Complex8 *x,int *incx,float *scale,float *sumsq);
void    CLASWP(int *n, MKL_Complex8 *a,int *lda,int *k1,int *k2,int *ipiv,int *incx);
void    claswp(int *n, MKL_Complex8 *a,int *lda,int *k1,int *k2,int *ipiv,int *incx);
void    CLASYF(char *uplo,int *n,int *nb,int *kb, MKL_Complex8 *a,int *lda,int *ipiv, MKL_Complex8 *w,int *ldw,int *info);
void    clasyf(char *uplo,int *n,int *nb,int *kb, MKL_Complex8 *a,int *lda,int *ipiv, MKL_Complex8 *w,int *ldw,int *info);
void    CLATBS(char *uplo,char *trans,char *diag,char *normin,int *n,int *kd, MKL_Complex8 *ab,int *ldab, MKL_Complex8 *x,float *scale,float *cnorm,int *info);
void    clatbs(char *uplo,char *trans,char *diag,char *normin,int *n,int *kd, MKL_Complex8 *ab,int *ldab, MKL_Complex8 *x,float *scale,float *cnorm,int *info);
void    CLATDF(int *ijob,int *n,float *z,int *ldz,float *rhs,float *rdsum,float *rdscal,int *ipiv,int *jpiv);
void    clatdf(int *ijob,int *n,float *z,int *ldz,float *rhs,float *rdsum,float *rdscal,int *ipiv,int *jpiv);
void    CLATPS(char *uplo,char *trans,char *diag,char *normin,int *n, MKL_Complex8 *ap, MKL_Complex8 *x,float *scale,float *cnorm,int *info);
void    clatps(char *uplo,char *trans,char *diag,char *normin,int *n, MKL_Complex8 *ap, MKL_Complex8 *x,float *scale,float *cnorm,int *info);
void    CLATRD(char *uplo,int *n,int *nb, MKL_Complex8 *a,int *lda,float *e, MKL_Complex8 *tau, MKL_Complex8 *w,int *ldw);
void    clatrd(char *uplo,int *n,int *nb, MKL_Complex8 *a,int *lda,float *e, MKL_Complex8 *tau, MKL_Complex8 *w,int *ldw);
void    CLATRS(char *uplo,char *trans,char *diag,char *normin,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *x,float *scale,float *cnorm,int *info);
void    clatrs(char *uplo,char *trans,char *diag,char *normin,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *x,float *scale,float *cnorm,int *info);
void    CLATRZ(int *m,int *n,int *l, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *work);
void    clatrz(int *m,int *n,int *l, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *work);
void    CLATZM(char *side,int *m,int *n, MKL_Complex8 *v,int *incv, MKL_Complex8 *tau, MKL_Complex8 *c1, MKL_Complex8 *c2,int *ldc, MKL_Complex8 *work);
void    clatzm(char *side,int *m,int *n, MKL_Complex8 *v,int *incv, MKL_Complex8 *tau, MKL_Complex8 *c1, MKL_Complex8 *c2,int *ldc, MKL_Complex8 *work);
void    CLAUU2(char *uplo,int *n,float *a,float *lda,int *info);
void    clauu2(char *uplo,int *n,float *a,float *lda,int *info);
void    CLAUUM(char *uplo,int *n, MKL_Complex8 *a,int *lda,int *info);
void    clauum(char *uplo,int *n, MKL_Complex8 *a,int *lda,int *info);
void    CPBCON(char *uplo,int *n,int *kd, MKL_Complex8 *ab,int *ldab,float *anorm,float *rcond, MKL_Complex8 *work,float *rwork,int *info);
void    cpbcon(char *uplo,int *n,int *kd, MKL_Complex8 *ab,int *ldab,float *anorm,float *rcond, MKL_Complex8 *work,float *rwork,int *info);
void    CPBEQU(char *uplo,int *n,int *kd, MKL_Complex8 *ab,int *ldab,float *s,float *scond,float *amax,int *info);
void    cpbequ(char *uplo,int *n,int *kd, MKL_Complex8 *ab,int *ldab,float *s,float *scond,float *amax,int *info);
void    CPBRFS(char *uplo,int *n,int *kd,int *nrhs, MKL_Complex8 *ab,int *ldab, MKL_Complex8 *afb,int *ldafb, MKL_Complex8 *b,int *ldb, MKL_Complex8 *x,int *ldx,float *ferr,float *berr, MKL_Complex8 *work,float *rwork,int *info);
void    cpbrfs(char *uplo,int *n,int *kd,int *nrhs, MKL_Complex8 *ab,int *ldab, MKL_Complex8 *afb,int *ldafb, MKL_Complex8 *b,int *ldb, MKL_Complex8 *x,int *ldx,float *ferr,float *berr, MKL_Complex8 *work,float *rwork,int *info);
void    CPBSTF(char *uplo,int *n,int *kd, MKL_Complex8 *ab,int *ldab,int *info);
void    cpbstf(char *uplo,int *n,int *kd, MKL_Complex8 *ab,int *ldab,int *info);
void    CPBSV(char *uplo,int *n,int *kd,int *nrhs, MKL_Complex8 *ab,int *ldab, MKL_Complex8 *b,int *ldb,int *info);
void    cpbsv(char *uplo,int *n,int *kd,int *nrhs, MKL_Complex8 *ab,int *ldab, MKL_Complex8 *b,int *ldb,int *info);
void    CPBSVX(char *fact,char *uplo,int *n,int *kd,int *nrhs, MKL_Complex8 *ab,int *ldab, MKL_Complex8 *afb,int *ldafb,char *equed,float *s, MKL_Complex8 *b,int *ldb, MKL_Complex8 *x,int *ldx,float *rcond,float *ferr,float *berr, MKL_Complex8 *work,float *rwork,int *info);
void    cpbsvx(char *fact,char *uplo,int *n,int *kd,int *nrhs, MKL_Complex8 *ab,int *ldab, MKL_Complex8 *afb,int *ldafb,char *equed,float *s, MKL_Complex8 *b,int *ldb, MKL_Complex8 *x,int *ldx,float *rcond,float *ferr,float *berr, MKL_Complex8 *work,float *rwork,int *info);
void    CPBTF2(char *uplo,int *n,int *kd, MKL_Complex8 *ab,int *ldab,int *info);
void    cpbtf2(char *uplo,int *n,int *kd, MKL_Complex8 *ab,int *ldab,int *info);
void    CPBTRF(char *uplo,int *n,int *kd, MKL_Complex8 *ab,int *ldab,int *info);
void    cpbtrf(char *uplo,int *n,int *kd, MKL_Complex8 *ab,int *ldab,int *info);
void    CPBTRS(char *uplo,int *n,int *kd,int *nrhs, MKL_Complex8 *ab,int *ldab, MKL_Complex8 *b,int *ldb,int *info);
void    cpbtrs(char *uplo,int *n,int *kd,int *nrhs, MKL_Complex8 *ab,int *ldab, MKL_Complex8 *b,int *ldb,int *info);
void    CPOCON(char *uplo,int *n, MKL_Complex8 *a,int *lda,float *anorm,float *rcond, MKL_Complex8 *work,float *rwork,int *info);
void    cpocon(char *uplo,int *n, MKL_Complex8 *a,int *lda,float *anorm,float *rcond, MKL_Complex8 *work,float *rwork,int *info);
void    CPOEQU(int *n, MKL_Complex8 *a,int *lda,float *s,float *scond,float *amax,int *info);
void    cpoequ(int *n, MKL_Complex8 *a,int *lda,float *s,float *scond,float *amax,int *info);
void    CPORFS(char *uplo,int *n,int *nrhs, MKL_Complex8 *a,int *lda, MKL_Complex8 *af,int *ldaf, MKL_Complex8 *b,int *ldb, MKL_Complex8 *x,int *ldx,float *ferr,float *berr, MKL_Complex8 *work,float *rwork,int *info);
void    cporfs(char *uplo,int *n,int *nrhs, MKL_Complex8 *a,int *lda, MKL_Complex8 *af,int *ldaf, MKL_Complex8 *b,int *ldb, MKL_Complex8 *x,int *ldx,float *ferr,float *berr, MKL_Complex8 *work,float *rwork,int *info);
void    CPOSV(char *uplo,int *n,int *nrhs, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb,int *info);
void    cposv(char *uplo,int *n,int *nrhs, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb,int *info);
void    CPOSVX(char *fact,char *uplo,int *n,int *nrhs, MKL_Complex8 *a,int *lda, MKL_Complex8 *af,int *ldaf,char *equed,float *s, MKL_Complex8 *b,int *ldb, MKL_Complex8 *x,int *ldx,float *rcond,float *ferr,float *berr, MKL_Complex8 *work,float *rwork,int *info);
void    cposvx(char *fact,char *uplo,int *n,int *nrhs, MKL_Complex8 *a,int *lda, MKL_Complex8 *af,int *ldaf,char *equed,float *s, MKL_Complex8 *b,int *ldb, MKL_Complex8 *x,int *ldx,float *rcond,float *ferr,float *berr, MKL_Complex8 *work,float *rwork,int *info);
void    CPOTF2(char *uplo,int *n,float *a,float *lda,int *info);
void    cpotf2(char *uplo,int *n,float *a,float *lda,int *info);
void    CPOTRF(char *uplo,int *n, MKL_Complex8 *a,int *lda,int *info);
void    cpotrf(char *uplo,int *n, MKL_Complex8 *a,int *lda,int *info);
void    CPOTRI(char *uplo,int *n, MKL_Complex8 *a,int *lda,int *info);
void    cpotri(char *uplo,int *n, MKL_Complex8 *a,int *lda,int *info);
void    CPOTRS(char *uplo,int *n,int *nrhs, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb,int *info);
void    cpotrs(char *uplo,int *n,int *nrhs, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb,int *info);
void    CPPCON(char *uplo,int *n, MKL_Complex8 *ap,float *anorm,float *rcond, MKL_Complex8 *work,float *rwork,int *info);
void    cppcon(char *uplo,int *n, MKL_Complex8 *ap,float *anorm,float *rcond, MKL_Complex8 *work,float *rwork,int *info);
void    CPPEQU(char *uplo,int *n, MKL_Complex8 *ap,float *s,float *scond,float *amax,int *info);
void    cppequ(char *uplo,int *n, MKL_Complex8 *ap,float *s,float *scond,float *amax,int *info);
void    CPPRFS(char *uplo,int *n,int *nrhs, MKL_Complex8 *ap, MKL_Complex8 *afp, MKL_Complex8 *b,int *ldb, MKL_Complex8 *x,int *ldx,float *ferr,float *berr, MKL_Complex8 *work,float *rwork,int *info);
void    cpprfs(char *uplo,int *n,int *nrhs, MKL_Complex8 *ap, MKL_Complex8 *afp, MKL_Complex8 *b,int *ldb, MKL_Complex8 *x,int *ldx,float *ferr,float *berr, MKL_Complex8 *work,float *rwork,int *info);
void    CPPSV(char *uplo,int *n,int *nrhs, MKL_Complex8 *ap, MKL_Complex8 *b,int *ldb,int *info);
void    cppsv(char *uplo,int *n,int *nrhs, MKL_Complex8 *ap, MKL_Complex8 *b,int *ldb,int *info);
void    CPPSVX(char *fact,char *uplo,int *n,int *nrhs, MKL_Complex8 *ap, MKL_Complex8 *afp,char *equed,float *s, MKL_Complex8 *b,int *ldb, MKL_Complex8 *x,int *ldx,float *rcond,float *ferr,float *berr, MKL_Complex8 *work,float *rwork,int *info);
void    cppsvx(char *fact,char *uplo,int *n,int *nrhs, MKL_Complex8 *ap, MKL_Complex8 *afp,char *equed,float *s, MKL_Complex8 *b,int *ldb, MKL_Complex8 *x,int *ldx,float *rcond,float *ferr,float *berr, MKL_Complex8 *work,float *rwork,int *info);
void    CPPTRF(char *uplo,int *n,float *ap,int *info);
void    cpptrf(char *uplo,int *n,float *ap,int *info);
void    CPPTRI(char *uplo,int *n,float *ap,int *info);
void    cpptri(char *uplo,int *n,float *ap,int *info);
void    CPPTRS(char *uplo,int *n,int *nrhs, MKL_Complex8 *ap, MKL_Complex8 *b,int *ldb,int *info);
void    cpptrs(char *uplo,int *n,int *nrhs, MKL_Complex8 *ap, MKL_Complex8 *b,int *ldb,int *info);
void    CPTCON(int *n,float *d, MKL_Complex8 *e,float *anorm,float *rcond,float *rwork,int *info);
void    cptcon(int *n,float *d, MKL_Complex8 *e,float *anorm,float *rcond,float *rwork,int *info);
void    CPTEQR(char *compz,int *n,float *d,float *e, MKL_Complex8 *z,int *ldz,float *work,int *info);
void    cpteqr(char *compz,int *n,float *d,float *e, MKL_Complex8 *z,int *ldz,float *work,int *info);
void    CPTRFS(char *uplo,int *n,int *nrhs,float *d, MKL_Complex8 *e,float *df, MKL_Complex8 *ef, MKL_Complex8 *b,int *ldb, MKL_Complex8 *x,int *ldx,float *ferr,float *berr, MKL_Complex8 *work,float *rwork,int *info);
void    cptrfs(char *uplo,int *n,int *nrhs,float *d, MKL_Complex8 *e,float *df, MKL_Complex8 *ef, MKL_Complex8 *b,int *ldb, MKL_Complex8 *x,int *ldx,float *ferr,float *berr, MKL_Complex8 *work,float *rwork,int *info);
void    CPTSV(int *n,int *nrhs,float *d, MKL_Complex8 *e, MKL_Complex8 *b,int *ldb,int *info);
void    cptsv(int *n,int *nrhs,float *d, MKL_Complex8 *e, MKL_Complex8 *b,int *ldb,int *info);
void    CPTSVX(char *fact,int *n,int *nrhs,float *d, MKL_Complex8 *e,float *df, MKL_Complex8 *ef, MKL_Complex8 *b,int *ldb, MKL_Complex8 *x,int *ldx,float *rcond,float *ferr,float *berr, MKL_Complex8 *work,float *rwork,int *info);
void    cptsvx(char *fact,int *n,int *nrhs,float *d, MKL_Complex8 *e,float *df, MKL_Complex8 *ef, MKL_Complex8 *b,int *ldb, MKL_Complex8 *x,int *ldx,float *rcond,float *ferr,float *berr, MKL_Complex8 *work,float *rwork,int *info);
void    CPTTRF(int *n,float *d, MKL_Complex8 *e,int *info);
void    cpttrf(int *n,float *d, MKL_Complex8 *e,int *info);
void    CPTTRS(char *uplo,int *n,int *nrhs,float *d, MKL_Complex8 *e, MKL_Complex8 *b,int *ldb,int *info);
void    cpttrs(char *uplo,int *n,int *nrhs,float *d, MKL_Complex8 *e, MKL_Complex8 *b,int *ldb,int *info);
void    CPTTS2(int *iuplo,int *n,int *nrhs,float *d, MKL_Complex8 *e, MKL_Complex8 *b,int *ldb);
void    cptts2(int *iuplo,int *n,int *nrhs,float *d, MKL_Complex8 *e, MKL_Complex8 *b,int *ldb);
void    CROT(int *n, MKL_Complex8 *cx,int *incx, MKL_Complex8 *cy,int *incy,float *c, MKL_Complex8 *s);
void    crot(int *n, MKL_Complex8 *cx,int *incx, MKL_Complex8 *cy,int *incy,float *c, MKL_Complex8 *s);
void    CSPCON(char *uplo,int *n, MKL_Complex8 *ap,int *ipiv,float *anorm,float *rcond, MKL_Complex8 *work,int *info);
void    cspcon(char *uplo,int *n, MKL_Complex8 *ap,int *ipiv,float *anorm,float *rcond, MKL_Complex8 *work,int *info);
void    CSPMV(char *uplo,int *n, MKL_Complex8 *alpha, MKL_Complex8 *ap, MKL_Complex8 *x,int *incx, MKL_Complex8 *beta, MKL_Complex8 *y,int *incy);
void    cspmv(char *uplo,int *n, MKL_Complex8 *alpha, MKL_Complex8 *ap, MKL_Complex8 *x,int *incx, MKL_Complex8 *beta, MKL_Complex8 *y,int *incy);
void    CSPR(char *uplo,int *n, MKL_Complex8 *alpha, MKL_Complex8 *x,int *incx, MKL_Complex8 *ap);
void    cspr(char *uplo,int *n, MKL_Complex8 *alpha, MKL_Complex8 *x,int *incx, MKL_Complex8 *ap);
void    CSPRFS(char *uplo,int *n,int *nrhs, MKL_Complex8 *ap, MKL_Complex8 *afp,int *ipiv, MKL_Complex8 *b,int *ldb, MKL_Complex8 *x,int *ldx,float *ferr,float *berr, MKL_Complex8 *work,float *rwork,int *info);
void    csprfs(char *uplo,int *n,int *nrhs, MKL_Complex8 *ap, MKL_Complex8 *afp,int *ipiv, MKL_Complex8 *b,int *ldb, MKL_Complex8 *x,int *ldx,float *ferr,float *berr, MKL_Complex8 *work,float *rwork,int *info);
void    CSPSV(char *uplo,int *n,int *nrhs, MKL_Complex8 *ap,int *ipiv, MKL_Complex8 *b,int *ldb,int *info);
void    cspsv(char *uplo,int *n,int *nrhs, MKL_Complex8 *ap,int *ipiv, MKL_Complex8 *b,int *ldb,int *info);
void    CSPSVX(char *fact,char *uplo,int *n,int *nrhs, MKL_Complex8 *ap, MKL_Complex8 *afp,int *ipiv, MKL_Complex8 *b,int *ldb, MKL_Complex8 *x,int *ldx,float *rcond,float *ferr,float *berr, MKL_Complex8 *work,float *rwork,int *info);
void    cspsvx(char *fact,char *uplo,int *n,int *nrhs, MKL_Complex8 *ap, MKL_Complex8 *afp,int *ipiv, MKL_Complex8 *b,int *ldb, MKL_Complex8 *x,int *ldx,float *rcond,float *ferr,float *berr, MKL_Complex8 *work,float *rwork,int *info);
void    CSPTRF(char *uplo,int *n, MKL_Complex8 *ap,int *ipiv,int *info);
void    csptrf(char *uplo,int *n, MKL_Complex8 *ap,int *ipiv,int *info);
void    CSPTRI(char *uplo,int *n, MKL_Complex8 *ap,int *ipiv, MKL_Complex8 *work,int *info);
void    csptri(char *uplo,int *n, MKL_Complex8 *ap,int *ipiv, MKL_Complex8 *work,int *info);
void    CSPTRS(char *uplo,int *n,int *nrhs, MKL_Complex8 *ap,int *ipiv, MKL_Complex8 *b,int *ldb,int *info);
void    csptrs(char *uplo,int *n,int *nrhs, MKL_Complex8 *ap,int *ipiv, MKL_Complex8 *b,int *ldb,int *info);
void    CSRSCL(int *n,float *sa, MKL_Complex8 *sx,int *incx);
void    csrscl(int *n,float *sa, MKL_Complex8 *sx,int *incx);
void    CSTEDC(char *compz,int *n,float *d,float *e, MKL_Complex8 *z,int *ldz, MKL_Complex8 *work,int *lwork,float *rwork,int *lrwork,int *iwork,int *liwork,int *info);
void    cstedc(char *compz,int *n,float *d,float *e, MKL_Complex8 *z,int *ldz, MKL_Complex8 *work,int *lwork,float *rwork,int *lrwork,int *iwork,int *liwork,int *info);
void    CSTEGR(char *jobz,char *range,int *n,float *d,float *e,float *vl,float *vu,int *il,int *iu,float *abstol,int *m,float *w, MKL_Complex8 *z,int *ldz,int *isuppz,float *work,int *lwork,int *iwork,int *liwork,int *info);
void    cstegr(char *jobz,char *range,int *n,float *d,float *e,float *vl,float *vu,int *il,int *iu,float *abstol,int *m,float *w, MKL_Complex8 *z,int *ldz,int *isuppz,float *work,int *lwork,int *iwork,int *liwork,int *info);
void    CSTEIN(int *n,float *d,float *e,int *m,float *w,int *iblock,int *isplit, MKL_Complex8 *z,int *ldz,float *work,int *iwork,int *ifail,int *info);
void    cstein(int *n,float *d,float *e,int *m,float *w,int *iblock,int *isplit, MKL_Complex8 *z,int *ldz,float *work,int *iwork,int *ifail,int *info);
void    CSTEQR(char *compz,int *n,float *d,float *e, MKL_Complex8 *z,int *ldz,float *work,int *info);
void    csteqr(char *compz,int *n,float *d,float *e, MKL_Complex8 *z,int *ldz,float *work,int *info);
void    CSYCON(char *uplo,int *n, MKL_Complex8 *a,int *lda,int *ipiv,float *anorm,float *rcond, MKL_Complex8 *work,int *info);
void    csycon(char *uplo,int *n, MKL_Complex8 *a,int *lda,int *ipiv,float *anorm,float *rcond, MKL_Complex8 *work,int *info);
void    CSYMV(char *uplo,int *n, MKL_Complex8 *alpha, MKL_Complex8 *a,int *lda, MKL_Complex8 *x,int *incx, MKL_Complex8 *beta, MKL_Complex8 *y,int *incy);
void    csymv(char *uplo,int *n, MKL_Complex8 *alpha, MKL_Complex8 *a,int *lda, MKL_Complex8 *x,int *incx, MKL_Complex8 *beta, MKL_Complex8 *y,int *incy);
void    CSYR(char *uplo,int *n, MKL_Complex8 *alpha, MKL_Complex8 *x,int *incx, MKL_Complex8 *a,int *lda);
void    csyr(char *uplo,int *n, MKL_Complex8 *alpha, MKL_Complex8 *x,int *incx, MKL_Complex8 *a,int *lda);
void    CSYRFS(char *uplo,int *n,int *nrhs, MKL_Complex8 *a,int *lda, MKL_Complex8 *af,int *ldaf,int *ipiv, MKL_Complex8 *b,int *ldb, MKL_Complex8 *x,int *ldx,float *ferr,float *berr, MKL_Complex8 *work,float *rwork,int *info);
void    csyrfs(char *uplo,int *n,int *nrhs, MKL_Complex8 *a,int *lda, MKL_Complex8 *af,int *ldaf,int *ipiv, MKL_Complex8 *b,int *ldb, MKL_Complex8 *x,int *ldx,float *ferr,float *berr, MKL_Complex8 *work,float *rwork,int *info);
void    CSYSV(char *uplo,int *n,int *nrhs, MKL_Complex8 *a,int *lda,int *ipiv, MKL_Complex8 *b,int *ldb, MKL_Complex8 *work,int *lwork,int *info);
void    csysv(char *uplo,int *n,int *nrhs, MKL_Complex8 *a,int *lda,int *ipiv, MKL_Complex8 *b,int *ldb, MKL_Complex8 *work,int *lwork,int *info);
void    CSYSVX(char *fact,char *uplo,int *n,int *nrhs, MKL_Complex8 *a,int *lda, MKL_Complex8 *af,int *ldaf,int *ipiv, MKL_Complex8 *b,int *ldb, MKL_Complex8 *x,int *ldx,float *rcond,float *ferr,float *berr, MKL_Complex8 *work,int *lwork,float *rwork,int *info);
void    csysvx(char *fact,char *uplo,int *n,int *nrhs, MKL_Complex8 *a,int *lda, MKL_Complex8 *af,int *ldaf,int *ipiv, MKL_Complex8 *b,int *ldb, MKL_Complex8 *x,int *ldx,float *rcond,float *ferr,float *berr, MKL_Complex8 *work,int *lwork,float *rwork,int *info);
void    CSYTF2(char *uplo,int *n, MKL_Complex8 *a,int *lda,int *ipiv,int *info);
void    csytf2(char *uplo,int *n, MKL_Complex8 *a,int *lda,int *ipiv,int *info);
void    CSYTRF(char *uplo,int *n, MKL_Complex8 *a,int *lda,int *ipiv, MKL_Complex8 *work,int *lwork,int *info);
void    csytrf(char *uplo,int *n, MKL_Complex8 *a,int *lda,int *ipiv, MKL_Complex8 *work,int *lwork,int *info);
void    CSYTRI(char *uplo,int *n, MKL_Complex8 *a,int *lda,int *ipiv, MKL_Complex8 *work,int *info);
void    csytri(char *uplo,int *n, MKL_Complex8 *a,int *lda,int *ipiv, MKL_Complex8 *work,int *info);
void    CSYTRS(char *uplo,int *n,int *nrhs, MKL_Complex8 *a,int *lda,int *ipiv, MKL_Complex8 *b,int *ldb,int *info);
void    csytrs(char *uplo,int *n,int *nrhs, MKL_Complex8 *a,int *lda,int *ipiv, MKL_Complex8 *b,int *ldb,int *info);
void    CTBCON(char *norm,char *uplo,char *diag,int *n,int *kd, MKL_Complex8 *ab,int *ldab,float *rcond, MKL_Complex8 *work,float *rwork,int *info);
void    ctbcon(char *norm,char *uplo,char *diag,int *n,int *kd, MKL_Complex8 *ab,int *ldab,float *rcond, MKL_Complex8 *work,float *rwork,int *info);
void    CTBRFS(char *uplo,char *trans,char *diag,int *n,int *kd,int *nrhs, MKL_Complex8 *ab,int *ldab, MKL_Complex8 *b,int *ldb, MKL_Complex8 *x,int *ldx,float *ferr,float *berr, MKL_Complex8 *work,float *rwork,int *info);
void    ctbrfs(char *uplo,char *trans,char *diag,int *n,int *kd,int *nrhs, MKL_Complex8 *ab,int *ldab, MKL_Complex8 *b,int *ldb, MKL_Complex8 *x,int *ldx,float *ferr,float *berr, MKL_Complex8 *work,float *rwork,int *info);
void    CTBTRS(char *uplo,char *trans,char *diag,int *n,int *kd,int *nrhs, MKL_Complex8 *ab,int *ldab, MKL_Complex8 *b,int *ldb,int *info);
void    ctbtrs(char *uplo,char *trans,char *diag,int *n,int *kd,int *nrhs, MKL_Complex8 *ab,int *ldab, MKL_Complex8 *b,int *ldb,int *info);
void    CTGEVC(char *side,char *howmny,void *select,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb, MKL_Complex8 *vl,int *ldvl, MKL_Complex8 *vr,int *ldvr,int *mm,int *m, MKL_Complex8 *work,float *rwork,int *info);
void    ctgevc(char *side,char *howmny,void *select,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb, MKL_Complex8 *vl,int *ldvl, MKL_Complex8 *vr,int *ldvr,int *mm,int *m, MKL_Complex8 *work,float *rwork,int *info);
void    CTGEX2(void *wantq,void *wantz,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb, MKL_Complex8 *q,int *ldq, MKL_Complex8 *z,int *ldz,int *j1,int *info);
void    ctgex2(void *wantq,void *wantz,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb, MKL_Complex8 *q,int *ldq, MKL_Complex8 *z,int *ldz,int *j1,int *info);
void    CTGEXC(void *wantq,void *wantz,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb, MKL_Complex8 *q,int *ldq, MKL_Complex8 *z,int *ldz,int *ifst,int *ilst,int *info);
void    ctgexc(void *wantq,void *wantz,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb, MKL_Complex8 *q,int *ldq, MKL_Complex8 *z,int *ldz,int *ifst,int *ilst,int *info);
void    CTGSEN(int *ijob,void *wantq,void *wantz,void *select,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb, MKL_Complex8 *alpha, MKL_Complex8 *beta, MKL_Complex8 *q,int *ldq, MKL_Complex8 *z,int *ldz,int *m,float *pl,float *pr,float *dif, MKL_Complex8 *work,int *lwork,int *iwork,int *liwork,int *info);
void    ctgsen(int *ijob,void *wantq,void *wantz,void *select,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb, MKL_Complex8 *alpha, MKL_Complex8 *beta, MKL_Complex8 *q,int *ldq, MKL_Complex8 *z,int *ldz,int *m,float *pl,float *pr,float *dif, MKL_Complex8 *work,int *lwork,int *iwork,int *liwork,int *info);
void    CTGSJA(char *jobu,char *jobv,char *jobq,int *m,int *p,int *n,int *k,int *l, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb,float *tola,float *tolb,float *alpha,float *beta, MKL_Complex8 *u,int *ldu, MKL_Complex8 *v,int *ldv, MKL_Complex8 *q,int *ldq, MKL_Complex8 *work,int *ncycle,int *info);
void    ctgsja(char *jobu,char *jobv,char *jobq,int *m,int *p,int *n,int *k,int *l, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb,float *tola,float *tolb,float *alpha,float *beta, MKL_Complex8 *u,int *ldu, MKL_Complex8 *v,int *ldv, MKL_Complex8 *q,int *ldq, MKL_Complex8 *work,int *ncycle,int *info);
void    CTGSNA(char *job,char *howmny,void *select,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb, MKL_Complex8 *vl,int *ldvl, MKL_Complex8 *vr,int *ldvr,float *s,float *dif,int *mm,int *m, MKL_Complex8 *work,int *lwork,int *iwork,int *info);
void    ctgsna(char *job,char *howmny,void *select,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb, MKL_Complex8 *vl,int *ldvl, MKL_Complex8 *vr,int *ldvr,float *s,float *dif,int *mm,int *m, MKL_Complex8 *work,int *lwork,int *iwork,int *info);
void    CTGSY2(char *trans,int *ijob,int *m,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb, MKL_Complex8 *c,int *ldc, MKL_Complex8 *d,int *ldd, MKL_Complex8 *e,int *lde, MKL_Complex8 *f,int *ldf,float *scale,float *rdsum,float *rdscal,int *info);
void    ctgsy2(char *trans,int *ijob,int *m,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb, MKL_Complex8 *c,int *ldc, MKL_Complex8 *d,int *ldd, MKL_Complex8 *e,int *lde, MKL_Complex8 *f,int *ldf,float *scale,float *rdsum,float *rdscal,int *info);
void    CTGSYL(char *trans,int *ijob,int *m,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb, MKL_Complex8 *c,int *ldc, MKL_Complex8 *d,int *ldd, MKL_Complex8 *e,int *lde, MKL_Complex8 *f,int *ldf,float *scale,float *dif, MKL_Complex8 *work,int *lwork,int *iwork,int *info);
void    ctgsyl(char *trans,int *ijob,int *m,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb, MKL_Complex8 *c,int *ldc, MKL_Complex8 *d,int *ldd, MKL_Complex8 *e,int *lde, MKL_Complex8 *f,int *ldf,float *scale,float *dif, MKL_Complex8 *work,int *lwork,int *iwork,int *info);
void    CTPCON(char *norm,char *uplo,char *diag,int *n, MKL_Complex8 *ap,float *rcond, MKL_Complex8 *work,float *rwork,int *info);
void    ctpcon(char *norm,char *uplo,char *diag,int *n, MKL_Complex8 *ap,float *rcond, MKL_Complex8 *work,float *rwork,int *info);
void    CTPRFS(char *uplo,char *trans,char *diag,int *n,int *nrhs, MKL_Complex8 *ap, MKL_Complex8 *b,int *ldb, MKL_Complex8 *x,int *ldx,float *ferr,float *berr, MKL_Complex8 *work,float *rwork,int *info);
void    ctprfs(char *uplo,char *trans,char *diag,int *n,int *nrhs, MKL_Complex8 *ap, MKL_Complex8 *b,int *ldb, MKL_Complex8 *x,int *ldx,float *ferr,float *berr, MKL_Complex8 *work,float *rwork,int *info);
void    CTPTRI(char *uplo,char *diag,int *n, MKL_Complex8 *ap,int *info);
void    ctptri(char *uplo,char *diag,int *n, MKL_Complex8 *ap,int *info);
void    CTPTRS(char *uplo,char *trans,char *diag,int *n,int *nrhs, MKL_Complex8 *ap, MKL_Complex8 *b,int *ldb,int *info);
void    ctptrs(char *uplo,char *trans,char *diag,int *n,int *nrhs, MKL_Complex8 *ap, MKL_Complex8 *b,int *ldb,int *info);
void    CTRCON(char *norm,char *uplo,char *diag,int *n, MKL_Complex8 *a,int *lda,float *rcond, MKL_Complex8 *work,float *rwork,int *info);
void    ctrcon(char *norm,char *uplo,char *diag,int *n, MKL_Complex8 *a,int *lda,float *rcond, MKL_Complex8 *work,float *rwork,int *info);
void    CTREVC(char *side,char *howmny,void *select,int *n, MKL_Complex8 *t,int *ldt, MKL_Complex8 *vl,int *ldvl, MKL_Complex8 *vr,int *ldvr,int *mm,int *m, MKL_Complex8 *work,float *rwork,int *info);
void    ctrevc(char *side,char *howmny,void *select,int *n, MKL_Complex8 *t,int *ldt, MKL_Complex8 *vl,int *ldvl, MKL_Complex8 *vr,int *ldvr,int *mm,int *m, MKL_Complex8 *work,float *rwork,int *info);
void    CTREXC(char *compq,int *n, MKL_Complex8 *t,int *ldt, MKL_Complex8 *q,int *ldq,int *ifst,int *ilst,int *info);
void    ctrexc(char *compq,int *n, MKL_Complex8 *t,int *ldt, MKL_Complex8 *q,int *ldq,int *ifst,int *ilst,int *info);
void    CTRRFS(char *uplo,char *trans,char *diag,int *n,int *nrhs, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb, MKL_Complex8 *x,int *ldx,float *ferr,float *berr, MKL_Complex8 *work,float *rwork,int *info);
void    ctrrfs(char *uplo,char *trans,char *diag,int *n,int *nrhs, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb, MKL_Complex8 *x,int *ldx,float *ferr,float *berr, MKL_Complex8 *work,float *rwork,int *info);
void    CTRSEN(char *job,char *compq,void *select,int *n, MKL_Complex8 *t,int *ldt, MKL_Complex8 *q,int *ldq, MKL_Complex8 *w,int *m,float *s,float *sep, MKL_Complex8 *work,int *lwork,int *info);
void    ctrsen(char *job,char *compq,void *select,int *n, MKL_Complex8 *t,int *ldt, MKL_Complex8 *q,int *ldq, MKL_Complex8 *w,int *m,float *s,float *sep, MKL_Complex8 *work,int *lwork,int *info);
void    CTRSNA(char *job,char *howmny,void *select,int *n, MKL_Complex8 *t,int *ldt, MKL_Complex8 *vl,int *ldvl, MKL_Complex8 *vr,int *ldvr,float *s,float *sep,int *mm,int *m, MKL_Complex8 *work,int *ldwork,float *rwork,int *info);
void    ctrsna(char *job,char *howmny,void *select,int *n, MKL_Complex8 *t,int *ldt, MKL_Complex8 *vl,int *ldvl, MKL_Complex8 *vr,int *ldvr,float *s,float *sep,int *mm,int *m, MKL_Complex8 *work,int *ldwork,float *rwork,int *info);
void    CTRSYL(char *trana,char *tranb,int *isgn,int *m,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb, MKL_Complex8 *c,int *ldc,float *scale,int *info);
void    ctrsyl(char *trana,char *tranb,int *isgn,int *m,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb, MKL_Complex8 *c,int *ldc,float *scale,int *info);
void    CTRTI2(char *uplo,char *diag,int *n, MKL_Complex8 *a,int *lda,int *info);
void    ctrti2(char *uplo,char *diag,int *n, MKL_Complex8 *a,int *lda,int *info);
void    CTRTRI(char *uplo,char *diag,int *n, MKL_Complex8 *a,int *lda,int *info);
void    ctrtri(char *uplo,char *diag,int *n, MKL_Complex8 *a,int *lda,int *info);
void    CTRTRS(char *uplo,char *trans,char *diag,int *n,int *nrhs, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb,int *info);
void    ctrtrs(char *uplo,char *trans,char *diag,int *n,int *nrhs, MKL_Complex8 *a,int *lda, MKL_Complex8 *b,int *ldb,int *info);
void    CTZRQF(int *m,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau,int *info);
void    ctzrqf(int *m,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau,int *info);
void    CTZRZF(int *m,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *work,int *lwork,int *info);
void    ctzrzf(int *m,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *work,int *lwork,int *info);
void    CUNG2L(int *m,int *n,int *k, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *work,int *info);
void    cung2l(int *m,int *n,int *k, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *work,int *info);
void    CUNG2R(int *m,int *n,int *k, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *work,int *info);
void    cung2r(int *m,int *n,int *k, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *work,int *info);
void    CUNGBR(char *vect,int *m,int *n,int *k, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *work,int *lwork,int *info);
void    cungbr(char *vect,int *m,int *n,int *k, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *work,int *lwork,int *info);
void    CUNGHR(int *n,int *ilo,int *ihi, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *work,int *lwork,int *info);
void    cunghr(int *n,int *ilo,int *ihi, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *work,int *lwork,int *info);
void    CUNGL2(int *m,int *n,int *k, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *work,int *info);
void    cungl2(int *m,int *n,int *k, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *work,int *info);
void    CUNGLQ(int *m,int *n,int *k, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *work,int *lwork,int *info);
void    cunglq(int *m,int *n,int *k, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *work,int *lwork,int *info);
void    CUNGQL(int *m,int *n,int *k, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *work,int *lwork,int *info);
void    cungql(int *m,int *n,int *k, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *work,int *lwork,int *info);
void    CUNGQR(int *m,int *n,int *k, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *work,int *lwork,int *info);
void    cungqr(int *m,int *n,int *k, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *work,int *lwork,int *info);
void    CUNGR2(int *m,int *n,int *k, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *work,int *info);
void    cungr2(int *m,int *n,int *k, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *work,int *info);
void    CUNGRQ(int *m,int *n,int *k, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *work,int *lwork,int *info);
void    cungrq(int *m,int *n,int *k, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *work,int *lwork,int *info);
void    CUNGTR(char *uplo,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *work,int *lwork,int *info);
void    cungtr(char *uplo,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *work,int *lwork,int *info);
void    CUNM2L(char *side,char *trans,int *m,int *n,int *k, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *c,int *ldc, MKL_Complex8 *work,int *info);
void    cunm2l(char *side,char *trans,int *m,int *n,int *k, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *c,int *ldc, MKL_Complex8 *work,int *info);
void    CUNM2R(char *side,char *trans,int *m,int *n,int *k, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *c,int *ldc, MKL_Complex8 *work,int *info);
void    cunm2r(char *side,char *trans,int *m,int *n,int *k, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *c,int *ldc, MKL_Complex8 *work,int *info);
void    CUNMBR(char *vect,char *side,char *trans,int *m,int *n,int *k, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *c,int *ldc, MKL_Complex8 *work,int *lwork,int *info);
void    cunmbr(char *vect,char *side,char *trans,int *m,int *n,int *k, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *c,int *ldc, MKL_Complex8 *work,int *lwork,int *info);
void    CUNMHR(char *side,char *trans,int *m,int *n,int *ilo,int *ihi, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *c,int *ldc, MKL_Complex8 *work,int *lwork,int *info);
void    cunmhr(char *side,char *trans,int *m,int *n,int *ilo,int *ihi, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *c,int *ldc, MKL_Complex8 *work,int *lwork,int *info);
void    CUNML2(char *side,char *trans,int *m,int *n,int *k, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *c,int *ldc, MKL_Complex8 *work,int *info);
void    cunml2(char *side,char *trans,int *m,int *n,int *k, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *c,int *ldc, MKL_Complex8 *work,int *info);
void    CUNMLQ(char *side,char *trans,int *m,int *n,int *k, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *c,int *ldc, MKL_Complex8 *work,int *lwork,int *info);
void    cunmlq(char *side,char *trans,int *m,int *n,int *k, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *c,int *ldc, MKL_Complex8 *work,int *lwork,int *info);
void    CUNMQL(char *side,char *trans,int *m,int *n,int *k, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *c,int *ldc, MKL_Complex8 *work,int *lwork,int *info);
void    cunmql(char *side,char *trans,int *m,int *n,int *k, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *c,int *ldc, MKL_Complex8 *work,int *lwork,int *info);
void    CUNMQR(char *side,char *trans,int *m,int *n,int *k, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *c,int *ldc, MKL_Complex8 *work,int *lwork,int *info);
void    cunmqr(char *side,char *trans,int *m,int *n,int *k, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *c,int *ldc, MKL_Complex8 *work,int *lwork,int *info);
void    CUNMR2(char *side,char *trans,int *m,int *n,int *k, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *c,int *ldc, MKL_Complex8 *work,int *info);
void    cunmr2(char *side,char *trans,int *m,int *n,int *k, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *c,int *ldc, MKL_Complex8 *work,int *info);
void    CUNMR3(char *side,char *trans,int *m,int *n,int *k,int *l, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *c,int *ldc, MKL_Complex8 *work,int *info);
void    cunmr3(char *side,char *trans,int *m,int *n,int *k,int *l, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *c,int *ldc, MKL_Complex8 *work,int *info);
void    CUNMRQ(char *side,char *trans,int *m,int *n,int *k, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *c,int *ldc, MKL_Complex8 *work,int *lwork,int *info);
void    cunmrq(char *side,char *trans,int *m,int *n,int *k, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *c,int *ldc, MKL_Complex8 *work,int *lwork,int *info);
void    CUNMRZ(char *side,char *trans,int *m,int *n,int *k,int *l, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *c,int *ldc, MKL_Complex8 *work,int *lwork,int *info);
void    cunmrz(char *side,char *trans,int *m,int *n,int *k,int *l, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *c,int *ldc, MKL_Complex8 *work,int *lwork,int *info);
void    CUNMTR(char *side,char *uplo,char *trans,int *m,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *c,int *ldc, MKL_Complex8 *work,int *lwork,int *info);
void    cunmtr(char *side,char *uplo,char *trans,int *m,int *n, MKL_Complex8 *a,int *lda, MKL_Complex8 *tau, MKL_Complex8 *c,int *ldc, MKL_Complex8 *work,int *lwork,int *info);
void    CUPGTR(char *uplo,int *n, MKL_Complex8 *ap, MKL_Complex8 *tau, MKL_Complex8 *q,int *ldq, MKL_Complex8 *work,int *info);
void    cupgtr(char *uplo,int *n, MKL_Complex8 *ap, MKL_Complex8 *tau, MKL_Complex8 *q,int *ldq, MKL_Complex8 *work,int *info);
void    CUPMTR(char *side,char *uplo,char *trans,int *m,int *n, MKL_Complex8 *ap, MKL_Complex8 *tau, MKL_Complex8 *c,int *ldc, MKL_Complex8 *work,int *info);
void    cupmtr(char *side,char *uplo,char *trans,int *m,int *n, MKL_Complex8 *ap, MKL_Complex8 *tau, MKL_Complex8 *c,int *ldc, MKL_Complex8 *work,int *info);
int     ICMAX1(int *n, MKL_Complex8 *cx,int *incx);
int     icmax1(int *n, MKL_Complex8 *cx,int *incx);
void    SBDSDC(char *uplo,char *compq,int *n,float *d,float *e,float *u,int *ldu,float *vt,int *ldvt,float *q,int *iq,float *work,int *iwork,int *info);
void    sbdsdc(char *uplo,char *compq,int *n,float *d,float *e,float *u,int *ldu,float *vt,int *ldvt,float *q,int *iq,float *work,int *iwork,int *info);
void    SBDSQR(char *uplo,int *n,int *ncvt,int *nru,int *ncc,float *d,float *e,float *vt,int *ldvt,float *u,int *ldu,float *c,int *ldc,float *work,int *info);
void    sbdsqr(char *uplo,int *n,int *ncvt,int *nru,int *ncc,float *d,float *e,float *vt,int *ldvt,float *u,int *ldu,float *c,int *ldc,float *work,int *info);
float   SCSUM1(int *n, MKL_Complex8 *cx,int *incx);
float   scsum1(int *n, MKL_Complex8 *cx,int *incx);
void    SDISNA(char *job,int *m,int *n,float *d,float *sep,int *info);
void    sdisna(char *job,int *m,int *n,float *d,float *sep,int *info);
void    SGBBRD(char *vect,int *m,int *n,int *ncc,int *kl,int *ku,float *ab,int *ldab,float *d,float *e,float *q,int *ldq,float *pt,int *ldpt,float *c,int *ldc,float *work,int *info);
void    sgbbrd(char *vect,int *m,int *n,int *ncc,int *kl,int *ku,float *ab,int *ldab,float *d,float *e,float *q,int *ldq,float *pt,int *ldpt,float *c,int *ldc,float *work,int *info);
void    SGBCON(char *norm,int *n,int *kl,int *ku,float *ab,int *ldab,int *ipiv,float *anorm,float *rcond,float *work,int *iwork,int *info);
void    sgbcon(char *norm,int *n,int *kl,int *ku,float *ab,int *ldab,int *ipiv,float *anorm,float *rcond,float *work,int *iwork,int *info);
void    SGBEQU(int *m,int *n,int *kl,int *ku,float *ab,int *ldab,float *r,float *c,float *rowcnd,float *colcnd,float *amax,int *info);
void    sgbequ(int *m,int *n,int *kl,int *ku,float *ab,int *ldab,float *r,float *c,float *rowcnd,float *colcnd,float *amax,int *info);
void    SGBRFS(char *trans,int *n,int *kl,int *ku,int *nrhs,float *ab,int *ldab,float *afb,int *ldafb,int *ipiv,float *b,int *ldb,float *x,int *ldx,float *ferr,float *berr,float *work,int *iwork,int *info);
void    sgbrfs(char *trans,int *n,int *kl,int *ku,int *nrhs,float *ab,int *ldab,float *afb,int *ldafb,int *ipiv,float *b,int *ldb,float *x,int *ldx,float *ferr,float *berr,float *work,int *iwork,int *info);
void    SGBSV(int *n,int *kl,int *ku,int *nrhs,float *ab,int *ldab,int *ipiv,float *b,int *ldb,int *info);
void    sgbsv(int *n,int *kl,int *ku,int *nrhs,float *ab,int *ldab,int *ipiv,float *b,int *ldb,int *info);
void    SGBSVX(char *fact,char *trans,int *n,int *kl,int *ku,int *nrhs,float *ab,int *ldab,float *afb,int *ldafb,int *ipiv,char *equed,float *r,float *c,float *b,int *ldb,float *x,int *ldx,float *rcond,float *ferr,float *berr,float *work,int *iwork,int *info);
void    sgbsvx(char *fact,char *trans,int *n,int *kl,int *ku,int *nrhs,float *ab,int *ldab,float *afb,int *ldafb,int *ipiv,char *equed,float *r,float *c,float *b,int *ldb,float *x,int *ldx,float *rcond,float *ferr,float *berr,float *work,int *iwork,int *info);
void    SGBTF2(int *m,int *n,int *kl,int *ku,float *ab,int *ldab,int *ipiv,int *info);
void    sgbtf2(int *m,int *n,int *kl,int *ku,float *ab,int *ldab,int *ipiv,int *info);
void    SGBTRF(int *m,int *n,int *kl,int *ku,float *ab,int *ldab,int *ipiv,int *info);
void    sgbtrf(int *m,int *n,int *kl,int *ku,float *ab,int *ldab,int *ipiv,int *info);
void    SGBTRS(char *trans,int *n,int *kl,int *ku,int *nrhs,float *ab,int *ldab,int *ipiv,float *b,int *ldb,int *info);
void    sgbtrs(char *trans,int *n,int *kl,int *ku,int *nrhs,float *ab,int *ldab,int *ipiv,float *b,int *ldb,int *info);
void    SGEBAK(char *job,char *side,int *n,int *ilo,int *ihi,float *scale,int *m,float *v,int *ldv,int *info);
void    sgebak(char *job,char *side,int *n,int *ilo,int *ihi,float *scale,int *m,float *v,int *ldv,int *info);
void    SGEBAL(char *job,int *n,float *a,int *lda,int *ilo,int *ihi,float *scale,int *info);
void    sgebal(char *job,int *n,float *a,int *lda,int *ilo,int *ihi,float *scale,int *info);
void    SGEBD2(int *m,int *n,float *a,int *lda,float *d,float *e,float *tauq,float *taup,float *work,int *info);
void    sgebd2(int *m,int *n,float *a,int *lda,float *d,float *e,float *tauq,float *taup,float *work,int *info);
void    SGEBRD(int *m,int *n,float *a,int *lda,float *d,float *e,float *tauq,float *taup,float *work,int *lwork,int *info);
void    sgebrd(int *m,int *n,float *a,int *lda,float *d,float *e,float *tauq,float *taup,float *work,int *lwork,int *info);
void    SGECON(char *norm,int *n,float *a,int *lda,float *anorm,float *rcond,float *work,int *iwork,int *info);
void    sgecon(char *norm,int *n,float *a,int *lda,float *anorm,float *rcond,float *work,int *iwork,int *info);
void    SGEEQU(int *m,int *n,float *a,int *lda,float *r,float *c,float *rowcnd,float *colcnd,float *amax,int *info);
void    sgeequ(int *m,int *n,float *a,int *lda,float *r,float *c,float *rowcnd,float *colcnd,float *amax,int *info);
void    SGEES(char *jobvs,char *sort,void *select,int *n,float *a,int *lda,int *sdim,float *wr,float *wi,float *vs,int *ldvs,float *work,int *lwork,void *bwork,int *info);
void    sgees(char *jobvs,char *sort,void *select,int *n,float *a,int *lda,int *sdim,float *wr,float *wi,float *vs,int *ldvs,float *work,int *lwork,void *bwork,int *info);
void    SGEESX(char *jobvs,char *sort,void *select,char *sense,int *n,float *a,int *lda,int *sdim,float *wr,float *wi,float *vs,int *ldvs,float *rconde,float *rcondv,float *work,int *lwork,int *iwork,int *liwork,void *bwork,int *info);
void    sgeesx(char *jobvs,char *sort,void *select,char *sense,int *n,float *a,int *lda,int *sdim,float *wr,float *wi,float *vs,int *ldvs,float *rconde,float *rcondv,float *work,int *lwork,int *iwork,int *liwork,void *bwork,int *info);
void    SGEEV(char *jobvl,char *jobvr,int *n,float *a,int *lda,float *wr,float *wi,float *vl,int *ldvl,float *vr,int *ldvr,float *work,int *lwork,int *info);
void    sgeev(char *jobvl,char *jobvr,int *n,float *a,int *lda,float *wr,float *wi,float *vl,int *ldvl,float *vr,int *ldvr,float *work,int *lwork,int *info);
void    SGEEVX(char *balanc,char *jobvl,char *jobvr,char *sense,int *n,float *a,int *lda,float *wr,float *wi,float *vl,int *ldvl,float *vr,int *ldvr,int *ilo,int *ihi,float *scale,float *abnrm,float *rconde,float *rcondv,float *work,int *lwork,int *iwork,int *info);
void    sgeevx(char *balanc,char *jobvl,char *jobvr,char *sense,int *n,float *a,int *lda,float *wr,float *wi,float *vl,int *ldvl,float *vr,int *ldvr,int *ilo,int *ihi,float *scale,float *abnrm,float *rconde,float *rcondv,float *work,int *lwork,int *iwork,int *info);
void    SGEGS(char *jobvsl,char *jobvsr,int *n,float *a,int *lda,float *b,int *ldb,float *alphar,float *alphai,float *beta,float *vsl,int *ldvsl,float *vsr,int *ldvsr,float *work,int *lwork,int *info);
void    sgegs(char *jobvsl,char *jobvsr,int *n,float *a,int *lda,float *b,int *ldb,float *alphar,float *alphai,float *beta,float *vsl,int *ldvsl,float *vsr,int *ldvsr,float *work,int *lwork,int *info);
void    SGEGV(char *jobvl,char *jobvr,int *n,float *a,int *lda,float *b,int *ldb,float *alphar,float *alphai,float *beta,float *vl,int *ldvl,float *vr,int *ldvr,float *work,int *lwork,int *info);
void    sgegv(char *jobvl,char *jobvr,int *n,float *a,int *lda,float *b,int *ldb,float *alphar,float *alphai,float *beta,float *vl,int *ldvl,float *vr,int *ldvr,float *work,int *lwork,int *info);
void    SGEHD2(int *n,int *ilo,int *ihi,float *a,int *lda,float *tau,float *work,int *info);
void    sgehd2(int *n,int *ilo,int *ihi,float *a,int *lda,float *tau,float *work,int *info);
void    SGEHRD(int *n,int *ilo,int *ihi,float *a,int *lda,float *tau,float *work,int *lwork,int *info);
void    sgehrd(int *n,int *ilo,int *ihi,float *a,int *lda,float *tau,float *work,int *lwork,int *info);
void    SGELQ2(int *m,int *n,float *a,int *lda,float *tau,float *work,int *info);
void    sgelq2(int *m,int *n,float *a,int *lda,float *tau,float *work,int *info);
void    SGELQF(int *m,int *n,float *a,int *lda,float *tau,float *work,int *lwork,int *info);
void    sgelqf(int *m,int *n,float *a,int *lda,float *tau,float *work,int *lwork,int *info);
void    SGELS(char *trans,int *m,int *n,int *nrhs,float *a,int *lda,float *b,int *ldb,float *work,int *lwork,int *info);
void    sgels(char *trans,int *m,int *n,int *nrhs,float *a,int *lda,float *b,int *ldb,float *work,int *lwork,int *info);
void    SGELSD(int *m,int *n,int *nrhs,float *a,int *lda,float *b,int *ldb,float *s,float *rcond,int *rank,float *work,int *lwork,int *iwork,int *info);
void    sgelsd(int *m,int *n,int *nrhs,float *a,int *lda,float *b,int *ldb,float *s,float *rcond,int *rank,float *work,int *lwork,int *iwork,int *info);
void    SGELSS(int *m,int *n,int *nrhs,float *a,int *lda,float *b,int *ldb,float *s,float *rcond,int *rank,float *work,int *lwork,int *info);
void    sgelss(int *m,int *n,int *nrhs,float *a,int *lda,float *b,int *ldb,float *s,float *rcond,int *rank,float *work,int *lwork,int *info);
void    SGELSX(int *m,int *n,int *nrhs,float *a,int *lda,float *b,int *ldb,int *jpvt,float *rcond,int *rank,float *work,int *info);
void    sgelsx(int *m,int *n,int *nrhs,float *a,int *lda,float *b,int *ldb,int *jpvt,float *rcond,int *rank,float *work,int *info);
void    SGELSY(int *m,int *n,int *nrhs,float *a,int *lda,float *b,int *ldb,int *jpvt,float *rcond,int *rank,float *work,int *lwork,int *info);
void    sgelsy(int *m,int *n,int *nrhs,float *a,int *lda,float *b,int *ldb,int *jpvt,float *rcond,int *rank,float *work,int *lwork,int *info);
void    SGEQL2(int *m,int *n,float *a,int *lda,float *tau,float *work,int *info);
void    sgeql2(int *m,int *n,float *a,int *lda,float *tau,float *work,int *info);
void    SGEQLF(int *m,int *n,float *a,int *lda,float *tau,float *work,int *lwork,int *info);
void    sgeqlf(int *m,int *n,float *a,int *lda,float *tau,float *work,int *lwork,int *info);
void    SGEQP3(int *m,int *n,float *a,int *lda,int *jpvt,float *tau,float *work,int *lwork,int *info);
void    sgeqp3(int *m,int *n,float *a,int *lda,int *jpvt,float *tau,float *work,int *lwork,int *info);
void    SGEQPF(int *m,int *n,float *a,int *lda,int *jpvt,float *tau,float *work,int *info);
void    sgeqpf(int *m,int *n,float *a,int *lda,int *jpvt,float *tau,float *work,int *info);
void    SGEQR2(int *m,int *n,float *a,int *lda,float *tau,float *work,int *info);
void    sgeqr2(int *m,int *n,float *a,int *lda,float *tau,float *work,int *info);
void    SGEQRF(int *m,int *n,float *a,int *lda,float *tau,float *work,int *lwork,int *info);
void    sgeqrf(int *m,int *n,float *a,int *lda,float *tau,float *work,int *lwork,int *info);
void    SGERFS(char *trans,int *n,int *nrhs,float *a,int *lda,float *af,int *ldaf,int *ipiv,float *b,int *ldb,float *x,int *ldx,float *ferr,float *berr,float *work,int *iwork,int *info);
void    sgerfs(char *trans,int *n,int *nrhs,float *a,int *lda,float *af,int *ldaf,int *ipiv,float *b,int *ldb,float *x,int *ldx,float *ferr,float *berr,float *work,int *iwork,int *info);
void    SGERQ2(int *m,int *n,float *a,int *lda,float *tau,float *work,int *info);
void    sgerq2(int *m,int *n,float *a,int *lda,float *tau,float *work,int *info);
void    SGERQF(int *m,int *n,float *a,int *lda,float *tau,float *work,int *lwork,int *info);
void    sgerqf(int *m,int *n,float *a,int *lda,float *tau,float *work,int *lwork,int *info);
void    SGESC2(int *n,float *a,int *lda,float *rhs,int *ipiv,int *jpiv,float *scale);
void    sgesc2(int *n,float *a,int *lda,float *rhs,int *ipiv,int *jpiv,float *scale);
void    SGESDD(char *jobz,int *m,int *n,float *a,int *lda,float *s,float *u,int *ldu,float *vt,int *ldvt,float *work,int *lwork,int *iwork,int *info);
void    sgesdd(char *jobz,int *m,int *n,float *a,int *lda,float *s,float *u,int *ldu,float *vt,int *ldvt,float *work,int *lwork,int *iwork,int *info);
void    SGESV(int *n,int *nrhs,float *a,int *lda,int *ipiv,float *b,int *ldb,int *info);
void    sgesv(int *n,int *nrhs,float *a,int *lda,int *ipiv,float *b,int *ldb,int *info);
void    SGESVD(char *jobu,char *jobvt,int *m,int *n,float *a,int *lda,float *s,float *u,int *ldu,float *vt,int *ldvt,float *work,int *lwork,int *info);
void    sgesvd(char *jobu,char *jobvt,int *m,int *n,float *a,int *lda,float *s,float *u,int *ldu,float *vt,int *ldvt,float *work,int *lwork,int *info);
void    SGESVX(char *fact,char *trans,int *n,int *nrhs,float *a,int *lda,float *af,int *ldaf,int *ipiv,char *equed,float *r,float *c,float *b,int *ldb,float *x,int *ldx,float *rcond,float *ferr,float *berr,float *work,int *iwork,int *info);
void    sgesvx(char *fact,char *trans,int *n,int *nrhs,float *a,int *lda,float *af,int *ldaf,int *ipiv,char *equed,float *r,float *c,float *b,int *ldb,float *x,int *ldx,float *rcond,float *ferr,float *berr,float *work,int *iwork,int *info);
void    SGETC2(int *n,float *a,int *lda,int *ipiv,int *jpiv,int *info);
void    sgetc2(int *n,float *a,int *lda,int *ipiv,int *jpiv,int *info);
void    SGETF2(int *m,int *n,float *a,int *lda,int *ipiv,int *info);
void    sgetf2(int *m,int *n,float *a,int *lda,int *ipiv,int *info);
void    SGETRF(int *m,int *n,float *a,int *lda,int *ipiv,int *info);
void    sgetrf(int *m,int *n,float *a,int *lda,int *ipiv,int *info);
void    SGETRI(int *n,float *a,int *lda,int *ipiv,float *work,int *lwork,int *info);
void    sgetri(int *n,float *a,int *lda,int *ipiv,float *work,int *lwork,int *info);
void    SGETRS(char *trans,int *n,int *nrhs,float *a,int *lda,int *ipiv,float *b,int *ldb,int *info);
void    sgetrs(char *trans,int *n,int *nrhs,float *a,int *lda,int *ipiv,float *b,int *ldb,int *info);
void    SGGBAK(char *job,char *side,int *n,int *ilo,int *ihi,float *lscale,float *rscale,int *m,float *v,int *ldv,int *info);
void    sggbak(char *job,char *side,int *n,int *ilo,int *ihi,float *lscale,float *rscale,int *m,float *v,int *ldv,int *info);
void    SGGBAL(char *job,int *n,float *a,int *lda,float *b,int *ldb,int *ilo,int *ihi,float *lscale,float *rscale,float *work,int *info);
void    sggbal(char *job,int *n,float *a,int *lda,float *b,int *ldb,int *ilo,int *ihi,float *lscale,float *rscale,float *work,int *info);
void    SGGES(char *jobvsl,char *jobvsr,char *sort,void *selctg,int *n,float *a,int *lda,float *b,int *ldb,int *sdim,float *alphar,float *alphai,float *beta,float *vsl,int *ldvsl,float *vsr,int *ldvsr,float *work,int *lwork,void *bwork,int *info);
void    sgges(char *jobvsl,char *jobvsr,char *sort,void *selctg,int *n,float *a,int *lda,float *b,int *ldb,int *sdim,float *alphar,float *alphai,float *beta,float *vsl,int *ldvsl,float *vsr,int *ldvsr,float *work,int *lwork,void *bwork,int *info);
void    SGGESX(char *jobvsl,char *jobvsr,char *sort,void *selctg,char *sense,int *n,float *a,int *lda,float *b,int *ldb,int *sdim,float *alphar,float *alphai,float *beta,float *vsl,int *ldvsl,float *vsr,int *ldvsr,float *rconde,float *rcondv,float *work,int *lwork,int *iwork,int *liwork,void *bwork,int *info);
void    sggesx(char *jobvsl,char *jobvsr,char *sort,void *selctg,char *sense,int *n,float *a,int *lda,float *b,int *ldb,int *sdim,float *alphar,float *alphai,float *beta,float *vsl,int *ldvsl,float *vsr,int *ldvsr,float *rconde,float *rcondv,float *work,int *lwork,int *iwork,int *liwork,void *bwork,int *info);
void    SGGEV(char *jobvl,char *jobvr,int *n,float *a,int *lda,float *b,int *ldb,float *alphar,float *alphai,float *beta,float *vl,int *ldvl,float *vr,int *ldvr,float *work,int *lwork,int *info);
void    sggev(char *jobvl,char *jobvr,int *n,float *a,int *lda,float *b,int *ldb,float *alphar,float *alphai,float *beta,float *vl,int *ldvl,float *vr,int *ldvr,float *work,int *lwork,int *info);
void    SGGEVX(char *balanc,char *jobvl,char *jobvr,char *sense,int *n,float *a,int *lda,float *b,int *ldb,float *alphar,float *alphai,float *beta,float *vl,int *ldvl,float *vr,int *ldvr,int *ilo,int *ihi,float *lscale,float *rscale,float *abnrm,float *bbnrm,float *rconde,float *rcondv,float *work,int *lwork,int *iwork,void *bwork,int *info);
void    sggevx(char *balanc,char *jobvl,char *jobvr,char *sense,int *n,float *a,int *lda,float *b,int *ldb,float *alphar,float *alphai,float *beta,float *vl,int *ldvl,float *vr,int *ldvr,int *ilo,int *ihi,float *lscale,float *rscale,float *abnrm,float *bbnrm,float *rconde,float *rcondv,float *work,int *lwork,int *iwork,void *bwork,int *info);
void    SGGGLM(int *n,int *m,int *p,float *a,int *lda,float *b,int *ldb,float *d,float *x,float *y,float *work,int *lwork,int *info);
void    sggglm(int *n,int *m,int *p,float *a,int *lda,float *b,int *ldb,float *d,float *x,float *y,float *work,int *lwork,int *info);
void    SGGHRD(char *compq,char *compz,int *n,int *ilo,int *ihi,float *a,int *lda,float *b,int *ldb,float *q,int *ldq,float *z,int *ldz,int *info);
void    sgghrd(char *compq,char *compz,int *n,int *ilo,int *ihi,float *a,int *lda,float *b,int *ldb,float *q,int *ldq,float *z,int *ldz,int *info);
void    SGGLSE(int *m,int *n,int *p,float *a,int *lda,float *b,int *ldb,float *c,float *d,float *x,float *work,int *lwork,int *info);
void    sgglse(int *m,int *n,int *p,float *a,int *lda,float *b,int *ldb,float *c,float *d,float *x,float *work,int *lwork,int *info);
void    SGGQRF(int *n,int *m,int *p,float *a,int *lda,float *taua,float *b,int *ldb,float *taub,float *work,int *lwork,int *info);
void    sggqrf(int *n,int *m,int *p,float *a,int *lda,float *taua,float *b,int *ldb,float *taub,float *work,int *lwork,int *info);
void    SGGRQF(int *m,int *p,int *n,float *a,int *lda,float *taua,float *b,int *ldb,float *taub,float *work,int *lwork,int *info);
void    sggrqf(int *m,int *p,int *n,float *a,int *lda,float *taua,float *b,int *ldb,float *taub,float *work,int *lwork,int *info);
void    SGGSVD(char *jobu,char *jobv,char *jobq,int *m,int *n,int *p,int *k,int *l,float *a,int *lda,float *b,int *ldb,float *alpha,float *beta,float *u,int *ldu,float *v,int *ldv,float *q,int *ldq,float *work,int *iwork,int *info);
void    sggsvd(char *jobu,char *jobv,char *jobq,int *m,int *n,int *p,int *k,int *l,float *a,int *lda,float *b,int *ldb,float *alpha,float *beta,float *u,int *ldu,float *v,int *ldv,float *q,int *ldq,float *work,int *iwork,int *info);
void    SGGSVP(char *jobu,char *jobv,char *jobq,int *m,int *p,int *n,float *a,int *lda,float *b,int *ldb,float *tola,float *tolb,int *k,int *l,float *u,int *ldu,float *v,int *ldv,float *q,int *ldq,int *iwork,float *tau,float *work,int *info);
void    sggsvp(char *jobu,char *jobv,char *jobq,int *m,int *p,int *n,float *a,int *lda,float *b,int *ldb,float *tola,float *tolb,int *k,int *l,float *u,int *ldu,float *v,int *ldv,float *q,int *ldq,int *iwork,float *tau,float *work,int *info);
void    SGTCON(char *norm,int *n,float *dl,float *d,float *du,float *du2,int *ipiv,float *anorm,float *rcond,float *work,int *iwork,int *info);
void    sgtcon(char *norm,int *n,float *dl,float *d,float *du,float *du2,int *ipiv,float *anorm,float *rcond,float *work,int *iwork,int *info);
void    SGTRFS(char *trans,int *n,int *nrhs,float *dl,float *d,float *du,float *dlf,float *df,float *duf,float *du2,int *ipiv,float *b,int *ldb,float *x,int *ldx,float *ferr,float *berr,float *work,int *iwork,int *info);
void    sgtrfs(char *trans,int *n,int *nrhs,float *dl,float *d,float *du,float *dlf,float *df,float *duf,float *du2,int *ipiv,float *b,int *ldb,float *x,int *ldx,float *ferr,float *berr,float *work,int *iwork,int *info);
void    SGTSV(int *n,int *nrhs,float *dl,float *d,float *du,float *b,int *ldb,int *info);
void    sgtsv(int *n,int *nrhs,float *dl,float *d,float *du,float *b,int *ldb,int *info);
void    SGTSVX(char *fact,char *trans,int *n,int *nrhs,float *dl,float *d,float *du,float *dlf,float *df,float *duf,float *du2,int *ipiv,float *b,int *ldb,float *x,int *ldx,float *rcond,float *ferr,float *berr,float *work,int *iwork,int *info);
void    sgtsvx(char *fact,char *trans,int *n,int *nrhs,float *dl,float *d,float *du,float *dlf,float *df,float *duf,float *du2,int *ipiv,float *b,int *ldb,float *x,int *ldx,float *rcond,float *ferr,float *berr,float *work,int *iwork,int *info);
void    SGTTRF(int *n,float *dl,float *d,float *du,float *du2,int *ipiv,int *info);
void    sgttrf(int *n,float *dl,float *d,float *du,float *du2,int *ipiv,int *info);
void    SGTTRS(char *trans,int *n,int *nrhs,float *dl,float *d,float *du,float *du2,int *ipiv,float *b,int *ldb,int *info);
void    sgttrs(char *trans,int *n,int *nrhs,float *dl,float *d,float *du,float *du2,int *ipiv,float *b,int *ldb,int *info);
void    SGTTS2(int *itrans,int *n,int *nrhs,float *dl,float *d,float *du,float *du2,int *ipiv,float *b,int *ldb);
void    sgtts2(int *itrans,int *n,int *nrhs,float *dl,float *d,float *du,float *du2,int *ipiv,float *b,int *ldb);
void    SHGEQZ(char *job,char *compq,char *compz,int *n,int *ilo,int *ihi,float *a,int *lda,float *b,int *ldb,float *alphar,float *alphai,float *beta,float *q,int *ldq,float *z,int *ldz,float *work,int *lwork,int *info);
void    shgeqz(char *job,char *compq,char *compz,int *n,int *ilo,int *ihi,float *a,int *lda,float *b,int *ldb,float *alphar,float *alphai,float *beta,float *q,int *ldq,float *z,int *ldz,float *work,int *lwork,int *info);
void    SHSEIN(char *side,char *eigsrc,char *initv,void *select,int *n,float *h,int *ldh,float *wr,float *wi,float *vl,int *ldvl,float *vr,int *ldvr,int *mm,int *m,float *work,int *ifaill,int *ifailr,int *info);
void    shsein(char *side,char *eigsrc,char *initv,void *select,int *n,float *h,int *ldh,float *wr,float *wi,float *vl,int *ldvl,float *vr,int *ldvr,int *mm,int *m,float *work,int *ifaill,int *ifailr,int *info);
void    SHSEQR(char *job,char *compz,int *n,int *ilo,int *ihi,float *h,int *ldh,float *wr,float *wi,float *z,int *ldz,float *work,int *lwork,int *info);
void    shseqr(char *job,char *compz,int *n,int *ilo,int *ihi,float *h,int *ldh,float *wr,float *wi,float *z,int *ldz,float *work,int *lwork,int *info);
void    SLABAD(float *,float *);
void    slabad(float *,float *);
void    SLABRD(int *m,int *n,int *nb,float *a,int *lda,float *d,float *e,float *tauq,float *taup,float *x,int *ldx,float *y,int *ldy);
void    slabrd(int *m,int *n,int *nb,float *a,int *lda,float *d,float *e,float *tauq,float *taup,float *x,int *ldx,float *y,int *ldy);
void    SLACON(int *n,float *v,float *x,int *isgn,float *est,int *kase);
void    slacon(int *n,float *v,float *x,int *isgn,float *est,int *kase);
void    SLACPY(char *uplo,int *m,int *n,float *a,int *lda,float *b,int *ldb);
void    slacpy(char *uplo,int *m,int *n,float *a,int *lda,float *b,int *ldb);
void    SLADIV(float *a,float *b,float *c,float *d,float *p,float *q);
void    sladiv(float *a,float *b,float *c,float *d,float *p,float *q);
void    SLAE2(float *a,float *b,float *c,float *rt1,float *rt2);
void    slae2(float *a,float *b,float *c,float *rt1,float *rt2);
void    SLAEBZ(int *ijob,int *nitmax,int *n,int *mmax,int *minp,int *nbmin,float *abstol,float *reltol,float *pivmin,float *d,float *e,float *e2,int *nval,float *ab,float *c,int *mout,int *nab,float *work,int *iwork,int *info);
void    slaebz(int *ijob,int *nitmax,int *n,int *mmax,int *minp,int *nbmin,float *abstol,float *reltol,float *pivmin,float *d,float *e,float *e2,int *nval,float *ab,float *c,int *mout,int *nab,float *work,int *iwork,int *info);
void    SLAED0(int *icompq,int *qsiz,int *n,float *d,float *e,float *q,int *ldq,float *qstore,int *ldqs,float *work,int *iwork,int *info);
void    slaed0(int *icompq,int *qsiz,int *n,float *d,float *e,float *q,int *ldq,float *qstore,int *ldqs,float *work,int *iwork,int *info);
void    SLAED1(int *n,float *d,float *q,int *ldq,int *indxq,float *rho,int *cutpnt,float *work,int *iwork,int *info);
void    slaed1(int *n,float *d,float *q,int *ldq,int *indxq,float *rho,int *cutpnt,float *work,int *iwork,int *info);
void    SLAED2(int *k,int *n,int *n1,float *d,float *q,int *ldq,int *indxq,float *rho,float *z,float *dlamda,float *w,float *q2,int *indx,int *indxc,int *indxp,int *coltyp,int *info);
void    slaed2(int *k,int *n,int *n1,float *d,float *q,int *ldq,int *indxq,float *rho,float *z,float *dlamda,float *w,float *q2,int *indx,int *indxc,int *indxp,int *coltyp,int *info);
void    SLAED3(int *k,int *n,int *n1,float *d,float *q,int *ldq,float *rho,float *dlamda,float *q2,int *indx,int *ctot,float *w,float *s,int *info);
void    slaed3(int *k,int *n,int *n1,float *d,float *q,int *ldq,float *rho,float *dlamda,float *q2,int *indx,int *ctot,float *w,float *s,int *info);
void    SLAED4(int *n,int *i,float *d,float *z,float *delta,float *rho,float *dlam,int *info);
void    slaed4(int *n,int *i,float *d,float *z,float *delta,float *rho,float *dlam,int *info);
void    SLAED5(int *i,float *d,float *z,float *delta,float *rho,float *dlam);
void    slaed5(int *i,float *d,float *z,float *delta,float *rho,float *dlam);
void    SLAED6(int *kniter,void *orgati,float *rho,float *d,float *z,float *finit,float *tau,int *info);
void    slaed6(int *kniter,void *orgati,float *rho,float *d,float *z,float *finit,float *tau,int *info);
void    SLAED7(int *icompq,int *n,int *qsiz,int *tlvls,int *curlvl,int *curpbm,float *d,float *q,int *ldq,int *indxq,float *rho,int *cutpnt,float *qstore,int *qptr,int *prmptr,int *perm,int *givptr,int *givcol,float *givnum,float *work,int *iwork,int *info);
void    slaed7(int *icompq,int *n,int *qsiz,int *tlvls,int *curlvl,int *curpbm,float *d,float *q,int *ldq,int *indxq,float *rho,int *cutpnt,float *qstore,int *qptr,int *prmptr,int *perm,int *givptr,int *givcol,float *givnum,float *work,int *iwork,int *info);
void    SLAED8(int *icompq,int *k,int *n,int *qsiz,float *d,float *q,int *ldq,int *indxq,float *rho,int *cutpnt,float *z,float *dlamda,float *q2,int *ldq2,float *w,int *perm,int *givptr,int *givcol,float *givnum,int *indxp,int *indx,int *info);
void    slaed8(int *icompq,int *k,int *n,int *qsiz,float *d,float *q,int *ldq,int *indxq,float *rho,int *cutpnt,float *z,float *dlamda,float *q2,int *ldq2,float *w,int *perm,int *givptr,int *givcol,float *givnum,int *indxp,int *indx,int *info);
void    SLAED9(int *k,int *kstart,int *kstop,int *n,float *d,float *q,int *ldq,float *rho,float *dlamda,float *w,float *s,int *lds,int *info);
void    slaed9(int *k,int *kstart,int *kstop,int *n,float *d,float *q,int *ldq,float *rho,float *dlamda,float *w,float *s,int *lds,int *info);
void    SLAEDA(int *n,int *tlvls,int *curlvl,int *curpbm,int *prmptr,int *perm,int *givptr,int *givcol,float *givnum,float *q,int *qptr,float *z,float *ztemp,int *info);
void    slaeda(int *n,int *tlvls,int *curlvl,int *curpbm,int *prmptr,int *perm,int *givptr,int *givcol,float *givnum,float *q,int *qptr,float *z,float *ztemp,int *info);
void    SLAEIN(void *rightv,void *noinit,int *n,float *h,int *ldh,float *wr,float *wi,float *vr,float *vi,float *b,int *ldb,float *work,float *eps3,float *smlnum,float *bignum,int *info);
void    slaein(void *rightv,void *noinit,int *n,float *h,int *ldh,float *wr,float *wi,float *vr,float *vi,float *b,int *ldb,float *work,float *eps3,float *smlnum,float *bignum,int *info);
void    SLAEV2(float *a,float *b,float *c,float *rt1,float *rt2,float *cs1,float *sn1);
void    slaev2(float *a,float *b,float *c,float *rt1,float *rt2,float *cs1,float *sn1);
void    SLAEXC(void *wantq,int *n,float *t,int *ldt,float *q,int *ldq,int *j1,int *n1,int *n2,float *work,int *info);
void    slaexc(void *wantq,int *n,float *t,int *ldt,float *q,int *ldq,int *j1,int *n1,int *n2,float *work,int *info);
void    SLAG2(float *a,int *lda,float *b,int *ldb,float *safmin,float *scale1,float *scale2,float *wr1,float *wr2,float *wi);
void    slag2(float *a,int *lda,float *b,int *ldb,float *safmin,float *scale1,float *scale2,float *wr1,float *wr2,float *wi);
void    SLAGS2(void *upper,float *a1,float *a2,float *a3,float *b1,float *b2,float *b3,float *csu,float *snu,float *csv,float *snv,float *csq,float *snq);
void    slags2(void *upper,float *a1,float *a2,float *a3,float *b1,float *b2,float *b3,float *csu,float *snu,float *csv,float *snv,float *csq,float *snq);
void    SLAGTF(int *n,float *a,float *lambda,float *b,float *c,float *tol,float *d,int *in,int *info);
void    slagtf(int *n,float *a,float *lambda,float *b,float *c,float *tol,float *d,int *in,int *info);
void    SLAGTM(char *trans,int *n,int *nrhs,float *alpha,float *dl,float *d,float *du,float *x,int *ldx,float *beta,float *b,int *ldb);
void    slagtm(char *trans,int *n,int *nrhs,float *alpha,float *dl,float *d,float *du,float *x,int *ldx,float *beta,float *b,int *ldb);
void    SLAGTS(int *job,int *n,float *a,float *b,float *c,float *d,int *in,float *y,float *tol,int *info);
void    slagts(int *job,int *n,float *a,float *b,float *c,float *d,int *in,float *y,float *tol,int *info);
void    SLAGV2(float *a,int *lda,float *b,int *ldb,float *alphar,float *alphai,float *beta,float *csl,float *snl,float *csr,float *snr);
void    slagv2(float *a,int *lda,float *b,int *ldb,float *alphar,float *alphai,float *beta,float *csl,float *snl,float *csr,float *snr);
void    SLAHQR(void *wantt,void *wantz,int *n,int *ilo,int *ihi,float *h,int *ldh,float *wr,float *wi,int *iloz,int *ihiz,float *z,int *ldz,int *info);
void    slahqr(void *wantt,void *wantz,int *n,int *ilo,int *ihi,float *h,int *ldh,float *wr,float *wi,int *iloz,int *ihiz,float *z,int *ldz,int *info);
void    SLAHRD(int *n,int *k,int *nb,float *a,int *lda,float *tau,float *t,int *ldt,float *y,int *ldy);
void    slahrd(int *n,int *k,int *nb,float *a,int *lda,float *tau,float *t,int *ldt,float *y,int *ldy);
void    SLAIC1(int *job,int *j,float *x,float *sest,float *w,float *gamma,float *sestpr,float *s,float *c);
void    slaic1(int *job,int *j,float *x,float *sest,float *w,float *gamma,float *sestpr,float *s,float *c);
void    SLALN2(void *ltrans,int *na,int *nw,float *smin,float *ca,float *a,int *lda,float *d1,float *d2,float *b,int *ldb,float *wr,float *wi,float *x,int *ldx,float *scale,float *xnorm,int *info);
void    slaln2(void *ltrans,int *na,int *nw,float *smin,float *ca,float *a,int *lda,float *d1,float *d2,float *b,int *ldb,float *wr,float *wi,float *x,int *ldx,float *scale,float *xnorm,int *info);
void    SLALS0(int *icompq,int *nl,int *nr,int *sqre,int *nrhs,float *b,int *ldb,float *bx,int *ldbx,int *perm,int *givptr,int *givcol,int *ldgcol,float *givnum,int *ldgnum,float *poles,float *difl,float *difr,float *z,int *k,float *c,float *s,float *work,int *info);
void    slals0(int *icompq,int *nl,int *nr,int *sqre,int *nrhs,float *b,int *ldb,float *bx,int *ldbx,int *perm,int *givptr,int *givcol,int *ldgcol,float *givnum,int *ldgnum,float *poles,float *difl,float *difr,float *z,int *k,float *c,float *s,float *work,int *info);
void    SLALSA(int *icompq,int *smlsiz,int *n,int *nrhs,float *b,int *ldb,float *bx,int *ldbx,float *u,int *ldu,float *vt,int *k,float *difl,float *difr,float *z,float *poles,int *givptr,int *givcol,int *ldgcol,int *perm,float *givnum,float *c,float *s,float *work,int *iwork,int *info);
void    slalsa(int *icompq,int *smlsiz,int *n,int *nrhs,float *b,int *ldb,float *bx,int *ldbx,float *u,int *ldu,float *vt,int *k,float *difl,float *difr,float *z,float *poles,int *givptr,int *givcol,int *ldgcol,int *perm,float *givnum,float *c,float *s,float *work,int *iwork,int *info);
void    SLALSD(char *uplo,int *smlsiz,int *n,int *nrhs,float *d,float *e,float *b,int *ldb,float *rcond,int *rank,float *work,int *iwork,int *info);
void    slalsd(char *uplo,int *smlsiz,int *n,int *nrhs,float *d,float *e,float *b,int *ldb,float *rcond,int *rank,float *work,int *iwork,int *info);
float   SLAMC3(float *a,float *b);
float   slamc3(float *a,float *b);
float   SLAMCH(char *cmach);
float   slamch(char *cmach);
void    SLAMRG(int *n1,int *n2,float *a,int *strd1,int *strd2,int *index);
void    slamrg(int *n1,int *n2,float *a,int *strd1,int *strd2,int *index);
float   SLANGB(char *norm,int *n,int *kl,int *ku,float *ab,int *ldab,float *work);
float   slangb(char *norm,int *n,int *kl,int *ku,float *ab,int *ldab,float *work);
float   SLANGE(char *norm,int *m,int *n,float *a,int *lda,float *work);
float   slange(char *norm,int *m,int *n,float *a,int *lda,float *work);
float   SLANGT(char *norm,int *n,float *dl,float *d,float *du);
float   slangt(char *norm,int *n,float *dl,float *d,float *du);
float   SLANHS(char *norm,int *n,float *a,int *lda,float *work);
float   slanhs(char *norm,int *n,float *a,int *lda,float *work);
float   SLANSB(char *norm,char *uplo,int *n,int *k,float *ab,int *ldab,float *work);
float   slansb(char *norm,char *uplo,int *n,int *k,float *ab,int *ldab,float *work);
float   SLANSP(char *norm,char *uplo,int *n,float *ap,float *work);
float   slansp(char *norm,char *uplo,int *n,float *ap,float *work);
float   SLANST(char *norm,int *n,float *d,float *e);
float   slanst(char *norm,int *n,float *d,float *e);
float   SLANSY(char *norm,char *uplo,int *n,float *a,int *lda,float *work);
float   slansy(char *norm,char *uplo,int *n,float *a,int *lda,float *work);
float   SLANTB(char *norm,char *uplo,char *diag,int *n,int *k,float *ab,int *ldab,float *work);
float   slantb(char *norm,char *uplo,char *diag,int *n,int *k,float *ab,int *ldab,float *work);
float   SLANTP(char *norm,char *uplo,char *diag,int *n,float *ap,float *work);
float   slantp(char *norm,char *uplo,char *diag,int *n,float *ap,float *work);
float   SLANTR(char *norm,char *uplo,char *diag,int *m,int *n,float *a,int *lda,float *work);
float   slantr(char *norm,char *uplo,char *diag,int *m,int *n,float *a,int *lda,float *work);
void    SLANV2(float *a,float *b,float *c,float *d,float *rt1r,float *rt1i,float *rt2r,float *rt2i,float *cs,float *sn);
void    slanv2(float *a,float *b,float *c,float *d,float *rt1r,float *rt1i,float *rt2r,float *rt2i,float *cs,float *sn);
void    SLAPLL(int *n,float *x,int *incx,float *y,int *incy,float *ssmin);
void    slapll(int *n,float *x,int *incx,float *y,int *incy,float *ssmin);
void    SLAPMT(void *forwrd,int *m,int *n,float *x,int *ldx,int *k);
void    slapmt(void *forwrd,int *m,int *n,float *x,int *ldx,int *k);
float   SLAPY2(float *x,float *y);
float   slapy2(float *x,float *y);
float   SLAPY3(float *x,float *y,float *z);
float   slapy3(float *x,float *y,float *z);
void    SLAQGB(int *m,int *n,int *kl,int *ku,float *ab,int *ldab,float *r,float *c,float *rowcnd,float *colcnd,float *amax,char *equed);
void    slaqgb(int *m,int *n,int *kl,int *ku,float *ab,int *ldab,float *r,float *c,float *rowcnd,float *colcnd,float *amax,char *equed);
void    SLAQGE(int *m,int *n,float *a,int *lda,float *r,float *c,float *rowcnd,float *colcnd,float *amax,char *equed);
void    slaqge(int *m,int *n,float *a,int *lda,float *r,float *c,float *rowcnd,float *colcnd,float *amax,char *equed);
void    SLAQP2(int *m,int *n,int *offset,float *a,int *lda,int *jpvt,float *tau,float *vn1,float *vn2,float *work);
void    slaqp2(int *m,int *n,int *offset,float *a,int *lda,int *jpvt,float *tau,float *vn1,float *vn2,float *work);
void    SLAQPS(int *m,int *n,int *offset,int *nb,int *kb,float *a,int *lda,int *jpvt,float *tau,float *vn1,float *vn2,float *auxv,float *f,int *ldf);
void    slaqps(int *m,int *n,int *offset,int *nb,int *kb,float *a,int *lda,int *jpvt,float *tau,float *vn1,float *vn2,float *auxv,float *f,int *ldf);
void    SLAQSB(char *uplo,int *n,int *kd,float *ab,int *ldab,float *s,float *scond,float *amax,char *equed);
void    slaqsb(char *uplo,int *n,int *kd,float *ab,int *ldab,float *s,float *scond,float *amax,char *equed);
void    SLAQSP(char *uplo,int *n,float *ap,float *s,float *scond,float *amax,char *equed);
void    slaqsp(char *uplo,int *n,float *ap,float *s,float *scond,float *amax,char *equed);
void    SLAQSY(char *uplo,int *n,float *a,int *lda,float *s,float *scond,float *amax,char *equed);
void    slaqsy(char *uplo,int *n,float *a,int *lda,float *s,float *scond,float *amax,char *equed);
float   SLAQTR(float *ltran,void *lreal,float *n,float *t,int *ldt,float *b,float *w,float *scale,float *x,float *work,int *info);
float   slaqtr(float *ltran,void *lreal,float *n,float *t,int *ldt,float *b,float *w,float *scale,float *x,float *work,int *info);
void    SLAR1V(int *n,int *b1,int *bn,float *sigma,float *d,float *l,float *ld,float *lld,float *gersch,float *z,float *ztz,float *mingma,int *r,int *isuppz,float *work);
void    slar1v(int *n,int *b1,int *bn,float *sigma,float *d,float *l,float *ld,float *lld,float *gersch,float *z,float *ztz,float *mingma,int *r,int *isuppz,float *work);
void    SLAR2V(int *n,float *x,float *y,float *z,int *incx,float *c,float *s,int *incc);
void    slar2v(int *n,float *x,float *y,float *z,int *incx,float *c,float *s,int *incc);
void    SLARF(char *side,int *m,int *n,float *v,int *incv,float *tau,float *c,int *ldc,float *work);
void    slarf(char *side,int *m,int *n,float *v,int *incv,float *tau,float *c,int *ldc,float *work);
void    SLARFB(char *side,char *trans,char *direct,char *storev,int *m,int *n,int *k,float *v,int *ldv,float *t,int *ldt,float *c,int *ldc,float *work,int *ldwork);
void    slarfb(char *side,char *trans,char *direct,char *storev,int *m,int *n,int *k,float *v,int *ldv,float *t,int *ldt,float *c,int *ldc,float *work,int *ldwork);
void    SLARFG(int *n,float *alpha,float *x,int *incx,float *tau);
void    slarfg(int *n,float *alpha,float *x,int *incx,float *tau);
void    SLARFT(char *direct,char *storev,int *n,int *k,float *v,int *ldv,float *tau,float *t,int *ldt);
void    slarft(char *direct,char *storev,int *n,int *k,float *v,int *ldv,float *tau,float *t,int *ldt);
void    SLARFX(char *side,int *m,int *n,float *v,float *tau,float *c,int *ldc,float *work);
void    slarfx(char *side,int *m,int *n,float *v,float *tau,float *c,int *ldc,float *work);
void    SLARGV(int *n,float *x,int *incx,float *y,int *incy,float *c,int *incc);
void    slargv(int *n,float *x,int *incx,float *y,int *incy,float *c,int *incc);
void    SLARNV(int *idist,int *iseed,int *n,float *x);
void    slarnv(int *idist,int *iseed,int *n,float *x);
void    SLARRB(int *n,float *d,float *l,float *ld,float *lld,int *ifirst,int *ilast,float *sigma,float *reltol,float *w,float *wgap,float *werr,float *work,int *iwork,int *info);
void    slarrb(int *n,float *d,float *l,float *ld,float *lld,int *ifirst,int *ilast,float *sigma,float *reltol,float *w,float *wgap,float *werr,float *work,int *iwork,int *info);
void    SLARRE(int *n,float *d,float *e,float *tol,int *nsplit,int *isplit,int *m,float *w,float *woff,float *gersch,float *work,int *info);
void    slarre(int *n,float *d,float *e,float *tol,int *nsplit,int *isplit,int *m,float *w,float *woff,float *gersch,float *work,int *info);
void    SLARRF(int *n,float *d,float *l,float *ld,float *lld,int *ifirst,int *ilast,float *w,float *dplus,float *lplus,float *work,int *iwork,int *info);
void    slarrf(int *n,float *d,float *l,float *ld,float *lld,int *ifirst,int *ilast,float *w,float *dplus,float *lplus,float *work,int *iwork,int *info);
void    SLARRV(int *n,float *d,float *l,int *isplit,int *m,float *w,int *iblock,float *gersch,float *tol,float *z,int *ldz,int *isuppz,float *work,int *iwork,int *info);
void    slarrv(int *n,float *d,float *l,int *isplit,int *m,float *w,int *iblock,float *gersch,float *tol,float *z,int *ldz,int *isuppz,float *work,int *iwork,int *info);
void    SLARTG(float *f,float *g,float *cs,float *sn,float *r);
void    slartg(float *f,float *g,float *cs,float *sn,float *r);
void    SLARTV(int *n,float *x,int *incx,float *y,int *incy,float *c,float *s,int *incc);
void    slartv(int *n,float *x,int *incx,float *y,int *incy,float *c,float *s,int *incc);
void    SLARUV(int *iseed,int *n,float *x);
void    slaruv(int *iseed,int *n,float *x);
void    SLARZ(char *side,int *m,int *n,int *l,float *v,int *incv,float *tau,float *c,int *ldc,float *work);
void    slarz(char *side,int *m,int *n,int *l,float *v,int *incv,float *tau,float *c,int *ldc,float *work);
void    SLARZB(char *side,char *trans,char *direct,char *storev,int *m,int *n,int *k,int *l,float *v,int *ldv,float *t,int *ldt,float *c,int *ldc,float *work,int *ldwork);
void    slarzb(char *side,char *trans,char *direct,char *storev,int *m,int *n,int *k,int *l,float *v,int *ldv,float *t,int *ldt,float *c,int *ldc,float *work,int *ldwork);
void    SLARZT(char *direct,char *storev,int *n,int *k,float *v,int *ldv,float *tau,float *t,int *ldt);
void    slarzt(char *direct,char *storev,int *n,int *k,float *v,int *ldv,float *tau,float *t,int *ldt);
void    SLAS2(float *f,float *g,float *h,float *ssmin,float *ssmax);
void    slas2(float *f,float *g,float *h,float *ssmin,float *ssmax);
void    SLASCL(char *type,int *kl,int *ku,float *cfrom,float *cto,int *m,int *n,float *a,int *lda,int *info);
void    slascl(char *type,int *kl,int *ku,float *cfrom,float *cto,int *m,int *n,float *a,int *lda,int *info);
void    SLASD0(int *n,int *sqre,float *d,float *e,float *u,int *ldu,float *vt,int *ldvt,int *smlsiz,int *iwork,float *work,int *info);
void    slasd0(int *n,int *sqre,float *d,float *e,float *u,int *ldu,float *vt,int *ldvt,int *smlsiz,int *iwork,float *work,int *info);
void    SLASD1(int *nl,int *nr,int *sqre,float *d,float *alpha,float *beta,float *u,int *ldu,float *vt,int *ldvt,int *idxq,int *iwork,float *work,int *info);
void    slasd1(int *nl,int *nr,int *sqre,float *d,float *alpha,float *beta,float *u,int *ldu,float *vt,int *ldvt,int *idxq,int *iwork,float *work,int *info);
void    SLASD2(int *nl,int *nr,int *sqre,int *k,float *d,float *z,float *alpha,float *beta,float *u,int *ldu,float *vt,int *ldvt,float *dsigma,float *u2,int *ldu2,float *vt2,int *ldvt2,int *idxp,int *idx,int *idxc,int *idxq,int *coltyp,int *info);
void    slasd2(int *nl,int *nr,int *sqre,int *k,float *d,float *z,float *alpha,float *beta,float *u,int *ldu,float *vt,int *ldvt,float *dsigma,float *u2,int *ldu2,float *vt2,int *ldvt2,int *idxp,int *idx,int *idxc,int *idxq,int *coltyp,int *info);
void    SLASD3(int *nl,int *nr,int *sqre,int *k,float *d,float *q,int *ldq,float *dsigma,float *u,int *ldu,float *u2,int *ldu2,float *vt,int *ldvt,float *vt2,int *ldvt2,int *idxc,int *ctot,float *z,int *info);
void    slasd3(int *nl,int *nr,int *sqre,int *k,float *d,float *q,int *ldq,float *dsigma,float *u,int *ldu,float *u2,int *ldu2,float *vt,int *ldvt,float *vt2,int *ldvt2,int *idxc,int *ctot,float *z,int *info);
void    SLASD4(int *n,int *i,float *d,float *z,float *delta,float *rho,float *sigma,float *work,int *info);
void    slasd4(int *n,int *i,float *d,float *z,float *delta,float *rho,float *sigma,float *work,int *info);
void    SLASD5(int *i,float *d,float *z,float *delta,float *rho,float *dsigma,float *work);
void    slasd5(int *i,float *d,float *z,float *delta,float *rho,float *dsigma,float *work);
void    SLASD6(int *icompq,int *nl,int *nr,int *sqre,float *d,float *vf,float *vl,float *alpha,float *beta,int *idxq,int *perm,int *givptr,int *givcol,int *ldgcol,float *givnum,int *ldgnum,float *poles,float *difl,float *difr,float *z,int *k,float *c,float *s,float *work,int *iwork,int *info);
void    slasd6(int *icompq,int *nl,int *nr,int *sqre,float *d,float *vf,float *vl,float *alpha,float *beta,int *idxq,int *perm,int *givptr,int *givcol,int *ldgcol,float *givnum,int *ldgnum,float *poles,float *difl,float *difr,float *z,int *k,float *c,float *s,float *work,int *iwork,int *info);
void    SLASD7(int *icompq,int *nl,int *nr,int *sqre,int *k,float *d,float *z,float *zw,float *vf,float *vfw,float *vl,float *vlw,float *alpha,float *beta,float *dsigma,int *idx,int *idxp,int *idxq,int *perm,int *givptr,int *givcol,int *ldgcol,float *givnum,int *ldgnum,float *c,float *s,int *info);
void    slasd7(int *icompq,int *nl,int *nr,int *sqre,int *k,float *d,float *z,float *zw,float *vf,float *vfw,float *vl,float *vlw,float *alpha,float *beta,float *dsigma,int *idx,int *idxp,int *idxq,int *perm,int *givptr,int *givcol,int *ldgcol,float *givnum,int *ldgnum,float *c,float *s,int *info);
void    SLASD8(int *icompq,int *k,float *d,float *z,float *vf,float *vl,float *difl,float *difr,int *lddifr,float *dsigma,float *work,int *info);
void    slasd8(int *icompq,int *k,float *d,float *z,float *vf,float *vl,float *difl,float *difr,int *lddifr,float *dsigma,float *work,int *info);
void    SLASD9(int *icompq,int *ldu,int *k,float *d,float *z,float *vf,float *vl,float *difl,float *difr,float *dsigma,float *work,int *info);
void    slasd9(int *icompq,int *ldu,int *k,float *d,float *z,float *vf,float *vl,float *difl,float *difr,float *dsigma,float *work,int *info);
void    SLASDA(int *icompq,int *smlsiz,int *n,int *sqre,float *d,float *e,float *u,int *ldu,float *vt,int *k,float *difl,float *difr,float *z,float *poles,int *givptr,int *givcol,int *ldgcol,int *perm,float *givnum,float *c,float *s,float *work,int *iwork,int *info);
void    slasda(int *icompq,int *smlsiz,int *n,int *sqre,float *d,float *e,float *u,int *ldu,float *vt,int *k,float *difl,float *difr,float *z,float *poles,int *givptr,int *givcol,int *ldgcol,int *perm,float *givnum,float *c,float *s,float *work,int *iwork,int *info);
void    SLASDQ(char *uplo,int *sqre,int *n,int *ncvt,int *nru,int *ncc,float *d,float *e,float *vt,int *ldvt,float *u,int *ldu,float *c,int *ldc,float *work,int *info);
void    slasdq(char *uplo,int *sqre,int *n,int *ncvt,int *nru,int *ncc,float *d,float *e,float *vt,int *ldvt,float *u,int *ldu,float *c,int *ldc,float *work,int *info);
void    SLASDT(int *n,int *lvl,int *nd,int *inode,int *ndiml,int *ndimr,int *msub);
void    slasdt(int *n,int *lvl,int *nd,int *inode,int *ndiml,int *ndimr,int *msub);
void    SLASET(char *uplo,int *m,int *n,float *alpha,float *beta,float *a,int *lda);
void    slaset(char *uplo,int *m,int *n,float *alpha,float *beta,float *a,int *lda);
void    SLASQ1(int *n,float *d,float *e,float *work,int *info);
void    slasq1(int *n,float *d,float *e,float *work,int *info);
void    SLASQ2(int *n,float *z,int *info);
void    slasq2(int *n,float *z,int *info);
void    SLASQ3(int *i0,int *n0,float *z,int *pp,float *dmin,float *sigma,float *desig,float *qmax,int *nfail,int *iter,int *ndiv,void *ieee);
void    slasq3(int *i0,int *n0,float *z,int *pp,float *dmin,float *sigma,float *desig,float *qmax,int *nfail,int *iter,int *ndiv,void *ieee);
void    SLASQ4(int *i0,int *n0,float *z,int *pp,int *n0in,float *dmin,float *dmin1,float *dmin2,float *dn,float *dn1,float *dn2,float *tau,int *ttype);
void    slasq4(int *i0,int *n0,float *z,int *pp,int *n0in,float *dmin,float *dmin1,float *dmin2,float *dn,float *dn1,float *dn2,float *tau,int *ttype);
void    SLASQ5(int *i0,int *n0,float *z,int *pp,float *tau,float *dmin,float *dmin1,float *dmin2,float *dn,float *dnm1,float *dnm2,void *ieee);
void    slasq5(int *i0,int *n0,float *z,int *pp,float *tau,float *dmin,float *dmin1,float *dmin2,float *dn,float *dnm1,float *dnm2,void *ieee);
void    SLASQ6(int *i0,int *n0,float *z,int *pp,float *dmin,float *dmin1,float *dmin2,float *dn,float *dnm1,float *dnm2);
void    slasq6(int *i0,int *n0,float *z,int *pp,float *dmin,float *dmin1,float *dmin2,float *dn,float *dnm1,float *dnm2);
void    SLASR(char *side,char *pivot,char *direct,int *m,int *n,float *c,float *s,float *a,int *lda);
void    slasr(char *side,char *pivot,char *direct,int *m,int *n,float *c,float *s,float *a,int *lda);
void    SLASRT(char *id,int *n,float *d,int *info);
void    slasrt(char *id,int *n,float *d,int *info);
void    SLASSQ(int *n,float *x,int *incx,float *scale,float *sumsq);
void    slassq(int *n,float *x,int *incx,float *scale,float *sumsq);
void    SLASV2(float *f,float *g,float *h,float *ssmin,float *ssmax,float *snr,float *csr,float *snl,float *csl);
void    slasv2(float *f,float *g,float *h,float *ssmin,float *ssmax,float *snr,float *csr,float *snl,float *csl);
void    SLASWP(int *n,float *a,int *lda,int *k1,int *k2,int *ipiv,int *incx);
void    slaswp(int *n,float *a,int *lda,int *k1,int *k2,int *ipiv,int *incx);
void    SLASY2(void *ltranl,void *ltranr,int *isgn,int *n1,int *n2,float *tl,int *ldtl,float *tr,int *ldtr,float *b,int *ldb,float *scale,float *x,int *ldx,float *xnorm,int *info);
void    slasy2(void *ltranl,void *ltranr,int *isgn,int *n1,int *n2,float *tl,int *ldtl,float *tr,int *ldtr,float *b,int *ldb,float *scale,float *x,int *ldx,float *xnorm,int *info);
void    SLASYF(char *uplo,int *n,int *nb,int *kb,float *a,int *lda,int *ipiv,float *w,int *ldw,int *info);
void    slasyf(char *uplo,int *n,int *nb,int *kb,float *a,int *lda,int *ipiv,float *w,int *ldw,int *info);
void    SLATBS(char *uplo,char *trans,char *diag,char *normin,int *n,int *kd,float *ab,int *ldab,float *x,float *scale,float *cnorm,int *info);
void    slatbs(char *uplo,char *trans,char *diag,char *normin,int *n,int *kd,float *ab,int *ldab,float *x,float *scale,float *cnorm,int *info);
void    SLATDF(int *ijob,int *n,float *z,int *ldz,float *rhs,float *rdsum,float *rdscal,int *ipiv,int *jpiv);
void    slatdf(int *ijob,int *n,float *z,int *ldz,float *rhs,float *rdsum,float *rdscal,int *ipiv,int *jpiv);
void    SLATPS(char *uplo,char *trans,char *diag,char *normin,int *n,float *ap,float *x,float *scale,float *cnorm,int *info);
void    slatps(char *uplo,char *trans,char *diag,char *normin,int *n,float *ap,float *x,float *scale,float *cnorm,int *info);
void    SLATRD(char *uplo,int *n,int *nb,float *a,int *lda,float *e,float *tau,float *w,int *ldw);
void    slatrd(char *uplo,int *n,int *nb,float *a,int *lda,float *e,float *tau,float *w,int *ldw);
void    SLATRS(char *uplo,char *trans,char *diag,char *normin,int *n,float *a,int *lda,float *x,float *scale,float *cnorm,int *info);
void    slatrs(char *uplo,char *trans,char *diag,char *normin,int *n,float *a,int *lda,float *x,float *scale,float *cnorm,int *info);
void    SLATRZ(int *m,int *n,int *l,float *a,int *lda,float *tau,float *work);
void    slatrz(int *m,int *n,int *l,float *a,int *lda,float *tau,float *work);
void    SLATZM(char *side,int *m,int *n,float *v,int *incv,float *tau,float *c1,float *c2,int *ldc,float *work);
void    slatzm(char *side,int *m,int *n,float *v,int *incv,float *tau,float *c1,float *c2,int *ldc,float *work);
void    SLAUU2(char *uplo,int *n,float *a,int *lda,int *info);
void    slauu2(char *uplo,int *n,float *a,int *lda,int *info);
void    SLAUUM(char *uplo,int *n,float *a,int *lda,int *info);
void    slauum(char *uplo,int *n,float *a,int *lda,int *info);
void    SOPGTR(char *uplo,int *n,float *ap,float *tau,float *q,int *ldq,float *work,int *info);
void    sopgtr(char *uplo,int *n,float *ap,float *tau,float *q,int *ldq,float *work,int *info);
void    SOPMTR(char *side,char *uplo,char *trans,int *m,int *n,float *ap,float *tau,float *c,int *ldc,float *work,int *info);
void    sopmtr(char *side,char *uplo,char *trans,int *m,int *n,float *ap,float *tau,float *c,int *ldc,float *work,int *info);
void    SORG2L(int *m,int *n,int *k,float *a,int *lda,float *tau,float *work,int *info);
void    sorg2l(int *m,int *n,int *k,float *a,int *lda,float *tau,float *work,int *info);
void    SORG2R(int *m,int *n,int *k,float *a,int *lda,float *tau,float *work,int *info);
void    sorg2r(int *m,int *n,int *k,float *a,int *lda,float *tau,float *work,int *info);
void    SORGBR(char *vect,int *m,int *n,int *k,float *a,int *lda,float *tau,float *work,int *lwork,int *info);
void    sorgbr(char *vect,int *m,int *n,int *k,float *a,int *lda,float *tau,float *work,int *lwork,int *info);
void    SORGHR(int *n,int *ilo,int *ihi,float *a,int *lda,float *tau,float *work,int *lwork,int *info);
void    sorghr(int *n,int *ilo,int *ihi,float *a,int *lda,float *tau,float *work,int *lwork,int *info);
void    SORGL2(int *m,int *n,int *k,float *a,int *lda,float *tau,float *work,int *info);
void    sorgl2(int *m,int *n,int *k,float *a,int *lda,float *tau,float *work,int *info);
void    SORGLQ(int *m,int *n,int *k,float *a,int *lda,float *tau,float *work,int *lwork,int *info);
void    sorglq(int *m,int *n,int *k,float *a,int *lda,float *tau,float *work,int *lwork,int *info);
void    SORGQL(int *m,int *n,int *k,float *a,int *lda,float *tau,float *work,int *lwork,int *info);
void    sorgql(int *m,int *n,int *k,float *a,int *lda,float *tau,float *work,int *lwork,int *info);
void    SORGQR(int *m,int *n,int *k,float *a,int *lda,float *tau,float *work,int *lwork,int *info);
void    sorgqr(int *m,int *n,int *k,float *a,int *lda,float *tau,float *work,int *lwork,int *info);
void    SORGR2(int *m,int *n,int *k,float *a,int *lda,float *tau,float *work,int *info);
void    sorgr2(int *m,int *n,int *k,float *a,int *lda,float *tau,float *work,int *info);
void    SORGRQ(int *m,int *n,int *k,float *a,int *lda,float *tau,float *work,int *lwork,int *info);
void    sorgrq(int *m,int *n,int *k,float *a,int *lda,float *tau,float *work,int *lwork,int *info);
void    SORGTR(char *uplo,int *n,float *a,int *lda,float *tau,float *work,int *lwork,int *info);
void    sorgtr(char *uplo,int *n,float *a,int *lda,float *tau,float *work,int *lwork,int *info);
void    SORM2L(char *side,char *trans,int *m,int *n,int *k,float *a,int *lda,float *tau,float *c,int *ldc,float *work,int *info);
void    sorm2l(char *side,char *trans,int *m,int *n,int *k,float *a,int *lda,float *tau,float *c,int *ldc,float *work,int *info);
void    SORM2R(char *side,char *trans,int *m,int *n,int *k,float *a,int *lda,float *tau,float *c,int *ldc,float *work,int *info);
void    sorm2r(char *side,char *trans,int *m,int *n,int *k,float *a,int *lda,float *tau,float *c,int *ldc,float *work,int *info);
void    SORMBR(char *vect,char *side,char *trans,int *m,int *n,int *k,float *a,int *lda,float *tau,float *c,int *ldc,float *work,int *lwork,int *info);
void    sormbr(char *vect,char *side,char *trans,int *m,int *n,int *k,float *a,int *lda,float *tau,float *c,int *ldc,float *work,int *lwork,int *info);
void    SORMHR(char *side,char *trans,int *m,int *n,int *ilo,int *ihi,float *a,int *lda,float *tau,float *c,int *ldc,float *work,int *lwork,int *info);
void    sormhr(char *side,char *trans,int *m,int *n,int *ilo,int *ihi,float *a,int *lda,float *tau,float *c,int *ldc,float *work,int *lwork,int *info);
void    SORML2(char *side,char *trans,int *m,int *n,int *k,float *a,int *lda,float *tau,float *c,int *ldc,float *work,int *info);
void    sorml2(char *side,char *trans,int *m,int *n,int *k,float *a,int *lda,float *tau,float *c,int *ldc,float *work,int *info);
void    SORMLQ(char *side,char *trans,int *m,int *n,int *k,float *a,int *lda,float *tau,float *c,int *ldc,float *work,int *lwork,int *info);
void    sormlq(char *side,char *trans,int *m,int *n,int *k,float *a,int *lda,float *tau,float *c,int *ldc,float *work,int *lwork,int *info);
void    SORMQL(char *side,char *trans,int *m,int *n,int *k,float *a,int *lda,float *tau,float *c,int *ldc,float *work,int *lwork,int *info);
void    sormql(char *side,char *trans,int *m,int *n,int *k,float *a,int *lda,float *tau,float *c,int *ldc,float *work,int *lwork,int *info);
void    SORMQR(char *side,char *trans,int *m,int *n,int *k,float *a,int *lda,float *tau,float *c,int *ldc,float *work,int *lwork,int *info);
void    sormqr(char *side,char *trans,int *m,int *n,int *k,float *a,int *lda,float *tau,float *c,int *ldc,float *work,int *lwork,int *info);
void    SORMR2(char *side,char *trans,int *m,int *n,int *k,float *a,int *lda,float *tau,float *c,int *ldc,float *work,int *info);
void    sormr2(char *side,char *trans,int *m,int *n,int *k,float *a,int *lda,float *tau,float *c,int *ldc,float *work,int *info);
void    SORMR3(char *side,char *trans,int *m,int *n,int *k,int *l,float *a,int *lda,float *tau,float *c,int *ldc,float *work,int *info);
void    sormr3(char *side,char *trans,int *m,int *n,int *k,int *l,float *a,int *lda,float *tau,float *c,int *ldc,float *work,int *info);
void    SORMRQ(char *side,char *trans,int *m,int *n,int *k,float *a,int *lda,float *tau,float *c,int *ldc,float *work,int *lwork,int *info);
void    sormrq(char *side,char *trans,int *m,int *n,int *k,float *a,int *lda,float *tau,float *c,int *ldc,float *work,int *lwork,int *info);
void    SORMRZ(char *side,char *trans,int *m,int *n,int *k,int *l,float *a,int *lda,float *tau,float *c,int *ldc,float *work,int *lwork,int *info);
void    sormrz(char *side,char *trans,int *m,int *n,int *k,int *l,float *a,int *lda,float *tau,float *c,int *ldc,float *work,int *lwork,int *info);
void    SORMTR(char *side,char *uplo,char *trans,int *m,int *n,float *a,int *lda,float *tau,float *c,int *ldc,float *work,int *lwork,int *info);
void    sormtr(char *side,char *uplo,char *trans,int *m,int *n,float *a,int *lda,float *tau,float *c,int *ldc,float *work,int *lwork,int *info);
void    SPBCON(char *uplo,int *n,int *kd,float *ab,int *ldab,float *anorm,float *rcond,float *work,int *iwork,int *info);
void    spbcon(char *uplo,int *n,int *kd,float *ab,int *ldab,float *anorm,float *rcond,float *work,int *iwork,int *info);
void    SPBEQU(char *uplo,int *n,int *kd,float *ab,int *ldab,float *s,float *scond,float *amax,int *info);
void    spbequ(char *uplo,int *n,int *kd,float *ab,int *ldab,float *s,float *scond,float *amax,int *info);
void    SPBRFS(char *uplo,int *n,int *kd,int *nrhs,float *ab,int *ldab,float *afb,int *ldafb,float *b,int *ldb,float *x,int *ldx,float *ferr,float *berr,float *work,int *iwork,int *info);
void    spbrfs(char *uplo,int *n,int *kd,int *nrhs,float *ab,int *ldab,float *afb,int *ldafb,float *b,int *ldb,float *x,int *ldx,float *ferr,float *berr,float *work,int *iwork,int *info);
void    SPBSTF(char *uplo,int *n,int *kd,float *ab,int *ldab,int *info);
void    spbstf(char *uplo,int *n,int *kd,float *ab,int *ldab,int *info);
void    SPBSV(char *uplo,int *n,int *kd,int *nrhs,float *ab,int *ldab,float *b,int *ldb,int *info);
void    spbsv(char *uplo,int *n,int *kd,int *nrhs,float *ab,int *ldab,float *b,int *ldb,int *info);
void    SPBSVX(char *fact,char *uplo,int *n,int *kd,int *nrhs,float *ab,int *ldab,float *afb,int *ldafb,char *equed,float *s,float *b,int *ldb,float *x,int *ldx,float *rcond,float *ferr,float *berr,float *work,int *iwork,int *info);
void    spbsvx(char *fact,char *uplo,int *n,int *kd,int *nrhs,float *ab,int *ldab,float *afb,int *ldafb,char *equed,float *s,float *b,int *ldb,float *x,int *ldx,float *rcond,float *ferr,float *berr,float *work,int *iwork,int *info);
void    SPBTF2(char *uplo,int *n,int *kd,float *ab,int *ldab,int *info);
void    spbtf2(char *uplo,int *n,int *kd,float *ab,int *ldab,int *info);
void    SPBTRF(char *uplo,int *n,int *kd,float *ab,int *ldab,int *info);
void    spbtrf(char *uplo,int *n,int *kd,float *ab,int *ldab,int *info);
void    SPBTRS(char *uplo,int *n,int *kd,int *nrhs,float *ab,int *ldab,float *b,int *ldb,int *info);
void    spbtrs(char *uplo,int *n,int *kd,int *nrhs,float *ab,int *ldab,float *b,int *ldb,int *info);
void    SPOCON(char *uplo,int *n,float *a,int *lda,float *anorm,float *rcond,float *work,int *iwork,int *info);
void    spocon(char *uplo,int *n,float *a,int *lda,float *anorm,float *rcond,float *work,int *iwork,int *info);
void    SPOEQU(int *n,float *a,int *lda,float *s,float *scond,float *amax,int *info);
void    spoequ(int *n,float *a,int *lda,float *s,float *scond,float *amax,int *info);
void    SPORFS(char *uplo,int *n,int *nrhs,float *a,int *lda,float *af,int *ldaf,float *b,int *ldb,float *x,int *ldx,float *ferr,float *berr,float *work,int *iwork,int *info);
void    sporfs(char *uplo,int *n,int *nrhs,float *a,int *lda,float *af,int *ldaf,float *b,int *ldb,float *x,int *ldx,float *ferr,float *berr,float *work,int *iwork,int *info);
void    SPOSV(char *uplo,int *n,int *nrhs,float *a,int *lda,float *b,int *ldb,int *info);
void    sposv(char *uplo,int *n,int *nrhs,float *a,int *lda,float *b,int *ldb,int *info);
void    SPOSVX(char *fact,char *uplo,int *n,int *nrhs,float *a,int *lda,float *af,int *ldaf,char *equed,float *s,float *b,int *ldb,float *x,int *ldx,float *rcond,float *ferr,float *berr,float *work,int *iwork,int *info);
void    sposvx(char *fact,char *uplo,int *n,int *nrhs,float *a,int *lda,float *af,int *ldaf,char *equed,float *s,float *b,int *ldb,float *x,int *ldx,float *rcond,float *ferr,float *berr,float *work,int *iwork,int *info);
void    SPOTF2(char *uplo,int *n,float *a,int *lda,int *info);
void    spotf2(char *uplo,int *n,float *a,int *lda,int *info);
void    SPOTRF(char *uplo,int *n,float *a,int *lda,int *info);
void    spotrf(char *uplo,int *n,float *a,int *lda,int *info);
void    SPOTRI(char *uplo,int *n,float *a,int *lda,int *info);
void    spotri(char *uplo,int *n,float *a,int *lda,int *info);
void    SPOTRS(char *uplo,int *n,int *nrhs,float *a,int *lda,float *b,int *ldb,int *info);
void    spotrs(char *uplo,int *n,int *nrhs,float *a,int *lda,float *b,int *ldb,int *info);
void    SPPCON(char *uplo,int *n,float *ap,float *anorm,float *rcond,float *work,int *iwork,int *info);
void    sppcon(char *uplo,int *n,float *ap,float *anorm,float *rcond,float *work,int *iwork,int *info);
void    SPPEQU(char *uplo,int *n,float *ap,float *s,float *scond,float *amax,int *info);
void    sppequ(char *uplo,int *n,float *ap,float *s,float *scond,float *amax,int *info);
void    SPPRFS(char *uplo,int *n,int *nrhs,float *ap,float *afp,float *b,int *ldb,float *x,int *ldx,float *ferr,float *berr,float *work,int *iwork,int *info);
void    spprfs(char *uplo,int *n,int *nrhs,float *ap,float *afp,float *b,int *ldb,float *x,int *ldx,float *ferr,float *berr,float *work,int *iwork,int *info);
void    SPPSV(char *uplo,int *n,int *nrhs,float *ap,float *b,int *ldb,int *info);
void    sppsv(char *uplo,int *n,int *nrhs,float *ap,float *b,int *ldb,int *info);
void    SPPSVX(char *fact,char *uplo,int *n,int *nrhs,float *ap,float *afp,char *equed,float *s,float *b,int *ldb,float *x,int *ldx,float *rcond,float *ferr,float *berr,float *work,int *iwork,int *info);
void    sppsvx(char *fact,char *uplo,int *n,int *nrhs,float *ap,float *afp,char *equed,float *s,float *b,int *ldb,float *x,int *ldx,float *rcond,float *ferr,float *berr,float *work,int *iwork,int *info);
void    SPPTRF(char *uplo,int *n,float *ap,int *info);
void    spptrf(char *uplo,int *n,float *ap,int *info);
void    SPPTRI(char *uplo,int *n,float *ap,int *info);
void    spptri(char *uplo,int *n,float *ap,int *info);
void    SPPTRS(char *uplo,int *n,int *nrhs,float *ap,float *b,int *ldb,int *info);
void    spptrs(char *uplo,int *n,int *nrhs,float *ap,float *b,int *ldb,int *info);
void    SPTCON(int *n,float *d,float *e,float *anorm,float *rcond,float *work,int *info);
void    sptcon(int *n,float *d,float *e,float *anorm,float *rcond,float *work,int *info);
void    SPTEQR(char *compz,int *n,float *d,float *e,float *z,int *ldz,float *work,int *info);
void    spteqr(char *compz,int *n,float *d,float *e,float *z,int *ldz,float *work,int *info);
void    SPTRFS(int *n,int *nrhs,float *d,float *e,float *df,float *ef,float *b,int *ldb,float *x,int *ldx,float *ferr,float *berr,float *work,int *info);
void    sptrfs(int *n,int *nrhs,float *d,float *e,float *df,float *ef,float *b,int *ldb,float *x,int *ldx,float *ferr,float *berr,float *work,int *info);
void    SPTSV(int *n,int *nrhs,float *d,float *e,float *b,int *ldb,int *info);
void    sptsv(int *n,int *nrhs,float *d,float *e,float *b,int *ldb,int *info);
void    SPTSVX(char *fact,int *n,int *nrhs,float *d,float *e,float *df,float *ef,float *b,int *ldb,float *x,int *ldx,float *rcond,float *ferr,float *berr,float *work,int *info);
void    sptsvx(char *fact,int *n,int *nrhs,float *d,float *e,float *df,float *ef,float *b,int *ldb,float *x,int *ldx,float *rcond,float *ferr,float *berr,float *work,int *info);
void    SPTTRF(int *n,float *d,float *e,int *info);
void    spttrf(int *n,float *d,float *e,int *info);
void    SPTTRS(int *n,int *nrhs,float *d,float *e,float *b,int *ldb,int *info);
void    spttrs(int *n,int *nrhs,float *d,float *e,float *b,int *ldb,int *info);
void    SPTTS2(int *n,int *nrhs,float *d,float *e,float *b,int *ldb);
void    sptts2(int *n,int *nrhs,float *d,float *e,float *b,int *ldb);
void    SRSCL(int *n,float *sa,float *sx,int *incx);
void    srscl(int *n,float *sa,float *sx,int *incx);
void    SSBEV(char *jobz,char *uplo,int *n,int *kd,float *ab,int *ldab,float *w,float *z,int *ldz,float *work,int *info);
void    ssbev(char *jobz,char *uplo,int *n,int *kd,float *ab,int *ldab,float *w,float *z,int *ldz,float *work,int *info);
void    SSBEVD(char *jobz,char *uplo,int *n,int *kd,float *ab,int *ldab,float *w,float *z,int *ldz,float *work,int *lwork,int *iwork,int *liwork,int *info);
void    ssbevd(char *jobz,char *uplo,int *n,int *kd,float *ab,int *ldab,float *w,float *z,int *ldz,float *work,int *lwork,int *iwork,int *liwork,int *info);
void    SSBEVX(char *jobz,char *range,char *uplo,int *n,int *kd,float *ab,int *ldab,float *q,int *ldq,float *vl,float *vu,int *il,int *iu,float *abstol,int *m,float *w,float *z,int *ldz,float *work,int *iwork,int *ifail,int *info);
void    ssbevx(char *jobz,char *range,char *uplo,int *n,int *kd,float *ab,int *ldab,float *q,int *ldq,float *vl,float *vu,int *il,int *iu,float *abstol,int *m,float *w,float *z,int *ldz,float *work,int *iwork,int *ifail,int *info);
void    SSBGST(char *vect,char *uplo,int *n,int *ka,int *kb,float *ab,int *ldab,float *bb,int *ldbb,float *x,int *ldx,float *work,int *info);
void    ssbgst(char *vect,char *uplo,int *n,int *ka,int *kb,float *ab,int *ldab,float *bb,int *ldbb,float *x,int *ldx,float *work,int *info);
void    SSBGV(char *jobz,char *uplo,int *n,int *ka,int *kb,float *ab,int *ldab,float *bb,int *ldbb,float *w,float *z,int *ldz,float *work,int *info);
void    ssbgv(char *jobz,char *uplo,int *n,int *ka,int *kb,float *ab,int *ldab,float *bb,int *ldbb,float *w,float *z,int *ldz,float *work,int *info);
void    SSBGVD(char *jobz,char *uplo,int *n,int *ka,int *kb,float *ab,int *ldab,float *bb,int *ldbb,float *w,float *z,int *ldz,float *work,int *lwork,int *iwork,int *liwork,int *info);
void    ssbgvd(char *jobz,char *uplo,int *n,int *ka,int *kb,float *ab,int *ldab,float *bb,int *ldbb,float *w,float *z,int *ldz,float *work,int *lwork,int *iwork,int *liwork,int *info);
void    SSBGVX(char *jobz,char *range,char *uplo,int *n,int *ka,int *kb,float *ab,int *ldab,float *bb,int *ldbb,float *q,int *ldq,float *vl,float *vu,int *il,int *iu,float *abstol,int *m,float *w,float *z,int *ldz,float *work,int *iwork,int *ifail,int *info);
void    ssbgvx(char *jobz,char *range,char *uplo,int *n,int *ka,int *kb,float *ab,int *ldab,float *bb,int *ldbb,float *q,int *ldq,float *vl,float *vu,int *il,int *iu,float *abstol,int *m,float *w,float *z,int *ldz,float *work,int *iwork,int *ifail,int *info);
void    SSBTRD(char *vect,char *uplo,int *n,int *kd,float *ab,int *ldab,float *d,float *e,float *q,int *ldq,float *work,int *info);
void    ssbtrd(char *vect,char *uplo,int *n,int *kd,float *ab,int *ldab,float *d,float *e,float *q,int *ldq,float *work,int *info);
void    SSPCON(char *uplo,int *n,float *ap,int *ipiv,float *anorm,float *rcond,float *work,int *iwork,int *info);
void    sspcon(char *uplo,int *n,float *ap,int *ipiv,float *anorm,float *rcond,float *work,int *iwork,int *info);
void    SSPEV(char *jobz,char *uplo,int *n,float *ap,float *w,float *z,int *ldz,float *work,int *info);
void    sspev(char *jobz,char *uplo,int *n,float *ap,float *w,float *z,int *ldz,float *work,int *info);
void    SSPEVD(char *jobz,char *uplo,int *n,float *ap,float *w,float *z,int *ldz,float *work,int *lwork,int *iwork,int *liwork,int *info);
void    sspevd(char *jobz,char *uplo,int *n,float *ap,float *w,float *z,int *ldz,float *work,int *lwork,int *iwork,int *liwork,int *info);
void    SSPEVX(char *jobz,char *range,char *uplo,int *n,float *ap,float *vl,float *vu,int *il,int *iu,float *abstol,int *m,float *w,float *z,int *ldz,float *work,int *iwork,int *ifail,int *info);
void    sspevx(char *jobz,char *range,char *uplo,int *n,float *ap,float *vl,float *vu,int *il,int *iu,float *abstol,int *m,float *w,float *z,int *ldz,float *work,int *iwork,int *ifail,int *info);
void    SSPGST(int *itype,char *uplo,int *n,float *ap,float *bp,int *info);
void    sspgst(int *itype,char *uplo,int *n,float *ap,float *bp,int *info);
void    SSPGV(int *itype,char *jobz,char *uplo,int *n,float *ap,float *bp,float *w,float *z,int *ldz,float *work,int *info);
void    sspgv(int *itype,char *jobz,char *uplo,int *n,float *ap,float *bp,float *w,float *z,int *ldz,float *work,int *info);
void    SSPGVD(int *itype,char *jobz,char *uplo,int *n,float *ap,float *bp,float *w,float *z,int *ldz,float *work,int *lwork,int *iwork,int *liwork,int *info);
void    sspgvd(int *itype,char *jobz,char *uplo,int *n,float *ap,float *bp,float *w,float *z,int *ldz,float *work,int *lwork,int *iwork,int *liwork,int *info);
void    SSPGVX(int *itype,char *jobz,char *range,char *uplo,int *n,float *ap,float *bp,float *vl,float *vu,int *il,int *iu,float *abstol,int *m,float *w,float *z,int *ldz,float *work,int *iwork,int *ifail,int *info);
void    sspgvx(int *itype,char *jobz,char *range,char *uplo,int *n,float *ap,float *bp,float *vl,float *vu,int *il,int *iu,float *abstol,int *m,float *w,float *z,int *ldz,float *work,int *iwork,int *ifail,int *info);
void    SSPRFS(char *uplo,int *n,int *nrhs,float *ap,float *afp,int *ipiv,float *b,int *ldb,float *x,int *ldx,float *ferr,float *berr,float *work,int *iwork,int *info);
void    ssprfs(char *uplo,int *n,int *nrhs,float *ap,float *afp,int *ipiv,float *b,int *ldb,float *x,int *ldx,float *ferr,float *berr,float *work,int *iwork,int *info);
void    SSPSV(char *uplo,int *n,int *nrhs,float *ap,int *ipiv,float *b,int *ldb,int *info);
void    sspsv(char *uplo,int *n,int *nrhs,float *ap,int *ipiv,float *b,int *ldb,int *info);
void    SSPSVX(char *fact,char *uplo,int *n,int *nrhs,float *ap,float *afp,int *ipiv,float *b,int *ldb,float *x,int *ldx,float *rcond,float *ferr,float *berr,float *work,int *iwork,int *info);
void    sspsvx(char *fact,char *uplo,int *n,int *nrhs,float *ap,float *afp,int *ipiv,float *b,int *ldb,float *x,int *ldx,float *rcond,float *ferr,float *berr,float *work,int *iwork,int *info);
void    SSPTRD(char *uplo,int *n,float *ap,float *d,float *e,float *tau,int *info);
void    ssptrd(char *uplo,int *n,float *ap,float *d,float *e,float *tau,int *info);
void    SSPTRF(char *uplo,int *n,float *ap,int *ipiv,int *info);
void    ssptrf(char *uplo,int *n,float *ap,int *ipiv,int *info);
void    SSPTRI(char *uplo,int *n,float *ap,int *ipiv,float *work,int *info);
void    ssptri(char *uplo,int *n,float *ap,int *ipiv,float *work,int *info);
void    SSPTRS(char *uplo,int *n,int *nrhs,float *ap,int *ipiv,float *b,int *ldb,int *info);
void    ssptrs(char *uplo,int *n,int *nrhs,float *ap,int *ipiv,float *b,int *ldb,int *info);
void    SSTEBZ(char *range,char *order,int *n,float *vl,float *vu,int *il,int *iu,float *abstol,float *d,float *e,int *m,int *nsplit,float *w,int *iblock,int *isplit,float *work,int *iwork,int *info);
void    sstebz(char *range,char *order,int *n,float *vl,float *vu,int *il,int *iu,float *abstol,float *d,float *e,int *m,int *nsplit,float *w,int *iblock,int *isplit,float *work,int *iwork,int *info);
void    SSTEDC(char *compz,int *n,float *d,float *e,float *z,int *ldz,float *work,int *lwork,int *iwork,int *liwork,int *info);
void    sstedc(char *compz,int *n,float *d,float *e,float *z,int *ldz,float *work,int *lwork,int *iwork,int *liwork,int *info);
void    SSTEGR(char *jobz,char *range,int *n,float *d,float *e,float *vl,float *vu,int *il,int *iu,float *abstol,int *m,float *w,float *z,int *ldz,int *isuppz,float *work,int *lwork,int *iwork,int *liwork,int *info);
void    sstegr(char *jobz,char *range,int *n,float *d,float *e,float *vl,float *vu,int *il,int *iu,float *abstol,int *m,float *w,float *z,int *ldz,int *isuppz,float *work,int *lwork,int *iwork,int *liwork,int *info);
void    SSTEIN(int *n,float *d,float *e,int *m,float *w,int *iblock,int *isplit,float *z,int *ldz,float *work,int *iwork,int *ifail,int *info);
void    sstein(int *n,float *d,float *e,int *m,float *w,int *iblock,int *isplit,float *z,int *ldz,float *work,int *iwork,int *ifail,int *info);
void    SSTEQR(char *compz,int *n,float *d,float *e,float *z,int *ldz,float *work,int *info);
void    ssteqr(char *compz,int *n,float *d,float *e,float *z,int *ldz,float *work,int *info);
void    SSTERF(int *n,float *d,float *e,int *info);
void    ssterf(int *n,float *d,float *e,int *info);
void    SSTEV(char *jobz,int *n,float *d,float *e,float *z,int *ldz,float *work,int *info);
void    sstev(char *jobz,int *n,float *d,float *e,float *z,int *ldz,float *work,int *info);
void    SSTEVD(char *jobz,int *n,float *d,float *e,float *z,int *ldz,float *work,int *lwork,int *iwork,int *liwork,int *info);
void    sstevd(char *jobz,int *n,float *d,float *e,float *z,int *ldz,float *work,int *lwork,int *iwork,int *liwork,int *info);
void    SSTEVR(char *jobz,char *range,int *n,float *d,float *e,float *vl,float *vu,int *il,int *iu,float *abstol,int *m,float *w,float *z,int *ldz,int *isuppz,float *work,int *lwork,int *iwork,int *liwork,int *info);
void    sstevr(char *jobz,char *range,int *n,float *d,float *e,float *vl,float *vu,int *il,int *iu,float *abstol,int *m,float *w,float *z,int *ldz,int *isuppz,float *work,int *lwork,int *iwork,int *liwork,int *info);
void    SSTEVX(char *jobz,char *range,int *n,float *d,float *e,float *vl,float *vu,int *il,int *iu,float *abstol,int *m,float *w,float *z,int *ldz,float *work,int *iwork,int *ifail,int *info);
void    sstevx(char *jobz,char *range,int *n,float *d,float *e,float *vl,float *vu,int *il,int *iu,float *abstol,int *m,float *w,float *z,int *ldz,float *work,int *iwork,int *ifail,int *info);
void    SSYCON(char *uplo,int *n,float *a,int *lda,int *ipiv,float *anorm,float *rcond,float *work,int *iwork,int *info);
void    ssycon(char *uplo,int *n,float *a,int *lda,int *ipiv,float *anorm,float *rcond,float *work,int *iwork,int *info);
void    SSYEV(char *jobz,char *uplo,int *n,float *a,int *lda,float *w,float *work,int *lwork,int *info);
void    ssyev(char *jobz,char *uplo,int *n,float *a,int *lda,float *w,float *work,int *lwork,int *info);
void    SSYEVD(char *jobz,char *uplo,int *n,float *a,int *lda,float *w,float *work,int *lwork,int *iwork,int *liwork,int *info);
void    ssyevd(char *jobz,char *uplo,int *n,float *a,int *lda,float *w,float *work,int *lwork,int *iwork,int *liwork,int *info);
void    SSYEVR(char *jobz,char *range,char *uplo,int *n,float *a,int *lda,float *vl,float *vu,int *il,int *iu,float *abstol,int *m,float *w,float *z,int *ldz,int *isuppz,float *work,int *lwork,int *iwork,int *liwork,int *info);
void    ssyevr(char *jobz,char *range,char *uplo,int *n,float *a,int *lda,float *vl,float *vu,int *il,int *iu,float *abstol,int *m,float *w,float *z,int *ldz,int *isuppz,float *work,int *lwork,int *iwork,int *liwork,int *info);
void    SSYEVX(char *jobz,char *range,char *uplo,int *n,float *a,int *lda,float *vl,float *vu,int *il,int *iu,float *abstol,int *m,float *w,float *z,int *ldz,float *work,int *lwork,int *iwork,int *ifail,int *info);
void    ssyevx(char *jobz,char *range,char *uplo,int *n,float *a,int *lda,float *vl,float *vu,int *il,int *iu,float *abstol,int *m,float *w,float *z,int *ldz,float *work,int *lwork,int *iwork,int *ifail,int *info);
void    SSYGS2(int *itype,char *uplo,int *n,float *a,int *lda,float *b,int *ldb,int *info);
void    ssygs2(int *itype,char *uplo,int *n,float *a,int *lda,float *b,int *ldb,int *info);
void    SSYGST(int *itype,char *uplo,int *n,float *a,int *lda,float *b,int *ldb,int *info);
void    ssygst(int *itype,char *uplo,int *n,float *a,int *lda,float *b,int *ldb,int *info);
void    SSYGV(int *itype,char *jobz,char *uplo,int *n,float *a,int *lda,float *b,int *ldb,float *w,float *work,int *lwork,int *info);
void    ssygv(int *itype,char *jobz,char *uplo,int *n,float *a,int *lda,float *b,int *ldb,float *w,float *work,int *lwork,int *info);
void    SSYGVD(int *itype,char *jobz,char *uplo,int *n,float *a,int *lda,float *b,int *ldb,float *w,float *work,int *lwork,int *iwork,int *liwork,int *info);
void    ssygvd(int *itype,char *jobz,char *uplo,int *n,float *a,int *lda,float *b,int *ldb,float *w,float *work,int *lwork,int *iwork,int *liwork,int *info);
void    SSYGVX(int *itype,char *jobz,char *range,char *uplo,int *n,float *a,int *lda,float *b,int *ldb,float *vl,float *vu,int *il,int *iu,float *abstol,int *m,float *w,float *z,int *ldz,float *work,int *lwork,int *iwork,int *ifail,int *info);
void    ssygvx(int *itype,char *jobz,char *range,char *uplo,int *n,float *a,int *lda,float *b,int *ldb,float *vl,float *vu,int *il,int *iu,float *abstol,int *m,float *w,float *z,int *ldz,float *work,int *lwork,int *iwork,int *ifail,int *info);
void    SSYRFS(char *uplo,int *n,int *nrhs,float *a,int *lda,float *af,int *ldaf,int *ipiv,float *b,int *ldb,float *x,int *ldx,float *ferr,float *berr,float *work,int *iwork,int *info);
void    ssyrfs(char *uplo,int *n,int *nrhs,float *a,int *lda,float *af,int *ldaf,int *ipiv,float *b,int *ldb,float *x,int *ldx,float *ferr,float *berr,float *work,int *iwork,int *info);
void    SSYSV(char *uplo,int *n,int *nrhs,float *a,int *lda,int *ipiv,float *b,int *ldb,float *work,int *lwork,int *info);
void    ssysv(char *uplo,int *n,int *nrhs,float *a,int *lda,int *ipiv,float *b,int *ldb,float *work,int *lwork,int *info);
void    SSYSVX(char *fact,char *uplo,int *n,int *nrhs,float *a,int *lda,float *af,int *ldaf,int *ipiv,float *b,int *ldb,float *x,int *ldx,float *rcond,float *ferr,float *berr,float *work,int *lwork,int *iwork,int *info);
void    ssysvx(char *fact,char *uplo,int *n,int *nrhs,float *a,int *lda,float *af,int *ldaf,int *ipiv,float *b,int *ldb,float *x,int *ldx,float *rcond,float *ferr,float *berr,float *work,int *lwork,int *iwork,int *info);
void    SSYTD2(char *uplo,int *n,float *a,int *lda,float *d,float *e,float *tau,int *info);
void    ssytd2(char *uplo,int *n,float *a,int *lda,float *d,float *e,float *tau,int *info);
void    SSYTF2(char *uplo,int *n,float *a,int *lda,int *ipiv,int *info);
void    ssytf2(char *uplo,int *n,float *a,int *lda,int *ipiv,int *info);
void    SSYTRD(char *uplo,int *n,float *a,int *lda,float *d,float *e,float *tau,float *work,int *lwork,int *info);
void    ssytrd(char *uplo,int *n,float *a,int *lda,float *d,float *e,float *tau,float *work,int *lwork,int *info);
void    SSYTRF(char *uplo,int *n,float *a,int *lda,int *ipiv,float *work,int *lwork,int *info);
void    ssytrf(char *uplo,int *n,float *a,int *lda,int *ipiv,float *work,int *lwork,int *info);
void    SSYTRI(char *uplo,int *n,float *a,int *lda,int *ipiv,float *work,int *info);
void    ssytri(char *uplo,int *n,float *a,int *lda,int *ipiv,float *work,int *info);
void    SSYTRS(char *uplo,int *n,int *nrhs,float *a,int *lda,int *ipiv,float *b,int *ldb,int *info);
void    ssytrs(char *uplo,int *n,int *nrhs,float *a,int *lda,int *ipiv,float *b,int *ldb,int *info);
void    STBCON(char *norm,char *uplo,char *diag,int *n,int *kd,float *ab,int *ldab,float *rcond,float *work,int *iwork,int *info);
void    stbcon(char *norm,char *uplo,char *diag,int *n,int *kd,float *ab,int *ldab,float *rcond,float *work,int *iwork,int *info);
void    STBRFS(char *uplo,char *trans,char *diag,int *n,int *kd,int *nrhs,float *ab,int *ldab,float *b,int *ldb,float *x,int *ldx,float *ferr,float *berr,float *work,int *iwork,int *info);
void    stbrfs(char *uplo,char *trans,char *diag,int *n,int *kd,int *nrhs,float *ab,int *ldab,float *b,int *ldb,float *x,int *ldx,float *ferr,float *berr,float *work,int *iwork,int *info);
void    STBTRS(char *uplo,char *trans,char *diag,int *n,int *kd,int *nrhs,float *ab,int *ldab,float *b,int *ldb,int *info);
void    stbtrs(char *uplo,char *trans,char *diag,int *n,int *kd,int *nrhs,float *ab,int *ldab,float *b,int *ldb,int *info);
void    STGEVC(char *side,char *howmny,void *select,int *n,float *a,int *lda,float *b,int *ldb,float *vl,int *ldvl,float *vr,int *ldvr,int *mm,int *m,float *work,int *info);
void    stgevc(char *side,char *howmny,void *select,int *n,float *a,int *lda,float *b,int *ldb,float *vl,int *ldvl,float *vr,int *ldvr,int *mm,int *m,float *work,int *info);
void    STGEX2(void *wantq,void *wantz,int *n,float *a,int *lda,float *b,int *ldb,float *q,int *ldq,float *z,int *ldz,int *j1,int *n1,int *n2,float *work,int *lwork,int *info);
void    stgex2(void *wantq,void *wantz,int *n,float *a,int *lda,float *b,int *ldb,float *q,int *ldq,float *z,int *ldz,int *j1,int *n1,int *n2,float *work,int *lwork,int *info);
void    STGEXC(void *wantq,void *wantz,int *n,float *a,int *lda,float *b,int *ldb,float *q,int *ldq,float *z,int *ldz,int *ifst,int *ilst,float *work,int *lwork,int *info);
void    stgexc(void *wantq,void *wantz,int *n,float *a,int *lda,float *b,int *ldb,float *q,int *ldq,float *z,int *ldz,int *ifst,int *ilst,float *work,int *lwork,int *info);
void    STGSEN(int *ijob,void *wantq,void *wantz,void *select,int *n,float *a,int *lda,float *b,int *ldb,float *alphar,float *alphai,float *beta,float *q,int *ldq,float *z,int *ldz,int *m,float *pl,float *pr,float *dif,float *work,int *lwork,int *iwork,int *liwork,int *info);
void    stgsen(int *ijob,void *wantq,void *wantz,void *select,int *n,float *a,int *lda,float *b,int *ldb,float *alphar,float *alphai,float *beta,float *q,int *ldq,float *z,int *ldz,int *m,float *pl,float *pr,float *dif,float *work,int *lwork,int *iwork,int *liwork,int *info);
void    STGSJA(char *jobu,char *jobv,char *jobq,int *m,int *p,int *n,int *k,int *l,float *a,int *lda,float *b,int *ldb,float *tola,float *tolb,float *alpha,float *beta,float *u,int *ldu,float *v,int *ldv,float *q,int *ldq,float *work,int *ncycle,int *info);
void    stgsja(char *jobu,char *jobv,char *jobq,int *m,int *p,int *n,int *k,int *l,float *a,int *lda,float *b,int *ldb,float *tola,float *tolb,float *alpha,float *beta,float *u,int *ldu,float *v,int *ldv,float *q,int *ldq,float *work,int *ncycle,int *info);
void    STGSNA(char *job,char *howmny,void *select,int *n,float *a,int *lda,float *b,int *ldb,float *vl,int *ldvl,float *vr,int *ldvr,float *s,float *dif,int *mm,int *m,float *work,int *lwork,int *iwork,int *info);
void    stgsna(char *job,char *howmny,void *select,int *n,float *a,int *lda,float *b,int *ldb,float *vl,int *ldvl,float *vr,int *ldvr,float *s,float *dif,int *mm,int *m,float *work,int *lwork,int *iwork,int *info);
void    STGSY2(char *trans,int *ijob,int *m,int *n,float *a,int *lda,float *b,int *ldb,float *c,int *ldc,float *d,int *ldd,float *e,int *lde,float *f,int *ldf,float *scale,float *rdsum,float *rdscal,int *iwork,int *pq,int *info);
void    stgsy2(char *trans,int *ijob,int *m,int *n,float *a,int *lda,float *b,int *ldb,float *c,int *ldc,float *d,int *ldd,float *e,int *lde,float *f,int *ldf,float *scale,float *rdsum,float *rdscal,int *iwork,int *pq,int *info);
void    STGSYL(char *trans,int *ijob,int *m,int *n,float *a,int *lda,float *b,int *ldb,float *c,int *ldc,float *d,int *ldd,float *e,int *lde,float *f,int *ldf,float *scale,float *dif,float *work,int *lwork,int *iwork,int *info);
void    stgsyl(char *trans,int *ijob,int *m,int *n,float *a,int *lda,float *b,int *ldb,float *c,int *ldc,float *d,int *ldd,float *e,int *lde,float *f,int *ldf,float *scale,float *dif,float *work,int *lwork,int *iwork,int *info);
void    STPCON(char *norm,char *uplo,char *diag,int *n,float *ap,float *rcond,float *work,int *iwork,int *info);
void    stpcon(char *norm,char *uplo,char *diag,int *n,float *ap,float *rcond,float *work,int *iwork,int *info);
void    STPRFS(char *uplo,char *trans,char *diag,int *n,int *nrhs,float *ap,float *b,int *ldb,float *x,int *ldx,float *ferr,float *berr,float *work,int *iwork,int *info);
void    stprfs(char *uplo,char *trans,char *diag,int *n,int *nrhs,float *ap,float *b,int *ldb,float *x,int *ldx,float *ferr,float *berr,float *work,int *iwork,int *info);
void    STPTRI(char *uplo,char *diag,int *n,float *ap,int *info);
void    stptri(char *uplo,char *diag,int *n,float *ap,int *info);
void    STPTRS(char *uplo,char *trans,char *diag,int *n,int *nrhs,float *ap,float *b,int *ldb,int *info);
void    stptrs(char *uplo,char *trans,char *diag,int *n,int *nrhs,float *ap,float *b,int *ldb,int *info);
void    STRCON(char *norm,char *uplo,char *diag,int *n,float *a,int *lda,float *rcond,float *work,int *iwork,int *info);
void    strcon(char *norm,char *uplo,char *diag,int *n,float *a,int *lda,float *rcond,float *work,int *iwork,int *info);
void    STREVC(char *side,char *howmny,void *select,int *n,float *t,int *ldt,float *vl,int *ldvl,float *vr,int *ldvr,int *mm,int *m,float *work,int *info);
void    strevc(char *side,char *howmny,void *select,int *n,float *t,int *ldt,float *vl,int *ldvl,float *vr,int *ldvr,int *mm,int *m,float *work,int *info);
void    STREXC(char *compq,int *n,float *t,int *ldt,float *q,int *ldq,int *ifst,int *ilst,float *work,int *info);
void    strexc(char *compq,int *n,float *t,int *ldt,float *q,int *ldq,int *ifst,int *ilst,float *work,int *info);
void    STRRFS(char *uplo,char *trans,char *diag,int *n,int *nrhs,float *a,int *lda,float *b,int *ldb,float *x,int *ldx,float *ferr,float *berr,float *work,int *iwork,int *info);
void    strrfs(char *uplo,char *trans,char *diag,int *n,int *nrhs,float *a,int *lda,float *b,int *ldb,float *x,int *ldx,float *ferr,float *berr,float *work,int *iwork,int *info);
void    STRSEN(char *job,char *compq,void *select,int *n,float *t,int *ldt,float *q,int *ldq,float *wr,float *wi,int *m,float *s,float *sep,float *work,int *lwork,int *iwork,int *liwork,int *info);
void    strsen(char *job,char *compq,void *select,int *n,float *t,int *ldt,float *q,int *ldq,float *wr,float *wi,int *m,float *s,float *sep,float *work,int *lwork,int *iwork,int *liwork,int *info);
void    STRSNA(char *job,char *howmny,void *select,int *n,float *t,int *ldt,float *vl,int *ldvl,float *vr,int *ldvr,float *s,float *sep,int *mm,int *m,float *work,int *ldwork,int *iwork,int *info);
void    strsna(char *job,char *howmny,void *select,int *n,float *t,int *ldt,float *vl,int *ldvl,float *vr,int *ldvr,float *s,float *sep,int *mm,int *m,float *work,int *ldwork,int *iwork,int *info);
void    STRSYL(char *trana,char *tranb,int *isgn,int *m,int *n,float *a,int *lda,float *b,int *ldb,float *c,int *ldc,float *scale,int *info);
void    strsyl(char *trana,char *tranb,int *isgn,int *m,int *n,float *a,int *lda,float *b,int *ldb,float *c,int *ldc,float *scale,int *info);
void    STRTI2(char *uplo,char *diag,int *n,float *a,int *lda,int *info);
void    strti2(char *uplo,char *diag,int *n,float *a,int *lda,int *info);
void    STRTRI(char *uplo,char *diag,int *n,float *a,int *lda,int *info);
void    strtri(char *uplo,char *diag,int *n,float *a,int *lda,int *info);
void    STRTRS(char *uplo,char *trans,char *diag,int *n,int *nrhs,float *a,int *lda,float *b,int *ldb,int *info);
void    strtrs(char *uplo,char *trans,char *diag,int *n,int *nrhs,float *a,int *lda,float *b,int *ldb,int *info);
void    STZRQF(int *m,int *n,float *a,int *lda,float *tau,int *info);
void    stzrqf(int *m,int *n,float *a,int *lda,float *tau,int *info);
void    STZRZF(int *m,int *n,float *a,int *lda,float *tau,float *work,int *lwork,int *info);
void    stzrzf(int *m,int *n,float *a,int *lda,float *tau,float *work,int *lwork,int *info);
void    DBDSDC(char *uplo,char *compq,int *n,double *d,double *e,double *u,int *ldu,double *vt,int *ldvt,double *q,int *iq,double *work,int *iwork,int *info);
void    dbdsdc(char *uplo,char *compq,int *n,double *d,double *e,double *u,int *ldu,double *vt,int *ldvt,double *q,int *iq,double *work,int *iwork,int *info);
void    DBDSQR(char *uplo,int *n,int *ncvt,int *nru,int *ncc,double *d,double *e,double *vt,int *ldvt,double *u,int *ldu,double *c,int *ldc,double *work,int *info);
void    dbdsqr(char *uplo,int *n,int *ncvt,int *nru,int *ncc,double *d,double *e,double *vt,int *ldvt,double *u,int *ldu,double *c,int *ldc,double *work,int *info);
void    DDISNA(char *job,int *m,int *n,double *d,double *sep,int *info);
void    ddisna(char *job,int *m,int *n,double *d,double *sep,int *info);
void    DGBBRD(char *vect,int *m,int *n,int *ncc,int *kl,int *ku,double *ab,int *ldab,double *d,double *e,double *q,int *ldq,double *pt,int *ldpt,double *c,int *ldc,double *work,int *info);
void    dgbbrd(char *vect,int *m,int *n,int *ncc,int *kl,int *ku,double *ab,int *ldab,double *d,double *e,double *q,int *ldq,double *pt,int *ldpt,double *c,int *ldc,double *work,int *info);
void    DGBCON(char *norm,int *n,int *kl,int *ku,double *ab,int *ldab,int *ipiv,double *anorm,double *rcond,double *work,int *iwork,int *info);
void    dgbcon(char *norm,int *n,int *kl,int *ku,double *ab,int *ldab,int *ipiv,double *anorm,double *rcond,double *work,int *iwork,int *info);
void    DGBEQU(int *m,int *n,int *kl,int *ku,double *ab,int *ldab,double *r,double *c,double *rowcnd,double *colcnd,double *amax,int *info);
void    dgbequ(int *m,int *n,int *kl,int *ku,double *ab,int *ldab,double *r,double *c,double *rowcnd,double *colcnd,double *amax,int *info);
void    DGBRFS(char *trans,int *n,int *kl,int *ku,int *nrhs,double *ab,int *ldab,double *afb,int *ldafb,int *ipiv,double *b,int *ldb,double *x,int *ldx,double *ferr,double *berr,double *work,int *iwork,int *info);
void    dgbrfs(char *trans,int *n,int *kl,int *ku,int *nrhs,double *ab,int *ldab,double *afb,int *ldafb,int *ipiv,double *b,int *ldb,double *x,int *ldx,double *ferr,double *berr,double *work,int *iwork,int *info);
void    DGBSV(int *n,int *kl,int *ku,int *nrhs,double *ab,int *ldab,int *ipiv,double *b,int *ldb,int *info);
void    dgbsv(int *n,int *kl,int *ku,int *nrhs,double *ab,int *ldab,int *ipiv,double *b,int *ldb,int *info);
void    DGBSVX(char *fact,char *trans,int *n,int *kl,int *ku,int *nrhs,double *ab,int *ldab,double *afb,int *ldafb,int *ipiv,char *equed,double *r,double *c,double *b,int *ldb,double *x,int *ldx,double *rcond,double *ferr,double *berr,double *work,int *iwork,int *info);
void    dgbsvx(char *fact,char *trans,int *n,int *kl,int *ku,int *nrhs,double *ab,int *ldab,double *afb,int *ldafb,int *ipiv,char *equed,double *r,double *c,double *b,int *ldb,double *x,int *ldx,double *rcond,double *ferr,double *berr,double *work,int *iwork,int *info);
void    DGBTF2(int *m,int *n,int *kl,int *ku,double *ab,int *ldab,int *ipiv,int *info);
void    dgbtf2(int *m,int *n,int *kl,int *ku,double *ab,int *ldab,int *ipiv,int *info);
void    DGBTRF(int *m,int *n,int *kl,int *ku,double *ab,int *ldab,int *ipiv,int *info);
void    dgbtrf(int *m,int *n,int *kl,int *ku,double *ab,int *ldab,int *ipiv,int *info);
void    DGBTRS(char *trans,int *n,int *kl,int *ku,int *nrhs,double *ab,int *ldab,int *ipiv,double *b,int *ldb,int *info);
void    dgbtrs(char *trans,int *n,int *kl,int *ku,int *nrhs,double *ab,int *ldab,int *ipiv,double *b,int *ldb,int *info);
void    DGEBAK(char *job,char *side,int *n,int *ilo,int *ihi,double *scale,int *m,double *v,int *ldv,int *info);
void    dgebak(char *job,char *side,int *n,int *ilo,int *ihi,double *scale,int *m,double *v,int *ldv,int *info);
void    DGEBAL(char *job,int *n,double *a,int *lda,int *ilo,int *ihi,double *scale,int *info);
void    dgebal(char *job,int *n,double *a,int *lda,int *ilo,int *ihi,double *scale,int *info);
void    DGEBD2(int *m,int *n,double *a,int *lda,double *d,double *e,double *tauq,double *taup,double *work,int *info);
void    dgebd2(int *m,int *n,double *a,int *lda,double *d,double *e,double *tauq,double *taup,double *work,int *info);
void    DGEBRD(int *m,int *n,double *a,int *lda,double *d,double *e,double *tauq,double *taup,double *work,int *lwork,int *info);
void    dgebrd(int *m,int *n,double *a,int *lda,double *d,double *e,double *tauq,double *taup,double *work,int *lwork,int *info);
void    DGECON(char *norm,int *n,double *a,int *lda,double *anorm,double *rcond,double *work,int *iwork,int *info);
void    dgecon(char *norm,int *n,double *a,int *lda,double *anorm,double *rcond,double *work,int *iwork,int *info);
void    DGEEQU(int *m,int *n,double *a,int *lda,double *r,double *c,double *rowcnd,double *colcnd,double *amax,int *info);
void    dgeequ(int *m,int *n,double *a,int *lda,double *r,double *c,double *rowcnd,double *colcnd,double *amax,int *info);
void    DGEES(char *jobvs,char *sort,void *select,int *n,double *a,int *lda,int *sdim,double *wr,double *wi,double *vs,int *ldvs,double *work,int *lwork,void *bwork,int *info);
void    dgees(char *jobvs,char *sort,void *select,int *n,double *a,int *lda,int *sdim,double *wr,double *wi,double *vs,int *ldvs,double *work,int *lwork,void *bwork,int *info);
void    DGEESX(char *jobvs,char *sort,void *select,char *sense,int *n,double *a,int *lda,int *sdim,double *wr,double *wi,double *vs,int *ldvs,double *rconde,double *rcondv,double *work,int *lwork,int *iwork,int *liwork,void *bwork,int *info);
void    dgeesx(char *jobvs,char *sort,void *select,char *sense,int *n,double *a,int *lda,int *sdim,double *wr,double *wi,double *vs,int *ldvs,double *rconde,double *rcondv,double *work,int *lwork,int *iwork,int *liwork,void *bwork,int *info);
void    DGEEV(char *jobvl,char *jobvr,int *n,double *a,int *lda,double *wr,double *wi,double *vl,int *ldvl,double *vr,int *ldvr,double *work,int *lwork,int *info);
void    dgeev(char *jobvl,char *jobvr,int *n,double *a,int *lda,double *wr,double *wi,double *vl,int *ldvl,double *vr,int *ldvr,double *work,int *lwork,int *info);
void    DGEEVX(char *balanc,char *jobvl,char *jobvr,char *sense,int *n,double *a,int *lda,double *wr,double *wi,double *vl,int *ldvl,double *vr,int *ldvr,int *ilo,int *ihi,double *scale,double *abnrm,double *rconde,double *rcondv,double *work,int *lwork,int *iwork,int *info);
void    dgeevx(char *balanc,char *jobvl,char *jobvr,char *sense,int *n,double *a,int *lda,double *wr,double *wi,double *vl,int *ldvl,double *vr,int *ldvr,int *ilo,int *ihi,double *scale,double *abnrm,double *rconde,double *rcondv,double *work,int *lwork,int *iwork,int *info);
void    DGEGS(char *jobvsl,char *jobvsr,int *n,double *a,int *lda,double *b,int *ldb,double *alphar,double *alphai,double *beta,double *vsl,int *ldvsl,double *vsr,int *ldvsr,double *work,int *lwork,int *info);
void    dgegs(char *jobvsl,char *jobvsr,int *n,double *a,int *lda,double *b,int *ldb,double *alphar,double *alphai,double *beta,double *vsl,int *ldvsl,double *vsr,int *ldvsr,double *work,int *lwork,int *info);
void    DGEGV(char *jobvl,char *jobvr,int *n,double *a,int *lda,double *b,int *ldb,double *alphar,double *alphai,double *beta,double *vl,int *ldvl,double *vr,int *ldvr,double *work,int *lwork,int *info);
void    dgegv(char *jobvl,char *jobvr,int *n,double *a,int *lda,double *b,int *ldb,double *alphar,double *alphai,double *beta,double *vl,int *ldvl,double *vr,int *ldvr,double *work,int *lwork,int *info);
void    DGEHD2(int *n,int *ilo,int *ihi,double *a,int *lda,double *tau,double *work,int *info);
void    dgehd2(int *n,int *ilo,int *ihi,double *a,int *lda,double *tau,double *work,int *info);
void    DGEHRD(int *n,int *ilo,int *ihi,double *a,int *lda,double *tau,double *work,int *lwork,int *info);
void    dgehrd(int *n,int *ilo,int *ihi,double *a,int *lda,double *tau,double *work,int *lwork,int *info);
void    DGELQ2(int *m,int *n,double *a,int *lda,double *tau,double *work,int *info);
void    dgelq2(int *m,int *n,double *a,int *lda,double *tau,double *work,int *info);
void    DGELQF(int *m,int *n,double *a,int *lda,double *tau,double *work,int *lwork,int *info);
void    dgelqf(int *m,int *n,double *a,int *lda,double *tau,double *work,int *lwork,int *info);
void    DGELS(char *trans,int *m,int *n,int *nrhs,double *a,int *lda,double *b,int *ldb,double *work,int *lwork,int *info);
void    dgels(char *trans,int *m,int *n,int *nrhs,double *a,int *lda,double *b,int *ldb,double *work,int *lwork,int *info);
void    DGELSD(int *m,int *n,int *nrhs,double *a,int *lda,double *b,int *ldb,double *s,double *rcond,int *rank,double *work,int *lwork,int *iwork,int *info);
void    dgelsd(int *m,int *n,int *nrhs,double *a,int *lda,double *b,int *ldb,double *s,double *rcond,int *rank,double *work,int *lwork,int *iwork,int *info);
void    DGELSS(int *m,int *n,int *nrhs,double *a,int *lda,double *b,int *ldb,double *s,double *rcond,int *rank,double *work,int *lwork,int *info);
void    dgelss(int *m,int *n,int *nrhs,double *a,int *lda,double *b,int *ldb,double *s,double *rcond,int *rank,double *work,int *lwork,int *info);
void    DGELSX(int *m,int *n,int *nrhs,double *a,int *lda,double *b,int *ldb,int *jpvt,double *rcond,int *rank,double *work,int *info);
void    dgelsx(int *m,int *n,int *nrhs,double *a,int *lda,double *b,int *ldb,int *jpvt,double *rcond,int *rank,double *work,int *info);
void    DGELSY(int *m,int *n,int *nrhs,double *a,int *lda,double *b,int *ldb,int *jpvt,double *rcond,int *rank,double *work,int *lwork,int *info);
void    dgelsy(int *m,int *n,int *nrhs,double *a,int *lda,double *b,int *ldb,int *jpvt,double *rcond,int *rank,double *work,int *lwork,int *info);
void    DGEQL2(int *m,int *n,double *a,int *lda,double *tau,double *work,int *info);
void    dgeql2(int *m,int *n,double *a,int *lda,double *tau,double *work,int *info);
void    DGEQLF(int *m,int *n,double *a,int *lda,double *tau,double *work,int *lwork,int *info);
void    dgeqlf(int *m,int *n,double *a,int *lda,double *tau,double *work,int *lwork,int *info);
void    DGEQP3(int *m,int *n,double *a,int *lda,int *jpvt,double *tau,double *work,int *lwork,int *info);
void    dgeqp3(int *m,int *n,double *a,int *lda,int *jpvt,double *tau,double *work,int *lwork,int *info);
void    DGEQPF(int *m,int *n,double *a,int *lda,int *jpvt,double *tau,double *work,int *info);
void    dgeqpf(int *m,int *n,double *a,int *lda,int *jpvt,double *tau,double *work,int *info);
void    DGEQR2(int *m,int *n,double *a,int *lda,double *tau,double *work,int *info);
void    dgeqr2(int *m,int *n,double *a,int *lda,double *tau,double *work,int *info);
void    DGEQRF(int *m,int *n,double *a,int *lda,double *tau,double *work,int *lwork,int *info);
void    dgeqrf(int *m,int *n,double *a,int *lda,double *tau,double *work,int *lwork,int *info);
void    DGERFS(char *trans,int *n,int *nrhs,double *a,int *lda,double *af,int *ldaf,int *ipiv,double *b,int *ldb,double *x,int *ldx,double *ferr,double *berr,double *work,int *iwork,int *info);
void    dgerfs(char *trans,int *n,int *nrhs,double *a,int *lda,double *af,int *ldaf,int *ipiv,double *b,int *ldb,double *x,int *ldx,double *ferr,double *berr,double *work,int *iwork,int *info);
void    DGERQ2(int *m,int *n,double *a,int *lda,double *tau,double *work,int *info);
void    dgerq2(int *m,int *n,double *a,int *lda,double *tau,double *work,int *info);
void    DGERQF(int *m,int *n,double *a,int *lda,double *tau,double *work,int *lwork,int *info);
void    dgerqf(int *m,int *n,double *a,int *lda,double *tau,double *work,int *lwork,int *info);
void    DGESC2(int *n,double *a,int *lda,double *rhs,int *ipiv,int *jpiv,double *scale);
void    dgesc2(int *n,double *a,int *lda,double *rhs,int *ipiv,int *jpiv,double *scale);
void    DGESDD(char *jobz,int *m,int *n,double *a,int *lda,double *s,double *u,int *ldu,double *vt,int *ldvt,double *work,int *lwork,int *iwork,int *info);
void    dgesdd(char *jobz,int *m,int *n,double *a,int *lda,double *s,double *u,int *ldu,double *vt,int *ldvt,double *work,int *lwork,int *iwork,int *info);
void    DGESV(int *n,int *nrhs,double *a,int *lda,int *ipiv,double *b,int *ldb,int *info);
void    dgesv(int *n,int *nrhs,double *a,int *lda,int *ipiv,double *b,int *ldb,int *info);
void    DGESVD(char *jobu,char *jobvt,int *m,int *n,double *a,int *lda,double *s,double *u,int *ldu,double *vt,int *ldvt,double *work,int *lwork,int *info);
void    dgesvd(char *jobu,char *jobvt,int *m,int *n,double *a,int *lda,double *s,double *u,int *ldu,double *vt,int *ldvt,double *work,int *lwork,int *info);
void    DGESVX(char *fact,char *trans,int *n,int *nrhs,double *a,int *lda,double *af,int *ldaf,int *ipiv,char *equed,double *r,double *c,double *b,int *ldb,double *x,int *ldx,double *rcond,double *ferr,double *berr,double *work,int *iwork,int *info);
void    dgesvx(char *fact,char *trans,int *n,int *nrhs,double *a,int *lda,double *af,int *ldaf,int *ipiv,char *equed,double *r,double *c,double *b,int *ldb,double *x,int *ldx,double *rcond,double *ferr,double *berr,double *work,int *iwork,int *info);
void    DGETC2(int *n,double *a,int *lda,int *ipiv,int *jpiv,int *info);
void    dgetc2(int *n,double *a,int *lda,int *ipiv,int *jpiv,int *info);
void    DGETF2(int *m,int *n,double *a,int *lda,int *ipiv,int *info);
void    dgetf2(int *m,int *n,double *a,int *lda,int *ipiv,int *info);
void    DGETRF(int *m,int *n,double *a,int *lda,int *ipiv,int *info);
void    dgetrf(int *m,int *n,double *a,int *lda,int *ipiv,int *info);
void    DGETRI(int *n,double *a,int *lda,int *ipiv,double *work,int *lwork,int *info);
void    dgetri(int *n,double *a,int *lda,int *ipiv,double *work,int *lwork,int *info);
void    DGETRS(char *trans,int *n,int *nrhs,double *a,int *lda,int *ipiv,double *b,int *ldb,int *info);
void    dgetrs(char *trans,int *n,int *nrhs,double *a,int *lda,int *ipiv,double *b,int *ldb,int *info);
void    DGGBAK(char *job,char *side,int *n,int *ilo,int *ihi,double *lscale,double *rscale,int *m,double *v,int *ldv,int *info);
void    dggbak(char *job,char *side,int *n,int *ilo,int *ihi,double *lscale,double *rscale,int *m,double *v,int *ldv,int *info);
void    DGGBAL(char *job,int *n,double *a,int *lda,double *b,int *ldb,int *ilo,int *ihi,double *lscale,double *rscale,double *work,int *info);
void    dggbal(char *job,int *n,double *a,int *lda,double *b,int *ldb,int *ilo,int *ihi,double *lscale,double *rscale,double *work,int *info);
void    DGGES(char *jobvsl,char *jobvsr,char *sort,void *delctg,int *n,double *a,int *lda,double *b,int *ldb,int *sdim,double *alphar,double *alphai,double *beta,double *vsl,int *ldvsl,double *vsr,int *ldvsr,double *work,int *lwork,void *bwork,int *info);
void    dgges(char *jobvsl,char *jobvsr,char *sort,void *delctg,int *n,double *a,int *lda,double *b,int *ldb,int *sdim,double *alphar,double *alphai,double *beta,double *vsl,int *ldvsl,double *vsr,int *ldvsr,double *work,int *lwork,void *bwork,int *info);
void    DGGESX(char *jobvsl,char *jobvsr,char *sort,void *delctg,char *sense,int *n,double *a,int *lda,double *b,int *ldb,int *sdim,double *alphar,double *alphai,double *beta,double *vsl,int *ldvsl,double *vsr,int *ldvsr,double *rconde,double *rcondv,double *work,int *lwork,int *iwork,int *liwork,void *bwork,int *info);
void    dggesx(char *jobvsl,char *jobvsr,char *sort,void *delctg,char *sense,int *n,double *a,int *lda,double *b,int *ldb,int *sdim,double *alphar,double *alphai,double *beta,double *vsl,int *ldvsl,double *vsr,int *ldvsr,double *rconde,double *rcondv,double *work,int *lwork,int *iwork,int *liwork,void *bwork,int *info);
void    DGGEV(char *jobvl,char *jobvr,int *n,double *a,int *lda,double *b,int *ldb,double *alphar,double *alphai,double *beta,double *vl,int *ldvl,double *vr,int *ldvr,double *work,int *lwork,int *info);
void    dggev(char *jobvl,char *jobvr,int *n,double *a,int *lda,double *b,int *ldb,double *alphar,double *alphai,double *beta,double *vl,int *ldvl,double *vr,int *ldvr,double *work,int *lwork,int *info);
void    DGGEVX(char *balanc,char *jobvl,char *jobvr,char *sense,int *n,double *a,int *lda,double *b,int *ldb,double *alphar,double *alphai,double *beta,double *vl,int *ldvl,double *vr,int *ldvr,int *ilo,int *ihi,double *lscale,double *rscale,double *abnrm,double *bbnrm,double *rconde,double *rcondv,double *work,int *lwork,int *iwork,void *bwork,int *info);
void    dggevx(char *balanc,char *jobvl,char *jobvr,char *sense,int *n,double *a,int *lda,double *b,int *ldb,double *alphar,double *alphai,double *beta,double *vl,int *ldvl,double *vr,int *ldvr,int *ilo,int *ihi,double *lscale,double *rscale,double *abnrm,double *bbnrm,double *rconde,double *rcondv,double *work,int *lwork,int *iwork,void *bwork,int *info);
void    DGGGLM(int *n,int *m,int *p,double *a,int *lda,double *b,int *ldb,double *d,double *x,double *y,double *work,int *lwork,int *info);
void    dggglm(int *n,int *m,int *p,double *a,int *lda,double *b,int *ldb,double *d,double *x,double *y,double *work,int *lwork,int *info);
void    DGGHRD(char *compq,char *compz,int *n,int *ilo,int *ihi,double *a,int *lda,double *b,int *ldb,double *q,int *ldq,double *z,int *ldz,int *info);
void    dgghrd(char *compq,char *compz,int *n,int *ilo,int *ihi,double *a,int *lda,double *b,int *ldb,double *q,int *ldq,double *z,int *ldz,int *info);
void    DGGLSE(int *m,int *n,int *p,double *a,int *lda,double *b,int *ldb,double *c,double *d,double *x,double *work,int *lwork,int *info);
void    dgglse(int *m,int *n,int *p,double *a,int *lda,double *b,int *ldb,double *c,double *d,double *x,double *work,int *lwork,int *info);
void    DGGQRF(int *n,int *m,int *p,double *a,int *lda,double *taua,double *b,int *ldb,double *taub,double *work,int *lwork,int *info);
void    dggqrf(int *n,int *m,int *p,double *a,int *lda,double *taua,double *b,int *ldb,double *taub,double *work,int *lwork,int *info);
void    DGGRQF(int *m,int *p,int *n,double *a,int *lda,double *taua,double *b,int *ldb,double *taub,double *work,int *lwork,int *info);
void    dggrqf(int *m,int *p,int *n,double *a,int *lda,double *taua,double *b,int *ldb,double *taub,double *work,int *lwork,int *info);
void    DGGSVD(char *jobu,char *jobv,char *jobq,int *m,int *n,int *p,int *k,int *l,double *a,int *lda,double *b,int *ldb,double *alpha,double *beta,double *u,int *ldu,double *v,int *ldv,double *q,int *ldq,double *work,int *iwork,int *info);
void    dggsvd(char *jobu,char *jobv,char *jobq,int *m,int *n,int *p,int *k,int *l,double *a,int *lda,double *b,int *ldb,double *alpha,double *beta,double *u,int *ldu,double *v,int *ldv,double *q,int *ldq,double *work,int *iwork,int *info);
void    DGGSVP(char *jobu,char *jobv,char *jobq,int *m,int *p,int *n,double *a,int *lda,double *b,int *ldb,double *tola,double *tolb,int *k,int *l,double *u,int *ldu,double *v,int *ldv,double *q,int *ldq,int *iwork,double *tau,double *work,int *info);
void    dggsvp(char *jobu,char *jobv,char *jobq,int *m,int *p,int *n,double *a,int *lda,double *b,int *ldb,double *tola,double *tolb,int *k,int *l,double *u,int *ldu,double *v,int *ldv,double *q,int *ldq,int *iwork,double *tau,double *work,int *info);
void    DGTCON(char *norm,int *n,double *dl,double *d,double *du,double *du2,int *ipiv,double *anorm,double *rcond,double *work,int *iwork,int *info);
void    dgtcon(char *norm,int *n,double *dl,double *d,double *du,double *du2,int *ipiv,double *anorm,double *rcond,double *work,int *iwork,int *info);
void    DGTRFS(char *trans,int *n,int *nrhs,double *dl,double *d,double *du,double *dlf,double *df,double *duf,double *du2,int *ipiv,double *b,int *ldb,double *x,int *ldx,double *ferr,double *berr,double *work,int *iwork,int *info);
void    dgtrfs(char *trans,int *n,int *nrhs,double *dl,double *d,double *du,double *dlf,double *df,double *duf,double *du2,int *ipiv,double *b,int *ldb,double *x,int *ldx,double *ferr,double *berr,double *work,int *iwork,int *info);
void    DGTSV(int *n,int *nrhs,double *dl,double *d,double *du,double *b,int *ldb,int *info);
void    dgtsv(int *n,int *nrhs,double *dl,double *d,double *du,double *b,int *ldb,int *info);
void    DGTSVX(char *fact,char *trans,int *n,int *nrhs,double *dl,double *d,double *du,double *dlf,double *df,double *duf,double *du2,int *ipiv,double *b,int *ldb,double *x,int *ldx,double *rcond,double *ferr,double *berr,double *work,int *iwork,int *info);
void    dgtsvx(char *fact,char *trans,int *n,int *nrhs,double *dl,double *d,double *du,double *dlf,double *df,double *duf,double *du2,int *ipiv,double *b,int *ldb,double *x,int *ldx,double *rcond,double *ferr,double *berr,double *work,int *iwork,int *info);
void    DGTTRF(int *n,double *dl,double *d,double *du,double *du2,int *ipiv,int *info);
void    dgttrf(int *n,double *dl,double *d,double *du,double *du2,int *ipiv,int *info);
void    DGTTRS(char *trans,int *n,int *nrhs,double *dl,double *d,double *du,double *du2,int *ipiv,double *b,int *ldb,int *info);
void    dgttrs(char *trans,int *n,int *nrhs,double *dl,double *d,double *du,double *du2,int *ipiv,double *b,int *ldb,int *info);
void    DGTTS2(int *itrans,int *n,int *nrhs,double *dl,double *d,double *du,double *du2,int *ipiv,double *b,int *ldb);
void    dgtts2(int *itrans,int *n,int *nrhs,double *dl,double *d,double *du,double *du2,int *ipiv,double *b,int *ldb);
void    DHGEQZ(char *job,char *compq,char *compz,int *n,int *ilo,int *ihi,double *a,int *lda,double *b,int *ldb,double *alphar,double *alphai,double *beta,double *q,int *ldq,double *z,int *ldz,double *work,int *lwork,int *info);
void    dhgeqz(char *job,char *compq,char *compz,int *n,int *ilo,int *ihi,double *a,int *lda,double *b,int *ldb,double *alphar,double *alphai,double *beta,double *q,int *ldq,double *z,int *ldz,double *work,int *lwork,int *info);
void    DHSEIN(char *side,char *eigsrc,char *initv,void *select,int *n,double *h,int *ldh,double *wr,double *wi,double *vl,int *ldvl,double *vr,int *ldvr,int *mm,int *m,double *work,int *ifaill,int *ifailr,int *info);
void    dhsein(char *side,char *eigsrc,char *initv,void *select,int *n,double *h,int *ldh,double *wr,double *wi,double *vl,int *ldvl,double *vr,int *ldvr,int *mm,int *m,double *work,int *ifaill,int *ifailr,int *info);
void    DHSEQR(char *job,char *compz,int *n,int *ilo,int *ihi,double *h,int *ldh,double *wr,double *wi,double *z,int *ldz,double *work,int *lwork,int *info);
void    dhseqr(char *job,char *compz,int *n,int *ilo,int *ihi,double *h,int *ldh,double *wr,double *wi,double *z,int *ldz,double *work,int *lwork,int *info);
void    DLABAD(double *,double *);
void    dlabad(double *,double *);
void    DLABRD(int *m,int *n,int *nb,double *a,int *lda,double *d,double *e,double *tauq,double *taup,double *x,int *ldx,double *y,int *ldy);
void    dlabrd(int *m,int *n,int *nb,double *a,int *lda,double *d,double *e,double *tauq,double *taup,double *x,int *ldx,double *y,int *ldy);
void    DLACON(int *n,double *v,double *x,int *isgn,double *est,int *kase);
void    dlacon(int *n,double *v,double *x,int *isgn,double *est,int *kase);
void    DLACPY(char *uplo,int *m,int *n,double *a,int *lda,double *b,int *ldb);
void    dlacpy(char *uplo,int *m,int *n,double *a,int *lda,double *b,int *ldb);
void    DLADIV(double *a,double *b,double *c,double *d,double *p,double *q);
void    dladiv(double *a,double *b,double *c,double *d,double *p,double *q);
void    DLAE2(double *a,double *b,double *c,double *rt1,double *rt2);
void    dlae2(double *a,double *b,double *c,double *rt1,double *rt2);
void    DLAEBZ(int *ijob,int *nitmax,int *n,int *mmax,int *minp,int *nbmin,double *abstol,double *reltol,double *pivmin,double *d,double *e,double *e2,int *nval,double *ab,double *c,int *mout,int *nab,double *work,int *iwork,int *info);
void    dlaebz(int *ijob,int *nitmax,int *n,int *mmax,int *minp,int *nbmin,double *abstol,double *reltol,double *pivmin,double *d,double *e,double *e2,int *nval,double *ab,double *c,int *mout,int *nab,double *work,int *iwork,int *info);
void    DLAED0(int *icompq,int *qsiz,int *n,double *d,double *e,double *q,int *ldq,double *qstore,int *ldqs,double *work,int *iwork,int *info);
void    dlaed0(int *icompq,int *qsiz,int *n,double *d,double *e,double *q,int *ldq,double *qstore,int *ldqs,double *work,int *iwork,int *info);
void    DLAED1(int *n,double *d,double *q,int *ldq,int *indxq,double *rho,int *cutpnt,double *work,int *iwork,int *info);
void    dlaed1(int *n,double *d,double *q,int *ldq,int *indxq,double *rho,int *cutpnt,double *work,int *iwork,int *info);
void    DLAED2(int *k,int *n,int *n1,double *d,double *q,int *ldq,int *indxq,double *rho,double *z,double *dlamda,double *w,double *q2,int *indx,int *indxc,int *indxp,int *coltyp,int *info);
void    dlaed2(int *k,int *n,int *n1,double *d,double *q,int *ldq,int *indxq,double *rho,double *z,double *dlamda,double *w,double *q2,int *indx,int *indxc,int *indxp,int *coltyp,int *info);
void    DLAED3(int *k,int *n,int *n1,double *d,double *q,int *ldq,double *rho,double *dlamda,double *q2,int *indx,int *ctot,double *w,double *s,int *info);
void    dlaed3(int *k,int *n,int *n1,double *d,double *q,int *ldq,double *rho,double *dlamda,double *q2,int *indx,int *ctot,double *w,double *s,int *info);
void    DLAED4(int *n,int *i,double *d,double *z,double *delta,double *rho,double *dlam,int *info);
void    dlaed4(int *n,int *i,double *d,double *z,double *delta,double *rho,double *dlam,int *info);
void    DLAED5(int *i,double *d,double *z,double *delta,double *rho,double *dlam);
void    dlaed5(int *i,double *d,double *z,double *delta,double *rho,double *dlam);
void    DLAED6(int *kniter,void *orgati,double *rho,double *d,double *z,double *finit,double *tau,int *info);
void    dlaed6(int *kniter,void *orgati,double *rho,double *d,double *z,double *finit,double *tau,int *info);
void    DLAED7(int *icompq,int *n,int *qsiz,int *tlvls,int *curlvl,int *curpbm,double *d,double *q,int *ldq,int *indxq,double *rho,int *cutpnt,double *qstore,int *qptr,int *prmptr,int *perm,int *givptr,int *givcol,double *givnum,double *work,int *iwork,int *info);
void    dlaed7(int *icompq,int *n,int *qsiz,int *tlvls,int *curlvl,int *curpbm,double *d,double *q,int *ldq,int *indxq,double *rho,int *cutpnt,double *qstore,int *qptr,int *prmptr,int *perm,int *givptr,int *givcol,double *givnum,double *work,int *iwork,int *info);
void    DLAED8(int *icompq,int *k,int *n,int *qsiz,double *d,double *q,int *ldq,int *indxq,double *rho,int *cutpnt,double *z,double *dlamda,double *q2,int *ldq2,double *w,int *perm,int *givptr,int *givcol,double *givnum,int *indxp,int *indx,int *info);
void    dlaed8(int *icompq,int *k,int *n,int *qsiz,double *d,double *q,int *ldq,int *indxq,double *rho,int *cutpnt,double *z,double *dlamda,double *q2,int *ldq2,double *w,int *perm,int *givptr,int *givcol,double *givnum,int *indxp,int *indx,int *info);
void    DLAED9(int *k,int *kstart,int *kstop,int *n,double *d,double *q,int *ldq,double *rho,double *dlamda,double *w,double *s,int *lds,int *info);
void    dlaed9(int *k,int *kstart,int *kstop,int *n,double *d,double *q,int *ldq,double *rho,double *dlamda,double *w,double *s,int *lds,int *info);
void    DLAEDA(int *n,int *tlvls,int *curlvl,int *curpbm,int *prmptr,int *perm,int *givptr,int *givcol,double *givnum,double *q,int *qptr,double *z,double *ztemp,int *info);
void    dlaeda(int *n,int *tlvls,int *curlvl,int *curpbm,int *prmptr,int *perm,int *givptr,int *givcol,double *givnum,double *q,int *qptr,double *z,double *ztemp,int *info);
void    DLAEIN(void *rightv,void *noinit,int *n,double *h,int *ldh,double *wr,double *wi,double *vr,double *vi,double *b,int *ldb,double *work,double *eps3,double *smlnum,double *bignum,int *info);
void    dlaein(void *rightv,void *noinit,int *n,double *h,int *ldh,double *wr,double *wi,double *vr,double *vi,double *b,int *ldb,double *work,double *eps3,double *smlnum,double *bignum,int *info);
void    DLAEV2(double *a,double *b,double *c,double *rt1,double *rt2,double *cs1,double *sn1);
void    dlaev2(double *a,double *b,double *c,double *rt1,double *rt2,double *cs1,double *sn1);
void    DLAEXC(void *wantq,int *n,double *t,int *ldt,double *q,int *ldq,int *j1,int *n1,int *n2,double *work,int *info);
void    dlaexc(void *wantq,int *n,double *t,int *ldt,double *q,int *ldq,int *j1,int *n1,int *n2,double *work,int *info);
void    DLAG2(double *a,int *lda,double *b,int *ldb,double *safmin,double *scale1,double *scale2,double *wr1,double *wr2,double *wi);
void    dlag2(double *a,int *lda,double *b,int *ldb,double *safmin,double *scale1,double *scale2,double *wr1,double *wr2,double *wi);
void    DLAGS2(void *upper,double *a1,double *a2,double *a3,double *b1,double *b2,double *b3,double *csu,double *snu,double *csv,double *snv,double *csq,double *snq);
void    dlags2(void *upper,double *a1,double *a2,double *a3,double *b1,double *b2,double *b3,double *csu,double *snu,double *csv,double *snv,double *csq,double *snq);
void    DLAGTF(int *n,double *a,double *lambda,double *b,double *c,double *tol,double *d,int *in,int *info);
void    dlagtf(int *n,double *a,double *lambda,double *b,double *c,double *tol,double *d,int *in,int *info);
void    DLAGTM(char *trans,int *n,int *nrhs,double *alpha,double *dl,double *d,double *du,double *x,int *ldx,double *beta,double *b,int *ldb);
void    dlagtm(char *trans,int *n,int *nrhs,double *alpha,double *dl,double *d,double *du,double *x,int *ldx,double *beta,double *b,int *ldb);
void    DLAGTS(int *job,int *n,double *a,double *b,double *c,double *d,int *in,double *y,double *tol,int *info);
void    dlagts(int *job,int *n,double *a,double *b,double *c,double *d,int *in,double *y,double *tol,int *info);
void    DLAGV2(double *a,int *lda,double *b,int *ldb,double *alphar,double *alphai,double *beta,double *csl,double *snl,double *csr,double *snr);
void    dlagv2(double *a,int *lda,double *b,int *ldb,double *alphar,double *alphai,double *beta,double *csl,double *snl,double *csr,double *snr);
void    DLAHQR(void *wantt,void *wantz,int *n,int *ilo,int *ihi,double *h,int *ldh,double *wr,double *wi,int *iloz,int *ihiz,double *z,int *ldz,int *info);
void    dlahqr(void *wantt,void *wantz,int *n,int *ilo,int *ihi,double *h,int *ldh,double *wr,double *wi,int *iloz,int *ihiz,double *z,int *ldz,int *info);
void    DLAHRD(int *n,int *k,int *nb,double *a,int *lda,double *tau,double *t,int *ldt,double *y,int *ldy);
void    dlahrd(int *n,int *k,int *nb,double *a,int *lda,double *tau,double *t,int *ldt,double *y,int *ldy);
void    DLAIC1(int *job,int *j,double *x,double *sest,double *w,double *gamma,double *sestpr,double *s,double *c);
void    dlaic1(int *job,int *j,double *x,double *sest,double *w,double *gamma,double *sestpr,double *s,double *c);
void    DLALN2(void *ltrans,int *na,int *nw,double *smin,double *ca,double *a,int *lda,double *d1,double *d2,double *b,int *ldb,double *wr,double *wi,double *x,int *ldx,double *scale,double *xnorm,int *info);
void    dlaln2(void *ltrans,int *na,int *nw,double *smin,double *ca,double *a,int *lda,double *d1,double *d2,double *b,int *ldb,double *wr,double *wi,double *x,int *ldx,double *scale,double *xnorm,int *info);
void    DLALS0(int *icompq,int *nl,int *nr,int *sqre,int *nrhs,double *b,int *ldb,double *bx,int *ldbx,int *perm,int *givptr,int *givcol,int *ldgcol,double *givnum,int *ldgnum,double *poles,double *difl,double *difr,double *z,int *k,double *c,double *s,double *work,int *info);
void    dlals0(int *icompq,int *nl,int *nr,int *sqre,int *nrhs,double *b,int *ldb,double *bx,int *ldbx,int *perm,int *givptr,int *givcol,int *ldgcol,double *givnum,int *ldgnum,double *poles,double *difl,double *difr,double *z,int *k,double *c,double *s,double *work,int *info);
void    DLALSA(int *icompq,int *smlsiz,int *n,int *nrhs,double *b,int *ldb,double *bx,int *ldbx,double *u,int *ldu,double *vt,int *k,double *difl,double *difr,double *z,double *poles,int *givptr,int *givcol,int *ldgcol,int *perm,double *givnum,double *c,double *s,double *work,int *iwork,int *info);
void    dlalsa(int *icompq,int *smlsiz,int *n,int *nrhs,double *b,int *ldb,double *bx,int *ldbx,double *u,int *ldu,double *vt,int *k,double *difl,double *difr,double *z,double *poles,int *givptr,int *givcol,int *ldgcol,int *perm,double *givnum,double *c,double *s,double *work,int *iwork,int *info);
void    DLALSD(char *uplo,int *smlsiz,int *n,int *nrhs,double *d,double *e,double *b,int *ldb,double *rcond,int *rank,double *work,int *iwork,int *info);
void    dlalsd(char *uplo,int *smlsiz,int *n,int *nrhs,double *d,double *e,double *b,int *ldb,double *rcond,int *rank,double *work,int *iwork,int *info);
double  DLAMC3(double *a,double *b);
double  dlamc3(double *a,double *b);
double  DLAMCH(char *cmach);
double  dlamch(char *cmach);
void    DLAMRG(int *n1,int *n2,double *a,int *dtrd1,int *dtrd2,int *index);
void    dlamrg(int *n1,int *n2,double *a,int *dtrd1,int *dtrd2,int *index);
double  DLANGB(char *norm,int *n,int *kl,int *ku,double *ab,int *ldab,double *work);
double  dlangb(char *norm,int *n,int *kl,int *ku,double *ab,int *ldab,double *work);
double  DLANGE(char *norm,int *m,int *n,double *a,int *lda,double *work);
double  dlange(char *norm,int *m,int *n,double *a,int *lda,double *work);
double  DLANGT(char *norm,int *n,double *dl,double *d,double *du);
double  dlangt(char *norm,int *n,double *dl,double *d,double *du);
double  DLANHS(char *norm,int *n,double *a,int *lda,double *work);
double  dlanhs(char *norm,int *n,double *a,int *lda,double *work);
double  DLANSB(char *norm,char *uplo,int *n,int *k,double *ab,int *ldab,double *work);
double  dlansb(char *norm,char *uplo,int *n,int *k,double *ab,int *ldab,double *work);
double  DLANSP(char *norm,char *uplo,int *n,double *ap,double *work);
double  dlansp(char *norm,char *uplo,int *n,double *ap,double *work);
double  DLANST(char *norm,int *n,double *d,double *e);
double  dlanst(char *norm,int *n,double *d,double *e);
double  DLANSY(char *norm,char *uplo,int *n,double *a,int *lda,double *work);
double  dlansy(char *norm,char *uplo,int *n,double *a,int *lda,double *work);
double  DLANTB(char *norm,char *uplo,char *diag,int *n,int *k,double *ab,int *ldab,double *work);
double  dlantb(char *norm,char *uplo,char *diag,int *n,int *k,double *ab,int *ldab,double *work);
double  DLANTP(char *norm,char *uplo,char *diag,int *n,double *ap,double *work);
double  dlantp(char *norm,char *uplo,char *diag,int *n,double *ap,double *work);
double  DLANTR(char *norm,char *uplo,char *diag,int *m,int *n,double *a,int *lda,double *work);
double  dlantr(char *norm,char *uplo,char *diag,int *m,int *n,double *a,int *lda,double *work);
void    DLANV2(double *a,double *b,double *c,double *d,double *rt1r,double *rt1i,double *rt2r,double *rt2i,double *cs,double *sn);
void    dlanv2(double *a,double *b,double *c,double *d,double *rt1r,double *rt1i,double *rt2r,double *rt2i,double *cs,double *sn);
void    DLAPLL(int *n,double *x,int *incx,double *y,int *incy,double *ssmin);
void    dlapll(int *n,double *x,int *incx,double *y,int *incy,double *ssmin);
void    DLAPMT(void *forwrd,int *m,int *n,double *x,int *ldx,int *k);
void    dlapmt(void *forwrd,int *m,int *n,double *x,int *ldx,int *k);
double  DLAPY2(double *x,double *y);
double  dlapy2(double *x,double *y);
double  DLAPY3(double *x,double *y,double *z);
double  dlapy3(double *x,double *y,double *z);
void    DLAQGB(int *m,int *n,int *kl,int *ku,double *ab,int *ldab,double *r,double *c,double *rowcnd,double *colcnd,double *amax,char *equed);
void    dlaqgb(int *m,int *n,int *kl,int *ku,double *ab,int *ldab,double *r,double *c,double *rowcnd,double *colcnd,double *amax,char *equed);
void    DLAQGE(int *m,int *n,double *a,int *lda,double *r,double *c,double *rowcnd,double *colcnd,double *amax,char *equed);
void    dlaqge(int *m,int *n,double *a,int *lda,double *r,double *c,double *rowcnd,double *colcnd,double *amax,char *equed);
void    DLAQP2(int *m,int *n,int *offset,double *a,int *lda,int *jpvt,double *tau,double *vn1,double *vn2,double *work);
void    dlaqp2(int *m,int *n,int *offset,double *a,int *lda,int *jpvt,double *tau,double *vn1,double *vn2,double *work);
void    DLAQPS(int *m,int *n,int *offset,int *nb,int *kb,double *a,int *lda,int *jpvt,double *tau,double *vn1,double *vn2,double *auxv,double *f,int *ldf);
void    dlaqps(int *m,int *n,int *offset,int *nb,int *kb,double *a,int *lda,int *jpvt,double *tau,double *vn1,double *vn2,double *auxv,double *f,int *ldf);
void    DLAQSB(char *uplo,int *n,int *kd,double *ab,int *ldab,double *s,double *scond,double *amax,char *equed);
void    dlaqsb(char *uplo,int *n,int *kd,double *ab,int *ldab,double *s,double *scond,double *amax,char *equed);
void    DLAQSP(char *uplo,int *n,double *ap,double *s,double *scond,double *amax,char *equed);
void    dlaqsp(char *uplo,int *n,double *ap,double *s,double *scond,double *amax,char *equed);
void    DLAQSY(char *uplo,int *n,double *a,int *lda,double *s,double *scond,double *amax,char *equed);
void    dlaqsy(char *uplo,int *n,double *a,int *lda,double *s,double *scond,double *amax,char *equed);
float   DLAQTR(float *ltran,void *lreal,float *n,double *t,int *ldt,float *b,double *w,double *scale,double *x,double *work,int *info);
float   dlaqtr(float *ltran,void *lreal,float *n,double *t,int *ldt,float *b,double *w,double *scale,double *x,double *work,int *info);
void    DLAR1V(int *n,int *b1,int *bn,double *sigma,double *d,double *l,double *ld,double *lld,double *gersch,double *z,double *ztz,double *mingma,int *r,int *isuppz,double *work);
void    dlar1v(int *n,int *b1,int *bn,double *sigma,double *d,double *l,double *ld,double *lld,double *gersch,double *z,double *ztz,double *mingma,int *r,int *isuppz,double *work);
void    DLAR2V(int *n,double *x,double *y,double *z,int *incx,double *c,double *s,int *incc);
void    dlar2v(int *n,double *x,double *y,double *z,int *incx,double *c,double *s,int *incc);
void    DLARF(char *side,int *m,int *n,double *v,int *incv,double *tau,double *c,int *ldc,double *work);
void    dlarf(char *side,int *m,int *n,double *v,int *incv,double *tau,double *c,int *ldc,double *work);
void    DLARFB(char *side,char *trans,char *direct,char *storev,int *m,int *n,int *k,double *v,int *ldv,double *t,int *ldt,double *c,int *ldc,double *work,int *ldwork);
void    dlarfb(char *side,char *trans,char *direct,char *storev,int *m,int *n,int *k,double *v,int *ldv,double *t,int *ldt,double *c,int *ldc,double *work,int *ldwork);
void    DLARFG(int *n,double *alpha,double *x,int *incx,double *tau);
void    dlarfg(int *n,double *alpha,double *x,int *incx,double *tau);
void    DLARFT(char *direct,char *storev,int *n,int *k,double *v,int *ldv,double *tau,double *t,int *ldt);
void    dlarft(char *direct,char *storev,int *n,int *k,double *v,int *ldv,double *tau,double *t,int *ldt);
void    DLARFX(char *side,int *m,int *n,double *v,double *tau,double *c,int *ldc,double *work);
void    dlarfx(char *side,int *m,int *n,double *v,double *tau,double *c,int *ldc,double *work);
void    DLARGV(int *n,double *x,int *incx,double *y,int *incy,double *c,int *incc);
void    dlargv(int *n,double *x,int *incx,double *y,int *incy,double *c,int *incc);
void    DLARNV(int *idist,int *iseed,int *n,double *x);
void    dlarnv(int *idist,int *iseed,int *n,double *x);
void    DLARRB(int *n,double *d,double *l,double *ld,double *lld,int *ifirst,int *ilast,double *sigma,double *reltol,double *w,double *wgap,double *werr,double *work,int *iwork,int *info);
void    dlarrb(int *n,double *d,double *l,double *ld,double *lld,int *ifirst,int *ilast,double *sigma,double *reltol,double *w,double *wgap,double *werr,double *work,int *iwork,int *info);
void    DLARRE(int *n,double *d,double *e,double *tol,int *nsplit,int *isplit,int *m,double *w,double *woff,double *gersch,double *work,int *info);
void    dlarre(int *n,double *d,double *e,double *tol,int *nsplit,int *isplit,int *m,double *w,double *woff,double *gersch,double *work,int *info);
void    DLARRF(int *n,double *d,double *l,double *ld,double *lld,int *ifirst,int *ilast,double *w,double *dplus,double *lplus,double *work,int *iwork,int *info);
void    dlarrf(int *n,double *d,double *l,double *ld,double *lld,int *ifirst,int *ilast,double *w,double *dplus,double *lplus,double *work,int *iwork,int *info);
void    DLARRV(int *n,double *d,double *l,int *isplit,int *m,double *w,int *iblock,double *gersch,double *tol,double *z,int *ldz,int *isuppz,double *work,int *iwork,int *info);
void    dlarrv(int *n,double *d,double *l,int *isplit,int *m,double *w,int *iblock,double *gersch,double *tol,double *z,int *ldz,int *isuppz,double *work,int *iwork,int *info);
void    DLARTG(double *f,double *g,double *cs,double *sn,double *r);
void    dlartg(double *f,double *g,double *cs,double *sn,double *r);
void    DLARTV(int *n,double *x,int *incx,double *y,int *incy,double *c,double *s,int *incc);
void    dlartv(int *n,double *x,int *incx,double *y,int *incy,double *c,double *s,int *incc);
void    DLARUV(int *iseed,int *n,double *x);
void    dlaruv(int *iseed,int *n,double *x);
void    DLARZ(char *side,int *m,int *n,int *l,double *v,int *incv,double *tau,double *c,int *ldc,double *work);
void    dlarz(char *side,int *m,int *n,int *l,double *v,int *incv,double *tau,double *c,int *ldc,double *work);
void    DLARZB(char *side,char *trans,char *direct,char *storev,int *m,int *n,int *k,int *l,double *v,int *ldv,double *t,int *ldt,double *c,int *ldc,double *work,int *ldwork);
void    dlarzb(char *side,char *trans,char *direct,char *storev,int *m,int *n,int *k,int *l,double *v,int *ldv,double *t,int *ldt,double *c,int *ldc,double *work,int *ldwork);
void    DLARZT(char *direct,char *storev,int *n,int *k,double *v,int *ldv,double *tau,double *t,int *ldt);
void    dlarzt(char *direct,char *storev,int *n,int *k,double *v,int *ldv,double *tau,double *t,int *ldt);
void    DLAS2(double *f,double *g,double *h,double *ssmin,double *ssmax);
void    dlas2(double *f,double *g,double *h,double *ssmin,double *ssmax);
void    DLASCL(char *type,int *kl,int *ku,double *cfrom,double *cto,int *m,int *n,double *a,int *lda,int *info);
void    dlascl(char *type,int *kl,int *ku,double *cfrom,double *cto,int *m,int *n,double *a,int *lda,int *info);
void    DLASD0(int *n,int *sqre,double *d,double *e,double *u,int *ldu,double *vt,int *ldvt,int *smlsiz,int *iwork,double *work,int *info);
void    dlasd0(int *n,int *sqre,double *d,double *e,double *u,int *ldu,double *vt,int *ldvt,int *smlsiz,int *iwork,double *work,int *info);
void    DLASD1(int *nl,int *nr,int *sqre,double *d,double *alpha,double *beta,double *u,int *ldu,double *vt,int *ldvt,int *idxq,int *iwork,double *work,int *info);
void    dlasd1(int *nl,int *nr,int *sqre,double *d,double *alpha,double *beta,double *u,int *ldu,double *vt,int *ldvt,int *idxq,int *iwork,double *work,int *info);
void    DLASD2(int *nl,int *nr,int *sqre,int *k,double *d,double *z,double *alpha,double *beta,double *u,int *ldu,double *vt,int *ldvt,double *dsigma,double *u2,int *ldu2,double *vt2,int *ldvt2,int *idxp,int *idx,int *idxc,int *idxq,int *coltyp,int *info);
void    dlasd2(int *nl,int *nr,int *sqre,int *k,double *d,double *z,double *alpha,double *beta,double *u,int *ldu,double *vt,int *ldvt,double *dsigma,double *u2,int *ldu2,double *vt2,int *ldvt2,int *idxp,int *idx,int *idxc,int *idxq,int *coltyp,int *info);
void    DLASD3(int *nl,int *nr,int *sqre,int *k,double *d,double *q,int *ldq,double *dsigma,double *u,int *ldu,double *u2,int *ldu2,double *vt,int *ldvt,double *vt2,int *ldvt2,int *idxc,int *ctot,double *z,int *info);
void    dlasd3(int *nl,int *nr,int *sqre,int *k,double *d,double *q,int *ldq,double *dsigma,double *u,int *ldu,double *u2,int *ldu2,double *vt,int *ldvt,double *vt2,int *ldvt2,int *idxc,int *ctot,double *z,int *info);
void    DLASD4(int *n,int *i,double *d,double *z,double *delta,double *rho,double *sigma,double *work,int *info);
void    dlasd4(int *n,int *i,double *d,double *z,double *delta,double *rho,double *sigma,double *work,int *info);
void    DLASD5(int *i,double *d,double *z,double *delta,double *rho,double *dsigma,double *work);
void    dlasd5(int *i,double *d,double *z,double *delta,double *rho,double *dsigma,double *work);
void    DLASD6(int *icompq,int *nl,int *nr,int *sqre,double *d,double *vf,double *vl,double *alpha,double *beta,int *idxq,int *perm,int *givptr,int *givcol,int *ldgcol,double *givnum,int *ldgnum,double *poles,double *difl,double *difr,double *z,int *k,double *c,double *s,double *work,int *iwork,int *info);
void    dlasd6(int *icompq,int *nl,int *nr,int *sqre,double *d,double *vf,double *vl,double *alpha,double *beta,int *idxq,int *perm,int *givptr,int *givcol,int *ldgcol,double *givnum,int *ldgnum,double *poles,double *difl,double *difr,double *z,int *k,double *c,double *s,double *work,int *iwork,int *info);
void    DLASD7(int *icompq,int *nl,int *nr,int *sqre,int *k,double *d,double *z,double *zw,double *vf,double *vfw,double *vl,double *vlw,double *alpha,double *beta,double *dsigma,int *idx,int *idxp,int *idxq,int *perm,int *givptr,int *givcol,int *ldgcol,double *givnum,int *ldgnum,double *c,double *s,int *info);
void    dlasd7(int *icompq,int *nl,int *nr,int *sqre,int *k,double *d,double *z,double *zw,double *vf,double *vfw,double *vl,double *vlw,double *alpha,double *beta,double *dsigma,int *idx,int *idxp,int *idxq,int *perm,int *givptr,int *givcol,int *ldgcol,double *givnum,int *ldgnum,double *c,double *s,int *info);
void    DLASD8(int *icompq,int *k,double *d,double *z,double *vf,double *vl,double *difl,double *difr,int *lddifr,double *dsigma,double *work,int *info);
void    dlasd8(int *icompq,int *k,double *d,double *z,double *vf,double *vl,double *difl,double *difr,int *lddifr,double *dsigma,double *work,int *info);
void    DLASD9(int *icompq,int *ldu,int *k,double *d,double *z,double *vf,double *vl,double *difl,double *difr,double *dsigma,double *work,int *info);
void    dlasd9(int *icompq,int *ldu,int *k,double *d,double *z,double *vf,double *vl,double *difl,double *difr,double *dsigma,double *work,int *info);
void    DLASDA(int *icompq,int *smlsiz,int *n,int *sqre,double *d,double *e,double *u,int *ldu,double *vt,int *k,double *difl,double *difr,double *z,double *poles,int *givptr,int *givcol,int *ldgcol,int *perm,double *givnum,double *c,double *s,double *work,int *iwork,int *info);
void    dlasda(int *icompq,int *smlsiz,int *n,int *sqre,double *d,double *e,double *u,int *ldu,double *vt,int *k,double *difl,double *difr,double *z,double *poles,int *givptr,int *givcol,int *ldgcol,int *perm,double *givnum,double *c,double *s,double *work,int *iwork,int *info);
void    DLASDQ(char *uplo,int *sqre,int *n,int *ncvt,int *nru,int *ncc,double *d,double *e,double *vt,int *ldvt,double *u,int *ldu,double *c,int *ldc,double *work,int *info);
void    dlasdq(char *uplo,int *sqre,int *n,int *ncvt,int *nru,int *ncc,double *d,double *e,double *vt,int *ldvt,double *u,int *ldu,double *c,int *ldc,double *work,int *info);
void    DLASDT(int *n,int *lvl,int *nd,int *inode,int *ndiml,int *ndimr,int *msub);
void    dlasdt(int *n,int *lvl,int *nd,int *inode,int *ndiml,int *ndimr,int *msub);
void    DLASET(char *uplo,int *m,int *n,double *alpha,double *beta,double *a,int *lda);
void    dlaset(char *uplo,int *m,int *n,double *alpha,double *beta,double *a,int *lda);
void    DLASQ1(int *n,double *d,double *e,double *work,int *info);
void    dlasq1(int *n,double *d,double *e,double *work,int *info);
void    DLASQ2(int *n,double *z,int *info);
void    dlasq2(int *n,double *z,int *info);
void    DLASQ3(int *i0,int *n0,double *z,int *pp,double *dmin,double *sigma,double *desig,double *qmax,int *nfail,int *iter,int *ndiv,void *ieee);
void    dlasq3(int *i0,int *n0,double *z,int *pp,double *dmin,double *sigma,double *desig,double *qmax,int *nfail,int *iter,int *ndiv,void *ieee);
void    DLASQ4(int *i0,int *n0,double *z,int *pp,int *n0in,double *dmin,double *dmin1,double *dmin2,double *dn,double *dn1,double *dn2,double *tau,int *ttype);
void    dlasq4(int *i0,int *n0,double *z,int *pp,int *n0in,double *dmin,double *dmin1,double *dmin2,double *dn,double *dn1,double *dn2,double *tau,int *ttype);
void    DLASQ5(int *i0,int *n0,double *z,int *pp,double *tau,double *dmin,double *dmin1,double *dmin2,double *dn,double *dnm1,double *dnm2,void *ieee);
void    dlasq5(int *i0,int *n0,double *z,int *pp,double *tau,double *dmin,double *dmin1,double *dmin2,double *dn,double *dnm1,double *dnm2,void *ieee);
void    DLASQ6(int *i0,int *n0,double *z,int *pp,double *dmin,double *dmin1,double *dmin2,double *dn,double *dnm1,double *dnm2);
void    dlasq6(int *i0,int *n0,double *z,int *pp,double *dmin,double *dmin1,double *dmin2,double *dn,double *dnm1,double *dnm2);
void    DLASR(char *side,char *pivot,char *direct,int *m,int *n,double *c,double *s,double *a,int *lda);
void    dlasr(char *side,char *pivot,char *direct,int *m,int *n,double *c,double *s,double *a,int *lda);
void    DLASRT(char *id,int *n,double *d,int *info);
void    dlasrt(char *id,int *n,double *d,int *info);
void    DLASSQ(int *n,double *x,int *incx,double *scale,double *sumsq);
void    dlassq(int *n,double *x,int *incx,double *scale,double *sumsq);
void    DLASV2(double *f,double *g,double *h,double *ssmin,double *ssmax,double *snr,double *csr,double *snl,double *csl);
void    dlasv2(double *f,double *g,double *h,double *ssmin,double *ssmax,double *snr,double *csr,double *snl,double *csl);
void    DLASWP(int *n,double *a,int *lda,int *k1,int *k2,int *ipiv,int *incx);
void    dlaswp(int *n,double *a,int *lda,int *k1,int *k2,int *ipiv,int *incx);
void    DLASY2(void *ltranl,void *ltranr,int *isgn,int *n1,int *n2,double *tl,int *ldtl,double *tr,int *ldtr,double *b,int *ldb,double *scale,double *x,int *ldx,double *xnorm,int *info);
void    dlasy2(void *ltranl,void *ltranr,int *isgn,int *n1,int *n2,double *tl,int *ldtl,double *tr,int *ldtr,double *b,int *ldb,double *scale,double *x,int *ldx,double *xnorm,int *info);
void    DLASYF(char *uplo,int *n,int *nb,int *kb,double *a,int *lda,int *ipiv,double *w,int *ldw,int *info);
void    dlasyf(char *uplo,int *n,int *nb,int *kb,double *a,int *lda,int *ipiv,double *w,int *ldw,int *info);
void    DLATBS(char *uplo,char *trans,char *diag,char *normin,int *n,int *kd,double *ab,int *ldab,double *x,double *scale,double *cnorm,int *info);
void    dlatbs(char *uplo,char *trans,char *diag,char *normin,int *n,int *kd,double *ab,int *ldab,double *x,double *scale,double *cnorm,int *info);
void    DLATDF(int *ijob,int *n,double *z,int *ldz,double *rhs,double *rdsum,double *rdscal,int *ipiv,int *jpiv);
void    dlatdf(int *ijob,int *n,double *z,int *ldz,double *rhs,double *rdsum,double *rdscal,int *ipiv,int *jpiv);
void    DLATPS(char *uplo,char *trans,char *diag,char *normin,int *n,double *ap,double *x,double *scale,double *cnorm,int *info);
void    dlatps(char *uplo,char *trans,char *diag,char *normin,int *n,double *ap,double *x,double *scale,double *cnorm,int *info);
void    DLATRD(char *uplo,int *n,int *nb,double *a,int *lda,double *e,double *tau,double *w,int *ldw);
void    dlatrd(char *uplo,int *n,int *nb,double *a,int *lda,double *e,double *tau,double *w,int *ldw);
void    DLATRS(char *uplo,char *trans,char *diag,char *normin,int *n,double *a,int *lda,double *x,double *scale,double *cnorm,int *info);
void    dlatrs(char *uplo,char *trans,char *diag,char *normin,int *n,double *a,int *lda,double *x,double *scale,double *cnorm,int *info);
void    DLATRZ(int *m,int *n,int *l,double *a,int *lda,double *tau,double *work);
void    dlatrz(int *m,int *n,int *l,double *a,int *lda,double *tau,double *work);
void    DLATZM(char *side,int *m,int *n,double *v,int *incv,double *tau,double *c1,double *c2,int *ldc,double *work);
void    dlatzm(char *side,int *m,int *n,double *v,int *incv,double *tau,double *c1,double *c2,int *ldc,double *work);
void    DLAUU2(char *uplo,int *n,double *a,int *lda,int *info);
void    dlauu2(char *uplo,int *n,double *a,int *lda,int *info);
void    DLAUUM(char *uplo,int *n,double *a,int *lda,int *info);
void    dlauum(char *uplo,int *n,double *a,int *lda,int *info);
void    DOPGTR(char *uplo,int *n,double *ap,double *tau,double *q,int *ldq,double *work,int *info);
void    dopgtr(char *uplo,int *n,double *ap,double *tau,double *q,int *ldq,double *work,int *info);
void    DOPMTR(char *side,char *uplo,char *trans,int *m,int *n,double *ap,double *tau,double *c,int *ldc,double *work,int *info);
void    dopmtr(char *side,char *uplo,char *trans,int *m,int *n,double *ap,double *tau,double *c,int *ldc,double *work,int *info);
void    DORG2L(int *m,int *n,int *k,double *a,int *lda,double *tau,double *work,int *info);
void    dorg2l(int *m,int *n,int *k,double *a,int *lda,double *tau,double *work,int *info);
void    DORG2R(int *m,int *n,int *k,double *a,int *lda,double *tau,double *work,int *info);
void    dorg2r(int *m,int *n,int *k,double *a,int *lda,double *tau,double *work,int *info);
void    DORGBR(char *vect,int *m,int *n,int *k,double *a,int *lda,double *tau,double *work,int *lwork,int *info);
void    dorgbr(char *vect,int *m,int *n,int *k,double *a,int *lda,double *tau,double *work,int *lwork,int *info);
void    DORGHR(int *n,int *ilo,int *ihi,double *a,int *lda,double *tau,double *work,int *lwork,int *info);
void    dorghr(int *n,int *ilo,int *ihi,double *a,int *lda,double *tau,double *work,int *lwork,int *info);
void    DORGL2(int *m,int *n,int *k,double *a,int *lda,double *tau,double *work,int *info);
void    dorgl2(int *m,int *n,int *k,double *a,int *lda,double *tau,double *work,int *info);
void    DORGLQ(int *m,int *n,int *k,double *a,int *lda,double *tau,double *work,int *lwork,int *info);
void    dorglq(int *m,int *n,int *k,double *a,int *lda,double *tau,double *work,int *lwork,int *info);
void    DORGQL(int *m,int *n,int *k,double *a,int *lda,double *tau,double *work,int *lwork,int *info);
void    dorgql(int *m,int *n,int *k,double *a,int *lda,double *tau,double *work,int *lwork,int *info);
void    DORGQR(int *m,int *n,int *k,double *a,int *lda,double *tau,double *work,int *lwork,int *info);
void    dorgqr(int *m,int *n,int *k,double *a,int *lda,double *tau,double *work,int *lwork,int *info);
void    DORGR2(int *m,int *n,int *k,double *a,int *lda,double *tau,double *work,int *info);
void    dorgr2(int *m,int *n,int *k,double *a,int *lda,double *tau,double *work,int *info);
void    DORGRQ(int *m,int *n,int *k,double *a,int *lda,double *tau,double *work,int *lwork,int *info);
void    dorgrq(int *m,int *n,int *k,double *a,int *lda,double *tau,double *work,int *lwork,int *info);
void    DORGTR(char *uplo,int *n,double *a,int *lda,double *tau,double *work,int *lwork,int *info);
void    dorgtr(char *uplo,int *n,double *a,int *lda,double *tau,double *work,int *lwork,int *info);
void    DORM2L(char *side,char *trans,int *m,int *n,int *k,double *a,int *lda,double *tau,double *c,int *ldc,double *work,int *info);
void    dorm2l(char *side,char *trans,int *m,int *n,int *k,double *a,int *lda,double *tau,double *c,int *ldc,double *work,int *info);
void    DORM2R(char *side,char *trans,int *m,int *n,int *k,double *a,int *lda,double *tau,double *c,int *ldc,double *work,int *info);
void    dorm2r(char *side,char *trans,int *m,int *n,int *k,double *a,int *lda,double *tau,double *c,int *ldc,double *work,int *info);
void    DORMBR(char *vect,char *side,char *trans,int *m,int *n,int *k,double *a,int *lda,double *tau,double *c,int *ldc,double *work,int *lwork,int *info);
void    dormbr(char *vect,char *side,char *trans,int *m,int *n,int *k,double *a,int *lda,double *tau,double *c,int *ldc,double *work,int *lwork,int *info);
void    DORMHR(char *side,char *trans,int *m,int *n,int *ilo,int *ihi,double *a,int *lda,double *tau,double *c,int *ldc,double *work,int *lwork,int *info);
void    dormhr(char *side,char *trans,int *m,int *n,int *ilo,int *ihi,double *a,int *lda,double *tau,double *c,int *ldc,double *work,int *lwork,int *info);
void    DORML2(char *side,char *trans,int *m,int *n,int *k,double *a,int *lda,double *tau,double *c,int *ldc,double *work,int *info);
void    dorml2(char *side,char *trans,int *m,int *n,int *k,double *a,int *lda,double *tau,double *c,int *ldc,double *work,int *info);
void    DORMLQ(char *side,char *trans,int *m,int *n,int *k,double *a,int *lda,double *tau,double *c,int *ldc,double *work,int *lwork,int *info);
void    dormlq(char *side,char *trans,int *m,int *n,int *k,double *a,int *lda,double *tau,double *c,int *ldc,double *work,int *lwork,int *info);
void    DORMQL(char *side,char *trans,int *m,int *n,int *k,double *a,int *lda,double *tau,double *c,int *ldc,double *work,int *lwork,int *info);
void    dormql(char *side,char *trans,int *m,int *n,int *k,double *a,int *lda,double *tau,double *c,int *ldc,double *work,int *lwork,int *info);
void    DORMQR(char *side,char *trans,int *m,int *n,int *k,double *a,int *lda,double *tau,double *c,int *ldc,double *work,int *lwork,int *info);
void    dormqr(char *side,char *trans,int *m,int *n,int *k,double *a,int *lda,double *tau,double *c,int *ldc,double *work,int *lwork,int *info);
void    DORMR2(char *side,char *trans,int *m,int *n,int *k,double *a,int *lda,double *tau,double *c,int *ldc,double *work,int *info);
void    dormr2(char *side,char *trans,int *m,int *n,int *k,double *a,int *lda,double *tau,double *c,int *ldc,double *work,int *info);
void    DORMR3(char *side,char *trans,int *m,int *n,int *k,int *l,double *a,int *lda,double *tau,double *c,int *ldc,double *work,int *info);
void    dormr3(char *side,char *trans,int *m,int *n,int *k,int *l,double *a,int *lda,double *tau,double *c,int *ldc,double *work,int *info);
void    DORMRQ(char *side,char *trans,int *m,int *n,int *k,double *a,int *lda,double *tau,double *c,int *ldc,double *work,int *lwork,int *info);
void    dormrq(char *side,char *trans,int *m,int *n,int *k,double *a,int *lda,double *tau,double *c,int *ldc,double *work,int *lwork,int *info);
void    DORMRZ(char *side,char *trans,int *m,int *n,int *k,int *l,double *a,int *lda,double *tau,double *c,int *ldc,double *work,int *lwork,int *info);
void    dormrz(char *side,char *trans,int *m,int *n,int *k,int *l,double *a,int *lda,double *tau,double *c,int *ldc,double *work,int *lwork,int *info);
void    DORMTR(char *side,char *uplo,char *trans,int *m,int *n,double *a,int *lda,double *tau,double *c,int *ldc,double *work,int *lwork,int *info);
void    dormtr(char *side,char *uplo,char *trans,int *m,int *n,double *a,int *lda,double *tau,double *c,int *ldc,double *work,int *lwork,int *info);
void    DPBCON(char *uplo,int *n,int *kd,double *ab,int *ldab,double *anorm,double *rcond,double *work,int *iwork,int *info);
void    dpbcon(char *uplo,int *n,int *kd,double *ab,int *ldab,double *anorm,double *rcond,double *work,int *iwork,int *info);
void    DPBEQU(char *uplo,int *n,int *kd,double *ab,int *ldab,double *s,double *scond,double *amax,int *info);
void    dpbequ(char *uplo,int *n,int *kd,double *ab,int *ldab,double *s,double *scond,double *amax,int *info);
void    DPBRFS(char *uplo,int *n,int *kd,int *nrhs,double *ab,int *ldab,double *afb,int *ldafb,double *b,int *ldb,double *x,int *ldx,double *ferr,double *berr,double *work,int *iwork,int *info);
void    dpbrfs(char *uplo,int *n,int *kd,int *nrhs,double *ab,int *ldab,double *afb,int *ldafb,double *b,int *ldb,double *x,int *ldx,double *ferr,double *berr,double *work,int *iwork,int *info);
void    DPBSTF(char *uplo,int *n,int *kd,double *ab,int *ldab,int *info);
void    dpbstf(char *uplo,int *n,int *kd,double *ab,int *ldab,int *info);
void    DPBSV(char *uplo,int *n,int *kd,int *nrhs,double *ab,int *ldab,double *b,int *ldb,int *info);
void    dpbsv(char *uplo,int *n,int *kd,int *nrhs,double *ab,int *ldab,double *b,int *ldb,int *info);
void    DPBSVX(char *fact,char *uplo,int *n,int *kd,int *nrhs,double *ab,int *ldab,double *afb,int *ldafb,char *equed,double *s,double *b,int *ldb,double *x,int *ldx,double *rcond,double *ferr,double *berr,double *work,int *iwork,int *info);
void    dpbsvx(char *fact,char *uplo,int *n,int *kd,int *nrhs,double *ab,int *ldab,double *afb,int *ldafb,char *equed,double *s,double *b,int *ldb,double *x,int *ldx,double *rcond,double *ferr,double *berr,double *work,int *iwork,int *info);
void    DPBTF2(char *uplo,int *n,int *kd,double *ab,int *ldab,int *info);
void    dpbtf2(char *uplo,int *n,int *kd,double *ab,int *ldab,int *info);
void    DPBTRF(char *uplo,int *n,int *kd,double *ab,int *ldab,int *info);
void    dpbtrf(char *uplo,int *n,int *kd,double *ab,int *ldab,int *info);
void    DPBTRS(char *uplo,int *n,int *kd,int *nrhs,double *ab,int *ldab,double *b,int *ldb,int *info);
void    dpbtrs(char *uplo,int *n,int *kd,int *nrhs,double *ab,int *ldab,double *b,int *ldb,int *info);
void    DPOCON(char *uplo,int *n,double *a,int *lda,double *anorm,double *rcond,double *work,int *iwork,int *info);
void    dpocon(char *uplo,int *n,double *a,int *lda,double *anorm,double *rcond,double *work,int *iwork,int *info);
void    DPOEQU(int *n,double *a,int *lda,double *s,double *scond,double *amax,int *info);
void    dpoequ(int *n,double *a,int *lda,double *s,double *scond,double *amax,int *info);
void    DPORFS(char *uplo,int *n,int *nrhs,double *a,int *lda,double *af,int *ldaf,double *b,int *ldb,double *x,int *ldx,double *ferr,double *berr,double *work,int *iwork,int *info);
void    dporfs(char *uplo,int *n,int *nrhs,double *a,int *lda,double *af,int *ldaf,double *b,int *ldb,double *x,int *ldx,double *ferr,double *berr,double *work,int *iwork,int *info);
void    DPOSV(char *uplo,int *n,int *nrhs,double *a,int *lda,double *b,int *ldb,int *info);
void    dposv(char *uplo,int *n,int *nrhs,double *a,int *lda,double *b,int *ldb,int *info);
void    DPOSVX(char *fact,char *uplo,int *n,int *nrhs,double *a,int *lda,double *af,int *ldaf,char *equed,double *s,double *b,int *ldb,double *x,int *ldx,double *rcond,double *ferr,double *berr,double *work,int *iwork,int *info);
void    dposvx(char *fact,char *uplo,int *n,int *nrhs,double *a,int *lda,double *af,int *ldaf,char *equed,double *s,double *b,int *ldb,double *x,int *ldx,double *rcond,double *ferr,double *berr,double *work,int *iwork,int *info);
void    DPOTF2(char *uplo,int *n,double *a,int *lda,int *info);
void    dpotf2(char *uplo,int *n,double *a,int *lda,int *info);
void    DPOTRF(char *uplo,int *n,double *a,int *lda,int *info);
void    dpotrf(char *uplo,int *n,double *a,int *lda,int *info);
void    DPOTRI(char *uplo,int *n,double *a,int *lda,int *info);
void    dpotri(char *uplo,int *n,double *a,int *lda,int *info);
void    DPOTRS(char *uplo,int *n,int *nrhs,double *a,int *lda,double *b,int *ldb,int *info);
void    dpotrs(char *uplo,int *n,int *nrhs,double *a,int *lda,double *b,int *ldb,int *info);
void    DPPCON(char *uplo,int *n,double *ap,double *anorm,double *rcond,double *work,int *iwork,int *info);
void    dppcon(char *uplo,int *n,double *ap,double *anorm,double *rcond,double *work,int *iwork,int *info);
void    DPPEQU(char *uplo,int *n,double *ap,double *s,double *scond,double *amax,int *info);
void    dppequ(char *uplo,int *n,double *ap,double *s,double *scond,double *amax,int *info);
void    DPPRFS(char *uplo,int *n,int *nrhs,double *ap,double *afp,double *b,int *ldb,double *x,int *ldx,double *ferr,double *berr,double *work,int *iwork,int *info);
void    dpprfs(char *uplo,int *n,int *nrhs,double *ap,double *afp,double *b,int *ldb,double *x,int *ldx,double *ferr,double *berr,double *work,int *iwork,int *info);
void    DPPSV(char *uplo,int *n,int *nrhs,double *ap,double *b,int *ldb,int *info);
void    dppsv(char *uplo,int *n,int *nrhs,double *ap,double *b,int *ldb,int *info);
void    DPPSVX(char *fact,char *uplo,int *n,int *nrhs,double *ap,double *afp,char *equed,double *s,double *b,int *ldb,double *x,int *ldx,double *rcond,double *ferr,double *berr,double *work,int *iwork,int *info);
void    dppsvx(char *fact,char *uplo,int *n,int *nrhs,double *ap,double *afp,char *equed,double *s,double *b,int *ldb,double *x,int *ldx,double *rcond,double *ferr,double *berr,double *work,int *iwork,int *info);
void    DPPTRF(char *uplo,int *n,double *ap,int *info);
void    dpptrf(char *uplo,int *n,double *ap,int *info);
void    DPPTRI(char *uplo,int *n,double *ap,int *info);
void    dpptri(char *uplo,int *n,double *ap,int *info);
void    DPPTRS(char *uplo,int *n,int *nrhs,double *ap,double *b,int *ldb,int *info);
void    dpptrs(char *uplo,int *n,int *nrhs,double *ap,double *b,int *ldb,int *info);
void    DPTCON(int *n,double *d,double *e,double *anorm,double *rcond,double *work,int *info);
void    dptcon(int *n,double *d,double *e,double *anorm,double *rcond,double *work,int *info);
void    DPTEQR(char *compz,int *n,double *d,double *e,double *z,int *ldz,double *work,int *info);
void    dpteqr(char *compz,int *n,double *d,double *e,double *z,int *ldz,double *work,int *info);
void    DPTRFS(int *n,int *nrhs,double *d,double *e,double *df,double *ef,double *b,int *ldb,double *x,int *ldx,double *ferr,double *berr,double *work,int *info);
void    dptrfs(int *n,int *nrhs,double *d,double *e,double *df,double *ef,double *b,int *ldb,double *x,int *ldx,double *ferr,double *berr,double *work,int *info);
void    DPTSV(int *n,int *nrhs,double *d,double *e,double *b,int *ldb,int *info);
void    dptsv(int *n,int *nrhs,double *d,double *e,double *b,int *ldb,int *info);
void    DPTSVX(char *fact,int *n,int *nrhs,double *d,double *e,double *df,double *ef,double *b,int *ldb,double *x,int *ldx,double *rcond,double *ferr,double *berr,double *work,int *info);
void    dptsvx(char *fact,int *n,int *nrhs,double *d,double *e,double *df,double *ef,double *b,int *ldb,double *x,int *ldx,double *rcond,double *ferr,double *berr,double *work,int *info);
void    DPTTRF(int *n,double *d,double *e,int *info);
void    dpttrf(int *n,double *d,double *e,int *info);
void    DPTTRS(int *n,int *nrhs,double *d,double *e,double *b,int *ldb,int *info);
void    dpttrs(int *n,int *nrhs,double *d,double *e,double *b,int *ldb,int *info);
void    DPTTS2(int *n,int *nrhs,double *d,double *e,double *b,int *ldb);
void    dptts2(int *n,int *nrhs,double *d,double *e,double *b,int *ldb);
void    DRSCL(int *n,double *sa,double *sx,int *incx);
void    drscl(int *n,double *sa,double *sx,int *incx);
void    DSBEV(char *jobz,char *uplo,int *n,int *kd,double *ab,int *ldab,double *w,double *z,int *ldz,double *work,int *info);
void    dsbev(char *jobz,char *uplo,int *n,int *kd,double *ab,int *ldab,double *w,double *z,int *ldz,double *work,int *info);
void    DSBEVD(char *jobz,char *uplo,int *n,int *kd,double *ab,int *ldab,double *w,double *z,int *ldz,double *work,int *lwork,int *iwork,int *liwork,int *info);
void    dsbevd(char *jobz,char *uplo,int *n,int *kd,double *ab,int *ldab,double *w,double *z,int *ldz,double *work,int *lwork,int *iwork,int *liwork,int *info);
void    DSBEVX(char *jobz,char *range,char *uplo,int *n,int *kd,double *ab,int *ldab,double *q,int *ldq,double *vl,double *vu,int *il,int *iu,double *abstol,int *m,double *w,double *z,int *ldz,double *work,int *iwork,int *ifail,int *info);
void    dsbevx(char *jobz,char *range,char *uplo,int *n,int *kd,double *ab,int *ldab,double *q,int *ldq,double *vl,double *vu,int *il,int *iu,double *abstol,int *m,double *w,double *z,int *ldz,double *work,int *iwork,int *ifail,int *info);
void    DSBGST(char *vect,char *uplo,int *n,int *ka,int *kb,double *ab,int *ldab,double *bb,int *ldbb,double *x,int *ldx,double *work,int *info);
void    dsbgst(char *vect,char *uplo,int *n,int *ka,int *kb,double *ab,int *ldab,double *bb,int *ldbb,double *x,int *ldx,double *work,int *info);
void    DSBGV(char *jobz,char *uplo,int *n,int *ka,int *kb,double *ab,int *ldab,double *bb,int *ldbb,double *w,double *z,int *ldz,double *work,int *info);
void    dsbgv(char *jobz,char *uplo,int *n,int *ka,int *kb,double *ab,int *ldab,double *bb,int *ldbb,double *w,double *z,int *ldz,double *work,int *info);
void    DSBGVD(char *jobz,char *uplo,int *n,int *ka,int *kb,double *ab,int *ldab,double *bb,int *ldbb,double *w,double *z,int *ldz,double *work,int *lwork,int *iwork,int *liwork,int *info);
void    dsbgvd(char *jobz,char *uplo,int *n,int *ka,int *kb,double *ab,int *ldab,double *bb,int *ldbb,double *w,double *z,int *ldz,double *work,int *lwork,int *iwork,int *liwork,int *info);
void    DSBGVX(char *jobz,char *range,char *uplo,int *n,int *ka,int *kb,double *ab,int *ldab,double *bb,int *ldbb,double *q,int *ldq,double *vl,double *vu,int *il,int *iu,double *abstol,int *m,double *w,double *z,int *ldz,double *work,int *iwork,int *ifail,int *info);
void    dsbgvx(char *jobz,char *range,char *uplo,int *n,int *ka,int *kb,double *ab,int *ldab,double *bb,int *ldbb,double *q,int *ldq,double *vl,double *vu,int *il,int *iu,double *abstol,int *m,double *w,double *z,int *ldz,double *work,int *iwork,int *ifail,int *info);
void    DSBTRD(char *vect,char *uplo,int *n,int *kd,double *ab,int *ldab,double *d,double *e,double *q,int *ldq,double *work,int *info);
void    dsbtrd(char *vect,char *uplo,int *n,int *kd,double *ab,int *ldab,double *d,double *e,double *q,int *ldq,double *work,int *info);
void    DSPCON(char *uplo,int *n,double *ap,int *ipiv,double *anorm,double *rcond,double *work,int *iwork,int *info);
void    dspcon(char *uplo,int *n,double *ap,int *ipiv,double *anorm,double *rcond,double *work,int *iwork,int *info);
void    DSPEV(char *jobz,char *uplo,int *n,double *ap,double *w,double *z,int *ldz,double *work,int *info);
void    dspev(char *jobz,char *uplo,int *n,double *ap,double *w,double *z,int *ldz,double *work,int *info);
void    DSPEVD(char *jobz,char *uplo,int *n,double *ap,double *w,double *z,int *ldz,double *work,int *lwork,int *iwork,int *liwork,int *info);
void    dspevd(char *jobz,char *uplo,int *n,double *ap,double *w,double *z,int *ldz,double *work,int *lwork,int *iwork,int *liwork,int *info);
void    DSPEVX(char *jobz,char *range,char *uplo,int *n,double *ap,double *vl,double *vu,int *il,int *iu,double *abstol,int *m,double *w,double *z,int *ldz,double *work,int *iwork,int *ifail,int *info);
void    dspevx(char *jobz,char *range,char *uplo,int *n,double *ap,double *vl,double *vu,int *il,int *iu,double *abstol,int *m,double *w,double *z,int *ldz,double *work,int *iwork,int *ifail,int *info);
void    DSPGST(int *itype,char *uplo,int *n,double *ap,double *bp,int *info);
void    dspgst(int *itype,char *uplo,int *n,double *ap,double *bp,int *info);
void    DSPGV(int *itype,char *jobz,char *uplo,int *n,double *ap,double *bp,double *w,double *z,int *ldz,double *work,int *info);
void    dspgv(int *itype,char *jobz,char *uplo,int *n,double *ap,double *bp,double *w,double *z,int *ldz,double *work,int *info);
void    DSPGVD(int *itype,char *jobz,char *uplo,int *n,double *ap,double *bp,double *w,double *z,int *ldz,double *work,int *lwork,int *iwork,int *liwork,int *info);
void    dspgvd(int *itype,char *jobz,char *uplo,int *n,double *ap,double *bp,double *w,double *z,int *ldz,double *work,int *lwork,int *iwork,int *liwork,int *info);
void    DSPGVX(int *itype,char *jobz,char *range,char *uplo,int *n,double *ap,double *bp,double *vl,double *vu,int *il,int *iu,double *abstol,int *m,double *w,double *z,int *ldz,double *work,int *iwork,int *ifail,int *info);
void    dspgvx(int *itype,char *jobz,char *range,char *uplo,int *n,double *ap,double *bp,double *vl,double *vu,int *il,int *iu,double *abstol,int *m,double *w,double *z,int *ldz,double *work,int *iwork,int *ifail,int *info);
void    DSPRFS(char *uplo,int *n,int *nrhs,double *ap,double *afp,int *ipiv,double *b,int *ldb,double *x,int *ldx,double *ferr,double *berr,double *work,int *iwork,int *info);
void    dsprfs(char *uplo,int *n,int *nrhs,double *ap,double *afp,int *ipiv,double *b,int *ldb,double *x,int *ldx,double *ferr,double *berr,double *work,int *iwork,int *info);
void    DSPSV(char *uplo,int *n,int *nrhs,double *ap,int *ipiv,double *b,int *ldb,int *info);
void    dspsv(char *uplo,int *n,int *nrhs,double *ap,int *ipiv,double *b,int *ldb,int *info);
void    DSPSVX(char *fact,char *uplo,int *n,int *nrhs,double *ap,double *afp,int *ipiv,double *b,int *ldb,double *x,int *ldx,double *rcond,double *ferr,double *berr,double *work,int *iwork,int *info);
void    dspsvx(char *fact,char *uplo,int *n,int *nrhs,double *ap,double *afp,int *ipiv,double *b,int *ldb,double *x,int *ldx,double *rcond,double *ferr,double *berr,double *work,int *iwork,int *info);
void    DSPTRD(char *uplo,int *n,double *ap,double *d,double *e,double *tau,int *info);
void    dsptrd(char *uplo,int *n,double *ap,double *d,double *e,double *tau,int *info);
void    DSPTRF(char *uplo,int *n,double *ap,int *ipiv,int *info);
void    dsptrf(char *uplo,int *n,double *ap,int *ipiv,int *info);
void    DSPTRI(char *uplo,int *n,double *ap,int *ipiv,double *work,int *info);
void    dsptri(char *uplo,int *n,double *ap,int *ipiv,double *work,int *info);
void    DSPTRS(char *uplo,int *n,int *nrhs,double *ap,int *ipiv,double *b,int *ldb,int *info);
void    dsptrs(char *uplo,int *n,int *nrhs,double *ap,int *ipiv,double *b,int *ldb,int *info);
void    DSTEBZ(char *range,char *order,int *n,double *vl,double *vu,int *il,int *iu,double *abstol,double *d,double *e,int *m,int *nsplit,double *w,int *iblock,int *isplit,double *work,int *iwork,int *info);
void    dstebz(char *range,char *order,int *n,double *vl,double *vu,int *il,int *iu,double *abstol,double *d,double *e,int *m,int *nsplit,double *w,int *iblock,int *isplit,double *work,int *iwork,int *info);
void    DSTEDC(char *compz,int *n,double *d,double *e,double *z,int *ldz,double *work,int *lwork,int *iwork,int *liwork,int *info);
void    dstedc(char *compz,int *n,double *d,double *e,double *z,int *ldz,double *work,int *lwork,int *iwork,int *liwork,int *info);
void    DSTEGR(char *jobz,char *range,int *n,double *d,double *e,double *vl,double *vu,int *il,int *iu,double *abstol,int *m,double *w,double *z,int *ldz,int *isuppz,double *work,int *lwork,int *iwork,int *liwork,int *info);
void    dstegr(char *jobz,char *range,int *n,double *d,double *e,double *vl,double *vu,int *il,int *iu,double *abstol,int *m,double *w,double *z,int *ldz,int *isuppz,double *work,int *lwork,int *iwork,int *liwork,int *info);
void    DSTEIN(int *n,double *d,double *e,int *m,double *w,int *iblock,int *isplit,double *z,int *ldz,double *work,int *iwork,int *ifail,int *info);
void    dstein(int *n,double *d,double *e,int *m,double *w,int *iblock,int *isplit,double *z,int *ldz,double *work,int *iwork,int *ifail,int *info);
void    DSTEQR(char *compz,int *n,double *d,double *e,double *z,int *ldz,double *work,int *info);
void    dsteqr(char *compz,int *n,double *d,double *e,double *z,int *ldz,double *work,int *info);
void    DSTERF(int *n,double *d,double *e,int *info);
void    dsterf(int *n,double *d,double *e,int *info);
void    DSTEV(char *jobz,int *n,double *d,double *e,double *z,int *ldz,double *work,int *info);
void    dstev(char *jobz,int *n,double *d,double *e,double *z,int *ldz,double *work,int *info);
void    DSTEVD(char *jobz,int *n,double *d,double *e,double *z,int *ldz,double *work,int *lwork,int *iwork,int *liwork,int *info);
void    dstevd(char *jobz,int *n,double *d,double *e,double *z,int *ldz,double *work,int *lwork,int *iwork,int *liwork,int *info);
void    DSTEVR(char *jobz,char *range,int *n,double *d,double *e,double *vl,double *vu,int *il,int *iu,double *abstol,int *m,double *w,double *z,int *ldz,int *isuppz,double *work,int *lwork,int *iwork,int *liwork,int *info);
void    dstevr(char *jobz,char *range,int *n,double *d,double *e,double *vl,double *vu,int *il,int *iu,double *abstol,int *m,double *w,double *z,int *ldz,int *isuppz,double *work,int *lwork,int *iwork,int *liwork,int *info);
void    DSTEVX(char *jobz,char *range,int *n,double *d,double *e,double *vl,double *vu,int *il,int *iu,double *abstol,int *m,double *w,double *z,int *ldz,double *work,int *iwork,int *ifail,int *info);
void    dstevx(char *jobz,char *range,int *n,double *d,double *e,double *vl,double *vu,int *il,int *iu,double *abstol,int *m,double *w,double *z,int *ldz,double *work,int *iwork,int *ifail,int *info);
void    DSYCON(char *uplo,int *n,double *a,int *lda,int *ipiv,double *anorm,double *rcond,double *work,int *iwork,int *info);
void    dsycon(char *uplo,int *n,double *a,int *lda,int *ipiv,double *anorm,double *rcond,double *work,int *iwork,int *info);
void    DSYEV(char *jobz,char *uplo,int *n,double *a,int *lda,double *w,double *work,int *lwork,int *info);
void    dsyev(char *jobz,char *uplo,int *n,double *a,int *lda,double *w,double *work,int *lwork,int *info);
void    DSYEVD(char *jobz,char *uplo,int *n,double *a,int *lda,double *w,double *work,int *lwork,int *iwork,int *liwork,int *info);
void    dsyevd(char *jobz,char *uplo,int *n,double *a,int *lda,double *w,double *work,int *lwork,int *iwork,int *liwork,int *info);
void    DSYEVR(char *jobz,char *range,char *uplo,int *n,double *a,int *lda,double *vl,double *vu,int *il,int *iu,double *abstol,int *m,double *w,double *z,int *ldz,int *isuppz,double *work,int *lwork,int *iwork,int *liwork,int *info);
void    dsyevr(char *jobz,char *range,char *uplo,int *n,double *a,int *lda,double *vl,double *vu,int *il,int *iu,double *abstol,int *m,double *w,double *z,int *ldz,int *isuppz,double *work,int *lwork,int *iwork,int *liwork,int *info);
void    DSYEVX(char *jobz,char *range,char *uplo,int *n,double *a,int *lda,double *vl,double *vu,int *il,int *iu,double *abstol,int *m,double *w,double *z,int *ldz,double *work,int *lwork,int *iwork,int *ifail,int *info);
void    dsyevx(char *jobz,char *range,char *uplo,int *n,double *a,int *lda,double *vl,double *vu,int *il,int *iu,double *abstol,int *m,double *w,double *z,int *ldz,double *work,int *lwork,int *iwork,int *ifail,int *info);
void    DSYGS2(int *itype,char *uplo,int *n,double *a,int *lda,double *b,int *ldb,int *info);
void    dsygs2(int *itype,char *uplo,int *n,double *a,int *lda,double *b,int *ldb,int *info);
void    DSYGST(int *itype,char *uplo,int *n,double *a,int *lda,double *b,int *ldb,int *info);
void    dsygst(int *itype,char *uplo,int *n,double *a,int *lda,double *b,int *ldb,int *info);
void    DSYGV(int *itype,char *jobz,char *uplo,int *n,double *a,int *lda,double *b,int *ldb,double *w,double *work,int *lwork,int *info);
void    dsygv(int *itype,char *jobz,char *uplo,int *n,double *a,int *lda,double *b,int *ldb,double *w,double *work,int *lwork,int *info);
void    DSYGVD(int *itype,char *jobz,char *uplo,int *n,double *a,int *lda,double *b,int *ldb,double *w,double *work,int *lwork,int *iwork,int *liwork,int *info);
void    dsygvd(int *itype,char *jobz,char *uplo,int *n,double *a,int *lda,double *b,int *ldb,double *w,double *work,int *lwork,int *iwork,int *liwork,int *info);
void    DSYGVX(int *itype,char *jobz,char *range,char *uplo,int *n,double *a,int *lda,double *b,int *ldb,double *vl,double *vu,int *il,int *iu,double *abstol,int *m,double *w,double *z,int *ldz,double *work,int *lwork,int *iwork,int *ifail,int *info);
void    dsygvx(int *itype,char *jobz,char *range,char *uplo,int *n,double *a,int *lda,double *b,int *ldb,double *vl,double *vu,int *il,int *iu,double *abstol,int *m,double *w,double *z,int *ldz,double *work,int *lwork,int *iwork,int *ifail,int *info);
void    DSYRFS(char *uplo,int *n,int *nrhs,double *a,int *lda,double *af,int *ldaf,int *ipiv,double *b,int *ldb,double *x,int *ldx,double *ferr,double *berr,double *work,int *iwork,int *info);
void    dsyrfs(char *uplo,int *n,int *nrhs,double *a,int *lda,double *af,int *ldaf,int *ipiv,double *b,int *ldb,double *x,int *ldx,double *ferr,double *berr,double *work,int *iwork,int *info);
void    DSYSV(char *uplo,int *n,int *nrhs,double *a,int *lda,int *ipiv,double *b,int *ldb,double *work,int *lwork,int *info);
void    dsysv(char *uplo,int *n,int *nrhs,double *a,int *lda,int *ipiv,double *b,int *ldb,double *work,int *lwork,int *info);
void    DSYSVX(char *fact,char *uplo,int *n,int *nrhs,double *a,int *lda,double *af,int *ldaf,int *ipiv,double *b,int *ldb,double *x,int *ldx,double *rcond,double *ferr,double *berr,double *work,int *lwork,int *iwork,int *info);
void    dsysvx(char *fact,char *uplo,int *n,int *nrhs,double *a,int *lda,double *af,int *ldaf,int *ipiv,double *b,int *ldb,double *x,int *ldx,double *rcond,double *ferr,double *berr,double *work,int *lwork,int *iwork,int *info);
void    DSYTD2(char *uplo,int *n,double *a,int *lda,double *d,double *e,double *tau,int *info);
void    dsytd2(char *uplo,int *n,double *a,int *lda,double *d,double *e,double *tau,int *info);
void    DSYTF2(char *uplo,int *n,double *a,int *lda,int *ipiv,int *info);
void    dsytf2(char *uplo,int *n,double *a,int *lda,int *ipiv,int *info);
void    DSYTRD(char *uplo,int *n,double *a,int *lda,double *d,double *e,double *tau,double *work,int *lwork,int *info);
void    dsytrd(char *uplo,int *n,double *a,int *lda,double *d,double *e,double *tau,double *work,int *lwork,int *info);
void    DSYTRF(char *uplo,int *n,double *a,int *lda,int *ipiv,double *work,int *lwork,int *info);
void    dsytrf(char *uplo,int *n,double *a,int *lda,int *ipiv,double *work,int *lwork,int *info);
void    DSYTRI(char *uplo,int *n,double *a,int *lda,int *ipiv,double *work,int *info);
void    dsytri(char *uplo,int *n,double *a,int *lda,int *ipiv,double *work,int *info);
void    DSYTRS(char *uplo,int *n,int *nrhs,double *a,int *lda,int *ipiv,double *b,int *ldb,int *info);
void    dsytrs(char *uplo,int *n,int *nrhs,double *a,int *lda,int *ipiv,double *b,int *ldb,int *info);
void    DTBCON(char *norm,char *uplo,char *diag,int *n,int *kd,double *ab,int *ldab,double *rcond,double *work,int *iwork,int *info);
void    dtbcon(char *norm,char *uplo,char *diag,int *n,int *kd,double *ab,int *ldab,double *rcond,double *work,int *iwork,int *info);
void    DTBRFS(char *uplo,char *trans,char *diag,int *n,int *kd,int *nrhs,double *ab,int *ldab,double *b,int *ldb,double *x,int *ldx,double *ferr,double *berr,double *work,int *iwork,int *info);
void    dtbrfs(char *uplo,char *trans,char *diag,int *n,int *kd,int *nrhs,double *ab,int *ldab,double *b,int *ldb,double *x,int *ldx,double *ferr,double *berr,double *work,int *iwork,int *info);
void    DTBTRS(char *uplo,char *trans,char *diag,int *n,int *kd,int *nrhs,double *ab,int *ldab,double *b,int *ldb,int *info);
void    dtbtrs(char *uplo,char *trans,char *diag,int *n,int *kd,int *nrhs,double *ab,int *ldab,double *b,int *ldb,int *info);
void    DTGEVC(char *side,char *howmny,void *select,int *n,double *a,int *lda,double *b,int *ldb,double *vl,int *ldvl,double *vr,int *ldvr,int *mm,int *m,double *work,int *info);
void    dtgevc(char *side,char *howmny,void *select,int *n,double *a,int *lda,double *b,int *ldb,double *vl,int *ldvl,double *vr,int *ldvr,int *mm,int *m,double *work,int *info);
void    DTGEX2(void *wantq,void *wantz,int *n,double *a,int *lda,double *b,int *ldb,double *q,int *ldq,double *z,int *ldz,int *j1,int *n1,int *n2,double *work,int *lwork,int *info);
void    dtgex2(void *wantq,void *wantz,int *n,double *a,int *lda,double *b,int *ldb,double *q,int *ldq,double *z,int *ldz,int *j1,int *n1,int *n2,double *work,int *lwork,int *info);
void    DTGEXC(void *wantq,void *wantz,int *n,double *a,int *lda,double *b,int *ldb,double *q,int *ldq,double *z,int *ldz,int *ifst,int *ilst,double *work,int *lwork,int *info);
void    dtgexc(void *wantq,void *wantz,int *n,double *a,int *lda,double *b,int *ldb,double *q,int *ldq,double *z,int *ldz,int *ifst,int *ilst,double *work,int *lwork,int *info);
void    DTGSEN(int *ijob,void *wantq,void *wantz,void *select,int *n,double *a,int *lda,double *b,int *ldb,double *alphar,double *alphai,double *beta,double *q,int *ldq,double *z,int *ldz,int *m,double *pl,double *pr,double *dif,double *work,int *lwork,int *iwork,int *liwork,int *info);
void    dtgsen(int *ijob,void *wantq,void *wantz,void *select,int *n,double *a,int *lda,double *b,int *ldb,double *alphar,double *alphai,double *beta,double *q,int *ldq,double *z,int *ldz,int *m,double *pl,double *pr,double *dif,double *work,int *lwork,int *iwork,int *liwork,int *info);
void    DTGSJA(char *jobu,char *jobv,char *jobq,int *m,int *p,int *n,int *k,int *l,double *a,int *lda,double *b,int *ldb,double *tola,double *tolb,double *alpha,double *beta,double *u,int *ldu,double *v,int *ldv,double *q,int *ldq,double *work,int *ncycle,int *info);
void    dtgsja(char *jobu,char *jobv,char *jobq,int *m,int *p,int *n,int *k,int *l,double *a,int *lda,double *b,int *ldb,double *tola,double *tolb,double *alpha,double *beta,double *u,int *ldu,double *v,int *ldv,double *q,int *ldq,double *work,int *ncycle,int *info);
void    DTGSNA(char *job,char *howmny,void *select,int *n,double *a,int *lda,double *b,int *ldb,double *vl,int *ldvl,double *vr,int *ldvr,double *s,double *dif,int *mm,int *m,double *work,int *lwork,int *iwork,int *info);
void    dtgsna(char *job,char *howmny,void *select,int *n,double *a,int *lda,double *b,int *ldb,double *vl,int *ldvl,double *vr,int *ldvr,double *s,double *dif,int *mm,int *m,double *work,int *lwork,int *iwork,int *info);
void    DTGSY2(char *trans,int *ijob,int *m,int *n,double *a,int *lda,double *b,int *ldb,double *c,int *ldc,double *d,int *ldd,double *e,int *lde,double *f,int *ldf,double *scale,double *rdsum,double *rdscal,int *iwork,int *pq,int *info);
void    dtgsy2(char *trans,int *ijob,int *m,int *n,double *a,int *lda,double *b,int *ldb,double *c,int *ldc,double *d,int *ldd,double *e,int *lde,double *f,int *ldf,double *scale,double *rdsum,double *rdscal,int *iwork,int *pq,int *info);
void    DTGSYL(char *trans,int *ijob,int *m,int *n,double *a,int *lda,double *b,int *ldb,double *c,int *ldc,double *d,int *ldd,double *e,int *lde,double *f,int *ldf,double *scale,double *dif,double *work,int *lwork,int *iwork,int *info);
void    dtgsyl(char *trans,int *ijob,int *m,int *n,double *a,int *lda,double *b,int *ldb,double *c,int *ldc,double *d,int *ldd,double *e,int *lde,double *f,int *ldf,double *scale,double *dif,double *work,int *lwork,int *iwork,int *info);
void    DTPCON(char *norm,char *uplo,char *diag,int *n,double *ap,double *rcond,double *work,int *iwork,int *info);
void    dtpcon(char *norm,char *uplo,char *diag,int *n,double *ap,double *rcond,double *work,int *iwork,int *info);
void    DTPRFS(char *uplo,char *trans,char *diag,int *n,int *nrhs,double *ap,double *b,int *ldb,double *x,int *ldx,double *ferr,double *berr,double *work,int *iwork,int *info);
void    dtprfs(char *uplo,char *trans,char *diag,int *n,int *nrhs,double *ap,double *b,int *ldb,double *x,int *ldx,double *ferr,double *berr,double *work,int *iwork,int *info);
void    DTPTRI(char *uplo,char *diag,int *n,double *ap,int *info);
void    dtptri(char *uplo,char *diag,int *n,double *ap,int *info);
void    DTPTRS(char *uplo,char *trans,char *diag,int *n,int *nrhs,double *ap,double *b,int *ldb,int *info);
void    dtptrs(char *uplo,char *trans,char *diag,int *n,int *nrhs,double *ap,double *b,int *ldb,int *info);
void    DTRCON(char *norm,char *uplo,char *diag,int *n,double *a,int *lda,double *rcond,double *work,int *iwork,int *info);
void    dtrcon(char *norm,char *uplo,char *diag,int *n,double *a,int *lda,double *rcond,double *work,int *iwork,int *info);
void    DTREVC(char *side,char *howmny,void *select,int *n,double *t,int *ldt,double *vl,int *ldvl,double *vr,int *ldvr,int *mm,int *m,double *work,int *info);
void    dtrevc(char *side,char *howmny,void *select,int *n,double *t,int *ldt,double *vl,int *ldvl,double *vr,int *ldvr,int *mm,int *m,double *work,int *info);
void    DTREXC(char *compq,int *n,double *t,int *ldt,double *q,int *ldq,int *ifst,int *ilst,double *work,int *info);
void    dtrexc(char *compq,int *n,double *t,int *ldt,double *q,int *ldq,int *ifst,int *ilst,double *work,int *info);
void    DTRRFS(char *uplo,char *trans,char *diag,int *n,int *nrhs,double *a,int *lda,double *b,int *ldb,double *x,int *ldx,double *ferr,double *berr,double *work,int *iwork,int *info);
void    dtrrfs(char *uplo,char *trans,char *diag,int *n,int *nrhs,double *a,int *lda,double *b,int *ldb,double *x,int *ldx,double *ferr,double *berr,double *work,int *iwork,int *info);
void    DTRSEN(char *job,char *compq,void *select,int *n,double *t,int *ldt,double *q,int *ldq,double *wr,double *wi,int *m,double *s,double *sep,double *work,int *lwork,int *iwork,int *liwork,int *info);
void    dtrsen(char *job,char *compq,void *select,int *n,double *t,int *ldt,double *q,int *ldq,double *wr,double *wi,int *m,double *s,double *sep,double *work,int *lwork,int *iwork,int *liwork,int *info);
void    DTRSNA(char *job,char *howmny,void *select,int *n,double *t,int *ldt,double *vl,int *ldvl,double *vr,int *ldvr,double *s,double *sep,int *mm,int *m,double *work,int *ldwork,int *iwork,int *info);
void    dtrsna(char *job,char *howmny,void *select,int *n,double *t,int *ldt,double *vl,int *ldvl,double *vr,int *ldvr,double *s,double *sep,int *mm,int *m,double *work,int *ldwork,int *iwork,int *info);
void    DTRSYL(char *trana,char *tranb,int *isgn,int *m,int *n,double *a,int *lda,double *b,int *ldb,double *c,int *ldc,double *scale,int *info);
void    dtrsyl(char *trana,char *tranb,int *isgn,int *m,int *n,double *a,int *lda,double *b,int *ldb,double *c,int *ldc,double *scale,int *info);
void    DTRTI2(char *uplo,char *diag,int *n,double *a,int *lda,int *info);
void    dtrti2(char *uplo,char *diag,int *n,double *a,int *lda,int *info);
void    DTRTRI(char *uplo,char *diag,int *n,double *a,int *lda,int *info);
void    dtrtri(char *uplo,char *diag,int *n,double *a,int *lda,int *info);
void    DTRTRS(char *uplo,char *trans,char *diag,int *n,int *nrhs,double *a,int *lda,double *b,int *ldb,int *info);
void    dtrtrs(char *uplo,char *trans,char *diag,int *n,int *nrhs,double *a,int *lda,double *b,int *ldb,int *info);
void    DTZRQF(int *m,int *n,double *a,int *lda,double *tau,int *info);
void    dtzrqf(int *m,int *n,double *a,int *lda,double *tau,int *info);
void    DTZRZF(int *m,int *n,double *a,int *lda,double *tau,double *work,int *lwork,int *info);
void    dtzrzf(int *m,int *n,double *a,int *lda,double *tau,double *work,int *lwork,int *info);
double  DZSUM1(int *n, MKL_Complex16 *cx,int *incx);
double  dzsum1(int *n, MKL_Complex16 *cx,int *incx);
int     IZMAX1(int *n, MKL_Complex16 *cx,int *incx);
int     izmax1(int *n, MKL_Complex16 *cx,int *incx);
void    ZBDSQR(char *uplo,int *n,int *ncvt,int *nru,int *ncc,double *d,double *e, MKL_Complex16 *vt,int *ldvt, MKL_Complex16 *u,int *ldu, MKL_Complex16 *c,int *ldc,double *rwork,int *info);
void    zbdsqr(char *uplo,int *n,int *ncvt,int *nru,int *ncc,double *d,double *e, MKL_Complex16 *vt,int *ldvt, MKL_Complex16 *u,int *ldu, MKL_Complex16 *c,int *ldc,double *rwork,int *info);
void    ZDRSCL(int *n,double *sa, MKL_Complex16 *sx,int *incx);
void    zdrscl(int *n,double *sa, MKL_Complex16 *sx,int *incx);
void    ZGBBRD(char *vect,int *m,int *n,int *ncc,int *kl,int *ku, MKL_Complex16 *ab,int *ldab,double *d,double *e, MKL_Complex16 *q,int *ldq, MKL_Complex16 *pt,int *ldpt, MKL_Complex16 *c,int *ldc, MKL_Complex16 *work,double *rwork,int *info);
void    zgbbrd(char *vect,int *m,int *n,int *ncc,int *kl,int *ku, MKL_Complex16 *ab,int *ldab,double *d,double *e, MKL_Complex16 *q,int *ldq, MKL_Complex16 *pt,int *ldpt, MKL_Complex16 *c,int *ldc, MKL_Complex16 *work,double *rwork,int *info);
void    ZGBCON(char *norm,int *n,int *kl,int *ku, MKL_Complex16 *ab,int *ldab,int *ipiv,double *anorm,double *rcond, MKL_Complex16 *work,double *rwork,int *info);
void    zgbcon(char *norm,int *n,int *kl,int *ku, MKL_Complex16 *ab,int *ldab,int *ipiv,double *anorm,double *rcond, MKL_Complex16 *work,double *rwork,int *info);
void    ZGBEQU(int *m,int *n,int *kl,int *ku, MKL_Complex16 *ab,int *ldab,double *r,double *c,double *rowcnd,double *colcnd,double *amax,int *info);
void    zgbequ(int *m,int *n,int *kl,int *ku, MKL_Complex16 *ab,int *ldab,double *r,double *c,double *rowcnd,double *colcnd,double *amax,int *info);
void    ZGBRFS(char *trans,int *n,int *kl,int *ku,int *nrhs, MKL_Complex16 *ab,int *ldab, MKL_Complex16 *afb,int *ldafb,int *ipiv, MKL_Complex16 *b,int *ldb, MKL_Complex16 *x,int *ldx,double *ferr,double *berr, MKL_Complex16 *work,double *rwork,int *info);
void    zgbrfs(char *trans,int *n,int *kl,int *ku,int *nrhs, MKL_Complex16 *ab,int *ldab, MKL_Complex16 *afb,int *ldafb,int *ipiv, MKL_Complex16 *b,int *ldb, MKL_Complex16 *x,int *ldx,double *ferr,double *berr, MKL_Complex16 *work,double *rwork,int *info);
void    ZGBSV(int *n,int *kl,int *ku,int *nrhs, MKL_Complex16 *ab,int *ldab,int *ipiv, MKL_Complex16 *b,int *ldb,int *info);
void    zgbsv(int *n,int *kl,int *ku,int *nrhs, MKL_Complex16 *ab,int *ldab,int *ipiv, MKL_Complex16 *b,int *ldb,int *info);
void    ZGBSVX(char *fact,char *trans,int *n,int *kl,int *ku,int *nrhs, MKL_Complex16 *ab,int *ldab, MKL_Complex16 *afb,int *ldafb,int *ipiv,char *equed,double *r,double *c, MKL_Complex16 *b,int *ldb, MKL_Complex16 *x,int *ldx,double *rcond,double *ferr,double *berr, MKL_Complex16 *work,double *rwork,int *info);
void    zgbsvx(char *fact,char *trans,int *n,int *kl,int *ku,int *nrhs, MKL_Complex16 *ab,int *ldab, MKL_Complex16 *afb,int *ldafb,int *ipiv,char *equed,double *r,double *c, MKL_Complex16 *b,int *ldb, MKL_Complex16 *x,int *ldx,double *rcond,double *ferr,double *berr, MKL_Complex16 *work,double *rwork,int *info);
void    ZGBTF2(int *m,int *n,int *kl,int *ku, MKL_Complex16 *ab,int *ldab,int *ipiv,int *info);
void    zgbtf2(int *m,int *n,int *kl,int *ku, MKL_Complex16 *ab,int *ldab,int *ipiv,int *info);
void    ZGBTRF(int *m,int *n,int *kl,int *ku, MKL_Complex16 *ab,int *ldab,int *ipiv,int *info);
void    zgbtrf(int *m,int *n,int *kl,int *ku, MKL_Complex16 *ab,int *ldab,int *ipiv,int *info);
void    ZGBTRS(char *trans,int *n,int *kl,int *ku,int *nrhs, MKL_Complex16 *ab,int *ldab,int *ipiv, MKL_Complex16 *b,int *ldb,int *info);
void    zgbtrs(char *trans,int *n,int *kl,int *ku,int *nrhs, MKL_Complex16 *ab,int *ldab,int *ipiv, MKL_Complex16 *b,int *ldb,int *info);
void    ZGEBAK(char *job,char *side,int *n,int *ilo,int *ihi,double *scale,int *m, MKL_Complex16 *v,int *ldv,int *info);
void    zgebak(char *job,char *side,int *n,int *ilo,int *ihi,double *scale,int *m, MKL_Complex16 *v,int *ldv,int *info);
void    ZGEBAL(char *job,int *n, MKL_Complex16 *a,int *lda,int *ilo,int *ihi,double *scale,int *info);
void    zgebal(char *job,int *n, MKL_Complex16 *a,int *lda,int *ilo,int *ihi,double *scale,int *info);
void    ZGEBD2(int *m,int *n, MKL_Complex16 *a,int *lda,double *d,double *e, MKL_Complex16 *tauq, MKL_Complex16 *taup, MKL_Complex16 *work,int *info);
void    zgebd2(int *m,int *n, MKL_Complex16 *a,int *lda,double *d,double *e, MKL_Complex16 *tauq, MKL_Complex16 *taup, MKL_Complex16 *work,int *info);
void    ZGEBRD(int *m,int *n, MKL_Complex16 *a,int *lda,double *d,double *e, MKL_Complex16 *tauq, MKL_Complex16 *taup, MKL_Complex16 *work,int *lwork,int *info);
void    zgebrd(int *m,int *n, MKL_Complex16 *a,int *lda,double *d,double *e, MKL_Complex16 *tauq, MKL_Complex16 *taup, MKL_Complex16 *work,int *lwork,int *info);
void    ZGECON(char *norm,int *n, MKL_Complex16 *a,int *lda,double *anorm,double *rcond, MKL_Complex16 *work,double *rwork,int *info);
void    zgecon(char *norm,int *n, MKL_Complex16 *a,int *lda,double *anorm,double *rcond, MKL_Complex16 *work,double *rwork,int *info);
void    ZGEEQU(int *m,int *n, MKL_Complex16 *a,int *lda,double *r,double *c,double *rowcnd,double *colcnd,double *amax,int *info);
void    zgeequ(int *m,int *n, MKL_Complex16 *a,int *lda,double *r,double *c,double *rowcnd,double *colcnd,double *amax,int *info);
void    ZGEES(char *jobvs,char *sort,void *select,int *n, MKL_Complex16 *a,int *lda,int *sdim, MKL_Complex16 *w, MKL_Complex16 *vs,int *ldvs, MKL_Complex16 *work,int *lwork,double *rwork,void *bwork,int *info);
void    zgees(char *jobvs,char *sort,void *select,int *n, MKL_Complex16 *a,int *lda,int *sdim, MKL_Complex16 *w, MKL_Complex16 *vs,int *ldvs, MKL_Complex16 *work,int *lwork,double *rwork,void *bwork,int *info);
void    ZGEESX(char *jobvs,char *sort,void *select,char *sense,int *n, MKL_Complex16 *a,int *lda,int *sdim, MKL_Complex16 *w, MKL_Complex16 *vs,int *ldvs,double *rconde,double *rcondv, MKL_Complex16 *work,int *lwork,double *rwork,void *bwork,int *info);
void    zgeesx(char *jobvs,char *sort,void *select,char *sense,int *n, MKL_Complex16 *a,int *lda,int *sdim, MKL_Complex16 *w, MKL_Complex16 *vs,int *ldvs,double *rconde,double *rcondv, MKL_Complex16 *work,int *lwork,double *rwork,void *bwork,int *info);
void    ZGEEV(char *jobvl,char *jobvr,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *w, MKL_Complex16 *vl,int *ldvl, MKL_Complex16 *vr,int *ldvr, MKL_Complex16 *work,int *lwork,double *rwork,int *info);
void    zgeev(char *jobvl,char *jobvr,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *w, MKL_Complex16 *vl,int *ldvl, MKL_Complex16 *vr,int *ldvr, MKL_Complex16 *work,int *lwork,double *rwork,int *info);
void    ZGEEVX(char *balanc,char *jobvl,char *jobvr,char *sense,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *w, MKL_Complex16 *vl,int *ldvl, MKL_Complex16 *vr,int *ldvr,int *ilo,int *ihi,double *scale,double *abnrm,double *rconde,double *rcondv, MKL_Complex16 *work,int *lwork,double *rwork,int *info);
void    zgeevx(char *balanc,char *jobvl,char *jobvr,char *sense,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *w, MKL_Complex16 *vl,int *ldvl, MKL_Complex16 *vr,int *ldvr,int *ilo,int *ihi,double *scale,double *abnrm,double *rconde,double *rcondv, MKL_Complex16 *work,int *lwork,double *rwork,int *info);
void    ZGEGS(char *jobvsl,char *jobvsr,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb, MKL_Complex16 *alpha, MKL_Complex16 *beta, MKL_Complex16 *vsl,int *ldvsl, MKL_Complex16 *vsr,int *ldvsr, MKL_Complex16 *work,int *lwork,double *rwork,int *info);
void    zgegs(char *jobvsl,char *jobvsr,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb, MKL_Complex16 *alpha, MKL_Complex16 *beta, MKL_Complex16 *vsl,int *ldvsl, MKL_Complex16 *vsr,int *ldvsr, MKL_Complex16 *work,int *lwork,double *rwork,int *info);
void    ZGEGV(char *jobvl,char *jobvr,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb, MKL_Complex16 *alpha, MKL_Complex16 *beta, MKL_Complex16 *vl,int *ldvl, MKL_Complex16 *vr,int *ldvr, MKL_Complex16 *work,int *lwork,double *rwork,int *info);
void    zgegv(char *jobvl,char *jobvr,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb, MKL_Complex16 *alpha, MKL_Complex16 *beta, MKL_Complex16 *vl,int *ldvl, MKL_Complex16 *vr,int *ldvr, MKL_Complex16 *work,int *lwork,double *rwork,int *info);
void    ZGEHD2(int *n,int *ilo,int *ihi, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *work,int *info);
void    zgehd2(int *n,int *ilo,int *ihi, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *work,int *info);
void    ZGEHRD(int *n,int *ilo,int *ihi, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *work,int *lwork,int *info);
void    zgehrd(int *n,int *ilo,int *ihi, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *work,int *lwork,int *info);
void    ZGELQ2(int *m,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *work,int *info);
void    zgelq2(int *m,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *work,int *info);
void    ZGELQF(int *m,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *work,int *lwork,int *info);
void    zgelqf(int *m,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *work,int *lwork,int *info);
void    ZGELS(char *trans,int *m,int *n,int *nrhs, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb, MKL_Complex16 *work,int *lwork,int *info);
void    zgels(char *trans,int *m,int *n,int *nrhs, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb, MKL_Complex16 *work,int *lwork,int *info);
void    ZGELSD(int *m,int *n,int *nrhs, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb,double *s,double *rcond,int *rank, MKL_Complex16 *work,int *lwork,double *rwork,int *iwork,int *info);
void    zgelsd(int *m,int *n,int *nrhs, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb,double *s,double *rcond,int *rank, MKL_Complex16 *work,int *lwork,double *rwork,int *iwork,int *info);
void    ZGELSS(int *m,int *n,int *nrhs, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb,double *s,double *rcond,int *rank, MKL_Complex16 *work,int *lwork,double *rwork,int *info);
void    zgelss(int *m,int *n,int *nrhs, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb,double *s,double *rcond,int *rank, MKL_Complex16 *work,int *lwork,double *rwork,int *info);
void    ZGELSX(int *m,int *n,int *nrhs, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb,int *jpvt,double *rcond,int *rank, MKL_Complex16 *work,double *rwork,int *info);
void    zgelsx(int *m,int *n,int *nrhs, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb,int *jpvt,double *rcond,int *rank, MKL_Complex16 *work,double *rwork,int *info);
void    ZGELSY(int *m,int *n,int *nrhs, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb,int *jpvt,double *rcond,int *rank, MKL_Complex16 *work,int *lwork,double *rwork,int *info);
void    zgelsy(int *m,int *n,int *nrhs, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb,int *jpvt,double *rcond,int *rank, MKL_Complex16 *work,int *lwork,double *rwork,int *info);
void    ZGEQL2(int *m,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *work,int *info);
void    zgeql2(int *m,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *work,int *info);
void    ZGEQLF(int *m,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *work,int *lwork,int *info);
void    zgeqlf(int *m,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *work,int *lwork,int *info);
void    ZGEQP3(int *m,int *n, MKL_Complex16 *a,int *lda,int *jpvt, MKL_Complex16 *tau, MKL_Complex16 *work,int *lwork,double *rwork,int *info);
void    zgeqp3(int *m,int *n, MKL_Complex16 *a,int *lda,int *jpvt, MKL_Complex16 *tau, MKL_Complex16 *work,int *lwork,double *rwork,int *info);
void    ZGEQPF(int *m,int *n, MKL_Complex16 *a,int *lda,int *jpvt, MKL_Complex16 *tau, MKL_Complex16 *work,double *rwork,int *info);
void    zgeqpf(int *m,int *n, MKL_Complex16 *a,int *lda,int *jpvt, MKL_Complex16 *tau, MKL_Complex16 *work,double *rwork,int *info);
void    ZGEQR2(int *m,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *work,int *info);
void    zgeqr2(int *m,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *work,int *info);
void    ZGEQRF(int *m,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *work,int *lwork,int *info);
void    zgeqrf(int *m,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *work,int *lwork,int *info);
void    ZGERFS(char *trans,int *n,int *nrhs, MKL_Complex16 *a,int *lda, MKL_Complex16 *af,int *ldaf,int *ipiv, MKL_Complex16 *b,int *ldb, MKL_Complex16 *x,int *ldx,double *ferr,double *berr, MKL_Complex16 *work,double *rwork,int *info);
void    zgerfs(char *trans,int *n,int *nrhs, MKL_Complex16 *a,int *lda, MKL_Complex16 *af,int *ldaf,int *ipiv, MKL_Complex16 *b,int *ldb, MKL_Complex16 *x,int *ldx,double *ferr,double *berr, MKL_Complex16 *work,double *rwork,int *info);
void    ZGERQ2(int *m,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *work,int *info);
void    zgerq2(int *m,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *work,int *info);
void    ZGERQF(int *m,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *work,int *lwork,int *info);
void    zgerqf(int *m,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *work,int *lwork,int *info);
void    ZGESC2(int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *rhs,int *ipiv,int *jpiv,double *scale);
void    zgesc2(int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *rhs,int *ipiv,int *jpiv,double *scale);
void    ZGESDD(char *jobz,int *m,int *n, MKL_Complex16 *a,int *lda,double *s, MKL_Complex16 *u,int *ldu, MKL_Complex16 *vt,int *ldvt, MKL_Complex16 *work,int *lwork,double *rwork,int *iwork,int *info);
void    zgesdd(char *jobz,int *m,int *n, MKL_Complex16 *a,int *lda,double *s, MKL_Complex16 *u,int *ldu, MKL_Complex16 *vt,int *ldvt, MKL_Complex16 *work,int *lwork,double *rwork,int *iwork,int *info);
void    ZGESV(int *n,int *nrhs, MKL_Complex16 *a,int *lda,int *ipiv, MKL_Complex16 *b,int *ldb,int *info);
void    zgesv(int *n,int *nrhs, MKL_Complex16 *a,int *lda,int *ipiv, MKL_Complex16 *b,int *ldb,int *info);
void    ZGESVD(char *jobu,char *jobvt,int *m,int *n, MKL_Complex16 *a,int *lda,double *s, MKL_Complex16 *u,int *ldu, MKL_Complex16 *vt,int *ldvt, MKL_Complex16 *work,int *lwork,double *rwork,int *info);
void    zgesvd(char *jobu,char *jobvt,int *m,int *n, MKL_Complex16 *a,int *lda,double *s, MKL_Complex16 *u,int *ldu, MKL_Complex16 *vt,int *ldvt, MKL_Complex16 *work,int *lwork,double *rwork,int *info);
void    ZGESVX(char *fact,char *trans,int *n,int *nrhs, MKL_Complex16 *a,int *lda, MKL_Complex16 *af,int *ldaf,int *ipiv,char *equed,double *r,double *c, MKL_Complex16 *b,int *ldb, MKL_Complex16 *x,int *ldx,double *rcond,double *ferr,double *berr, MKL_Complex16 *work,double *rwork,int *info);
void    zgesvx(char *fact,char *trans,int *n,int *nrhs, MKL_Complex16 *a,int *lda, MKL_Complex16 *af,int *ldaf,int *ipiv,char *equed,double *r,double *c, MKL_Complex16 *b,int *ldb, MKL_Complex16 *x,int *ldx,double *rcond,double *ferr,double *berr, MKL_Complex16 *work,double *rwork,int *info);
void    ZGETC2(int *n, MKL_Complex16 *a,int *lda,int *ipiv,int *jpiv,int *info);
void    zgetc2(int *n, MKL_Complex16 *a,int *lda,int *ipiv,int *jpiv,int *info);
void    ZGETF2(int *m,int *n, MKL_Complex16 *a,int *lda,int *ipiv,int *info);
void    zgetf2(int *m,int *n, MKL_Complex16 *a,int *lda,int *ipiv,int *info);
void    ZGETRF(int *m,int *n, MKL_Complex16 *a,int *lda,int *ipiv,int *info);
void    zgetrf(int *m,int *n, MKL_Complex16 *a,int *lda,int *ipiv,int *info);
void    ZGETRI(int *n, MKL_Complex16 *a,int *lda,int *ipiv, MKL_Complex16 *work,int *lwork,int *info);
void    zgetri(int *n, MKL_Complex16 *a,int *lda,int *ipiv, MKL_Complex16 *work,int *lwork,int *info);
void    ZGETRS(char *trans,int *n,int *nrhs, MKL_Complex16 *a,int *lda,int *ipiv, MKL_Complex16 *b,int *ldb,int *info);
void    zgetrs(char *trans,int *n,int *nrhs, MKL_Complex16 *a,int *lda,int *ipiv, MKL_Complex16 *b,int *ldb,int *info);
void    ZGGBAK(char *job,char *side,int *n,int *ilo,int *ihi,double *lscale,double *rscale,int *m, MKL_Complex16 *v,int *ldv,int *info);
void    zggbak(char *job,char *side,int *n,int *ilo,int *ihi,double *lscale,double *rscale,int *m, MKL_Complex16 *v,int *ldv,int *info);
void    ZGGBAL(char *job,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb,int *ilo,int *ihi,double *lscale,double *rscale,double *work,int *info);
void    zggbal(char *job,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb,int *ilo,int *ihi,double *lscale,double *rscale,double *work,int *info);
void    ZGGES(char *jobvsl,char *jobvsr,char *sort,void *delctg,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb,int *sdim, MKL_Complex16 *alpha, MKL_Complex16 *beta, MKL_Complex16 *vsl,int *ldvsl, MKL_Complex16 *vsr,int *ldvsr, MKL_Complex16 *work,int *lwork,double *rwork,void *bwork,int *info);
void    zgges(char *jobvsl,char *jobvsr,char *sort,void *delctg,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb,int *sdim, MKL_Complex16 *alpha, MKL_Complex16 *beta, MKL_Complex16 *vsl,int *ldvsl, MKL_Complex16 *vsr,int *ldvsr, MKL_Complex16 *work,int *lwork,double *rwork,void *bwork,int *info);
void    ZGGESX(char *jobvsl,char *jobvsr,char *sort,void *delctg,char *sense,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb,int *sdim, MKL_Complex16 *alpha, MKL_Complex16 *beta, MKL_Complex16 *vsl,int *ldvsl, MKL_Complex16 *vsr,int *ldvsr,double *rconde,double *rcondv, MKL_Complex16 *work,int *lwork,double *rwork,int *iwork,int *liwork,void *bwork,int *info);
void    zggesx(char *jobvsl,char *jobvsr,char *sort,void *delctg,char *sense,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb,int *sdim, MKL_Complex16 *alpha, MKL_Complex16 *beta, MKL_Complex16 *vsl,int *ldvsl, MKL_Complex16 *vsr,int *ldvsr,double *rconde,double *rcondv, MKL_Complex16 *work,int *lwork,double *rwork,int *iwork,int *liwork,void *bwork,int *info);
void    ZGGEV(char *jobvl,char *jobvr,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb, MKL_Complex16 *alpha, MKL_Complex16 *beta, MKL_Complex16 *vl,int *ldvl, MKL_Complex16 *vr,int *ldvr, MKL_Complex16 *work,int *lwork,double *rwork,int *info);
void    zggev(char *jobvl,char *jobvr,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb, MKL_Complex16 *alpha, MKL_Complex16 *beta, MKL_Complex16 *vl,int *ldvl, MKL_Complex16 *vr,int *ldvr, MKL_Complex16 *work,int *lwork,double *rwork,int *info);
void    ZGGEVX(char *balanc,char *jobvl,char *jobvr,char *sense,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb, MKL_Complex16 *alpha, MKL_Complex16 *beta, MKL_Complex16 *vl,int *ldvl, MKL_Complex16 *vr,int *ldvr,int *ilo,int *ihi,double *lscale,double *rscale,double *abnrm,double *bbnrm,double *rconde,double *rcondv, MKL_Complex16 *work,int *lwork,double *rwork,int *iwork,void *bwork,int *info);
void    zggevx(char *balanc,char *jobvl,char *jobvr,char *sense,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb, MKL_Complex16 *alpha, MKL_Complex16 *beta, MKL_Complex16 *vl,int *ldvl, MKL_Complex16 *vr,int *ldvr,int *ilo,int *ihi,double *lscale,double *rscale,double *abnrm,double *bbnrm,double *rconde,double *rcondv, MKL_Complex16 *work,int *lwork,double *rwork,int *iwork,void *bwork,int *info);
void    ZGGGLM(int *n,int *m,int *p, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb, MKL_Complex16 *d, MKL_Complex16 *x, MKL_Complex16 *y, MKL_Complex16 *work,int *lwork,int *info);
void    zggglm(int *n,int *m,int *p, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb, MKL_Complex16 *d, MKL_Complex16 *x, MKL_Complex16 *y, MKL_Complex16 *work,int *lwork,int *info);
void    ZGGHRD(char *compq,char *compz,int *n,int *ilo,int *ihi, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb, MKL_Complex16 *q,int *ldq, MKL_Complex16 *z,int *ldz,int *info);
void    zgghrd(char *compq,char *compz,int *n,int *ilo,int *ihi, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb, MKL_Complex16 *q,int *ldq, MKL_Complex16 *z,int *ldz,int *info);
void    ZGGLSE(int *m,int *n,int *p, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb, MKL_Complex16 *c, MKL_Complex16 *d, MKL_Complex16 *x, MKL_Complex16 *work,int *lwork,int *info);
void    zgglse(int *m,int *n,int *p, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb, MKL_Complex16 *c, MKL_Complex16 *d, MKL_Complex16 *x, MKL_Complex16 *work,int *lwork,int *info);
void    ZGGQRF(int *n,int *m,int *p, MKL_Complex16 *a,int *lda, MKL_Complex16 *taua, MKL_Complex16 *b,int *ldb, MKL_Complex16 *taub, MKL_Complex16 *work,int *lwork,int *info);
void    zggqrf(int *n,int *m,int *p, MKL_Complex16 *a,int *lda, MKL_Complex16 *taua, MKL_Complex16 *b,int *ldb, MKL_Complex16 *taub, MKL_Complex16 *work,int *lwork,int *info);
void    ZGGRQF(int *m,int *p,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *taua, MKL_Complex16 *b,int *ldb, MKL_Complex16 *taub, MKL_Complex16 *work,int *lwork,int *info);
void    zggrqf(int *m,int *p,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *taua, MKL_Complex16 *b,int *ldb, MKL_Complex16 *taub, MKL_Complex16 *work,int *lwork,int *info);
void    ZGGSVD(char *jobu,char *jobv,char *jobq,int *m,int *n,int *p,int *k,int *l, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb,double *alpha,double *beta, MKL_Complex16 *u,int *ldu, MKL_Complex16 *v,int *ldv, MKL_Complex16 *q,int *ldq, MKL_Complex16 *work,double *rwork,int *iwork,int *info);
void    zggsvd(char *jobu,char *jobv,char *jobq,int *m,int *n,int *p,int *k,int *l, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb,double *alpha,double *beta, MKL_Complex16 *u,int *ldu, MKL_Complex16 *v,int *ldv, MKL_Complex16 *q,int *ldq, MKL_Complex16 *work,double *rwork,int *iwork,int *info);
void    ZGGSVP(char *jobu,char *jobv,char *jobq,int *m,int *p,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb,double *tola,double *tolb,int *k,int *l, MKL_Complex16 *u,int *ldu, MKL_Complex16 *v,int *ldv, MKL_Complex16 *q,int *ldq,int *iwork,double *rwork, MKL_Complex16 *tau, MKL_Complex16 *work,int *info);
void    zggsvp(char *jobu,char *jobv,char *jobq,int *m,int *p,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb,double *tola,double *tolb,int *k,int *l, MKL_Complex16 *u,int *ldu, MKL_Complex16 *v,int *ldv, MKL_Complex16 *q,int *ldq,int *iwork,double *rwork, MKL_Complex16 *tau, MKL_Complex16 *work,int *info);
void    ZGTCON(char *norm,int *n, MKL_Complex16 *dl, MKL_Complex16 *d, MKL_Complex16 *du, MKL_Complex16 *du2,int *ipiv,double *anorm,double *rcond, MKL_Complex16 *work,int *info);
void    zgtcon(char *norm,int *n, MKL_Complex16 *dl, MKL_Complex16 *d, MKL_Complex16 *du, MKL_Complex16 *du2,int *ipiv,double *anorm,double *rcond, MKL_Complex16 *work,int *info);
void    ZGTRFS(char *trans,int *n,int *nrhs, MKL_Complex16 *dl, MKL_Complex16 *d, MKL_Complex16 *du, MKL_Complex16 *dlf, MKL_Complex16 *df, MKL_Complex16 *duf, MKL_Complex16 *du2,int *ipiv, MKL_Complex16 *b,int *ldb, MKL_Complex16 *x,int *ldx,double *ferr,double *berr, MKL_Complex16 *work,double *rwork,int *info);
void    zgtrfs(char *trans,int *n,int *nrhs, MKL_Complex16 *dl, MKL_Complex16 *d, MKL_Complex16 *du, MKL_Complex16 *dlf, MKL_Complex16 *df, MKL_Complex16 *duf, MKL_Complex16 *du2,int *ipiv, MKL_Complex16 *b,int *ldb, MKL_Complex16 *x,int *ldx,double *ferr,double *berr, MKL_Complex16 *work,double *rwork,int *info);
void    ZGTSV(int *n,int *nrhs, MKL_Complex16 *dl, MKL_Complex16 *d, MKL_Complex16 *du, MKL_Complex16 *b,int *ldb,int *info);
void    zgtsv(int *n,int *nrhs, MKL_Complex16 *dl, MKL_Complex16 *d, MKL_Complex16 *du, MKL_Complex16 *b,int *ldb,int *info);
void    ZGTSVX(char *fact,char *trans,int *n,int *nrhs, MKL_Complex16 *dl, MKL_Complex16 *d, MKL_Complex16 *du, MKL_Complex16 *dlf, MKL_Complex16 *df, MKL_Complex16 *duf, MKL_Complex16 *du2,int *ipiv, MKL_Complex16 *b,int *ldb, MKL_Complex16 *x,int *ldx,double *rcond,double *ferr,double *berr, MKL_Complex16 *work,double *rwork,int *info);
void    zgtsvx(char *fact,char *trans,int *n,int *nrhs, MKL_Complex16 *dl, MKL_Complex16 *d, MKL_Complex16 *du, MKL_Complex16 *dlf, MKL_Complex16 *df, MKL_Complex16 *duf, MKL_Complex16 *du2,int *ipiv, MKL_Complex16 *b,int *ldb, MKL_Complex16 *x,int *ldx,double *rcond,double *ferr,double *berr, MKL_Complex16 *work,double *rwork,int *info);
void    ZGTTRF(int *n, MKL_Complex16 *dl, MKL_Complex16 *d, MKL_Complex16 *du, MKL_Complex16 *du2,int *ipiv,int *info);
void    zgttrf(int *n, MKL_Complex16 *dl, MKL_Complex16 *d, MKL_Complex16 *du, MKL_Complex16 *du2,int *ipiv,int *info);
void    ZGTTRS(char *trans,int *n,int *nrhs, MKL_Complex16 *dl, MKL_Complex16 *d, MKL_Complex16 *du, MKL_Complex16 *du2,int *ipiv, MKL_Complex16 *b,int *ldb,int *info);
void    zgttrs(char *trans,int *n,int *nrhs, MKL_Complex16 *dl, MKL_Complex16 *d, MKL_Complex16 *du, MKL_Complex16 *du2,int *ipiv, MKL_Complex16 *b,int *ldb,int *info);
void    ZGTTS2(int *itrans,int *n,int *nrhs, MKL_Complex16 *dl, MKL_Complex16 *d, MKL_Complex16 *du, MKL_Complex16 *du2,int *ipiv, MKL_Complex16 *b,int *ldb);
void    zgtts2(int *itrans,int *n,int *nrhs, MKL_Complex16 *dl, MKL_Complex16 *d, MKL_Complex16 *du, MKL_Complex16 *du2,int *ipiv, MKL_Complex16 *b,int *ldb);
void    ZHBEV(char *jobz,char *uplo,int *n,int *kd, MKL_Complex16 *ab,int *ldab,double *w, MKL_Complex16 *z,int *ldz, MKL_Complex16 *work,double *rwork,int *info);
void    zhbev(char *jobz,char *uplo,int *n,int *kd, MKL_Complex16 *ab,int *ldab,double *w, MKL_Complex16 *z,int *ldz, MKL_Complex16 *work,double *rwork,int *info);
void    ZHBEVD(char *jobz,char *uplo,int *n,int *kd, MKL_Complex16 *ab,int *ldab,double *w, MKL_Complex16 *z,int *ldz, MKL_Complex16 *work,int *lwork,double *rwork,int *lrwork,int *iwork,int *liwork,int *info);
void    zhbevd(char *jobz,char *uplo,int *n,int *kd, MKL_Complex16 *ab,int *ldab,double *w, MKL_Complex16 *z,int *ldz, MKL_Complex16 *work,int *lwork,double *rwork,int *lrwork,int *iwork,int *liwork,int *info);
void    ZHBEVX(char *jobz,char *range,char *uplo,int *n,int *kd, MKL_Complex16 *ab,int *ldab, MKL_Complex16 *q,int *ldq,double *vl,double *vu,int *il,int *iu,double *abstol,int *m,double *w, MKL_Complex16 *z,int *ldz, MKL_Complex16 *work,double *rwork,int *iwork,int *ifail,int *info);
void    zhbevx(char *jobz,char *range,char *uplo,int *n,int *kd, MKL_Complex16 *ab,int *ldab, MKL_Complex16 *q,int *ldq,double *vl,double *vu,int *il,int *iu,double *abstol,int *m,double *w, MKL_Complex16 *z,int *ldz, MKL_Complex16 *work,double *rwork,int *iwork,int *ifail,int *info);
void    ZHBGST(char *vect,char *uplo,int *n,int *ka,int *kb, MKL_Complex16 *ab,int *ldab, MKL_Complex16 *bb,int *ldbb, MKL_Complex16 *x,int *ldx, MKL_Complex16 *work,double *rwork,int *info);
void    zhbgst(char *vect,char *uplo,int *n,int *ka,int *kb, MKL_Complex16 *ab,int *ldab, MKL_Complex16 *bb,int *ldbb, MKL_Complex16 *x,int *ldx, MKL_Complex16 *work,double *rwork,int *info);
void    ZHBGV(char *jobz,char *uplo,int *n,int *ka,int *kb, MKL_Complex16 *ab,int *ldab, MKL_Complex16 *bb,int *ldbb,double *w, MKL_Complex16 *z,int *ldz, MKL_Complex16 *work,double *rwork,int *info);
void    zhbgv(char *jobz,char *uplo,int *n,int *ka,int *kb, MKL_Complex16 *ab,int *ldab, MKL_Complex16 *bb,int *ldbb,double *w, MKL_Complex16 *z,int *ldz, MKL_Complex16 *work,double *rwork,int *info);
void    ZHBGVD(char *jobz,char *uplo,int *n,int *ka,int *kb, MKL_Complex16 *ab,int *ldab, MKL_Complex16 *bb,int *ldbb,double *w, MKL_Complex16 *z,int *ldz, MKL_Complex16 *work,int *lwork,double *rwork,int *lrwork,int *iwork,int *liwork,int *info);
void    zhbgvd(char *jobz,char *uplo,int *n,int *ka,int *kb, MKL_Complex16 *ab,int *ldab, MKL_Complex16 *bb,int *ldbb,double *w, MKL_Complex16 *z,int *ldz, MKL_Complex16 *work,int *lwork,double *rwork,int *lrwork,int *iwork,int *liwork,int *info);
void    ZHBGVX(char *jobz,char *range,char *uplo,int *n,int *ka,int *kb, MKL_Complex16 *ab,int *ldab, MKL_Complex16 *bb,int *ldbb, MKL_Complex16 *q,int *ldq,double *vl,double *vu,int *il,int *iu,double *abstol,int *m,double *w, MKL_Complex16 *z,int *ldz, MKL_Complex16 *work,double *rwork,int *iwork,int *ifail,int *info);
void    zhbgvx(char *jobz,char *range,char *uplo,int *n,int *ka,int *kb, MKL_Complex16 *ab,int *ldab, MKL_Complex16 *bb,int *ldbb, MKL_Complex16 *q,int *ldq,double *vl,double *vu,int *il,int *iu,double *abstol,int *m,double *w, MKL_Complex16 *z,int *ldz, MKL_Complex16 *work,double *rwork,int *iwork,int *ifail,int *info);
void    ZHBTRD(char *vect,char *uplo,int *n,int *kd, MKL_Complex16 *ab,int *ldab,double *d,double *e, MKL_Complex16 *q,int *ldq, MKL_Complex16 *work,int *info);
void    zhbtrd(char *vect,char *uplo,int *n,int *kd, MKL_Complex16 *ab,int *ldab,double *d,double *e, MKL_Complex16 *q,int *ldq, MKL_Complex16 *work,int *info);
void    ZHECON(char *uplo,int *n, MKL_Complex16 *a,int *lda,int *ipiv,double *anorm,double *rcond, MKL_Complex16 *work,int *info);
void    zhecon(char *uplo,int *n, MKL_Complex16 *a,int *lda,int *ipiv,double *anorm,double *rcond, MKL_Complex16 *work,int *info);
void    ZHEEV(char *jobz,char *uplo,int *n, MKL_Complex16 *a,int *lda,double *w, MKL_Complex16 *work,int *lwork,double *rwork,int *info);
void    zheev(char *jobz,char *uplo,int *n, MKL_Complex16 *a,int *lda,double *w, MKL_Complex16 *work,int *lwork,double *rwork,int *info);
void    ZHEEVD(char *jobz,char *uplo,int *n, MKL_Complex16 *a,int *lda,double *w, MKL_Complex16 *work,int *lwork,double *rwork,int *lrwork,int *iwork,int *liwork,int *info);
void    zheevd(char *jobz,char *uplo,int *n, MKL_Complex16 *a,int *lda,double *w, MKL_Complex16 *work,int *lwork,double *rwork,int *lrwork,int *iwork,int *liwork,int *info);
void    ZHEEVR(char *jobz,char *range,char *uplo,int *n, MKL_Complex16 *a,int *lda,double *vl,double *vu,int *il,int *iu,double *abstol,int *m,double *w, MKL_Complex16 *z,int *ldz,int *isuppz, MKL_Complex16 *work,int *lwork,double *rwork,int *lrwork,int *iwork,int *liwork,int *info);
void    zheevr(char *jobz,char *range,char *uplo,int *n, MKL_Complex16 *a,int *lda,double *vl,double *vu,int *il,int *iu,double *abstol,int *m,double *w, MKL_Complex16 *z,int *ldz,int *isuppz, MKL_Complex16 *work,int *lwork,double *rwork,int *lrwork,int *iwork,int *liwork,int *info);
void    ZHEEVX(char *jobz,char *range,char *uplo,int *n, MKL_Complex16 *a,int *lda,double *vl,double *vu,int *il,int *iu,double *abstol,int *m,double *w, MKL_Complex16 *z,int *ldz, MKL_Complex16 *work,int *lwork,double *rwork,int *iwork,int *ifail,int *info);
void    zheevx(char *jobz,char *range,char *uplo,int *n, MKL_Complex16 *a,int *lda,double *vl,double *vu,int *il,int *iu,double *abstol,int *m,double *w, MKL_Complex16 *z,int *ldz, MKL_Complex16 *work,int *lwork,double *rwork,int *iwork,int *ifail,int *info);
void    ZHEGS2(int *itype,char *uplo,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb,int *info);
void    zhegs2(int *itype,char *uplo,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb,int *info);
void    ZHEGST(int *itype,char *uplo,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb,int *info);
void    zhegst(int *itype,char *uplo,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb,int *info);
void    ZHEGV(int *itype,char *jobz,char *uplo,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb,double *w, MKL_Complex16 *work,int *lwork,double *rwork,int *info);
void    zhegv(int *itype,char *jobz,char *uplo,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb,double *w, MKL_Complex16 *work,int *lwork,double *rwork,int *info);
void    ZHEGVD(int *itype,char *jobz,char *uplo,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb,double *w, MKL_Complex16 *work,int *lwork,double *rwork,int *lrwork,int *iwork,int *liwork,int *info);
void    zhegvd(int *itype,char *jobz,char *uplo,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb,double *w, MKL_Complex16 *work,int *lwork,double *rwork,int *lrwork,int *iwork,int *liwork,int *info);
void    ZHEGVX(int *itype,char *jobz,char *range,char *uplo,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb,double *vl,double *vu,int *il,int *iu,double *abstol,int *m,double *w, MKL_Complex16 *z,int *ldz, MKL_Complex16 *work,int *lwork,double *rwork,int *iwork,int *ifail,int *info);
void    zhegvx(int *itype,char *jobz,char *range,char *uplo,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb,double *vl,double *vu,int *il,int *iu,double *abstol,int *m,double *w, MKL_Complex16 *z,int *ldz, MKL_Complex16 *work,int *lwork,double *rwork,int *iwork,int *ifail,int *info);
void    ZHERFS(char *uplo,int *n,int *nrhs, MKL_Complex16 *a,int *lda, MKL_Complex16 *af,int *ldaf,int *ipiv, MKL_Complex16 *b,int *ldb, MKL_Complex16 *x,int *ldx,double *ferr,double *berr, MKL_Complex16 *work,double *rwork,int *info);
void    zherfs(char *uplo,int *n,int *nrhs, MKL_Complex16 *a,int *lda, MKL_Complex16 *af,int *ldaf,int *ipiv, MKL_Complex16 *b,int *ldb, MKL_Complex16 *x,int *ldx,double *ferr,double *berr, MKL_Complex16 *work,double *rwork,int *info);
void    ZHESV(char *uplo,int *n,int *nrhs, MKL_Complex16 *a,int *lda,int *ipiv, MKL_Complex16 *b,int *ldb, MKL_Complex16 *work,int *lwork,int *info);
void    zhesv(char *uplo,int *n,int *nrhs, MKL_Complex16 *a,int *lda,int *ipiv, MKL_Complex16 *b,int *ldb, MKL_Complex16 *work,int *lwork,int *info);
void    ZHESVX(char *fact,char *uplo,int *n,int *nrhs, MKL_Complex16 *a,int *lda, MKL_Complex16 *af,int *ldaf,int *ipiv, MKL_Complex16 *b,int *ldb, MKL_Complex16 *x,int *ldx,double *rcond,double *ferr,double *berr, MKL_Complex16 *work,int *lwork,double *rwork,int *info);
void    zhesvx(char *fact,char *uplo,int *n,int *nrhs, MKL_Complex16 *a,int *lda, MKL_Complex16 *af,int *ldaf,int *ipiv, MKL_Complex16 *b,int *ldb, MKL_Complex16 *x,int *ldx,double *rcond,double *ferr,double *berr, MKL_Complex16 *work,int *lwork,double *rwork,int *info);
void    ZHETD2(char *uplo,int *n, MKL_Complex16 *a,int *lda,double *d,double *e, MKL_Complex16 *tau,int *info);
void    zhetd2(char *uplo,int *n, MKL_Complex16 *a,int *lda,double *d,double *e, MKL_Complex16 *tau,int *info);
void    ZHETF2(char *uplo,int *n, MKL_Complex16 *a,int *lda,int *ipiv,int *info);
void    zhetf2(char *uplo,int *n, MKL_Complex16 *a,int *lda,int *ipiv,int *info);
void    ZHETRD(char *uplo,int *n, MKL_Complex16 *a,int *lda,double *d,double *e, MKL_Complex16 *tau, MKL_Complex16 *work,int *lwork,int *info);
void    zhetrd(char *uplo,int *n, MKL_Complex16 *a,int *lda,double *d,double *e, MKL_Complex16 *tau, MKL_Complex16 *work,int *lwork,int *info);
void    ZHETRF(char *uplo,int *n, MKL_Complex16 *a,int *lda,int *ipiv, MKL_Complex16 *work,int *lwork,int *info);
void    zhetrf(char *uplo,int *n, MKL_Complex16 *a,int *lda,int *ipiv, MKL_Complex16 *work,int *lwork,int *info);
void    ZHETRI(char *uplo,int *n, MKL_Complex16 *a,int *lda,int *ipiv, MKL_Complex16 *work,int *info);
void    zhetri(char *uplo,int *n, MKL_Complex16 *a,int *lda,int *ipiv, MKL_Complex16 *work,int *info);
void    ZHETRS(char *uplo,int *n,int *nrhs, MKL_Complex16 *a,int *lda,int *ipiv, MKL_Complex16 *b,int *ldb,int *info);
void    zhetrs(char *uplo,int *n,int *nrhs, MKL_Complex16 *a,int *lda,int *ipiv, MKL_Complex16 *b,int *ldb,int *info);
void    ZHGEQZ(char *job,char *compq,char *compz,int *n,int *ilo,int *ihi, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb, MKL_Complex16 *alpha, MKL_Complex16 *beta, MKL_Complex16 *q,int *ldq, MKL_Complex16 *z,int *ldz, MKL_Complex16 *work,int *lwork,double *rwork,int *info);
void    zhgeqz(char *job,char *compq,char *compz,int *n,int *ilo,int *ihi, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb, MKL_Complex16 *alpha, MKL_Complex16 *beta, MKL_Complex16 *q,int *ldq, MKL_Complex16 *z,int *ldz, MKL_Complex16 *work,int *lwork,double *rwork,int *info);
void    ZHPCON(char *uplo,int *n, MKL_Complex16 *ap,int *ipiv,double *anorm,double *rcond, MKL_Complex16 *work,int *info);
void    zhpcon(char *uplo,int *n, MKL_Complex16 *ap,int *ipiv,double *anorm,double *rcond, MKL_Complex16 *work,int *info);
void    ZHPEV(char *jobz,char *uplo,int *n, MKL_Complex16 *ap,double *w, MKL_Complex16 *z,int *ldz, MKL_Complex16 *work,double *rwork,int *info);
void    zhpev(char *jobz,char *uplo,int *n, MKL_Complex16 *ap,double *w, MKL_Complex16 *z,int *ldz, MKL_Complex16 *work,double *rwork,int *info);
void    ZHPEVD(char *jobz,char *uplo,int *n, MKL_Complex16 *ap,double *w, MKL_Complex16 *z,int *ldz, MKL_Complex16 *work,int *lwork,double *rwork,int *lrwork,int *iwork,int *liwork,int *info);
void    zhpevd(char *jobz,char *uplo,int *n, MKL_Complex16 *ap,double *w, MKL_Complex16 *z,int *ldz, MKL_Complex16 *work,int *lwork,double *rwork,int *lrwork,int *iwork,int *liwork,int *info);
void    ZHPEVX(char *jobz,char *range,char *uplo,int *n, MKL_Complex16 *ap,double *vl,double *vu,int *il,int *iu,double *abstol,int *m,double *w, MKL_Complex16 *z,int *ldz, MKL_Complex16 *work,double *rwork,int *iwork,int *ifail,int *info);
void    zhpevx(char *jobz,char *range,char *uplo,int *n, MKL_Complex16 *ap,double *vl,double *vu,int *il,int *iu,double *abstol,int *m,double *w, MKL_Complex16 *z,int *ldz, MKL_Complex16 *work,double *rwork,int *iwork,int *ifail,int *info);
void    ZHPGST(int *itype,char *uplo,int *n, MKL_Complex16 *ap, MKL_Complex16 *bp,int *info);
void    zhpgst(int *itype,char *uplo,int *n, MKL_Complex16 *ap, MKL_Complex16 *bp,int *info);
void    ZHPGV(int *itype,char *jobz,char *uplo,int *n, MKL_Complex16 *ap, MKL_Complex16 *bp,double *w, MKL_Complex16 *z,int *ldz, MKL_Complex16 *work,double *rwork,int *info);
void    zhpgv(int *itype,char *jobz,char *uplo,int *n, MKL_Complex16 *ap, MKL_Complex16 *bp,double *w, MKL_Complex16 *z,int *ldz, MKL_Complex16 *work,double *rwork,int *info);
void    ZHPGVD(int *itype,char *jobz,char *uplo,int *n, MKL_Complex16 *ap, MKL_Complex16 *bp,double *w, MKL_Complex16 *z,int *ldz, MKL_Complex16 *work,int *lwork,double *rwork,int *lrwork,int *iwork,int *liwork,int *info);
void    zhpgvd(int *itype,char *jobz,char *uplo,int *n, MKL_Complex16 *ap, MKL_Complex16 *bp,double *w, MKL_Complex16 *z,int *ldz, MKL_Complex16 *work,int *lwork,double *rwork,int *lrwork,int *iwork,int *liwork,int *info);
void    ZHPGVX(int *itype,char *jobz,char *range,char *uplo,int *n, MKL_Complex16 *ap, MKL_Complex16 *bp,double *vl,double *vu,int *il,int *iu,double *abstol,int *m,double *w, MKL_Complex16 *z,int *ldz, MKL_Complex16 *work,double *rwork,int *iwork,int *ifail,int *info);
void    zhpgvx(int *itype,char *jobz,char *range,char *uplo,int *n, MKL_Complex16 *ap, MKL_Complex16 *bp,double *vl,double *vu,int *il,int *iu,double *abstol,int *m,double *w, MKL_Complex16 *z,int *ldz, MKL_Complex16 *work,double *rwork,int *iwork,int *ifail,int *info);
void    ZHPRFS(char *uplo,int *n,int *nrhs, MKL_Complex16 *ap, MKL_Complex16 *afp,int *ipiv, MKL_Complex16 *b,int *ldb, MKL_Complex16 *x,int *ldx,double *ferr,double *berr, MKL_Complex16 *work,double *rwork,int *info);
void    zhprfs(char *uplo,int *n,int *nrhs, MKL_Complex16 *ap, MKL_Complex16 *afp,int *ipiv, MKL_Complex16 *b,int *ldb, MKL_Complex16 *x,int *ldx,double *ferr,double *berr, MKL_Complex16 *work,double *rwork,int *info);
void    ZHPSV(char *uplo,int *n,int *nrhs, MKL_Complex16 *ap,int *ipiv, MKL_Complex16 *b,int *ldb,int *info);
void    zhpsv(char *uplo,int *n,int *nrhs, MKL_Complex16 *ap,int *ipiv, MKL_Complex16 *b,int *ldb,int *info);
void    ZHPSVX(char *fact,char *uplo,int *n,int *nrhs, MKL_Complex16 *ap, MKL_Complex16 *afp,int *ipiv, MKL_Complex16 *b,int *ldb, MKL_Complex16 *x,int *ldx,double *rcond,double *ferr,double *berr, MKL_Complex16 *work,double *rwork,int *info);
void    zhpsvx(char *fact,char *uplo,int *n,int *nrhs, MKL_Complex16 *ap, MKL_Complex16 *afp,int *ipiv, MKL_Complex16 *b,int *ldb, MKL_Complex16 *x,int *ldx,double *rcond,double *ferr,double *berr, MKL_Complex16 *work,double *rwork,int *info);
void    ZHPTRD(char *uplo,int *n, MKL_Complex16 *ap,double *d,double *e, MKL_Complex16 *tau,int *info);
void    zhptrd(char *uplo,int *n, MKL_Complex16 *ap,double *d,double *e, MKL_Complex16 *tau,int *info);
void    ZHPTRF(char *uplo,int *n, MKL_Complex16 *ap,int *ipiv,int *info);
void    zhptrf(char *uplo,int *n, MKL_Complex16 *ap,int *ipiv,int *info);
void    ZHPTRI(char *uplo,int *n, MKL_Complex16 *ap,int *ipiv, MKL_Complex16 *work,int *info);
void    zhptri(char *uplo,int *n, MKL_Complex16 *ap,int *ipiv, MKL_Complex16 *work,int *info);
void    ZHPTRS(char *uplo,int *n,int *nrhs, MKL_Complex16 *ap,int *ipiv, MKL_Complex16 *b,int *ldb,int *info);
void    zhptrs(char *uplo,int *n,int *nrhs, MKL_Complex16 *ap,int *ipiv, MKL_Complex16 *b,int *ldb,int *info);
void    ZHSEIN(char *side,char *eigsrc,char *initv,void *select,int *n, MKL_Complex16 *h,int *ldh, MKL_Complex16 *w, MKL_Complex16 *vl,int *ldvl, MKL_Complex16 *vr,int *ldvr,int *mm,int *m, MKL_Complex16 *work,double *rwork,int *ifaill,int *ifailr,int *info);
void    zhsein(char *side,char *eigsrc,char *initv,void *select,int *n, MKL_Complex16 *h,int *ldh, MKL_Complex16 *w, MKL_Complex16 *vl,int *ldvl, MKL_Complex16 *vr,int *ldvr,int *mm,int *m, MKL_Complex16 *work,double *rwork,int *ifaill,int *ifailr,int *info);
void    ZHSEQR(char *job,char *compz,int *n,int *ilo,int *ihi, MKL_Complex16 *h,int *ldh, MKL_Complex16 *w, MKL_Complex16 *z,int *ldz, MKL_Complex16 *work,int *lwork,int *info);
void    zhseqr(char *job,char *compz,int *n,int *ilo,int *ihi, MKL_Complex16 *h,int *ldh, MKL_Complex16 *w, MKL_Complex16 *z,int *ldz, MKL_Complex16 *work,int *lwork,int *info);
void    ZLABRD(int *m,int *n,int *nb, MKL_Complex16 *a,int *lda,double *d,double *e, MKL_Complex16 *tauq, MKL_Complex16 *taup, MKL_Complex16 *x,int *ldx, MKL_Complex16 *y,int *ldy);
void    zlabrd(int *m,int *n,int *nb, MKL_Complex16 *a,int *lda,double *d,double *e, MKL_Complex16 *tauq, MKL_Complex16 *taup, MKL_Complex16 *x,int *ldx, MKL_Complex16 *y,int *ldy);
void    ZLACGV(int *n, MKL_Complex16 *x,int *incx);
void    zlacgv(int *n, MKL_Complex16 *x,int *incx);
void    ZLACON(int *n, MKL_Complex16 *v, MKL_Complex16 *x,double *est,int *kase);
void    zlacon(int *n, MKL_Complex16 *v, MKL_Complex16 *x,double *est,int *kase);
void    ZLACP2(char *uplo,int *m,int *n,double *a,int *lda, MKL_Complex16 *b,int *ldb);
void    zlacp2(char *uplo,int *m,int *n,double *a,int *lda, MKL_Complex16 *b,int *ldb);
void    ZLACPY(char *uplo,int *m,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb);
void    zlacpy(char *uplo,int *m,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb);
void    ZLACRM(int *m,int *n, MKL_Complex16 *a,int *lda,double *b,int *ldb, MKL_Complex16 *c,int *ldc,double *rwork);
void    zlacrm(int *m,int *n, MKL_Complex16 *a,int *lda,double *b,int *ldb, MKL_Complex16 *c,int *ldc,double *rwork);
void    ZLACRT(int *n, MKL_Complex16 *cx,int *incx, MKL_Complex16 *cy,int *incy, MKL_Complex16 *c, MKL_Complex16 *s);
void    zlacrt(int *n, MKL_Complex16 *cx,int *incx, MKL_Complex16 *cy,int *incy, MKL_Complex16 *c, MKL_Complex16 *s);
void    ZLADIV( MKL_Complex16 *pres, MKL_Complex16 *x, MKL_Complex16 *y);
void    zladiv( MKL_Complex16 *pres, MKL_Complex16 *x, MKL_Complex16 *y);
void    ZLAED0(int *qsiz,int *n,double *d,double *e, MKL_Complex16 *q,int *ldq, MKL_Complex16 *qstore,int *ldqs,double *rwork,int *iwork,int *info);
void    zlaed0(int *qsiz,int *n,double *d,double *e, MKL_Complex16 *q,int *ldq, MKL_Complex16 *qstore,int *ldqs,double *rwork,int *iwork,int *info);
void    ZLAED7(int *n,int *cutpnt,int *qsiz,int *tlvls,int *curlvl,int *curpbm,double *d, MKL_Complex16 *q,int *ldq,double *rho,int *indxq,double *qstore,int *qptr,int *prmptr,int *perm,int *givptr,int *givcol,double *givnum, MKL_Complex16 *work,double *rwork,int *iwork,int *info);
void    zlaed7(int *n,int *cutpnt,int *qsiz,int *tlvls,int *curlvl,int *curpbm,double *d, MKL_Complex16 *q,int *ldq,double *rho,int *indxq,double *qstore,int *qptr,int *prmptr,int *perm,int *givptr,int *givcol,double *givnum, MKL_Complex16 *work,double *rwork,int *iwork,int *info);
void    ZLAED8(int *k,int *n,int *qsiz, MKL_Complex16 *q,int *ldq,double *d,double *rho,int *cutpnt,double *z,double *dlamda, MKL_Complex16 *q2,int *ldq2,double *w,int *indxp,int *indx,int *indxq,int *perm,int *givptr,int *givcol,double *givnum,int *info);
void    zlaed8(int *k,int *n,int *qsiz, MKL_Complex16 *q,int *ldq,double *d,double *rho,int *cutpnt,double *z,double *dlamda, MKL_Complex16 *q2,int *ldq2,double *w,int *indxp,int *indx,int *indxq,int *perm,int *givptr,int *givcol,double *givnum,int *info);
void    ZLAEIN(void *rightv,void *noinit,int *n, MKL_Complex16 *h,int *ldh, MKL_Complex16 *w, MKL_Complex16 *v, MKL_Complex16 *b,int *ldb,double *rwork,double *eps3,double *smlnum,int *info);
void    zlaein(void *rightv,void *noinit,int *n, MKL_Complex16 *h,int *ldh, MKL_Complex16 *w, MKL_Complex16 *v, MKL_Complex16 *b,int *ldb,double *rwork,double *eps3,double *smlnum,int *info);
void    ZLAESY( MKL_Complex16 *a, MKL_Complex16 *b, MKL_Complex16 *c, MKL_Complex16 *rt1, MKL_Complex16 *rt2, MKL_Complex16 *evscal, MKL_Complex16 *cs1, MKL_Complex16 *sn1);
void    zlaesy( MKL_Complex16 *a, MKL_Complex16 *b, MKL_Complex16 *c, MKL_Complex16 *rt1, MKL_Complex16 *rt2, MKL_Complex16 *evscal, MKL_Complex16 *cs1, MKL_Complex16 *sn1);
void    ZLAEV2( MKL_Complex16 *a, MKL_Complex16 *b, MKL_Complex16 *c,double *rt1,double *rt2,double *cs1, MKL_Complex16 *sn1);
void    zlaev2( MKL_Complex16 *a, MKL_Complex16 *b, MKL_Complex16 *c,double *rt1,double *rt2,double *cs1, MKL_Complex16 *sn1);
void    ZLAGS2(void *upper,double *a1, MKL_Complex16 *a2,double *a3,double *b1, MKL_Complex16 *b2,double *b3,double *csu, MKL_Complex16 *snu,double *csv, MKL_Complex16 *snv,double *csq, MKL_Complex16 *snq);
void    zlags2(void *upper,double *a1, MKL_Complex16 *a2,double *a3,double *b1, MKL_Complex16 *b2,double *b3,double *csu, MKL_Complex16 *snu,double *csv, MKL_Complex16 *snv,double *csq, MKL_Complex16 *snq);
void    ZLAGTM(char *trans,int *n,int *nrhs,double *alpha, MKL_Complex16 *dl, MKL_Complex16 *d, MKL_Complex16 *du, MKL_Complex16 *x,int *ldx,double *beta, MKL_Complex16 *b,int *ldb);
void    zlagtm(char *trans,int *n,int *nrhs,double *alpha, MKL_Complex16 *dl, MKL_Complex16 *d, MKL_Complex16 *du, MKL_Complex16 *x,int *ldx,double *beta, MKL_Complex16 *b,int *ldb);
void    ZLAHEF(char *uplo,int *n,int *nb,int *kb, MKL_Complex16 *a,int *lda,int *ipiv, MKL_Complex16 *w,int *ldw,int *info);
void    zlahef(char *uplo,int *n,int *nb,int *kb, MKL_Complex16 *a,int *lda,int *ipiv, MKL_Complex16 *w,int *ldw,int *info);
void    ZLAHQR(void *wantt,void *wantz,int *n,int *ilo,int *ihi, MKL_Complex16 *h,int *ldh, MKL_Complex16 *w,int *iloz,int *ihiz, MKL_Complex16 *z,int *ldz,int *info);
void    zlahqr(void *wantt,void *wantz,int *n,int *ilo,int *ihi, MKL_Complex16 *h,int *ldh, MKL_Complex16 *w,int *iloz,int *ihiz, MKL_Complex16 *z,int *ldz,int *info);
void    ZLAHRD(int *n,int *k,int *nb, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *t,int *ldt, MKL_Complex16 *y,int *ldy);
void    zlahrd(int *n,int *k,int *nb, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *t,int *ldt, MKL_Complex16 *y,int *ldy);
void    ZLAIC1(int *job,int *j, MKL_Complex16 *x,double *sest, MKL_Complex16 *w, MKL_Complex16 *gamma,double *sestpr, MKL_Complex16 *s, MKL_Complex16 *c);
void    zlaic1(int *job,int *j, MKL_Complex16 *x,double *sest, MKL_Complex16 *w, MKL_Complex16 *gamma,double *sestpr, MKL_Complex16 *s, MKL_Complex16 *c);
void    ZLALS0(int *icompq,int *nl,int *nr,int *sqre,int *nrhs, MKL_Complex16 *b,int *ldb, MKL_Complex16 *bx,int *ldbx,int *perm,int *givptr,int *givcol,int *ldgcol,double *givnum,int *ldgnum,double *poles,double *difl,double *difr,double *z,int *k,double *c,double *s,double *rwork,int *info);
void    zlals0(int *icompq,int *nl,int *nr,int *sqre,int *nrhs, MKL_Complex16 *b,int *ldb, MKL_Complex16 *bx,int *ldbx,int *perm,int *givptr,int *givcol,int *ldgcol,double *givnum,int *ldgnum,double *poles,double *difl,double *difr,double *z,int *k,double *c,double *s,double *rwork,int *info);
void    ZLALSA(int *icompq,int *smlsiz,int *n,int *nrhs, MKL_Complex16 *b,int *ldb, MKL_Complex16 *bx,int *ldbx,double *u,int *ldu,double *vt,int *k,double *difl,double *difr,double *z,double *poles,int *givptr,int *givcol,int *ldgcol,int *perm,double *givnum,double *c,double *s,float *rwork,int *iwork,int *info);
void    zlalsa(int *icompq,int *smlsiz,int *n,int *nrhs, MKL_Complex16 *b,int *ldb, MKL_Complex16 *bx,int *ldbx,double *u,int *ldu,double *vt,int *k,double *difl,double *difr,double *z,double *poles,int *givptr,int *givcol,int *ldgcol,int *perm,double *givnum,double *c,double *s,float *rwork,int *iwork,int *info);
void    ZLALSD(char *uplo,int *smlsiz,int *n,int *nrhs,double *d,double *e, MKL_Complex16 *b,int *ldb,double *rcond,int *rank, MKL_Complex16 *work,float *rwork,int *iwork,int *info);
void    zlalsd(char *uplo,int *smlsiz,int *n,int *nrhs,double *d,double *e, MKL_Complex16 *b,int *ldb,double *rcond,int *rank, MKL_Complex16 *work,float *rwork,int *iwork,int *info);
double  ZLANGB(char *norm,int *n,int *kl,int *ku, MKL_Complex16 *ab,int *ldab,double *work);
double  zlangb(char *norm,int *n,int *kl,int *ku, MKL_Complex16 *ab,int *ldab,double *work);
double  ZLANGE(char *norm,int *m,int *n, MKL_Complex16 *a,int *lda,double *work);
double  zlange(char *norm,int *m,int *n, MKL_Complex16 *a,int *lda,double *work);
double  ZLANGT(char *norm,int *n, MKL_Complex16 *dl, MKL_Complex16 *d, MKL_Complex16 *du);
double  zlangt(char *norm,int *n, MKL_Complex16 *dl, MKL_Complex16 *d, MKL_Complex16 *du);
double  ZLANHB(char *norm,char *uplo,int *n,int *k, MKL_Complex16 *ab,int *ldab,double *work);
double  zlanhb(char *norm,char *uplo,int *n,int *k, MKL_Complex16 *ab,int *ldab,double *work);
double  ZLANHE(char *norm,char *uplo,int *n, MKL_Complex16 *a,int *lda,double *work);
double  zlanhe(char *norm,char *uplo,int *n, MKL_Complex16 *a,int *lda,double *work);
double  ZLANHP(char *norm,char *uplo,int *n, MKL_Complex16 *ap,double *work);
double  zlanhp(char *norm,char *uplo,int *n, MKL_Complex16 *ap,double *work);
double  ZLANHS(char *norm,int *n, MKL_Complex16 *a,int *lda,double *work);
double  zlanhs(char *norm,int *n, MKL_Complex16 *a,int *lda,double *work);
double  ZLANHT(char *norm,int *n,double *d, MKL_Complex16 *e);
double  zlanht(char *norm,int *n,double *d, MKL_Complex16 *e);
double  ZLANSB(char *norm,char *uplo,int *n,int *k, MKL_Complex16 *ab,int *ldab,double *work);
double  zlansb(char *norm,char *uplo,int *n,int *k, MKL_Complex16 *ab,int *ldab,double *work);
double  ZLANSP(char *norm,char *uplo,int *n, MKL_Complex16 *ap,double *work);
double  zlansp(char *norm,char *uplo,int *n, MKL_Complex16 *ap,double *work);
double  ZLANSY(char *norm,char *uplo,int *n, MKL_Complex16 *a,int *lda,double *work);
double  zlansy(char *norm,char *uplo,int *n, MKL_Complex16 *a,int *lda,double *work);
double  ZLANTB(char *norm,char *uplo,char *diag,int *n,int *k, MKL_Complex16 *ab,int *ldab,double *work);
double  zlantb(char *norm,char *uplo,char *diag,int *n,int *k, MKL_Complex16 *ab,int *ldab,double *work);
double  ZLANTP(char *norm,char *uplo,char *diag,int *n, MKL_Complex16 *ap,double *work);
double  zlantp(char *norm,char *uplo,char *diag,int *n, MKL_Complex16 *ap,double *work);
double  ZLANTR(char *norm,char *uplo,char *diag,int *m,int *n, MKL_Complex16 *a,int *lda,double *work);
double  zlantr(char *norm,char *uplo,char *diag,int *m,int *n, MKL_Complex16 *a,int *lda,double *work);
void    ZLAPLL(int *n, MKL_Complex16 *x,int *incx, MKL_Complex16 *y,int *incy,double *ssmin);
void    zlapll(int *n, MKL_Complex16 *x,int *incx, MKL_Complex16 *y,int *incy,double *ssmin);
void    ZLAPMT(void *forwrd,int *m,int *n, MKL_Complex16 *x,int *ldx,int *k);
void    zlapmt(void *forwrd,int *m,int *n, MKL_Complex16 *x,int *ldx,int *k);
void    ZLAQGB(int *m,int *n,int *kl,int *ku, MKL_Complex16 *ab,int *ldab,double *r,double *c,double *rowcnd,double *colcnd,double *amax,char *equed);
void    zlaqgb(int *m,int *n,int *kl,int *ku, MKL_Complex16 *ab,int *ldab,double *r,double *c,double *rowcnd,double *colcnd,double *amax,char *equed);
void    ZLAQGE(int *m,int *n, MKL_Complex16 *a,int *lda,double *r,double *c,double *rowcnd,double *colcnd,double *amax,char *equed);
void    zlaqge(int *m,int *n, MKL_Complex16 *a,int *lda,double *r,double *c,double *rowcnd,double *colcnd,double *amax,char *equed);
void    ZLAQHB(char *uplo,int *n,int *kd, MKL_Complex16 *ab,int *ldab,double *s,double *scond,double *amax,char *equed);
void    zlaqhb(char *uplo,int *n,int *kd, MKL_Complex16 *ab,int *ldab,double *s,double *scond,double *amax,char *equed);
void    ZLAQHE(char *uplo,int *n, MKL_Complex16 *a,int *lda,double *s,double *scond,double *amax,char *equed);
void    zlaqhe(char *uplo,int *n, MKL_Complex16 *a,int *lda,double *s,double *scond,double *amax,char *equed);
void    ZLAQHP(char *uplo,int *n, MKL_Complex16 *ap,double *s,double *scond,double *amax,char *equed);
void    zlaqhp(char *uplo,int *n, MKL_Complex16 *ap,double *s,double *scond,double *amax,char *equed);
void    ZLAQP2(int *m,int *n,int *offset, MKL_Complex16 *a,int *lda,int *jpvt, MKL_Complex16 *tau,double *vn1,double *vn2, MKL_Complex16 *work);
void    zlaqp2(int *m,int *n,int *offset, MKL_Complex16 *a,int *lda,int *jpvt, MKL_Complex16 *tau,double *vn1,double *vn2, MKL_Complex16 *work);
void    ZLAQPS(int *m,int *n,int *offset,int *nb,int *kb, MKL_Complex16 *a,int *lda,int *jpvt, MKL_Complex16 *tau,double *vn1,double *vn2, MKL_Complex16 *auxv, MKL_Complex16 *f,int *ldf);
void    zlaqps(int *m,int *n,int *offset,int *nb,int *kb, MKL_Complex16 *a,int *lda,int *jpvt, MKL_Complex16 *tau,double *vn1,double *vn2, MKL_Complex16 *auxv, MKL_Complex16 *f,int *ldf);
void    ZLAQSB(char *uplo,int *n,int *kd, MKL_Complex16 *ab,int *ldab,double *s,double *scond,double *amax,char *equed);
void    zlaqsb(char *uplo,int *n,int *kd, MKL_Complex16 *ab,int *ldab,double *s,double *scond,double *amax,char *equed);
void    ZLAQSP(char *uplo,int *n, MKL_Complex16 *ap,double *s,double *scond,double *amax,char *equed);
void    zlaqsp(char *uplo,int *n, MKL_Complex16 *ap,double *s,double *scond,double *amax,char *equed);
void    ZLAQSY(char *uplo,int *n, MKL_Complex16 *a,int *lda,double *s,double *scond,double *amax,char *equed);
void    zlaqsy(char *uplo,int *n, MKL_Complex16 *a,int *lda,double *s,double *scond,double *amax,char *equed);
void    ZLAR1V(int *n,int *b1,int *bn,double *sigma,double *d,double *l,double *ld,double *lld,double *gersch, MKL_Complex16 *z,double *ztz,double *mingma,int *r,int *isuppz,double *work);
void    zlar1v(int *n,int *b1,int *bn,double *sigma,double *d,double *l,double *ld,double *lld,double *gersch, MKL_Complex16 *z,double *ztz,double *mingma,int *r,int *isuppz,double *work);
void    ZLAR2V(int *n, MKL_Complex16 *x, MKL_Complex16 *y, MKL_Complex16 *z,int *incx,double *c, MKL_Complex16 *s,int *incc);
void    zlar2v(int *n, MKL_Complex16 *x, MKL_Complex16 *y, MKL_Complex16 *z,int *incx,double *c, MKL_Complex16 *s,int *incc);
void    ZLARCM(int *m,int *n,double *a,int *lda, MKL_Complex16 *b,int *ldb, MKL_Complex16 *c,int *ldc,double *rwork);
void    zlarcm(int *m,int *n,double *a,int *lda, MKL_Complex16 *b,int *ldb, MKL_Complex16 *c,int *ldc,double *rwork);
void    ZLARF(char *side,int *m,int *n, MKL_Complex16 *v,int *incv, MKL_Complex16 *tau, MKL_Complex16 *c,int *ldc, MKL_Complex16 *work);
void    zlarf(char *side,int *m,int *n, MKL_Complex16 *v,int *incv, MKL_Complex16 *tau, MKL_Complex16 *c,int *ldc, MKL_Complex16 *work);
void    ZLARFB(char *side,char *trans,char *direct,char *storev,int *m,int *n,int *k, MKL_Complex16 *v,int *ldv, MKL_Complex16 *t,int *ldt, MKL_Complex16 *c,int *ldc, MKL_Complex16 *work,int *ldwork);
void    zlarfb(char *side,char *trans,char *direct,char *storev,int *m,int *n,int *k, MKL_Complex16 *v,int *ldv, MKL_Complex16 *t,int *ldt, MKL_Complex16 *c,int *ldc, MKL_Complex16 *work,int *ldwork);
void    ZLARFG(int *n, MKL_Complex16 *alpha, MKL_Complex16 *x,int *incx, MKL_Complex16 *tau);
void    zlarfg(int *n, MKL_Complex16 *alpha, MKL_Complex16 *x,int *incx, MKL_Complex16 *tau);
void    ZLARFT(char *direct,char *storev,int *n,int *k, MKL_Complex16 *v,int *ldv, MKL_Complex16 *tau, MKL_Complex16 *t,int *ldt);
void    zlarft(char *direct,char *storev,int *n,int *k, MKL_Complex16 *v,int *ldv, MKL_Complex16 *tau, MKL_Complex16 *t,int *ldt);
void    ZLARFX(char *side,int *m,int *n, MKL_Complex16 *v, MKL_Complex16 *tau, MKL_Complex16 *c,int *ldc, MKL_Complex16 *work);
void    zlarfx(char *side,int *m,int *n, MKL_Complex16 *v, MKL_Complex16 *tau, MKL_Complex16 *c,int *ldc, MKL_Complex16 *work);
void    ZLARGV(int *n, MKL_Complex16 *x,int *incx, MKL_Complex16 *y,int *incy,double *c,int *incc);
void    zlargv(int *n, MKL_Complex16 *x,int *incx, MKL_Complex16 *y,int *incy,double *c,int *incc);
void    ZLARNV(int *idist,int *iseed,int *n, MKL_Complex16 *x);
void    zlarnv(int *idist,int *iseed,int *n, MKL_Complex16 *x);
void    ZLARRV(int *n,double *d,double *l,int *isplit,int *m,double *w,int *iblock,double *gersch,double *tol, MKL_Complex16 *z,int *ldz,int *isuppz,double *work,int *iwork,int *info);
void    zlarrv(int *n,double *d,double *l,int *isplit,int *m,double *w,int *iblock,double *gersch,double *tol, MKL_Complex16 *z,int *ldz,int *isuppz,double *work,int *iwork,int *info);
void    ZLARTG( MKL_Complex16 *f, MKL_Complex16 *g,double *cs, MKL_Complex16 *sn, MKL_Complex16 *r);
void    zlartg( MKL_Complex16 *f, MKL_Complex16 *g,double *cs, MKL_Complex16 *sn, MKL_Complex16 *r);
void    ZLARTV(int *n, MKL_Complex16 *x,int *incx, MKL_Complex16 *y,int *incy,double *c, MKL_Complex16 *s,int *incc);
void    zlartv(int *n, MKL_Complex16 *x,int *incx, MKL_Complex16 *y,int *incy,double *c, MKL_Complex16 *s,int *incc);
void    ZLARZ(char *side,int *m,int *n,int *l, MKL_Complex16 *v,int *incv, MKL_Complex16 *tau, MKL_Complex16 *c,int *ldc, MKL_Complex16 *work);
void    zlarz(char *side,int *m,int *n,int *l, MKL_Complex16 *v,int *incv, MKL_Complex16 *tau, MKL_Complex16 *c,int *ldc, MKL_Complex16 *work);
void    ZLARZB(char *side,char *trans,char *direct,char *storev,int *m,int *n,int *k,int *l, MKL_Complex16 *v,int *ldv, MKL_Complex16 *t,int *ldt, MKL_Complex16 *c,int *ldc, MKL_Complex16 *work,int *ldwork);
void    zlarzb(char *side,char *trans,char *direct,char *storev,int *m,int *n,int *k,int *l, MKL_Complex16 *v,int *ldv, MKL_Complex16 *t,int *ldt, MKL_Complex16 *c,int *ldc, MKL_Complex16 *work,int *ldwork);
void    ZLARZT(char *direct,char *storev,int *n,int *k, MKL_Complex16 *v,int *ldv, MKL_Complex16 *tau, MKL_Complex16 *t,int *ldt);
void    zlarzt(char *direct,char *storev,int *n,int *k, MKL_Complex16 *v,int *ldv, MKL_Complex16 *tau, MKL_Complex16 *t,int *ldt);
void    ZLASCL(char *type,int *kl,int *ku,double *cfrom,double *cto,int *m,int *n, MKL_Complex16 *a,int *lda,int *info);
void    zlascl(char *type,int *kl,int *ku,double *cfrom,double *cto,int *m,int *n, MKL_Complex16 *a,int *lda,int *info);
void    ZLASET(char *uplo,int *m,int *n, MKL_Complex16 *alpha, MKL_Complex16 *beta, MKL_Complex16 *a,int *lda);
void    zlaset(char *uplo,int *m,int *n, MKL_Complex16 *alpha, MKL_Complex16 *beta, MKL_Complex16 *a,int *lda);
void    ZLASR(char *side,char *pivot,char *direct,int *m,int *n,double *c,double *s, MKL_Complex16 *a,int *lda);
void    zlasr(char *side,char *pivot,char *direct,int *m,int *n,double *c,double *s, MKL_Complex16 *a,int *lda);
void    ZLASSQ(int *n, MKL_Complex16 *x,int *incx,double *scale,double *sumsq);
void    zlassq(int *n, MKL_Complex16 *x,int *incx,double *scale,double *sumsq);
void    ZLASWP(int *n, MKL_Complex16 *a,int *lda,int *k1,int *k2,int *ipiv,int *incx);
void    zlaswp(int *n, MKL_Complex16 *a,int *lda,int *k1,int *k2,int *ipiv,int *incx);
void    ZLASYF(char *uplo,int *n,int *nb,int *kb, MKL_Complex16 *a,int *lda,int *ipiv, MKL_Complex16 *w,int *ldw,int *info);
void    zlasyf(char *uplo,int *n,int *nb,int *kb, MKL_Complex16 *a,int *lda,int *ipiv, MKL_Complex16 *w,int *ldw,int *info);
void    ZLATBS(char *uplo,char *trans,char *diag,char *normin,int *n,int *kd, MKL_Complex16 *ab,int *ldab, MKL_Complex16 *x,double *scale,double *cnorm,int *info);
void    zlatbs(char *uplo,char *trans,char *diag,char *normin,int *n,int *kd, MKL_Complex16 *ab,int *ldab, MKL_Complex16 *x,double *scale,double *cnorm,int *info);
void    ZLATDF(int *ijob,int *n, MKL_Complex16 *z,int *ldz, MKL_Complex16 *rhs,double *rdsum,double *rdscal,int *ipiv,int *jpiv);
void    zlatdf(int *ijob,int *n, MKL_Complex16 *z,int *ldz, MKL_Complex16 *rhs,double *rdsum,double *rdscal,int *ipiv,int *jpiv);
void    ZLATPS(char *uplo,char *trans,char *diag,char *normin,int *n, MKL_Complex16 *ap, MKL_Complex16 *x,double *scale,double *cnorm,int *info);
void    zlatps(char *uplo,char *trans,char *diag,char *normin,int *n, MKL_Complex16 *ap, MKL_Complex16 *x,double *scale,double *cnorm,int *info);
void    ZLATRD(char *uplo,int *n,int *nb, MKL_Complex16 *a,int *lda,double *e, MKL_Complex16 *tau, MKL_Complex16 *w,int *ldw);
void    zlatrd(char *uplo,int *n,int *nb, MKL_Complex16 *a,int *lda,double *e, MKL_Complex16 *tau, MKL_Complex16 *w,int *ldw);
void    ZLATRS(char *uplo,char *trans,char *diag,char *normin,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *x,double *scale,double *cnorm,int *info);
void    zlatrs(char *uplo,char *trans,char *diag,char *normin,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *x,double *scale,double *cnorm,int *info);
void    ZLATRZ(int *m,int *n,int *l, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *work);
void    zlatrz(int *m,int *n,int *l, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *work);
void    ZLATZM(char *side,int *m,int *n, MKL_Complex16 *v,int *incv, MKL_Complex16 *tau, MKL_Complex16 *c1, MKL_Complex16 *c2,int *ldc, MKL_Complex16 *work);
void    zlatzm(char *side,int *m,int *n, MKL_Complex16 *v,int *incv, MKL_Complex16 *tau, MKL_Complex16 *c1, MKL_Complex16 *c2,int *ldc, MKL_Complex16 *work);
void    ZLAUU2(char *uplo,int *n, MKL_Complex16 *a,int *lda,int *info);
void    zlauu2(char *uplo,int *n, MKL_Complex16 *a,int *lda,int *info);
void    ZLAUUM(char *uplo,int *n, MKL_Complex16 *a,int *lda,int *info);
void    zlauum(char *uplo,int *n, MKL_Complex16 *a,int *lda,int *info);
void    ZPBCON(char *uplo,int *n,int *kd, MKL_Complex16 *ab,int *ldab,double *anorm,double *rcond, MKL_Complex16 *work,double *rwork,int *info);
void    zpbcon(char *uplo,int *n,int *kd, MKL_Complex16 *ab,int *ldab,double *anorm,double *rcond, MKL_Complex16 *work,double *rwork,int *info);
void    ZPBEQU(char *uplo,int *n,int *kd, MKL_Complex16 *ab,int *ldab,double *s,double *scond,double *amax,int *info);
void    zpbequ(char *uplo,int *n,int *kd, MKL_Complex16 *ab,int *ldab,double *s,double *scond,double *amax,int *info);
void    ZPBRFS(char *uplo,int *n,int *kd,int *nrhs, MKL_Complex16 *ab,int *ldab, MKL_Complex16 *afb,int *ldafb, MKL_Complex16 *b,int *ldb, MKL_Complex16 *x,int *ldx,double *ferr,double *berr, MKL_Complex16 *work,double *rwork,int *info);
void    zpbrfs(char *uplo,int *n,int *kd,int *nrhs, MKL_Complex16 *ab,int *ldab, MKL_Complex16 *afb,int *ldafb, MKL_Complex16 *b,int *ldb, MKL_Complex16 *x,int *ldx,double *ferr,double *berr, MKL_Complex16 *work,double *rwork,int *info);
void    ZPBSTF(char *uplo,int *n,int *kd, MKL_Complex16 *ab,int *ldab,int *info);
void    zpbstf(char *uplo,int *n,int *kd, MKL_Complex16 *ab,int *ldab,int *info);
void    ZPBSV(char *uplo,int *n,int *kd,int *nrhs, MKL_Complex16 *ab,int *ldab, MKL_Complex16 *b,int *ldb,int *info);
void    zpbsv(char *uplo,int *n,int *kd,int *nrhs, MKL_Complex16 *ab,int *ldab, MKL_Complex16 *b,int *ldb,int *info);
void    ZPBSVX(char *fact,char *uplo,int *n,int *kd,int *nrhs, MKL_Complex16 *ab,int *ldab, MKL_Complex16 *afb,int *ldafb,char *equed,double *s, MKL_Complex16 *b,int *ldb, MKL_Complex16 *x,int *ldx,double *rcond,double *ferr,double *berr, MKL_Complex16 *work,double *rwork,int *info);
void    zpbsvx(char *fact,char *uplo,int *n,int *kd,int *nrhs, MKL_Complex16 *ab,int *ldab, MKL_Complex16 *afb,int *ldafb,char *equed,double *s, MKL_Complex16 *b,int *ldb, MKL_Complex16 *x,int *ldx,double *rcond,double *ferr,double *berr, MKL_Complex16 *work,double *rwork,int *info);
void    ZPBTF2(char *uplo,int *n,int *kd, MKL_Complex16 *ab,int *ldab,int *info);
void    zpbtf2(char *uplo,int *n,int *kd, MKL_Complex16 *ab,int *ldab,int *info);
void    ZPBTRF(char *uplo,int *n,int *kd, MKL_Complex16 *ab,int *ldab,int *info);
void    zpbtrf(char *uplo,int *n,int *kd, MKL_Complex16 *ab,int *ldab,int *info);
void    ZPBTRS(char *uplo,int *n,int *kd,int *nrhs, MKL_Complex16 *ab,int *ldab, MKL_Complex16 *b,int *ldb,int *info);
void    zpbtrs(char *uplo,int *n,int *kd,int *nrhs, MKL_Complex16 *ab,int *ldab, MKL_Complex16 *b,int *ldb,int *info);
void    ZPOCON(char *uplo,int *n, MKL_Complex16 *a,int *lda,double *anorm,double *rcond, MKL_Complex16 *work,double *rwork,int *info);
void    zpocon(char *uplo,int *n, MKL_Complex16 *a,int *lda,double *anorm,double *rcond, MKL_Complex16 *work,double *rwork,int *info);
void    ZPOEQU(int *n, MKL_Complex16 *a,int *lda,double *s,double *scond,double *amax,int *info);
void    zpoequ(int *n, MKL_Complex16 *a,int *lda,double *s,double *scond,double *amax,int *info);
void    ZPORFS(char *uplo,int *n,int *nrhs, MKL_Complex16 *a,int *lda, MKL_Complex16 *af,int *ldaf, MKL_Complex16 *b,int *ldb, MKL_Complex16 *x,int *ldx,double *ferr,double *berr, MKL_Complex16 *work,double *rwork,int *info);
void    zporfs(char *uplo,int *n,int *nrhs, MKL_Complex16 *a,int *lda, MKL_Complex16 *af,int *ldaf, MKL_Complex16 *b,int *ldb, MKL_Complex16 *x,int *ldx,double *ferr,double *berr, MKL_Complex16 *work,double *rwork,int *info);
void    ZPOSV(char *uplo,int *n,int *nrhs, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb,int *info);
void    zposv(char *uplo,int *n,int *nrhs, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb,int *info);
void    ZPOSVX(char *fact,char *uplo,int *n,int *nrhs, MKL_Complex16 *a,int *lda, MKL_Complex16 *af,int *ldaf,char *equed,double *s, MKL_Complex16 *b,int *ldb, MKL_Complex16 *x,int *ldx,double *rcond,double *ferr,double *berr, MKL_Complex16 *work,double *rwork,int *info);
void    zposvx(char *fact,char *uplo,int *n,int *nrhs, MKL_Complex16 *a,int *lda, MKL_Complex16 *af,int *ldaf,char *equed,double *s, MKL_Complex16 *b,int *ldb, MKL_Complex16 *x,int *ldx,double *rcond,double *ferr,double *berr, MKL_Complex16 *work,double *rwork,int *info);
void    ZPOTF2(char *uplo,int *n, MKL_Complex16 *a,int *lda,int *info);
void    zpotf2(char *uplo,int *n, MKL_Complex16 *a,int *lda,int *info);
void    ZPOTRF(char *uplo,int *n, MKL_Complex16 *a,int *lda,int *info);
void    zpotrf(char *uplo,int *n, MKL_Complex16 *a,int *lda,int *info);
void    ZPOTRI(char *uplo,int *n, MKL_Complex16 *a,int *lda,int *info);
void    zpotri(char *uplo,int *n, MKL_Complex16 *a,int *lda,int *info);
void    ZPOTRS(char *uplo,int *n,int *nrhs, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb,int *info);
void    zpotrs(char *uplo,int *n,int *nrhs, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb,int *info);
void    ZPPCON(char *uplo,int *n, MKL_Complex16 *ap,double *anorm,double *rcond, MKL_Complex16 *work,double *rwork,int *info);
void    zppcon(char *uplo,int *n, MKL_Complex16 *ap,double *anorm,double *rcond, MKL_Complex16 *work,double *rwork,int *info);
void    ZPPEQU(char *uplo,int *n, MKL_Complex16 *ap,double *s,double *scond,double *amax,int *info);
void    zppequ(char *uplo,int *n, MKL_Complex16 *ap,double *s,double *scond,double *amax,int *info);
void    ZPPRFS(char *uplo,int *n,int *nrhs, MKL_Complex16 *ap, MKL_Complex16 *afp, MKL_Complex16 *b,int *ldb, MKL_Complex16 *x,int *ldx,double *ferr,double *berr, MKL_Complex16 *work,double *rwork,int *info);
void    zpprfs(char *uplo,int *n,int *nrhs, MKL_Complex16 *ap, MKL_Complex16 *afp, MKL_Complex16 *b,int *ldb, MKL_Complex16 *x,int *ldx,double *ferr,double *berr, MKL_Complex16 *work,double *rwork,int *info);
void    ZPPSV(char *uplo,int *n,int *nrhs, MKL_Complex16 *ap, MKL_Complex16 *b,int *ldb,int *info);
void    zppsv(char *uplo,int *n,int *nrhs, MKL_Complex16 *ap, MKL_Complex16 *b,int *ldb,int *info);
void    ZPPSVX(char *fact,char *uplo,int *n,int *nrhs, MKL_Complex16 *ap, MKL_Complex16 *afp,char *equed,double *s, MKL_Complex16 *b,int *ldb, MKL_Complex16 *x,int *ldx,double *rcond,double *ferr,double *berr, MKL_Complex16 *work,double *rwork,int *info);
void    zppsvx(char *fact,char *uplo,int *n,int *nrhs, MKL_Complex16 *ap, MKL_Complex16 *afp,char *equed,double *s, MKL_Complex16 *b,int *ldb, MKL_Complex16 *x,int *ldx,double *rcond,double *ferr,double *berr, MKL_Complex16 *work,double *rwork,int *info);
void    ZPPTRF(char *uplo,int *n, MKL_Complex16 *ap,int *info);
void    zpptrf(char *uplo,int *n, MKL_Complex16 *ap,int *info);
void    ZPPTRI(char *uplo,int *n, MKL_Complex16 *ap,int *info);
void    zpptri(char *uplo,int *n, MKL_Complex16 *ap,int *info);
void    ZPPTRS(char *uplo,int *n,int *nrhs, MKL_Complex16 *ap, MKL_Complex16 *b,int *ldb,int *info);
void    zpptrs(char *uplo,int *n,int *nrhs, MKL_Complex16 *ap, MKL_Complex16 *b,int *ldb,int *info);
void    ZPTCON(int *n,double *d, MKL_Complex16 *e,double *anorm,double *rcond,double *rwork,int *info);
void    zptcon(int *n,double *d, MKL_Complex16 *e,double *anorm,double *rcond,double *rwork,int *info);
void    ZPTEQR(char *compz,int *n,double *d,double *e, MKL_Complex16 *z,int *ldz,double *work,int *info);
void    zpteqr(char *compz,int *n,double *d,double *e, MKL_Complex16 *z,int *ldz,double *work,int *info);
void    ZPTRFS(char *uplo,int *n,int *nrhs,double *d, MKL_Complex16 *e,double *df, MKL_Complex16 *ef, MKL_Complex16 *b,int *ldb, MKL_Complex16 *x,int *ldx,double *ferr,double *berr, MKL_Complex16 *work,double *rwork,int *info);
void    zptrfs(char *uplo,int *n,int *nrhs,double *d, MKL_Complex16 *e,double *df, MKL_Complex16 *ef, MKL_Complex16 *b,int *ldb, MKL_Complex16 *x,int *ldx,double *ferr,double *berr, MKL_Complex16 *work,double *rwork,int *info);
void    ZPTSV(int *n,int *nrhs,double *d, MKL_Complex16 *e, MKL_Complex16 *b,int *ldb,int *info);
void    zptsv(int *n,int *nrhs,double *d, MKL_Complex16 *e, MKL_Complex16 *b,int *ldb,int *info);
void    ZPTSVX(char *fact,int *n,int *nrhs,double *d, MKL_Complex16 *e,double *df, MKL_Complex16 *ef, MKL_Complex16 *b,int *ldb, MKL_Complex16 *x,int *ldx,double *rcond,double *ferr,double *berr, MKL_Complex16 *work,double *rwork,int *info);
void    zptsvx(char *fact,int *n,int *nrhs,double *d, MKL_Complex16 *e,double *df, MKL_Complex16 *ef, MKL_Complex16 *b,int *ldb, MKL_Complex16 *x,int *ldx,double *rcond,double *ferr,double *berr, MKL_Complex16 *work,double *rwork,int *info);
void    ZPTTRF(int *n,double *d, MKL_Complex16 *e,int *info);
void    zpttrf(int *n,double *d, MKL_Complex16 *e,int *info);
void    ZPTTRS(char *uplo,int *n,int *nrhs,double *d, MKL_Complex16 *e, MKL_Complex16 *b,int *ldb,int *info);
void    zpttrs(char *uplo,int *n,int *nrhs,double *d, MKL_Complex16 *e, MKL_Complex16 *b,int *ldb,int *info);
void    ZPTTS2(int *iuplo,int *n,int *nrhs,double *d, MKL_Complex16 *e, MKL_Complex16 *b,int *ldb);
void    zptts2(int *iuplo,int *n,int *nrhs,double *d, MKL_Complex16 *e, MKL_Complex16 *b,int *ldb);
void    ZROT(int *n, MKL_Complex16 *cx,int *incx, MKL_Complex16 *cy,int *incy,double *c, MKL_Complex16 *s);
void    zrot(int *n, MKL_Complex16 *cx,int *incx, MKL_Complex16 *cy,int *incy,double *c, MKL_Complex16 *s);
void    ZSPCON(char *uplo,int *n, MKL_Complex16 *ap,int *ipiv,double *anorm,double *rcond, MKL_Complex16 *work,int *info);
void    zspcon(char *uplo,int *n, MKL_Complex16 *ap,int *ipiv,double *anorm,double *rcond, MKL_Complex16 *work,int *info);
void    ZSPMV(char *uplo,int *n, MKL_Complex16 *alpha, MKL_Complex16 *ap, MKL_Complex16 *x,int *incx, MKL_Complex16 *beta, MKL_Complex16 *y,int *incy);
void    zspmv(char *uplo,int *n, MKL_Complex16 *alpha, MKL_Complex16 *ap, MKL_Complex16 *x,int *incx, MKL_Complex16 *beta, MKL_Complex16 *y,int *incy);
void    ZSPR(char *uplo,int *n, MKL_Complex16 *alpha, MKL_Complex16 *x,int *incx, MKL_Complex16 *ap);
void    zspr(char *uplo,int *n, MKL_Complex16 *alpha, MKL_Complex16 *x,int *incx, MKL_Complex16 *ap);
void    ZSPRFS(char *uplo,int *n,int *nrhs, MKL_Complex16 *ap, MKL_Complex16 *afp,int *ipiv, MKL_Complex16 *b,int *ldb, MKL_Complex16 *x,int *ldx,double *ferr,double *berr, MKL_Complex16 *work,double *rwork,int *info);
void    zsprfs(char *uplo,int *n,int *nrhs, MKL_Complex16 *ap, MKL_Complex16 *afp,int *ipiv, MKL_Complex16 *b,int *ldb, MKL_Complex16 *x,int *ldx,double *ferr,double *berr, MKL_Complex16 *work,double *rwork,int *info);
void    ZSPSV(char *uplo,int *n,int *nrhs, MKL_Complex16 *ap,int *ipiv, MKL_Complex16 *b,int *ldb,int *info);
void    zspsv(char *uplo,int *n,int *nrhs, MKL_Complex16 *ap,int *ipiv, MKL_Complex16 *b,int *ldb,int *info);
void    ZSPSVX(char *fact,char *uplo,int *n,int *nrhs, MKL_Complex16 *ap, MKL_Complex16 *afp,int *ipiv, MKL_Complex16 *b,int *ldb, MKL_Complex16 *x,int *ldx,double *rcond,double *ferr,double *berr, MKL_Complex16 *work,double *rwork,int *info);
void    zspsvx(char *fact,char *uplo,int *n,int *nrhs, MKL_Complex16 *ap, MKL_Complex16 *afp,int *ipiv, MKL_Complex16 *b,int *ldb, MKL_Complex16 *x,int *ldx,double *rcond,double *ferr,double *berr, MKL_Complex16 *work,double *rwork,int *info);
void    ZSPTRF(char *uplo,int *n, MKL_Complex16 *ap,int *ipiv,int *info);
void    zsptrf(char *uplo,int *n, MKL_Complex16 *ap,int *ipiv,int *info);
void    ZSPTRI(char *uplo,int *n, MKL_Complex16 *ap,int *ipiv, MKL_Complex16 *work,int *info);
void    zsptri(char *uplo,int *n, MKL_Complex16 *ap,int *ipiv, MKL_Complex16 *work,int *info);
void    ZSPTRS(char *uplo,int *n,int *nrhs, MKL_Complex16 *ap,int *ipiv, MKL_Complex16 *b,int *ldb,int *info);
void    zsptrs(char *uplo,int *n,int *nrhs, MKL_Complex16 *ap,int *ipiv, MKL_Complex16 *b,int *ldb,int *info);
void    ZSTEDC(char *compz,int *n,double *d,double *e, MKL_Complex16 *z,int *ldz, MKL_Complex16 *work,int *lwork,double *rwork,int *lrwork,int *iwork,int *liwork,int *info);
void    zstedc(char *compz,int *n,double *d,double *e, MKL_Complex16 *z,int *ldz, MKL_Complex16 *work,int *lwork,double *rwork,int *lrwork,int *iwork,int *liwork,int *info);
void    ZSTEGR(char *jobz,char *range,int *n,double *d,double *e,double *vl,double *vu,int *il,int *iu,double *abstol,int *m,double *w, MKL_Complex16 *z,int *ldz,int *isuppz,double *work,int *lwork,int *iwork,int *liwork,int *info);
void    zstegr(char *jobz,char *range,int *n,double *d,double *e,double *vl,double *vu,int *il,int *iu,double *abstol,int *m,double *w, MKL_Complex16 *z,int *ldz,int *isuppz,double *work,int *lwork,int *iwork,int *liwork,int *info);
void    ZSTEIN(int *n,double *d,double *e,int *m,double *w,int *iblock,int *isplit, MKL_Complex16 *z,int *ldz,double *work,int *iwork,int *ifail,int *info);
void    zstein(int *n,double *d,double *e,int *m,double *w,int *iblock,int *isplit, MKL_Complex16 *z,int *ldz,double *work,int *iwork,int *ifail,int *info);
void    ZSTEQR(char *compz,int *n,double *d,double *e, MKL_Complex16 *z,int *ldz,double *work,int *info);
void    zsteqr(char *compz,int *n,double *d,double *e, MKL_Complex16 *z,int *ldz,double *work,int *info);
void    ZSYCON(char *uplo,int *n, MKL_Complex16 *a,int *lda,int *ipiv,double *anorm,double *rcond, MKL_Complex16 *work,int *info);
void    zsycon(char *uplo,int *n, MKL_Complex16 *a,int *lda,int *ipiv,double *anorm,double *rcond, MKL_Complex16 *work,int *info);
void    ZSYMV(char *uplo,int *n, MKL_Complex16 *alpha, MKL_Complex16 *a,int *lda, MKL_Complex16 *x,int *incx, MKL_Complex16 *beta, MKL_Complex16 *y,int *incy);
void    zsymv(char *uplo,int *n, MKL_Complex16 *alpha, MKL_Complex16 *a,int *lda, MKL_Complex16 *x,int *incx, MKL_Complex16 *beta, MKL_Complex16 *y,int *incy);
void    ZSYR(char *uplo,int *n, MKL_Complex16 *alpha, MKL_Complex16 *x,int *incx, MKL_Complex16 *a,int *lda);
void    zsyr(char *uplo,int *n, MKL_Complex16 *alpha, MKL_Complex16 *x,int *incx, MKL_Complex16 *a,int *lda);
void    ZSYRFS(char *uplo,int *n,int *nrhs, MKL_Complex16 *a,int *lda, MKL_Complex16 *af,int *ldaf,int *ipiv, MKL_Complex16 *b,int *ldb, MKL_Complex16 *x,int *ldx,double *ferr,double *berr, MKL_Complex16 *work,double *rwork,int *info);
void    zsyrfs(char *uplo,int *n,int *nrhs, MKL_Complex16 *a,int *lda, MKL_Complex16 *af,int *ldaf,int *ipiv, MKL_Complex16 *b,int *ldb, MKL_Complex16 *x,int *ldx,double *ferr,double *berr, MKL_Complex16 *work,double *rwork,int *info);
void    ZSYSV(char *uplo,int *n,int *nrhs, MKL_Complex16 *a,int *lda,int *ipiv, MKL_Complex16 *b,int *ldb, MKL_Complex16 *work,int *lwork,int *info);
void    zsysv(char *uplo,int *n,int *nrhs, MKL_Complex16 *a,int *lda,int *ipiv, MKL_Complex16 *b,int *ldb, MKL_Complex16 *work,int *lwork,int *info);
void    ZSYSVX(char *fact,char *uplo,int *n,int *nrhs, MKL_Complex16 *a,int *lda, MKL_Complex16 *af,int *ldaf,int *ipiv, MKL_Complex16 *b,int *ldb, MKL_Complex16 *x,int *ldx,double *rcond,double *ferr,double *berr, MKL_Complex16 *work,int *lwork,double *rwork,int *info);
void    zsysvx(char *fact,char *uplo,int *n,int *nrhs, MKL_Complex16 *a,int *lda, MKL_Complex16 *af,int *ldaf,int *ipiv, MKL_Complex16 *b,int *ldb, MKL_Complex16 *x,int *ldx,double *rcond,double *ferr,double *berr, MKL_Complex16 *work,int *lwork,double *rwork,int *info);
void    ZSYTF2(char *uplo,int *n, MKL_Complex16 *a,int *lda,int *ipiv,int *info);
void    zsytf2(char *uplo,int *n, MKL_Complex16 *a,int *lda,int *ipiv,int *info);
void    ZSYTRF(char *uplo,int *n, MKL_Complex16 *a,int *lda,int *ipiv, MKL_Complex16 *work,int *lwork,int *info);
void    zsytrf(char *uplo,int *n, MKL_Complex16 *a,int *lda,int *ipiv, MKL_Complex16 *work,int *lwork,int *info);
void    ZSYTRI(char *uplo,int *n, MKL_Complex16 *a,int *lda,int *ipiv, MKL_Complex16 *work,int *info);
void    zsytri(char *uplo,int *n, MKL_Complex16 *a,int *lda,int *ipiv, MKL_Complex16 *work,int *info);
void    ZSYTRS(char *uplo,int *n,int *nrhs, MKL_Complex16 *a,int *lda,int *ipiv, MKL_Complex16 *b,int *ldb,int *info);
void    zsytrs(char *uplo,int *n,int *nrhs, MKL_Complex16 *a,int *lda,int *ipiv, MKL_Complex16 *b,int *ldb,int *info);
void    ZTBCON(char *norm,char *uplo,char *diag,int *n,int *kd, MKL_Complex16 *ab,int *ldab,double *rcond, MKL_Complex16 *work,double *rwork,int *info);
void    ztbcon(char *norm,char *uplo,char *diag,int *n,int *kd, MKL_Complex16 *ab,int *ldab,double *rcond, MKL_Complex16 *work,double *rwork,int *info);
void    ZTBRFS(char *uplo,char *trans,char *diag,int *n,int *kd,int *nrhs, MKL_Complex16 *ab,int *ldab, MKL_Complex16 *b,int *ldb, MKL_Complex16 *x,int *ldx,double *ferr,double *berr, MKL_Complex16 *work,double *rwork,int *info);
void    ztbrfs(char *uplo,char *trans,char *diag,int *n,int *kd,int *nrhs, MKL_Complex16 *ab,int *ldab, MKL_Complex16 *b,int *ldb, MKL_Complex16 *x,int *ldx,double *ferr,double *berr, MKL_Complex16 *work,double *rwork,int *info);
void    ZTBTRS(char *uplo,char *trans,char *diag,int *n,int *kd,int *nrhs, MKL_Complex16 *ab,int *ldab, MKL_Complex16 *b,int *ldb,int *info);
void    ztbtrs(char *uplo,char *trans,char *diag,int *n,int *kd,int *nrhs, MKL_Complex16 *ab,int *ldab, MKL_Complex16 *b,int *ldb,int *info);
void    ZTGEVC(char *side,char *howmny,void *select,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb, MKL_Complex16 *vl,int *ldvl, MKL_Complex16 *vr,int *ldvr,int *mm,int *m, MKL_Complex16 *work,double *rwork,int *info);
void    ztgevc(char *side,char *howmny,void *select,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb, MKL_Complex16 *vl,int *ldvl, MKL_Complex16 *vr,int *ldvr,int *mm,int *m, MKL_Complex16 *work,double *rwork,int *info);
void    ZTGEX2(void *wantq,void *wantz,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb, MKL_Complex16 *q,int *ldq, MKL_Complex16 *z,int *ldz,int *j1,int *info);
void    ztgex2(void *wantq,void *wantz,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb, MKL_Complex16 *q,int *ldq, MKL_Complex16 *z,int *ldz,int *j1,int *info);
void    ZTGEXC(void *wantq,void *wantz,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb, MKL_Complex16 *q,int *ldq, MKL_Complex16 *z,int *ldz,int *ifst,int *ilst,int *info);
void    ztgexc(void *wantq,void *wantz,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb, MKL_Complex16 *q,int *ldq, MKL_Complex16 *z,int *ldz,int *ifst,int *ilst,int *info);
void    ZTGSEN(int *ijob,void *wantq,void *wantz,void *select,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb, MKL_Complex16 *alpha, MKL_Complex16 *beta, MKL_Complex16 *q,int *ldq, MKL_Complex16 *z,int *ldz,int *m,double *pl,double *pr,double *dif, MKL_Complex16 *work,int *lwork,int *iwork,int *liwork,int *info);
void    ztgsen(int *ijob,void *wantq,void *wantz,void *select,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb, MKL_Complex16 *alpha, MKL_Complex16 *beta, MKL_Complex16 *q,int *ldq, MKL_Complex16 *z,int *ldz,int *m,double *pl,double *pr,double *dif, MKL_Complex16 *work,int *lwork,int *iwork,int *liwork,int *info);
void    ZTGSJA(char *jobu,char *jobv,char *jobq,int *m,int *p,int *n,int *k,int *l, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb,double *tola,double *tolb,double *alpha,double *beta, MKL_Complex16 *u,int *ldu, MKL_Complex16 *v,int *ldv, MKL_Complex16 *q,int *ldq, MKL_Complex16 *work,int *ncycle,int *info);
void    ztgsja(char *jobu,char *jobv,char *jobq,int *m,int *p,int *n,int *k,int *l, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb,double *tola,double *tolb,double *alpha,double *beta, MKL_Complex16 *u,int *ldu, MKL_Complex16 *v,int *ldv, MKL_Complex16 *q,int *ldq, MKL_Complex16 *work,int *ncycle,int *info);
void    ZTGSNA(char *job,char *howmny,void *select,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb, MKL_Complex16 *vl,int *ldvl, MKL_Complex16 *vr,int *ldvr,double *s,double *dif,int *mm,int *m, MKL_Complex16 *work,int *lwork,int *iwork,int *info);
void    ztgsna(char *job,char *howmny,void *select,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb, MKL_Complex16 *vl,int *ldvl, MKL_Complex16 *vr,int *ldvr,double *s,double *dif,int *mm,int *m, MKL_Complex16 *work,int *lwork,int *iwork,int *info);
void    ZTGSY2(char *trans,int *ijob,int *m,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb, MKL_Complex16 *c,int *ldc, MKL_Complex16 *d,int *ldd, MKL_Complex16 *e,int *lde, MKL_Complex16 *f,int *ldf,double *scale,double *rdsum,double *rdscal,int *info);
void    ztgsy2(char *trans,int *ijob,int *m,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb, MKL_Complex16 *c,int *ldc, MKL_Complex16 *d,int *ldd, MKL_Complex16 *e,int *lde, MKL_Complex16 *f,int *ldf,double *scale,double *rdsum,double *rdscal,int *info);
void    ZTGSYL(char *trans,int *ijob,int *m,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb, MKL_Complex16 *c,int *ldc, MKL_Complex16 *d,int *ldd, MKL_Complex16 *e,int *lde, MKL_Complex16 *f,int *ldf,double *scale,double *dif, MKL_Complex16 *work,int *lwork,int *iwork,int *info);
void    ztgsyl(char *trans,int *ijob,int *m,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb, MKL_Complex16 *c,int *ldc, MKL_Complex16 *d,int *ldd, MKL_Complex16 *e,int *lde, MKL_Complex16 *f,int *ldf,double *scale,double *dif, MKL_Complex16 *work,int *lwork,int *iwork,int *info);
void    ZTPCON(char *norm,char *uplo,char *diag,int *n, MKL_Complex16 *ap,double *rcond, MKL_Complex16 *work,double *rwork,int *info);
void    ztpcon(char *norm,char *uplo,char *diag,int *n, MKL_Complex16 *ap,double *rcond, MKL_Complex16 *work,double *rwork,int *info);
void    ZTPRFS(char *uplo,char *trans,char *diag,int *n,int *nrhs, MKL_Complex16 *ap, MKL_Complex16 *b,int *ldb, MKL_Complex16 *x,int *ldx,double *ferr,double *berr, MKL_Complex16 *work,double *rwork,int *info);
void    ztprfs(char *uplo,char *trans,char *diag,int *n,int *nrhs, MKL_Complex16 *ap, MKL_Complex16 *b,int *ldb, MKL_Complex16 *x,int *ldx,double *ferr,double *berr, MKL_Complex16 *work,double *rwork,int *info);
void    ZTPTRI(char *uplo,char *diag,int *n, MKL_Complex16 *ap,int *info);
void    ztptri(char *uplo,char *diag,int *n, MKL_Complex16 *ap,int *info);
void    ZTPTRS(char *uplo,char *trans,char *diag,int *n,int *nrhs, MKL_Complex16 *ap, MKL_Complex16 *b,int *ldb,int *info);
void    ztptrs(char *uplo,char *trans,char *diag,int *n,int *nrhs, MKL_Complex16 *ap, MKL_Complex16 *b,int *ldb,int *info);
void    ZTRCON(char *norm,char *uplo,char *diag,int *n, MKL_Complex16 *a,int *lda,double *rcond, MKL_Complex16 *work,double *rwork,int *info);
void    ztrcon(char *norm,char *uplo,char *diag,int *n, MKL_Complex16 *a,int *lda,double *rcond, MKL_Complex16 *work,double *rwork,int *info);
void    ZTREVC(char *side,char *howmny,void *select,int *n, MKL_Complex16 *t,int *ldt, MKL_Complex16 *vl,int *ldvl, MKL_Complex16 *vr,int *ldvr,int *mm,int *m, MKL_Complex16 *work,double *rwork,int *info);
void    ztrevc(char *side,char *howmny,void *select,int *n, MKL_Complex16 *t,int *ldt, MKL_Complex16 *vl,int *ldvl, MKL_Complex16 *vr,int *ldvr,int *mm,int *m, MKL_Complex16 *work,double *rwork,int *info);
void    ZTREXC(char *compq,int *n, MKL_Complex16 *t,int *ldt, MKL_Complex16 *q,int *ldq,int *ifst,int *ilst,int *info);
void    ztrexc(char *compq,int *n, MKL_Complex16 *t,int *ldt, MKL_Complex16 *q,int *ldq,int *ifst,int *ilst,int *info);
void    ZTRRFS(char *uplo,char *trans,char *diag,int *n,int *nrhs, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb, MKL_Complex16 *x,int *ldx,double *ferr,double *berr, MKL_Complex16 *work,double *rwork,int *info);
void    ztrrfs(char *uplo,char *trans,char *diag,int *n,int *nrhs, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb, MKL_Complex16 *x,int *ldx,double *ferr,double *berr, MKL_Complex16 *work,double *rwork,int *info);
void    ZTRSEN(char *job,char *compq,void *select,int *n, MKL_Complex16 *t,int *ldt, MKL_Complex16 *q,int *ldq, MKL_Complex16 *w,int *m,double *s,double *sep, MKL_Complex16 *work,int *lwork,int *info);
void    ztrsen(char *job,char *compq,void *select,int *n, MKL_Complex16 *t,int *ldt, MKL_Complex16 *q,int *ldq, MKL_Complex16 *w,int *m,double *s,double *sep, MKL_Complex16 *work,int *lwork,int *info);
void    ZTRSNA(char *job,char *howmny,void *select,int *n, MKL_Complex16 *t,int *ldt, MKL_Complex16 *vl,int *ldvl, MKL_Complex16 *vr,int *ldvr,double *s,double *sep,int *mm,int *m, MKL_Complex16 *work,int *ldwork,double *rwork,int *info);
void    ztrsna(char *job,char *howmny,void *select,int *n, MKL_Complex16 *t,int *ldt, MKL_Complex16 *vl,int *ldvl, MKL_Complex16 *vr,int *ldvr,double *s,double *sep,int *mm,int *m, MKL_Complex16 *work,int *ldwork,double *rwork,int *info);
void    ZTRSYL(char *trana,char *tranb,int *isgn,int *m,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb, MKL_Complex16 *c,int *ldc,double *scale,int *info);
void    ztrsyl(char *trana,char *tranb,int *isgn,int *m,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb, MKL_Complex16 *c,int *ldc,double *scale,int *info);
void    ZTRTI2(char *uplo,char *diag,int *n, MKL_Complex16 *a,int *lda,int *info);
void    ztrti2(char *uplo,char *diag,int *n, MKL_Complex16 *a,int *lda,int *info);
void    ZTRTRI(char *uplo,char *diag,int *n, MKL_Complex16 *a,int *lda,int *info);
void    ztrtri(char *uplo,char *diag,int *n, MKL_Complex16 *a,int *lda,int *info);
void    ZTRTRS(char *uplo,char *trans,char *diag,int *n,int *nrhs, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb,int *info);
void    ztrtrs(char *uplo,char *trans,char *diag,int *n,int *nrhs, MKL_Complex16 *a,int *lda, MKL_Complex16 *b,int *ldb,int *info);
void    ZTZRQF(int *m,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau,int *info);
void    ztzrqf(int *m,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau,int *info);
void    ZTZRZF(int *m,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *work,int *lwork,int *info);
void    ztzrzf(int *m,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *work,int *lwork,int *info);
void    ZUNG2L(int *m,int *n,int *k, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *work,int *info);
void    zung2l(int *m,int *n,int *k, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *work,int *info);
void    ZUNG2R(int *m,int *n,int *k, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *work,int *info);
void    zung2r(int *m,int *n,int *k, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *work,int *info);
void    ZUNGBR(char *vect,int *m,int *n,int *k, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *work,int *lwork,int *info);
void    zungbr(char *vect,int *m,int *n,int *k, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *work,int *lwork,int *info);
void    ZUNGHR(int *n,int *ilo,int *ihi, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *work,int *lwork,int *info);
void    zunghr(int *n,int *ilo,int *ihi, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *work,int *lwork,int *info);
void    ZUNGL2(int *m,int *n,int *k, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *work,int *info);
void    zungl2(int *m,int *n,int *k, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *work,int *info);
void    ZUNGLQ(int *m,int *n,int *k, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *work,int *lwork,int *info);
void    zunglq(int *m,int *n,int *k, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *work,int *lwork,int *info);
void    ZUNGQL(int *m,int *n,int *k, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *work,int *lwork,int *info);
void    zungql(int *m,int *n,int *k, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *work,int *lwork,int *info);
void    ZUNGQR(int *m,int *n,int *k, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *work,int *lwork,int *info);
void    zungqr(int *m,int *n,int *k, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *work,int *lwork,int *info);
void    ZUNGR2(int *m,int *n,int *k, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *work,int *info);
void    zungr2(int *m,int *n,int *k, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *work,int *info);
void    ZUNGRQ(int *m,int *n,int *k, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *work,int *lwork,int *info);
void    zungrq(int *m,int *n,int *k, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *work,int *lwork,int *info);
void    ZUNGTR(char *uplo,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *work,int *lwork,int *info);
void    zungtr(char *uplo,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *work,int *lwork,int *info);
void    ZUNM2L(char *side,char *trans,int *m,int *n,int *k, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *c,int *ldc, MKL_Complex16 *work,int *info);
void    zunm2l(char *side,char *trans,int *m,int *n,int *k, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *c,int *ldc, MKL_Complex16 *work,int *info);
void    ZUNM2R(char *side,char *trans,int *m,int *n,int *k, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *c,int *ldc, MKL_Complex16 *work,int *info);
void    zunm2r(char *side,char *trans,int *m,int *n,int *k, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *c,int *ldc, MKL_Complex16 *work,int *info);
void    ZUNMBR(char *vect,char *side,char *trans,int *m,int *n,int *k, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *c,int *ldc, MKL_Complex16 *work,int *lwork,int *info);
void    zunmbr(char *vect,char *side,char *trans,int *m,int *n,int *k, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *c,int *ldc, MKL_Complex16 *work,int *lwork,int *info);
void    ZUNMHR(char *side,char *trans,int *m,int *n,int *ilo,int *ihi, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *c,int *ldc, MKL_Complex16 *work,int *lwork,int *info);
void    zunmhr(char *side,char *trans,int *m,int *n,int *ilo,int *ihi, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *c,int *ldc, MKL_Complex16 *work,int *lwork,int *info);
void    ZUNML2(char *side,char *trans,int *m,int *n,int *k, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *c,int *ldc, MKL_Complex16 *work,int *info);
void    zunml2(char *side,char *trans,int *m,int *n,int *k, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *c,int *ldc, MKL_Complex16 *work,int *info);
void    ZUNMLQ(char *side,char *trans,int *m,int *n,int *k, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *c,int *ldc, MKL_Complex16 *work,int *lwork,int *info);
void    zunmlq(char *side,char *trans,int *m,int *n,int *k, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *c,int *ldc, MKL_Complex16 *work,int *lwork,int *info);
void    ZUNMQL(char *side,char *trans,int *m,int *n,int *k, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *c,int *ldc, MKL_Complex16 *work,int *lwork,int *info);
void    zunmql(char *side,char *trans,int *m,int *n,int *k, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *c,int *ldc, MKL_Complex16 *work,int *lwork,int *info);
void    ZUNMQR(char *side,char *trans,int *m,int *n,int *k, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *c,int *ldc, MKL_Complex16 *work,int *lwork,int *info);
void    zunmqr(char *side,char *trans,int *m,int *n,int *k, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *c,int *ldc, MKL_Complex16 *work,int *lwork,int *info);
void    ZUNMR2(char *side,char *trans,int *m,int *n,int *k, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *c,int *ldc, MKL_Complex16 *work,int *info);
void    zunmr2(char *side,char *trans,int *m,int *n,int *k, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *c,int *ldc, MKL_Complex16 *work,int *info);
void    ZUNMR3(char *side,char *trans,int *m,int *n,int *k,int *l, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *c,int *ldc, MKL_Complex16 *work,int *info);
void    zunmr3(char *side,char *trans,int *m,int *n,int *k,int *l, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *c,int *ldc, MKL_Complex16 *work,int *info);
void    ZUNMRQ(char *side,char *trans,int *m,int *n,int *k, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *c,int *ldc, MKL_Complex16 *work,int *lwork,int *info);
void    zunmrq(char *side,char *trans,int *m,int *n,int *k, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *c,int *ldc, MKL_Complex16 *work,int *lwork,int *info);
void    ZUNMRZ(char *side,char *trans,int *m,int *n,int *k,int *l, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *c,int *ldc, MKL_Complex16 *work,int *lwork,int *info);
void    zunmrz(char *side,char *trans,int *m,int *n,int *k,int *l, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *c,int *ldc, MKL_Complex16 *work,int *lwork,int *info);
void    ZUNMTR(char *side,char *uplo,char *trans,int *m,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *c,int *ldc, MKL_Complex16 *work,int *lwork,int *info);
void    zunmtr(char *side,char *uplo,char *trans,int *m,int *n, MKL_Complex16 *a,int *lda, MKL_Complex16 *tau, MKL_Complex16 *c,int *ldc, MKL_Complex16 *work,int *lwork,int *info);
void    ZUPGTR(char *uplo,int *n, MKL_Complex16 *ap, MKL_Complex16 *tau, MKL_Complex16 *q,int *ldq, MKL_Complex16 *work,int *info);
void    zupgtr(char *uplo,int *n, MKL_Complex16 *ap, MKL_Complex16 *tau, MKL_Complex16 *q,int *ldq, MKL_Complex16 *work,int *info);
void    ZUPMTR(char *side,char *uplo,char *trans,int *m,int *n, MKL_Complex16 *ap, MKL_Complex16 *tau, MKL_Complex16 *c,int *ldc, MKL_Complex16 *work,int *info);
void    zupmtr(char *side,char *uplo,char *trans,int *m,int *n, MKL_Complex16 *ap, MKL_Complex16 *tau, MKL_Complex16 *c,int *ldc, MKL_Complex16 *work,int *info);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* _MKL_LAPACK_H_ */
